#
# Time-stamp: <2003-11-26 00:52:52 sutner> 
#
# File:  	longtest.prg
# Purpose:	testfile for stand-alone`aut'
#

"urelements  --------------------------------------------------"

# primitive urelements

123456

-123456

11111111111111122222222222222222223333333333333333333344444444444444444444

"abcdefgh" 

( ( 1, 2, (("aa","bb"), 3), -5555 ), (4,(5,(6))) )


# complex urelements

FA[ 12, 2, ((1,1,2), (2,1,3), (4,1,5), (5,1,6), (7,2,8), (8,2,9), (4,0,7), (6,0,9), (3,0,4), (4,0,10), (9,0,4), (10,2,11), (11,2,12)), (1), (12)]

FA[ 12, 2, ((1,1,2), (2,1,3), (2,1,4), (2,1,7), (2,1,10), (4,1,5), (5,1,6), (5,1,9), (5,1,4), (5,1,7), (5,1,10), (7,2,8), (8,2,9), (8,2,4), (8,2,7), (8,2,10), (10,2,11), (11,2,12)), (1), (12)]

DFA[ 8, 2, ((2, 4, 3, 5, 7, 3, 5, 5), (3, 3, 3, 6, 3, 8, 6, 6)), 1, (8)]

DFA[ 6, 2, ((5, 3, 4, 3, 5, 3), (2, 1, 5, 1, 5, 5)), 6, (2)]

# Graph[6, 11, 4, ((5, 2), (3, 1), (4, 5), (3, 1), (5), (3, 5))]

CA[ 7, 2, 170141183460469231731687303715884105728 ]



"list operations  --------------------------------------------------"

r5 = range[5];
r10 = range[10];
c = cart[r5,r10];
equal[ 50, length[c] ]
equal[ 100, length[flat[c]] ]

cc = sort[ flat[ c ] ];
u  = unique[ cc ];
equal[ 10, length[u] ]

equal[ rev[ rev[ cc ] ], cc ]

L = ((1,2,3),1,2,3);
S = (0,10,20,30);
equal[ subst[ L, S ], ((10,20,30),10,20,30) ]

p = powerset[ range[6] ];
equal[ 192, length[flat[p]] ]


(1,2,3,4,5) == range[5]


a = (1);
b = (2);
if( a < b )  1  fi

if( 0 < 1 )
	1
else
	2
fi

a = 0;
while( a < 10 )
{
	a = inc[a]
};
a == 10

x = range[10];
while( x ) 
{
	x = .x 
};

i = 0;
while( i < 20 )
{
        a = range[ 100 ]
        c = cart[ range[25], range[25] ]
        i = inc[i]
};

defun id[zzz]
{
	zzz
}

defun sum[ L ] 
{
#       print[ L ];
        if( L )
                add[ H[L], sum[ T[L] ] ]
        else
                0
        fi
}

defun  fibo[ x ]
{
	if( x < 2 ) 
		x
	else
		add[ fibo[ dec[x] ], fibo[dec[dec[x]]] ]
	fi
}


"finite state machines  --------------------------------------------------"


# epsilon elimation
fa =  FA[11, 3, ((1, 0, 2), (2, 1, 3), (2, 2, 3), (2, 3, 3), (2, 0, 4), (3, 0, 2), (4, 1, 5), (5, 1, 6), (5, 2, 6), (5, 3, 6), (6, 1, 7), (6, 2, 7), (6, 3, 7), (7, 1, 8), (7, 2, 8), (7, 3, 8), (8, 1, 9), (8, 2, 9), (8, 3, 9), (9, 1, 10), (9, 2, 10), (9, 3, 10), (10, 1, 11), (10, 2, 11), (10, 3, 11)), (1), (11)]; 
d1 = todfa[epselim[fa]];
d2 = todfa[fa];
equal[d1,d2]

# minimization
c = FA[9, 2, ((1, 1, 1), (1, 1, 2), (1, 2, 1), (2, 1, 3), (2, 2, 3), (3, 1, 4), (3, 2, 4), (4, 1, 5), (4, 2, 5), (5, 1, 6), (5, 2, 6), (6, 1, 7), (6, 2, 7), (7, 1, 8), (7, 2, 8), (8, 1, 9), (8, 2, 9)), (1), (9)];

d1 = todfa[c]; 
equal[ 256, size[d1] ]

d2 = minimize[ d1 ];
equal[ 256, size[d2] ]


sa = tosa[ CA[ 6, 2, 1324132401327409123490123740923174 ] ];
d3 = todfa[ sa ];
equal[ 1154, size[d3] ]

# acceptance language 
ll = lang[ d2, -8 ];
equal[ (0, 0, 0, 0, 0, 0, 0, 0, 128),  map[ length, ll ] ]

# size of power automaton
# 11-th symbol from the end is an `a'
fa11 = FA[12, 2, ((1, 1, 1), (1, 1, 2), (1, 2, 1), (2, 1, 3), (2, 2, 3), (3, 1, 4), (3, 2, 4), (4, 1, 5), (4, 2, 5), (5, 1, 6), (5, 2, 6), (6, 1, 7), (6, 2, 7), (7, 1, 8), (7, 2, 8), (8, 1, 9), (8, 2, 9), (9, 1, 10), (9, 2, 10), (10, 1, 11), (10, 2, 11), (11, 1, 12), (11, 2, 12)), (1), (12)];

equal[ 2048, todfasize[fa11] ]
equal[ 2048, size[todfa[fa11]] ]
m11 = minimize[fa11];
equal[ 2048, size[m11] ]

# structured state sets 
fa = tofa[tosa[CA[3,2,72]]];
d  = todfa[fa,0];
dd = minimize[d,0];
s0 = sort[ (((1,2,4),(1,2,3,4)),((3,4)),((4)),((1,2,3),(1,2)),((3)),(())) ];
s1 = sort[ states[dd] ];
equal[ s0, s1 ]


# regular expressions

# fa = < (aa + bb + (ab + ba)(aa + bb)*(ab + ba))* >;
# equal[ 4, fa eelim todfa  min size ]
# 
# fa = < (a+b+c+d)*a (a+b+c+d)(a+b+c+d)(a+b+c+d)(a+b+c+d)(a+b+c+d)(a+b+c+d)(a+b+c+d) >;
# equal[ 256, fa todfa min size ]
# 
# equal[ 9, < (a+b+c+d)*a (a+b)(a+b)(c+d) >  min  size ]


# kernel automata

sa0 = tosa[CA[4,2,1234567]];

equal[ 39, size[ kernel[ sa0, ((1)) ] ] ]
equal[ 45, size[ kernel[ sa0, (range[8]) ] ] ]
k = kernel[ sa0, (range[4],range[5,8]), 0 ];
equal[ 48, size[ k ] ]
equal[ 133, size[ flat[ states[k] ] ] ]



"semigroups  --------------------------------------------------"
# semigroup tests
# below are a few generators for standard groups and semigroups
# uncomment sg466656 if you have enough resources



# symmetric group S_5: 120 elements
sg120 = generate[ ( 5, 2, 1,2,3,4,0, 1,0,2,3,4 ) ];
equal[ 120, size[sg120]]

# full transfomation semigroup T_4: 256 elements
sg2 = generate[ ( 4, 3, 1,2,3,0, 1,0,2,3, 0,0,2,3), 2 ];
equal[ 256, size[sg2] ]


# full transfomation semigroup T_5: 3125 elements
sg3125 = generate[ ( 5, 3, 1,2,3,4,0, 1,0,2,3,4,  0,0,2,3,4 ) ];
equal[ 3125, size[sg3125]]

# Pin's semigroup
sg5777 = generate[ ( 8, 2, 2, 0, 1, 4, 3, 2, 7, 6, 3, 0, 1, 2, 3, 4, 1, 7 ) ];
equal[ 5777, size[ sg5777 ] ]

# full transfomation semigroup T_6: 46656 elements
# sg466656 = generate[ ( 6, 3, 1,2,3,4,5,0, 1,0,2,3,4,5,  0,0,2,3,4,5 ) ];
# equal[ 46656, size[sg466656]]


"cellular automata  --------------------------------------------------"


g = togen[acc[todfa[tosa[CA[3,2,72]]]]];
sg1 = generate[g,2];
equal[ 26, size[sg1] ]
equal[ 209, length[flat[dclist[sg1]]] ]

sa = tosa[ CA[4,2,12345] ];
equal[ 14, size[todfa[sa]] ]  

c1 = CA[3,2,50] ;
equal[ 0, analyze[c1] ]
equal[ ((1), (2, 3, 4)), scc[ tograph[ minimize[ tosa[ c1 ] ] ] ] ]

c2 = CA[ 4, 2, 7770 ];
equal[ 1, analyze[c2] ]
ww = towelch[ c2, 0 ];

equal[ 12, length[flat[states[H[ww]]]]]
equal[ 16, length[flat[states[H[T[ww]]]]]]

seed = (0,0,0,0,0,0,0,1,0,0,0,0,0,0,0);
equal[ 165, size[orbit[ ( c2, seed, 10, 0 ) ]] ]


"graphs  --------------------------------------------------"

ss = squaresa[tosa[c2]]; 
g = tograph[ss]; 
equal[ 36, size[g] ]
equal[ map[ length , scc[g] ], (1, 15, 1, 1, 8, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1) ]

equal[ 36, size[tograph[ss] ] ]
equal[ 7, size[tograph[todfa[ss]] ] ]


"done ------------------------------------------------";
