//---------------------------------------------------------------------------
// $Id: bparser.y,v 1.1.1.1 2001/07/28 17:13:16 sutner Exp $
// 
//  Time-stamp: <99/02/27 19:51:26 sutner> 
//
// :File:      bparser.y
// :Purpose:   Bison .y file.
//---------------------------------------------------------------------------


%{
#include   "urlist.h"
#include   "listutil.h"
#include   "parser.h"

#define  YYSTYPE  UList

//#define  BUGM(ss)   cerr << (ss) << endl
#define  BUGM(ss)  

int  argcnt = 0;

#define YYPARSE_PARAM parm
#define YYLEX_PARAM   parm

int  yylex ( YYSTYPE *lvalp, void* vparm );
int  yyerror(char *s);

%}
%token  INTT STRT VART OPER LSTT
%token  NONET 
%token  ARGT 
%token  EQT 
%token  IFT ELSET FIT WHILET DEFUNT STOPT WHLRDT
//%type  input line expr stmt stmtlist asgn defn cond list arglist fcall

%right '='
%expect 11
%pure_parser

%%				// the grammar 

input:    /* empty */           { BUGM("input empty"); } 
        | input '\n'            { BUGM("input nl"); 
                                  ((ParserControl*)parm)->pap->in_prompt(); }
        | input line '\n'       { BUGM("input line "); 
	                          ((ParserControl*)parm)->pap->set_value($2); 
                                  ((ParserControl*)parm)->pap->set_print(1);
				  ((ParserControl*)parm)->pap->out_prompt($2);
                                  ((ParserControl*)parm)->pap->in_prompt(); }
        | input line noprnt     { BUGM("input line "); 
                                  ((ParserControl*)parm)->pap->set_value($2); 
                                  ((ParserControl*)parm)->pap->set_print(0);
                                  ((ParserControl*)parm)->pap->in_prompt(); }
        | error errstp          { BUGM("line  error"); yyerrok; }
        ;

errstp:   '\n'
        | ';' '\n'
        ;

noprnt:   ';'
        | ';' '\n'
        ;


line:     stmt                  { BUGM("line  eval");   
                                  $$ = $1.eval(*((ParserControl*)parm)->env); }
        ;

expr:     INTT            	{ BUGM("expr  int");  $$ = $1; }
        | STRT            	{ BUGM("expr  str");  $$ = $1; }
        | VART            	{ BUGM("expr  var");  $$ = new VarExpr( svalue($1) ); }
        | asgn            	{ BUGM("expr  asg");  $$ = $1; }
        | LSTT            	{ BUGM("expr  IL");   $$ = $1; }
        | '%'            	{ BUGM("expr  last"); 
	                          $$ = ((ParserControl*)parm)->pap->value(); }


        | '(' list ')'    	{ BUGM("expr  list"); $$ = reverse($2); }
        | OPER '[' arglist ']'  { BUGM("expr  fcall");      
                                  $$ = new FuncExpr( svalue($1), reverse($3), length_int($3) ); }

        | VART '[' arglist ']'  { BUGM("expr  ucall");      
                                  $$ = new UserFuncExpr( svalue($1), reverse($3) ); }


        | '*' expr              { BUGM("expr  *");      
                                  $$ = new FuncExpr( "H", $2 -= nil, 1 ); }
        | '.' expr              { BUGM("expr  .");      
                                  $$ = new FuncExpr( "T", $2 -= nil, 1 ); }
        | expr '<' expr         { BUGM("expr  <");      
                                  $$ = new FuncExpr( "less", $1 -= $3 -= nil, 2 ); }
        | expr EQT expr         { BUGM("expr  ==");      
                                  $$ = new FuncExpr( "equal", $1 -= $3 -= nil, 2 ); }
        ;		  	    
			  	    
list:     /* empty */       	{ $$ = nil; }        
        | expr            	{ $$ = $1 -= nil; }        
        | list ',' whsp expr   	{ $$ = $4 -= $1; }   
        ;

arglist:   /* empty */          { $$ = nil; }
        | expr                  { $$ = $1 -= nil; }
        | arglist ',' expr      { $$ = $3 -= $1; }
        | OPER ',' expr         { $$ = $3 -= $1 -= nil; }
        ;

asgn:     VART '=' expr         {  BUGM("asgn ");   
                                   $$ = new AssgnExpr( svalue($1), $3 ); }
        ;

whsp:     /* empty */
        | '\n' 
        ;

stmt:     expr                  { BUGM("stmt  expr");    $$ = $1; }

        | defn                  { BUGM("stmt  defn");    $$ = $1;}

        | IFT cond stmt end     { BUGM("stmt  if");      $$ = new IfNode( $2, $3, nil ); }
        | IFT cond stmt else stmt end   
                                { BUGM("stmt  if-else"); $$ = new IfNode( $2, $3, $5 ); }
        | WHILET cond stmt      { BUGM("stmt  while");   $$ = new WhileNode( $2, $3 ); }
        | WHLRDT '(' VART ',' STRT ')' whsp stmt      { BUGM("stmt  whileread");   
                                  $$ = new WhileReadNode( svalue($3), svalue($5), $8 ); }
        | '{' stmtlist '}'      { BUGM("stmt  list");    $$ = new CompNode( reverse($2) ); } 
        ;

cond:     '(' expr ')' whsp     { BUGM("cond"); $$ = $2; }
        ;

end:      whsp FIT
        ;

else:     whsp ELSET whsp
        ;

stmtlist:   /* empty */         { $$ = nil; }        
        | stmtlist '\n'         { $$ = $1; }  
        | stmtlist  stmt        { $$ = $2 -= $1; }   
        ;

defn:     DEFUNT VART '[' paral ']' whsp stmt
                                { BUGM("defun "); 
                                  $$ = new DefNode( svalue($2), reverse($4), $7 ); }
        ;

paral:   /* empty */            { $$ = nil; }
        | VART                  { $$ = $1 -= nil; }
        | paral ',' VART        { $$ = $3 -= $1; }
        ;
%%



int  yylex ( YYSTYPE *lvalp, void* vparm )
{
    return  ((ParserControl*)vparm)->pap->get_next_token( lvalp );
/*      int x = ((ParserControl*)vparm)->pap->get_next_token( lvalp ); */
/*      cout << "+++ " << x << endl; */
/*      return  x; */
}



//----------------------------------------------------------------------
// error handling, pitiful 

int  yyerror(char *s)  
{
  printf ("%s\n", s);
  return 0;
}

//----------------------------------------------------------------------
// eof
