//--------------------------------------------------------------------------------
//
// Time-stamp: <2003-11-24 18:19:37 sutner>
// 
// File:     fsmconst.cc
// Purpose:  constructors for fsm's
//
//--------------------------------------------------------------------------------

#include  "stl-wrap.h"
#include  "fsm.h"
#include  "urlist.h"
#include  "listutil.h"
#include  "util.h"


//---------------------------------------------------------------------
// constructors


//  x[-n] == a

void   IthSymbolFA( int a, int n, int k, FA& fa )
{
    int     i;
    size_t  s;

    fa.set( n+1, k );

    fa.transitionsInsert(0,a,1);		  // nondeterministic branch

    foreach_symbol( s, fa )		  // loop at state 0 
	fa.transitionsInsert(0,s,0);
   
    for( i = 1; i < n; i++ )			  // main path
	foreach_symbol( s, fa )
	    fa.transitionsInsert(i,s,i+1);

    fa.initial().initialize(n+1);
    fa.final().initialize(n+1);
    fa.initial().insert(0);
    fa.final().insert(n);

    fa.eps_free() = fa.accessible() = TRUE;
}

