//---------------------------------------------------------------------------
//
//  Time-stamp: <2003-11-24 18:36:11 sutner> 
//
// :File:      auto.h
// :Purpose:   Standard functions for aut calculator.
// 
//---------------------------------------------------------------------------

#ifndef  _AUTO_H_
#define  _AUTO_H_

#include  "Clock.h"
#include  "basic.h"
#include  "listutil.h"
#include  "makeatom.h"
#include  "parser.h"
#include  "ptree.h"
#include  "symtab.h"
#include  "urlist.h"

//--------------------------------------------------------------------------------
// helper functions, should be inlined

UList   at_i( UList L, UList i );
UList   print_globals();

int  less_ii( int x, int y );
int  equal_ii( int x, int y );
int  greater_ii( int x, int y );

int  add_ii( int x, int y );
int  sub_ii( int x, int y );
int  mult_ii( int x, int y );
int  div_ii( int x, int y );

int  and_ii( int x, int y );
int  or_ii( int x, int y );

int  not_i( int x );
int  positive_i( int x );
int  inc_i( int x );
int  dec_i( int x );


//--------------------------------------------------------------------------------
// reading with `read()'

UList  read_expression();
UList  openread( UList L );
UList  closeread();

//--------------------------------------------------------------------------------

void   load_standard_globals( SymTable& stab );

//--------------------------------------------------------------------------------
#endif
