//---------------------------------------------------------------------------
//
//  Time-stamp: <2003-11-24 18:36:46 sutner> 
//
// :File:      befa.h
// :Purpose:   begin/exit automata
// 
//---------------------------------------------------------------------------

#ifndef  _BEFA_H_
#define  _BEFA_H_


#include  <vector>

typedef  vector<int>  ivector;


class  BEFA
{
    int       _nstat;                   // number of states 
    ivector  _tran;                   // flat array of transitions

public:

    BEFA(): _nstat(-1) {}

    explicit  BEFA( int r );            // special machines: eps (0), empty (-1) 
    BEFA( char *ww, char off='a' );     // machine for one word ww, _nstat = |ww|
    ~BEFA();
   
    BEFA( const BEFA& M );   
    BEFA& operator=( const BEFA& M );   
    int   operator==( const BEFA& M ) const;   

    BEFA&  operator+=( const BEFA& M );
    BEFA&  operator*=( const BEFA& M );
    BEFA&   star();
    
    void  add_transition(int,int,int);

    int  numStates()  const     { return _nstat; }
    int  numTransitions() const { return _tran.size()/3; }
    ivector&       transitions()       { return _tran; }
    const ivector& transitions() const { return _tran; }

    // (this,m2) -> mout
    // always return size of result
//    int   catenation( const BEFA& M, BEFA& mout ) const;
//    int   sum( const BEFA& M, BEFA& mout ) const;
//    int   convert( FA *mout ) const;

    friend   BEFA  operator+( const BEFA&, const BEFA& );
    friend   BEFA  operator*( const BEFA&, const BEFA& );

    friend  ostream& operator<<( ostream& out, const BEFA& M );
};



#endif
