//---------------------------------------------------------------------------
//
//  Time-stamp: <2003-11-24 18:44:25 sutner> 
//
// :File:      refcount.h
// :Purpose:   General reference counting class, use in handles
// 
//             class Handle {
//                   Item     *ptr;
//                   RefCount  rc;
//                   ...
//             };
// 
//---------------------------------------------------------------------------

#ifndef  _REFCOUNT_H_
#define  _REFCOUNT_H_

#include  <iostream.h>

//--------------------------------------------------------------------------------
class RefCount 
{
public:
    RefCount();
    RefCount(const RefCount&);
    ~RefCount();

    bool  unique();		// check if only instance
    bool  reattach(const RefCount&);
    bool  make_unique();
    friend  ostream& operator<<( ostream& os, const RefCount& rc );

    int   refcount() const;	// only for demo

private:
    int* rcnt;

    RefCount& operator=(const RefCount&); // block
};

//--------------------------------------------------------------------------------
#endif

