//---------------------------------------------------------------------------
//
//  Time-stamp: <2003-11-24 18:49:43 sutner>
// 
//  :File:     trace.h
//  :Purpose:  Test class for container tests.
//             Constructor, destructor, and copy constructor visible.
//---------------------------------------------------------------------------

#ifndef   _TRACECLASS_H_
#define   _TRACECLASS_H_

#include  <iostream>
#include  <iomanip>

//--------------------------------------------------------------------------------

// a help message explaining all the fields in the census 
static char  *mssg = "Trace:\n"
"cu:   current # instances\n"
"tot:  total # instances\n"
"sc:   # simple constructs\n"
"cu:   # copy constructs\n"
"de:   # destructs\n"
"as:   # assignments\n";


//--------------------------------------------------------------------------------

class Trace
{

    static  int cu_cnt;		// current global count
    static  int t_cnt;		// total global count
    static  int sc_cnt;		// simple constructor
    static  int cc_cnt;		// copy constructor
    static  int as_cnt;		// assignments
    static  int d_cnt;		// destructor

    static  bool fl_tr;		// full trace on/off

    static  int n_cnt;		// automatic stamp
    int     n;			// local stamp

    char   *msg;		// local message
    
public:				// we have no secrets

    Trace( char *s=NULL );
    Trace( const Trace& src );
    ~Trace();

    int&   access() { return n; }

    
    bool  operator==( const Trace& src ) const { return  n == src.n; }
    Trace& operator=( const Trace& src );
    
    friend  void  TraceCensus( bool fc = 0 );
    friend  void  TraceClear();
    friend  void  FullTraceOn();
    friend  void  FullTraceOff();
    friend  ostream& operator<<( ostream& out, const Trace& x );

    friend void  TraceHelp() { cout << mssg << endl; }
};


#endif

