(* DO NOT EDIT THIS FILE *)

(* package generated at 2004/4/26 21:48 from AutomataSource.nb *)

(* Title: automata *)

(* 
* Author:Klaus Sutner
* Affiliation:CMU
* email:sutner@cs.cmu.edu
*)

(*
* Version:Version 5.0
*)

BeginPackage["Automata`automata`","Graphics`Colors`"];

$alphabet::usage = "$alphabet  is the default alphabet used in commands that require an alphabet as part of their input. ";
AlgebraicForm::usage = "AlgebraicForm[w]  writes word w in algebraic form using exponents for runs of a symbol.";
Alphabet::usage = "Alphabet[M]  returns the proper alphabet of machine M.";
Alphabetic::usage = "Alphabetic  is an option for FunctionToSA and FunctionToDFA.";
AlphabetQ::usage = "AlphabetQ[K]  tests whether K represents an alphabet.";
AlphabetSize::usage = "AlphabetSize[K]  returns the size of the alphabet  K. ";
Concatenate::usage = "Concatenate[u,v]  concatenates words u and v. ";
Eps::usage = "Eps  is used to denote the empty string. ";
FromEps::usage = "FromEps[exp]  replaces all occurences of Eps (as symbol and as string) in exp by the empty string.";
FromFrontier::usage = "FromFrontier[W]  computes the set of all proper prefixes of the finite language W. ";
FrontierQ::usage = "FrontierQ[L,K]  tests whether the finite language L is a frontier over alphabet K.";
MakeAlphabet::usage = "MakeAlphabet[KK]  returns  K  where  K  is the alphabet determined by the raw alphabet  KK. ";
MakeWord::usage = "MakeWord[a,i,b,j,...]  generates the word starting with i repetitions of letter a, j repetitions of letter b, and so on.";
ParikhVector::usage = "ParikhVector[w,K]  computes the Parihk vector of word w over the ordered alphabet K.";
RandomWord::usage = "RandomWord[n,K]  produces a random word over alphabet K of length n. ";
ToBlocks::usage = "ToBlocks[L,w]  partitions a list L into a list of overlapping blocks of width w (with offset 1). ";
ToEps::usage = "ToEps[x]  replaces all occurences of the empty string in x by Eps (as a string).";
ToFrontier::usage = "ToFrontier[W,K]  computes the prefix set corresponding to the finite language W over alphabet K. ";
ToIndex::usage = "ToIndex[w,K]  converts a word w over a sorted alphabet K to positional notation.";
ToWord::usage = "ToWord[L,K]  converts a list of indexes to the corresponding word over sorted alphabet K.";
WordBinomial::usage = "WordBinomial[u,v]  generalizes binomial coefficients to words: counts the number of subwords v in u. ";
WordConjugateQ::usage = "WordConjugateQ[u,v]  tests whether words u and v are conjugates.";
WordConjugates::usage = "WordConjugates[w]  generates all conjugates of a word w, in lexicographic order.";
WordFactorizations::usage = "WordFactorizations[w]  generates all factorizations uv of a word w. ";
WordFactorQ::usage = "WordFactorQ[x,y]  tests whether word x is a factor (or infix) of word y.";
WordFactors::usage = "WordFactors[w,opts]  generates a list of all factors of word w, in length-lex order. ";
WordFusion::usage = "WordFusion[u,v,r]  returns the r-fusion of words u and v. ";
WordLength::usage = "WordLength[w]  returns the length of word w. ";
WordOrder::usage = "WordOrder[u,v]  returns -1, 0, +1 depending on the position of u and v in the length-lex order";
WordPeriod::usage = "WordPeriod[w]  returns the minimal period of a word w.";
WordPower::usage = "WordPower[w,r]  returns word w repeated r times.";
WordPrefixQ::usage = "WordPrefixQ[x,y]  tests whether word x is a prefix of word y.";
WordPrefixes::usage = "WordPrefixes[w]  generates all prefixes of word  w, in length order. ";
WordPrimitiveCount::usage = "WordPrimitiveCount[n,k]  returns the number of primitive words of length n over a k symbol alphabet. ";
WordPrimitiveQ::usage = "WordPrimitiveQ[w]  tests whether word w is primitive, i.e, not the power of a shorter word. ";
WordQ::usage = "WordQ[w]  tests whether w is a word: w may be a symbol or a string.";
WordReverse::usage = "WordReverse[w]  reverses the word w like StringReverse but accepts symbols as input and treats the empty word properly.";
WordRoot::usage = "WordRoot[w]  computes the root of a word w, i.e., the shortest word u such that w is a power of u.";
WordRotate::usage = "WordRotate[w,n]  rotates the word w by n places to the left.  ";
Words::usage = "Words[r,K]  produces a list of words of length r over alphabet K. ";
WordShuffle::usage = "WordShuffle[u,v]  generates the shuffle language of words u and v.";
WordSort::usage = "WordSort[L]  sorts a list L of words in length-lex order: first by length, then lexicographically. ";
WordSuffixQ::usage = "WordSuffixQ[x,y]  tests whether word x is a suffix of word y.";
WordSuffixes::usage = "WordSuffixes[w]  generates all suffixes of word w, in length order. ";
$bottom::usage = "$bottom   is the default object used for the trap state added to machines by CompleteFA. ";
$defaultnormalize::usage = "$defaultnormalize  is the default value used for all commands with option Normalize.";
AcceptQFA::usage = "AcceptQFA[M,w]  tests whether machine M accepts input w. ";
AccessibleFA::usage = "AccessibleFA[M]  constructs the accessible part of a FSM M. ";
AddTransitionFA::usage = "AddTransitionFA[M,p,w,q]  adds the transition {p,w,q} to M. ";
AllDFA::usage = "AllDFA[K]  constructs a DFA that accepts all words over alphabet K.";
AmbiguousQFA::usage = "AmbiguousQFA[M,opts]  tests whether FSM M  is ambiguous. ";
BEFA::usage = "BEFA[n,T]  denotes a begin-exit automaton, a special type of nondeterminisitc automaton that has exactly one initial state (begin) and one final state (exit). ";
BEFAToFA::usage = "BEFAToFA[M]  converts BEFA M  into an FA.";
BehaviorFA::usage = "BehaviorFA[M,p]  constructs the minimal DFA whose acceptance language is the behavior of state p in automaton M.";
Boundary::usage = "Boundary  is an option for ToBlocks. ";
BuildBEFA::usage = "BuildBEFA[w]  constructs a BEFA (begin/exit automaton) that accepts exactly the word w.";
BuildDFA::usage = "BuildDFA[w1,..,ws,K]  constructs the minimal DFA for the finite language consisting of the given words, over alphabet K. ";
BuildNNFA::usage = "BuildNNFA[w]  constructs a NNFA that accepts exactly the word w (returns only the tail of the automaton).";
BuildStarDFA::usage = "BuildStarDFA[w]  builds a DFA for the language of all words consisting of any number of repetitions of given word w.";
CirculantSA::usage = "CirculantSA[n,dd,lab,K]  constructs a semiautomaton whose transition diagram is a circulant graph and whose transitions are given by the list lab.";
CoAccessibleFA::usage = "CoAccessibleFA[M]  returns the coaccessible part of a finite state machine M. ";
ComplementFA::usage = "ComplementFA[M]  generates a DFA that accepts the complement of the acceptance language of machine M. ";
CompleteFA::usage = "CompleteFA[M]  adds a sink to M if necessary to produce a complete automaton.";
CompleteQFA::usage = "CompleteQFA[M]  tests whether the finite state machine M is complete.";
ComputationFA::usage = "ComputationFA[M,w,opts]  determines all computations of machine  M  on an input word  w  (starting at an initial state).";
ComputationGraphFA::usage = "ComputationGraphFA[M,w]  produces the unfolding of the finite state machine M with respect to input word w. ";
ConcatenateFA::usage = "ConcatenateFA[M1,M2]  generates a machine that accepts the concatenation of the acceptance languages of M1 and M2. ";
ConvertToFA::usage = "ConvertToFA[H,Q,K,A,I,F]  generates a machine with head H, states Q, alphabet K, transitions A, initial/final states I/F. ";
CounterDFA::usage = "CounterDFA[a,r,K]  constructs a DFA for the language of all words w over alphabet K that contain exactly r many a's. ";
CoverQDFA::usage = "CoverQDFA[M1,M2,opts]  tests whether DFA M1 covers DFA M2.";
DefiniteQFA::usage = "DefiniteQFA[M]  tests wether M  is definite, i.e., whether for all sufficiently long words w computations on w always end at the same state, regardless of the starting state. 
";
DegreesFA::usage = "DegreesFA[M]  returns a K by Q matrix of integers where entry (p,a) is the number of transitions with source p and label a.";
DeleteStateFA::usage = "DeleteStateFA[M,p]  removes state p from machine M.";
DeterministicQFA::usage = "DeterministicQFA[M]  tests whether machine M is deterministic.";
DFA::usage = "DFA[n,k,T,q0,F]  denotes a deterministic complete finite automaton. ";
DivisibilityDFA::usage = "DivisibilityDFA[m,B,opts]  produces the minimal DFA recognizing all numbers in base B that are divisible by m. ";
EdgeLU::usage = "EdgeLU  is an option for LocalUniversalFA.";
EmptyDFA::usage = "EmptyDFA[K]  constructs a DFA that accepts the empty language over alphabet K.";
EmptyQFA::usage = "EmptyQFA[M]  tests whether the acceptance language of M is empty.";
EpsElim::usage = "EpsElim  is an option for StarFA and RegularExpressionToFA. ";
EpsilonFreeQ::usage = "EpsilonFreeQ[M]  tests whether a machine is epsilon-free.";
EpsilonEliminationFA::usage = "EpsilonEliminationFA[M]  converts a machine M into an equivalent epsilon-free machine. ";
EquivalentQFA::usage = "EquivalentQFA[M1,M2]  tests whether automata M1 and M2 are equivalent. ";
FactorialQFA::usage = "FactorialQFA[M,opts]  tests whether the language accepted by FSM M is factorial, i.e., closed under factors.";
FA::usage = "FA[n,k,T,I,F]  denotes a general finite automaton. ";
FinalVectorFA::usage = "FinalVectorFA[M] returns the bitvector representing the  final states of M.";
Final::usage = "Final[M]  returns a list of the final states of finite state machine M in positional notation.";
FiniteComplementSA::usage = "FiniteComplementSA[W,K]  returns the canonical semiautomaton that accepts the language of all words not containing any word in the finite language W as a factor. ";
FinLU::usage = "FinLU  is an option for LocalUniversalFA.";
Fixed::usage = "Fixed  is an option for ToBlocks.";
BoundLFA::usage = "BoundLFA  is an option for LanguageFA.";
FrontierToDFA::usage = "FrontierToDFA[g,F]  converts frontier automaton given by g and F  into an ordinary DFA.  ";
FSMQ::usage = "FSMQ[M]  tests whether M is a finite state machine.";
FullQFA::usage = "EmptyQFA[M]  tests whether the acceptance language of M is empty ";
FullTransitionMatrixFA::usage = "FullTransitionMatrixFA[M]  returns the transitions of a machine expressed as a matrix over a semiring  (integers, Boolean, or tropical).";
FullTransitions::usage = "FullTransitions[M]  returns a list of the transitionsa finite state machine M.";
FunctionToDFA::usage = "FunctionToDFA[Q,K,del,q0,F,opts]  returns the DFA determined by Q, K, del, q0 and F. ";
FunctionToSA::usage = "FunctionToSA[Q,K,del]  returns the semiautomaton determined by Q,  K,  and  del. ";
GenerateDFA::usage = "GenerateDFA[q0,dot,K,fin]  produces the cyclic semimodule generated by q0 and operation dot, as well as the corresponding accessible DFA.  ";
GenerateQuotients::usage = "GenerateQuotients[L,K]  computes all quotients of a finite language L  over alphabet K .";
GrowthSeriesDFA::usage = "GrowthSeriesDFA[M,x]  returns the rational function in variable x that represents the generating function for the growth sequence of DFA M.";
HomomorphismFA::usage = "HomomorphismFA[M,h,K]  generates an FA that accepts the image of the acceptance language of M under homomorphism h. ";
Hopcroft::usage = "Hopcroft  is an option for StateMergeDFA.";
HurwitzProduct::usage = "HurwitzProduct[S1,S2]  computes the Hurwitz product of two formal power series.";
IdealBaseFA::usage = "IdealBaseFA[M]  constructs a DFA for the ideal base of the language of M.";
IdealQFA::usage = "IdealQFA[M]  tests whether the language of M forms an ideal. ";
Implementation::usage = "Implementation Implementation is an option for LanguageFA. ";
InfiniteQFA::usage = "InfiniteQFA[M]  tests whether the acceptance language of M is infinite.";
IniLU::usage = "IniLU  is an option for LocalUniversalFA.";
InitialVectorFA::usage = "InitialVectorFA[M]   returns the bitvector representing the  initial states of M.";
Initial::usage = "Initial[M]  returns a list of the initial states of finite state machine M in positional notation.";
IntersectionFA::usage = "IntersectionFA[M1,M2]  generates a finite state machine that accepts the intersection of the acceptance languages of M1 and M2. ";
IrreducibleFA::usage = "IrreducibleFA[W,K]  returns the canonical tree automaton that accepts all words not containg a factor w from the the list W. ";
IsomorphicQDFA::usage = "IsomorphicQDFA[M1,M2]  tests whether two DFAs M1 and M2 are isomorphic. ";
IthSymbolFA::usage = "IthSymbolFA[a,i,K]  constructs an FA for the language of all words whose whose i-th symbol is a (over alphabet K).";
JoinSA::usage = "JoinSA[M1,M2,A]  determines the join of two semiautomata according to overlap list A.";
LanguageFA::usage = "LanguageFA[M,n]  displays all words of length n accepted by machine M.";
LanguageSort::usage = "LanguageSort[LL]  sorts a list LL of finite languages in natural order, also sorts the languages";
LanguageToSeries::usage = "LanguageToSeries[L]  adds multiplicities 1 to a language L. ";
LeftQuotient::usage = "LeftQuotient[w,L]  computes the left quotient of a finite language L with respect to word w.";
LengthDFA::usage = "LengthDFA[n,K]  constructs a DFA for the language of all words over alphabet K of length n. ";
LocalQSA::usage = "LocalQSA[M,opts]  tests whether the semiautomaton  M  is local.";
LocalUniversalFA::usage = "LocalUniversalFA[n,k,opts]  generates the n-local-universal FA over a k letter alphabet.";
LoopAutomatonFA::usage = "LoopAutomatonFA[M]  converts DFA M into a loop automaton. ";
MakeHomomorphismDFA::usage = "MakeHomomorphismDFA[h,M1,M2]  attempts to construct a homomorphism from M1 to M2, and assigns it to symbol h. ";
MakeHomomorphism::usage = "MakeHomomorphism[f,A,B]  assigns the monoid homomorphism on words given by A and B to symbol f. ";
MakeTrim::usage = "MakeTrim MakeTrim is an option for LanguageFA. ";
MatrixToTransitions::usage = "MatrixToTransitions[M]  converts a transition matrix of DFA or NFA  M  into the corresponding list of transitions.";
MinimalFischerFA::usage = "MinimalFischerFA[M]  returns the minimal Fischer automaton associated with semiautomaton M. ";
MinimizeDFA::usage = "MinimizeDFA[M]  computes the minimal automaton of a DFA M. ";
MinimizeFA::usage = "MinimizeFA[M,opts]  computes the minimal automaton of a finite state machine M, using the external code whenever possible. ";
NFA::usage = "NFA[n,k,A,I,F]  denotes a non-deterministic finite automaton. ";
NNFAToFA::usage = "NNFAToFA[M]  converts the tail M of an NNFA into the corresponding FA.";
NNFA::usage = "NNFA[n,E,L,I,F,e]  denotes the tail of a McNaughton-Yamada type finite automaton. ";
Normalize::usage = "Normalize is an option for numerous commands in Automata.";
NormalizeControl::usage = "NormalizeControl[]  turns off normalization for finite state machines. ";
NormalizeFA::usage = "NormalizeFA[M]  normalizes finite state machine M.";
NumberOfDFA::usage = "NumberOfDFA[n,k]  computes the number of DFAs on n states and k symbols.";
NumTransitions::usage = "NumTransitions[M]  returns the number of transitions in machine M.";
PermutationSA::usage = "PermutationSA[perm,K]  constructs a semiautomaton from the list of permutations perm over alphabet K.";
PermuteFA::usage = "PermuteFA[M,perm]  permutes the states of FSM M according to permutation perm. ";
PrintFA::usage = "PrintFA[M]  pretty prints a finite state machine M. ";
ProductFA::usage = "ProductFA[M1,M2]  computes the product automaton of M1 and M2. ";
ProductTransitions::usage = "ProductTransitions[T1,T2,k]  computes the product of transition lists T1 and T2 over an alphabet of size k. ";
QuotientDFA::usage = "QuotientDFA[L,K]  computes the quotient automaton of a finite language L  over alphabet K.";
QuotientMachineFA::usage = "QuotientMachineFA[M1,M2]  computes an FA for the language of all words y such that there is a word x accepted by M1 such that M2 accepts xy.";
RandomDFA::usage = "RandomDFA[n,k]  produces a random DFA over alphabet K on n states. ";
RankOfDFA::usage = "RankOfDFA[M]  computes the rank of the DFA M  with respect to a canonical enumeration.";
RankToDFA::usage = "RankToDFA[r,n,k]  computes the DFA of rank r on n states and k symbols with respect to a canonical enumeration.";
DeleteTransitionFA::usage = "DeleteTransitionFA[M,p,w,q] removes the transition (p,w,q)   from M. Here w may be a symbol or an integer. ";
ReverseFA::usage = "ReverseFA[M]  reverses a FSM M by flipping transitions and interchanging initial and final states. ";
SA::usage = "SA[n,k,T]  denotes a semiautomaton. ";
SelectFA::usage = "SelectFA[M,L]  computes the subautomaton of M induced by the states in L.";
SetAlphabet::usage = "SetAlphabet[M,K]  is a mutating operation that sets the alphabet of M to K.";
SetFinalFA::usage = "SetFinalFA[m,F]  returns a FSM  M  with final states changed to  F. ";
SetInitialFA::usage = "SetInitialFinalFA[m,I]  returns FSM M with initial states changed to I.";
SetInitialFinalFA::usage = "SetInitialFinalFA[m,I,F]  returns FSM M with initial states changed to I and final states changed to F. ";
SetStates::usage = "SetStates[M,Q]  is a mutating operation that sets the states of M to Q.";
ShowAll::usage = "ShowAll   is an option for PlotComputationFA, ";
ShowEdges::usage = "ShowEdges  is an option for PlotComputationFA,";
ShuffleProductFA::usage = "ShuffleProductFA[M1,M2]  generates a finite state machine that accepts the shuffle product of the acceptance languages of FSMs M1 and M2.";
SinkQDFA::usage = "SinkQDFA[M] tests whether DFA  M  is a sink automaton.";
SizeOnly::usage = "SizeOnly  is an option in RegularExpressionToFA";
Size::usage = "Size[M]  returns the number of states of machine M.";
Some::usage = "Some  is an option for FormatAutomata.";
SquareSA::usage = "SquareSA[M]  computes the product semiautomaton of semiautomaton M with itself. ";
StarFA::usage = "StarFA[M]  generates a FA that accepts the Kleene star of the acceptance languages of M. ";
StateMergeDFA::usage = "StateMergeDFA[M,R]  performs state-merging on a DFA M according to the equivalence relation represented by list R. ";
States::usage = "States[M]  returns the state set of finite state machine M ";
SubsetQFA::usage = "SubsetQFA[M1,M2]  tests whether the acceptance language of M1 is a subset of the acceptance language of M2. ";
SubwordCounterDFA::usage = "SubwordCounterDFA[w,p,K,opts]  constructs a DFA that accepts all words x such that  WordBinomial[x,w] == p  over alphabet K. ";
SubwordDFA::usage = "SubwordDFA[w,K]  constructs a DFA that accepts all words that contain subword w  over alphabet K.";
SumFA::usage = "SumFA[M1,M2]  computes the disjoint sum of two machines M1 and M2. ";
SwitchTransitionFA::usage = "SwitchTransitionFA[M,p,q]  switches the transition {p,w,q} in M to {p,w+1,q}. ";
TheInitial::usage = "TheInitial[M]  returns the initial state of a DFA  M  in positional notation.";
Thompson::usage = "Thompson  is an option in RegularExpressionToFA. ";
ToCharacters::usage = "ToCharacters[w]  converts symbols and strings to a list of atomic characters ";
ToDFA::usage = "ToDFA[M]  converts a finite state machine into an equivalent DFA. ";
ToEquationsDFA::usage = "ToEquationsDFA[M]  converts DFA M  into a system of equations.";
ToFA::usage = "ToFA[M]  converts a FSM  M  to an equivalent FA. ";
ToFactorFA::usage = "ToFactorFA[M]  converts a FSM M  into a machine that accepts the language of all factors of words in the language of M.";
ToFrontierDFA::usage = "ToFrontierDFA[M]  converts DFA M  into the corresponding frontier automaton (g,F).";
ToGeneratorsFA::usage = "ToGeneratorsFA[M]  converts the transition matrix of a DFA into a list of generators for the transition semigroup of the machine.";
ToGraphFA::usage = "ToGraphFA[M]  converts a finites state machine M into the underlying transition diagram: a directed graph with point set Q. ";
ToKernelFA::usage = "ToKernelFA[M,L,opts]  generates the kernel automaton of M  generated from the states in list L. ";
ToMatrix::usage = "ToMatrix  is an option for ConvertToFA. ";
ToNFA::usage = "ToNFA[M]  converts FSM M to an equivalent NFA.";
ToRegularExpressionFA::usage = "ToRegularExpressionFA[M]  uses Kleene's algorithm to convert an FA into an equivalent regular expression. ";
ToSA::usage = "ToSA[M]  converts any finite state machine to the corresponding semiautomaton. ";
ToSeries::usage = "ToSeries[L]  converts a list L with multiplicities into a formal power series of words with integer coefficients. ";
ToTransitions::usage = "ToTransitions[T,K]  translates a list of transitions with string labels into a proper transition list in positional notation with respect to alphabet K.";
TransferSequenceFA::usage = "TransferSequenceFA[M,S,T]  computes a least word in length-lex order  that leads to state t from state s in machine M, if such a word exists, for all pairs (s,t) with s in S, t in T.";
TransitionFunctionFA::usage = "TransitionFunctionFA[M,delta]  assigns to delta the transition function of machine M.";
TransitionMatrixFA::usage = "TransitionMatrixFA[M,f]  assigns to f the natural homomorphism from all words to matrices over the natural numbers given by machine M.";
TransitionsToMatrix::usage = "TransitionsToMatrix[n,k,T]  converts a list of transitions T into the corresponding k by n matrix, where k is the alphabet size and n the number of states. ";
Transitions::usage = "Transitions[M]  returns the transition matrix (for DFAs) or transitions list (for all others), where M is a finite state machine. ";
TransitiveLanguageQFA::usage = "TransitiveLanguageQFA[M]  tests whether the language accepted by M is transitive. ";
TransitiveQFA::usage = "TransitiveQFA[M,opts]  tests whether M is transitive. ";
TransOnly::usage = "TransOnly  is an option for PrintFA, ";
TrapStatesFA::usage = "TrapStatesFA[M]  returns all the trap states of machine M.";
TrimFA::usage = "TrimFA[M]  constructs the trim part of FA M: only states that are accessible from the initial states and coaccessible from the final states are retained.";
TropicalIdentityMatrix::usage = "TropicalIdentityMatrix[n]  generates the n by n identity matrix in the tropical semiring. ";
Tropical::usage = "Tropical  is an option for TransitionMatrixFA, ";
TS::usage = "TS[x]  denotes an element in the tropical semiring; x is a non-negative integer or Infinity. ";
UnionFA::usage = "UnionFA[M1,M2]  generates a finite state machine that accepts the union of the acceptance languages of M1 and M2. ";
Unlabeled::usage = "Unlabeled   is an option for ToGraphFA, causes an unlabeled graph to be generated.";
VerifyFA::usage = "VerifyFA[M]  checks if M is properly constructed. Recommended if a machine is constructed 'by hand'. ";
WordToFA::usage = "WordToFA[w]  constructs a machine that accepts all factors of word w.  ";
$regexrules::usage = "$regexrules   is a set of simplification rules for regular expressions. ";
ArdenSolve::usage = "ArdenSolve[eq]  solves a linear equation eq over the language semiring using Arden's lemma. The second component of the resulting equation is a rational expression, possibly containing additional variables. ";
Empty::usage = "Empty  is a regular expression that denotes the empty set.";
FormatX::usage = "FormatX[True] formats X so X[i] prints in subscript notation. ";
REEpsQ::usage = "REEpsQ[reg]  tests whether the language denoted by regular expression reg contains epsilon. ";
RegExpSimp::usage = "RegExpSimp  is an option for ToRegularExpressionFA. ";
RegularExpressionToBEFA::usage = "RegularExpressionToBEFA[exp]  computes the BEFA for regular expression exp.";
RegularExpressionToFA::usage = "RegularExpressionToFA[exp,K]  computes an FA for regular expression exp over alphabet K. ";
RegularExpressionToNNFA::usage = "RegularExpressionToNNFA[exp]  computes the NNFA for regular expression exp.";
REP::usage = "REP  is a header for regular expressions, denotes union.";
REQuotient::usage = "REQuotient[w,exp]  computes the left quotient of the given rational expression exp by the word w.";
RES::usage = "RES  is a header for regular expressions, denotes Kleene star.";
RESimplify::usage = "RESimplify[exp]  tries to simplify the regular expression exp using the rules defined in $regexrules.";
RET::usage = "RET  is a header for regular expressions, denotes concatenation.";
SubstituteRE::usage = "SubstituteRE[eq1,eq2]  substitutes a linear equation eq2 over the language semiring into eq1. ";
ToRegExp::usage = "ToRegExp[reg]  converts an expression containing arithmetic operators +  and ** (Plus and NonCommutativeMultiply) into the corresponding regular expression containing only headers REP, RET and RES. ";
BFunctionToCA::usage = "BFunctionToCA[f,w]  constructs a CA of width w over alphabet {0,1} whose local map is given by f, a Boolean expression in variables x1, x2, ... ";
CA::usage = "CA[w,k,r]  denotes a linear cellular automaton with width w, alphabet k and local rule given by the rule number r. ";
ClassifyCA::usage = "ClassifyCA[C] classifies a cellular automaton C according to properties of the global map. The algorithm distinguishes between injective, open, and surjective global maps.";
ComposeCA::usage = "ComposeCA[C1,C2]  composes cellular automata C1 and C2 .  The cellular automata are assumed to be over the same alphabet.";
Cyclic::usage = "Cyclic  is a possible value for option Boundary in ToBlocks and various operations on cellular automata.";
EvolutionCA::usage = "EvolutionCA[C,X,t,opts]  plots t steps in the evolution of pattern X under the global map of cellular automaton C. ";
DependencyCA::usage = "DependencyCA[C]  returns a list of the indices of the variables upon which the local map of cellular automaton C depends. ";
FSurjectiveCA::usage = "FSurjectiveCA[C]  tests whether a given surjective CA C  is  surjective on all finite configurations.";
FunctionToCA::usage = "FunctionToCA[f,w,k]  constructs a cellular automaton of width w over the digit alphabet of size k whose local map is given by f.";
GlobalMapCA::usage = "GlobalMapCA[f,C]  assigns the global map of cellular automaton C to symbol f. Valid input for f is a  list of integers in the appropriate range.";
InverseCA::usage = "InverseCA[C]  computes the inverse of a reversible cellular automaton C.";
IterateCA::usage = "IterateCA[C,t]  returns the cellular automaton corresponding to iterating C  t-times. ";
LocalMapCA::usage = "LocalMapCA[f,C]  assigns the local map of cellular automaton C to symbol f. ";
NumberOfCA::usage = "NumberOfCA[w,k]  returnes the number of cellular automata of width w and and alphabet of size k. ";
NumberOfTotalisticCA::usage = "NumberOfTotalisticCA[w,K]  determinces the number of totalistic cellular automata of width w and and alphabet of size k. ";
OrbitCA::usage = "OrbitCA[C,pat,t,opts]  computes the orbit of pattern pat under application of the global map of cellular automaton C  up to time t. ";
Padding::usage = "Padding is an option for SeedConfiguration that controls the pattern used to fill in the configuration.";
PolynomialToCA::usage = "PolynomialToCA[pol,w,k]  constructs a CA of width w over the digit alphabet of size k whose local map is given by the polynomial pol. ";
PrintCA::usage = "PrintCA[C]  pretty-prints the local function of cellular automaton  C  as a table of replacement rules.";
RuleCA::usage = "RuleCA[C]  returns the rule number of a cellular automaton C.";
RulesToCA::usage = "RulesToCA[rw,w,Q]  constructs a cellular automaton of width w over the alphabet Q whose local map is determined by a collection rw of rewrite rules.";
SeedConfiguration::usage = "SeedConfiguration[{w},n]  produces a seed configuration of length n with w at the center. ";
SimplifyCA::usage = "SimplifyCA[C]  eliminates the initial and final segment of variables that are superfluous in the local rule of cellular automaton C,  if any. ";
ToRulesCA::usage = "ToRulesCA[C]  returns  a list of Mathematica replacement rules corresponding to the local map of cellular automaton C.";
TotalisticRuleToCA::usage = "TotalisticRuleToCA[w,k,r]  produces the ordinary CA with totalistic rule number r and width w. ";
ToTotalisticRuleCA::usage = "ToTotalisticRuleCA[C]  determines the totalistic rule number r of a given CA C. ";
WelchCA::usage = "WelchCA[C]  computes the Welch indices of a surjective cellular automaton C. ";
Where::usage = "Where is an option for SeedConfiguration that controls positioning of the seed pattern. ";
WidthCA::usage = "WidthCA[C]  returns the width of a cellular automaton C.";
WordMap::usage = "WordMap  is an option for an number of functions dealing with cellular automata.";
AddEdge::usage = "AddEdge[G,e]  adds edge e to graph G. ";
AddVertex::usage = "AddVertex[G]  adds a new vertex to graph G. ";
BiAccessibleGraph::usage = "BiAccessibleGraph[G,S,T]  constructs the subgraph of G induced by the vertices reachable from S and coreachable from T.";
AccessibleGraph::usage = "AccessibleGraph[G,A]  constructs the subgraph of G induced by the vertices reachable from set A.  AccessibleGraph uses the function WeaklyConnectedComponents.";
CirculantGraph::usage = "CirculantGraph[n,{d1,...,dr}]  generates the circulant graph on n nodes with strides given by the d-list.";
CyclicQGraph::usage = "CyclicQGraph[G]  tests whether graph G is cyclic.";
DeBruijnEdges::usage = "DeBruijnEdges[w,K]  generates an edge list for the de Bruijn graph of width w over alphabet K.";
DeBruijnGraph::usage = "DeBruijnGraph[w,K]  generates the de Bruijn graph of width w over alphabet K.";
DegreeGraph::usage = "DegreeGraph[G,v]  returns the degree of vertex v in graph G. ";
DeleteEdge::usage = "DeleteEdge[G,e]  removes edge e from graph G. ";
DeleteVertex::usage = "DeleteVertex[G,x]  removes vertex x from graph G. ";
EdgeQ::usage = "EdgeQ[G,x,y]  tests whether the directed edge  (x,y)  is present in graph G.";
Edges::usage = "Edges[G]  returns the edges of a graph G";
Graph::usage = "Graph[n,e,t,A]  represents a directed graph on n nodes and e edges with adjacencies given by A. Field t indicates the type of the graph. ";
GridGraph::usage = "GridGraph[n,m,opts]  constructs a directed grid graph on n by m nodes.";
LabelEdgeList::usage = "LabelEdgeList[E,lab]  inserts labels into the edge list E of a graph.";
LongestPath::usage = "LongestPath[G]  determines the length of a longest path in an acyclic graph G. ";
NormalizeGraph::usage = "NormalizeGraph[M]  normalizes graph G to have vertex set [n].";
NonTransientGraph::usage = "NonTransientGraph[G]  returns the non-transient part of the collapse of G.";
NonTrivial::usage = "NonTrivial  is an option for command StronglyConnectedComponents. ";
NumEdges::usage = "NumEdges[G]  returns the number of edges of a graph G.";
NumVertices::usage = "NumVertices[G]  returns the number of vertices of a graph G.";
PathGraph::usage = "PathGraph[n]  generates a path of length n in edge-list form. ";
PermuteGraph::usage = "PermuteGraph[G,p]  applies isomorphism p to G. ";
ProductGraph::usage = "ProductGraph[G1,G2]  computes the Cartesian product of two  graphs G1 and G2.";
ProductLabeledGraph::usage = "ProductLabeledGraph[G1,G2]  computes the product of two labeled graphs G1 and G2.";
ReverseGraph::usage = "ReverseGraph[G]  reverses all edges in a graph G.";
SetVertices::usage = "SetVertices[G,V]  is a mutating operation that sets the vertex set of G to V.";
ShortestPath::usage = "ShortestPath[G,s]  constructs a shortest path from source vertex s in graph G to all vertices reachable from s.";
StronglyConnectedComponents::usage = "StronglyConnectedComponents[G]  computes the strongly connected components of graph G using a linear algorithm. ";
SubGraph::usage = "SubGraph[G,L]  constructs the subgraph of G induced by vertex set L. ";
ToAdjacencyList::usage = "ToAdjacencyList[G]  converts a graph G into adjacency list form.";
ToAdjacencyMatrix::usage = "ToAdjacencyMatrix[G]  converts a graph G  into adjacency matrix form.";
ToDirectedAcyclicGraph::usage = "ToDirectedAcyclicGraph[G]  computes the directed acyclic graph obtained from G by collapsing its strongly connected components into points and preserving edges between these points.";
ToEdgeList::usage = "ToEdgeList[G]  converts a graph G into edge list form.";
ToTDGraph::usage = "ToTDGraph[{RR},m]  converts a sequence of relations RR to a time dependent graph over ground set m.";
TypeGraph::usage = "TypeGraph[G]  returns the type of a graph G.";
VertexSet::usage = "VertexSet[G]  returns the vertex set of a graph G.";
WeaklyConnectedComponents::usage = "WeaklyConnectedComponents[G,X]  computes the weakly connected component of vertex set X in graph G. ";
$generateSGBound::usage = "$generateSGBound  is a default bound for the size of a semigroup generated  by GenerateSG. ";
$identitystring::usage = "$identitystring   denotes the identity element of a monoid in rewrite rules produced by GenerateSG.";
$nullstring::usage = "$nullstring   denotes the null element of a semigroup in rewrite rules produced by GenerateSG. ";
AllTimes::usage = "AllTimes[L1,L2]  computes all products between elements in L1 and L2 using NonCommutativeMultiply.";
AlternatingGroupSG::usage = "AlternatingGroupSG[n]  returns the alternating group on n elements. The group is returned as a semigroup object. ";
AperiodicQSG::usage = "AperiodicQSG[S]  determines whether semigroup S is aperiodic. ";
AperiodicSG::usage = "AperiodicSG[S]  returns the aperiodic elements of semigroup S.";
BlocksToDClass::usage = "BlocksToDClass[db,S]  converts a D-class in semigroup S from block representation to multiplier representation.";
BoundCSM::usage = "BoundCSM  is an option for GenerateCSM, limits the size of the generated cyclic semimodule. ";
BoundGSG::usage = "BoundGSG  is an option that controls the size of a semigroup generated by GenerateSG. ";
CollapseT::usage = "CollapseT[t]  produces the image transformation associated with transformation t. ";
ConstantT::usage = "ConstantT[k,n]  returns the constant transformation T[k,...,k] of length n.";
CycleDecompositionT::usage = "CycleDecompositionT[t]  returns the cycle decomposition of a permutation t. ";
CycleToT::usage = "CycleToT[cycles,n]  converts a cycle decomposition to a permutation, given as a transformation.";
DC::usage = "DC[L,R,H]  is an expression denoting a D-class in a transformation semigroup. ";
DClasses::usage = "DClasses  is an option for GenerateSG.";
DClassDecomposition::usage = "DClassDecomposition[S]  generates a list of all regular D-classes of semigroup S. ";
DClassSize::usage = "DClassSize[dc]  returns the size of D-class dc. ";
DClassT::usage = "DClassT[x,S]  determines the D-class of a regular element x in a semigroup S. ";
DClassToBlocks::usage = "DClassToBlocks[dc]  converts a D-class in standard form into a matrix of H-classes (a tensor of rank 3).";
DihedralGroupSG::usage = "DihedralGroupSG[n]  returns the dihedral group on n points. ";
GEN::usage = "GEN[n,k,{g1,...,gk}]  is a collection of k generators, suitable as input to GenerateSG. ";
GenerateCSM::usage = "GenerateCSM[q0,dot,K,opts]  produces the cyclic right semimodule generated by q0 and operation dot, a right action of the monoid of words over K.";
GenerateCayleyGraph::usage = "GenerateCayleyGraph[q0,dot,K,opts]  produces the Cayley graph for the right semimodule generated by q0 and operation dot, a right action of the monoid of words over K.";
GenerateSG::usage = "GenerateSG[gen]  produces the semigroup generated by the generators gen.  ";
GreenHQT::usage = "GreenRQT[x,y,S]  tests whether transformations x and y are J-equivalent in semigroup S.";
GreenJQT::usage = "GreenRQT[x,y,S]  tests whether transformations x and y are J-equivalent in semigroup S.";
GreenLQT::usage = "GreenRQT[x,y,S]  tests whether transformations x and y are L-equivalent in semigroup S.";
GreenRQT::usage = "GreenRQT[x,y,S]  tests whether transformations x and y are R-equivalent in semigroup S.";
HClassSize::usage = "HClassSize[dc]  returns the size of the H-classes of D-class dc.";
HClassT::usage = "HClassT[x,S]  returns the H-class of a regular element x in semigroup S.";
HTrivialQSG::usage = "HTrivialQSG[S]  tests whether semigroup S is H-trivial.";
IdealT::usage = "IdealT[x,S]  computes the two-sided ideal generated by transformation x in semigroup S.";
IdemSG::usage = "IdemSG[S]  lists the idempotent elements of a semigroup S.";
ImageT::usage = "ImageT[t]  gives the range of transformation t as an ordered list.";
InGroupSG::usage = "InGroupSG[S]  produces all elements in semigroup S that belong to a subgroup of S.";
InverseT::usage = "InverseT[x]  computes the inverse of a transformation x.";
JTrivialQSG::usage = "JTrivialQSG[S]  tests whether semigroup S is J-trivial";
JTrivialSG::usage = "JTrivialSG[n]  generates the J-trivial semigroup of all order preserving inflationary transformations. ";
KernelImageToT::usage = "KernelImageToT[ker,im]  reconstructs a transformation given its range and kernel. ";
KernelT::usage = "KernelT[t]  gives the kernel of transformation t.";
LeftIdealT::usage = "LeftIdealT[x,S]  computes the left ideal generated by transformation x in semigroup S.";
LeftNullSG::usage = "LeftNullSG[S]  lists the left nulls of a semigroup S.";
LeftOneSG::usage = "LeftOneSG[S]  lists the left identities of a semigroup S.";
LocallyCommutativeQSG::usage = "LocallyCommutativeQSG[S]  tests if semigroup S is locally commutative";
LocallyIdempotentQSG::usage = "LocallyIdempotentQSG[S]  tests if semigroup S is locally idempotent.";
Merge12T::usage = "Merge12T[n]  returns the transformation T[1,1,3,..,n].";
MakeMonoidSG::usage = "MakeMonoidSG[S]  turns semigroup S into a monoid by adjoining a unit, if necessary.";
MonoidQSG::usage = "MonoidQSG[S]  tests whether semigroup S is a monoid.";
NilpotentQSG::usage = "NilpotentQSG[S]  tests whether semigroup S is nilpotent, i.e., whether null is the only idempotent element.";
NullSG::usage = "NullSG[S]  lists the null element of a semigroup S, if it exists.";
OneSG::usage = "OneSG[S]  lists the identity of a semigroup S, if it exists.";
OneT::usage = "OneT[t]  produces the identity transformation of size Length[t] where t is any transformation. ";
OrderT::usage = "OrderT[x]  returns the order of a permutation x.";
PrintDClass::usage = "PrintDClass[dc]  pretty prints a D-class dc.";
PrintEquations::usage = "PrintEquations[eq]  pretty prints a list of equations in word form. ";
PrintWitnesses::usage = "PrintWitnesses[S,wit]  prints a table of witnesses and semigroup elements for semigroup S. ";
RegularSG::usage = "RegularSG[S]  returns the regular elements in semigroup S.";
RandomT::usage = "RandomT[n]  generates a random transformation on [n]. ";
RankT::usage = "RankT[t]  gives the rank of transformation t, i.e., the cardinality of its image and kernel.";
RegularOnly::usage = "RegularOnly  is an option for command DClassDecomposition. ";
RightIdealT::usage = "RightIdealT[x,T]  computes the right ideal generated by transformation x in semigroup S.";
RightNullSG::usage = "LeftNullSG[S]  lists the right nulls of a semigroup S.";
RightOneSG::usage = "RightOneSG[S]  lists the right identities of a semigroup S.";
ShiftT::usage = "ShiftT[n]  returns the right shift transformation T[n,1,2,..,n-1].";
SG::usage = "SG  is a header used for transformation semigroups.";
SolveSG::usage = "SolveSG[a,b,S]  returns a list of all solutions of equation  a**x = b  in a transformation semigroup S.";
SymmetricGroupSG::usage = "SymmetricGroupSG[n]  returns the symmetric group on n points.";
SyntacticCongruence::usage = "SyntacticCongruence[M,r]  determines the syntactic congruence classes of all words of length r. ";
SyntacticHomomorphism::usage = "SyntacticHomomorphism[f,M]  assigns the syntactic homomorphism to symbol f. ";
SyntacticSG::usage = "SyntacticSG[M]  generates the transition semigroup of M. ";
T::usage = "T[a1,...,ak]  denotes an element in a transformation semigroup";
TableSG::usage = "TableSG[S,W]  prints the multiplication table of semigroup S using witnesses W.";
ToIdentityString::usage = "ToIdentityString[x]  replaces all occurrences of the empty string in x by $identitystring.";
TransformationSG::usage = "TransformationSG[n]  returns the transformation semigroup on n points. ";
TransientPeriodicT::usage = "TransientPeriodicT[x]  returns the length of the transient and periodic part of the semigroup generated by transformation x. ";
TranspositionT::usage = "TranspositionT[n,i]  returns the transposition (i,i+1)  as a transformation on n.";
UnitElement::usage = "UnitElement[x]  returns the unit element in the monoid to which x naturally belongs. ";
$rewriteSimpBound::usage = "$rewriteSimpBound  is a default bound for the number of transformation steps taken in the normalization algorithm for rewrite systems. ";
AllStringReplace::usage = "AllStringReplace[eq][w]  generates all words obtainable from word w by applying the rewrite equations in eq once.";
BoundETW::usage = "BoundETW  is an option for EquationsToWitnesses. ";
BoundWR::usage = "BoundWR  is an upper bound for the number of reduction steps in WordReduce. ";
Cols::usage = "Cols  is an option PrintEquations.";
EquationsToWitnesses::usage = "EquationsToWitnesses[eq,K]  generates witnesses for the semigroup on generators K with defining relationes given by eq, a rewrite system. ";
Equations::usage = "Equations  is an option for various functions.";
FromIdentityString::usage = "FromIdentityString[x]  replaces all occurences of $identitystring in x by the empty string.";
IrreducibleQ::usage = "IrreducibleQ[w,eq]  test is word w is irreducible with respect to the rewrite system eq. ";
PairsToRules::usage = "PairsToRules[rw]  replaces word pairs by rules.";
RulesToPairs::usage = "RulesToPairs[rw]  replaces rewrite rules by word pairs.";
SimplifyEquations::usage = "SimplifyEquations[S,wit,eq]  simplifies the rewrite system associated with a semigroup produces by GenerateSG.";
SimplifyRewriteSystem::usage = "SimplifyRewriteSystem[eq]  normalizes a rewrite system given by the directed equations eq. ";
WordReduce::usage = "WordReduce[w,eq,opt]  reduces word w according to equations eq. ";
BooleanComplement::usage = "BooleanComplement[M1,M2]  computes the Boolean difference (pointwise) of two Boolean matrices M1 and M2, corresponding to relational complement. Also works with a single matrix. ";
BooleanComposition::usage = "BooleanComposition[M1,M2]  computes the Boolean dot product of two Boolean matrices M1 and M2, corresponding to relational composition. ";
BooleanConverse::usage = "BooleanConverse[M]  computes the transpose of a Boolean matrix M, corresponding to relational converse. ";
BooleanIntersection::usage = "BooleanIntersection[M1,M2]  computes the Boolean product (pointwise) of two Boolean matrices M1 and M2, corresponding to relational intersection. ";
BooleanPower::usage = "BooleanPower[M,n]  computes the n-th power of the Boolean matrix M, corresponding to relational iteration. ";
BooleanUnion::usage = "BooleanUnion[M1,M2]  computes the Boolean sum (pointwise) of two Boolean matrices M1 and M2, corresponding to relational union.";
Boolean::usage = "Boolean  is an option for TransitionMatrixFA, causes the constructed homomorphism to take values in the semiring of Boolean matrices. ";
RelationToMatrix::usage = "RelationToMatrix[A,rel]  converts a binary relation rel on carrier set A into a square Boolean matrix.";
ToClasses::usage = "ToClasses[L,R]  generates the equivalence classes of list L with respect to equivalence relation R. ";
TransitiveClosure::usage = "TransitiveClosure[B]  determines the transitive closure of Boolean matrix B. ";
Warshall::usage = "Warshall[B]  computes the transitive closure of Boolean matrix B using Warshall's algorithm. ";
AnalyzeOrbit::usage = "AnalyzeOrbit[f,x]  returns {t,p} where t is the length of the transient part of the orbit of point x under map f, and p is the length of the cyclic part.  Option  b is the entry point of the transient part on the cycle. Computation is memoryless. ";
BoundAO::usage = "BoundAO  is an option for AnalyzeOrbit that causes the search to be truncated.";
CartesianProduct::usage = "CartesianProduct[A,B]  computes the Cartesian product of lists A and B.";
$closureBound::usage = "$closureBound  is a default bound for the number of steps taken in Closure.";
ClosureBound::usage = "ClosureBound  is an option for Closure and ClosureSearch.";
$closureSearchBound::usage = "$closureSearchBound   is a default bound for ClosureSearch. ";
ClosureSearch::usage = "ClosureSearch[L,targ,ff]  determines whether targ occurs in the closure of list L under the function ff.";
Closure::usage = "Closure[L,ff]  computes the closure of list L under the function ff  ";
Cycle::usage = "Cycle  is an option for AnalyzeOrbit that causes the limit cycle to be displayed.";
DeleteDuplicates::usage = "DeleteDuplicates[L]  removes duplicates from list L. ";
DisjointQ::usage = "DisjointQ[L1,L2]  tests whether lists L1 and L2 are disjoint.";
EnumForm::usage = "EnumForm[L]  displays list L in ColumnForm with line numbers starting at 1.";
External::usage = "External  is an option for various commands with an external implementation. ";
FastPowerSet::usage = "FastPowerSet[L]   uses pattern matching to generate a power set.";
Filter::usage = "Filter is an option that can be used in GenerateSG to further process the objects generated by semigroup multiplications. ";
Frequencies::usage = "Frequencies[L]  counts the occurrences of all elements in the list L.";
FromBitVector::usage = "FromBitVector[B,U]  transforms bitvector B into a subset of universe U. ";
Index::usage = "Index  is a possible value for option Type in function ToClasses.";
Kary::usage = "Kary  is a Boolean option for AssignFunction, causes the function to be treated as a k-ary function.";
LongestCommonSubsequence::usage = "LongestCommonSubsequence[A,B]  produces a longest common subsequence of the two lists A and B.";
MakeIndex::usage = "MakeIndex[L,R]  computes an index of list L with respect to equivalence relation R. ";
Matrix::usage = "Matrix  is a possible value for option Type in function ToClasses.";
NonDecreasingSequences::usage = "NonDecreasingSequences[n,k]  generates all non-decreasing sequences of length k over [n].";
NoRest::usage = "NoRest  is an option for PlotMatrix.";
OutPairs::usage = "OutPairs  is an option for command DeleteDuplicates. ";
Pairs::usage = "Pairs[A,B]  generates a list of pairs with elements taken from lists A and B.";
Partitions::usage = "Partitions[n]  returns the partitions of n. ";
Periodic::usage = "Periodic  is an option that speeds up the computation in AnalyzeOrbit if the orbit is known to be periodic. ";
PowerSet::usage = "PowerSet[L,k]  produces all k-element subsets of L.";
RandomPermutation::usage = "RandomPermutation[k]  produces a random permutation on k points.";
Rank::usage = "Rank  is an option for Closure.";
RankingRules::usage = "RankingRules[L]  produces a list of rules that replace the elements of list L by their ranks.";
Reflexive::usage = "Reflexive  is an option for function TransitiveClosure";
Relation::usage = "Relation  is a possible value for option Type in function ToClasses.";
RootList::usage = "RootList[L]  computes the root of a list L, i.e., the shortest list K such that L is a repetition of copies of K.";
SelectorQ::usage = "SelectorQ[A,P]  tests whether list A selects precisely one element of each of the lists in P.";
SetClosure::usage = "SetClosure  is an option in Closure and ClosureSearch that determines the signature of the closure function.";
Shuffle::usage = "Shuffle[A,B]  shuffles two lists A and B.";
SubsetQ::usage = "SubsetQ[S1,S2]  tests whether S1 is a subset of S2.";
ToBitVector::usage = "ToBitVector[S,U]  transforms set S into a bitvector over universe U.";
ToList::usage = "ToList[S]  replaces the head of object S by List.";
ToPairs::usage = "ToPairs[A]  returns a list of all unordered pairs of elements in list A.";
Tuples::usage = "Tuples[L,k]  produces a list of all tuples of length k with elements taken from list L. ";
Type::usage = "Type  is an option for ToClasses. ";
$extlink::usage = "$extlink  is the MathLink connection to the external code.";
$defaultexternal::usage = "$defaultexternal  determines whether an external algorithm is used in a number of commands.";
$LLL::usage = "$LLL   is a global parameter for the recursive language map in command LanguageFA with option Implementation->3 .  ";
$shortlines::usage = "$shortlines  is controls the size of expression printed inside machines when formatting is turned on. ";
$transdispwidth::usage = "$transdispwidth   controls the number of transitions displayed in one row in PrintFA. ";
All::usage = "All  is an option value for various functions.";
AssignFunction::usage = "AssignFunction[h,P]  defines h to be function with graph P, where P is a list of pairs, representing the functional digraph of h. ";
Curry::usage = "Curry[f]  curries a function f of two variables.";
Dependency::usage = "Dependency[V,k]  computes the indices of the variables on which the k-ary function represented by the value list V depends. ";
DoTrace::usage = "DoTrace  is an option for various functions, causes additional output to be generated.";
Drei::usage = "Drei[x]  returns the third part of object x.";
ExtAutomata::usage = "ExtAutomata[bool]  controls the use of external code via MathLink.";
FlattenOne::usage = "FlattenOne[x]  is shorthand for Flatten[x,1].";
FormatAutomata::usage = "FormatAutomata[fmt]  controls formatting of the output form of finite state machines and graphs. ";
Full::usage = "Full  is an option for various functions.";
MinusEins::usage = "MinusEins  returns the last part of object x.";
MinusZwei::usage = "MinusZwei[x]  returns the second to the last part of object x.";
Opts::usage = "Opts  is an option for AssignFunction. ";
PositionList::usage = "PositionList[A,B,opts]  generates a flattened list of the positions of the elements of list B in list A.  ";
PositionOne::usage = "PositionOne[x,y]  evaluates to Position[x,y][[1,1]].";
ReplaceParts::usage = "ReplaceParts[x,r1,p1,r2,p2]  performs several consecutive replacements.";
SelectOptions::usage = "SelectOptions[cmd,opts]  selects those options from opts that make sense for cmd. ";
Status::usage = "Status[]  displays some information about the ongoing session.";
SymbolList::usage = "SymbolList[sym,k]  generates a list of symbols of the form sym1, sym2, ..., symk.";
Zwei::usage = "Zwei[x]  extracts the zweiten part of   x.";
$AutomataReleaseNumber::usage = "$AutomataReleaseNumber   is the release number of the current Automata package.";
PostLoad::usage = "postload  sets some system parameters. Is executed automatically after the package is loaded.  ";
PreLoad::usage = "preload  defines load messages. Is executed automatically before the package is loaded.";
$deffatline::usage = "$deffatline   controls the width of emphasized lines in PlotTDGraph. ";
$deflabeloffset::usage = "$deflabeloffset   controls the position of labels in GridPoints. ";
$defpointsize::usage = "$defpointsize  controls the pointsize in function GridPoints. ";
$defthinline::usage = "$defthinline controls the width of plain lines in PlotTDGraph. ";
$plotrangeoffset::usage = "$plotrangeoffset   controls the offset for MakePlotRange. ";
$rastercolors::usage = "$rastercolors   is a list of rules that determines plot colors for raster array plots. ";
ColorQ::usage = "ColorQ[x]  tests whether x is a color specification.";
DoShow::usage = "DoShow[gr]  displays graphics object gr by setting the DisplayFunction to $DisplayFunction. ";
GridLine::usage = "GridLine[n,m]   generates a graphics object representing an n by m grid of points. ";
GridOffset::usage = "GridOffset  is an option for GridLine.";
GridPoints::usage = "GridPoints[n,m]  generates a graphics object representing an n by m grid of points. ";
HueRasterColors::usage = "HueRasterColors[p]  can be used in PlotMatrix to control colors. ";
LabelGrid::usage = "LabelGrid  is an option for GridPoints, causes the first and last column of grid points to be labeled by integers.";
LabelPoints::usage = "LabelPoints  is an option for GridPoints, causes all grid points to be labeled by integers.";
LineStyle::usage = "LineStyle  is an option for PlotTDGraph that controls thickness and color of the lines in the plot.";
MakePlotRange::usage = "MakePlotRange[x1,x2,y1,y2]  constructs data for the PlotRange option, adds proper margins. ";
MultiCol::usage = "MultiCol  is an option for PlotMatrix.";
NRows::usage = "NRows  is an option for PlotMatrix.";
PlotComputationFA::usage = "PlotComputationFA[M,w,opts]  graphs the computation of FSM  M  on input word w. ";
PlotFunction::usage = "PlotFunction[f,A,n,opts]  plots a picture of a function f on domain A, iterated n steps. ";
PlotMatrix::usage = "PlotMatrix[M,opts]  plots a raster image of matrix M. ";
PlotRelation::usage = "PlotRelation[R,A,n,opts]  plots a picture of a binary relation R on domain A, iterated n steps. ";
PlotTDGraph::usage = "PlotTDGraph[gr,n]  plots a picture of a time dependent graph gr of order n.";
PlotT::usage = "PlotT[t,n]  plots the first n iterations of transformation t. ";
RasterStyle::usage = "RasterStyle  is an option for PlotMatrix, determines the colors used in the raster graphics. ";
RView::usage = "RView  is an option for PlotMatrix.";
ShowArray::usage = "ShowArray[L,k]  produces a graphics array of width k from a linear list L of graphics objects. ";
StaircasePlot::usage = "StaircasePlot[L,opts]  generates a staircase plot of the data in the numerical list L. ";


Begin["`Private`"];

(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)































$alphabet = 2;




























AlgebraicForm[
      Eps|"Eps"|Global`\[Epsilon]|1|$identitystring] = $identitystring;
AlgebraicForm[0|$nullstring] = $nullstring;
AlgebraicForm[w_?WordQ] := 
    Apply[ SequenceForm, makeruns@Characters@ToString[w] ]; 

Format[algfrm[a_,1]] := a;
Format[algfrm[a_,i_]] := Subscripted[a[i],0,-1];
makeruns[LL_List] := Apply[ algfrm, {First[#],Length[#]}& /@ Split[LL], 1 ];













































Attribute[Alphabet]={Listable};

Options[Alphabet]={Full\[Rule]False,Normalize\[Rule]0};

Alphabet[ M_?FSMQ ,opts___?OptionQ] := 
    With[ {res = 
          If[ MinusZwei[M]=!={}, MinusZwei[M],  MakeAlphabet@Zwei[M] ]},
      If[ 0<(Normalize /. {opts}  /. Options[Alphabet]),
        	Return[  {ShortAlphabetSize[M],ShortAlphabet[M]}]];
      If[ Full /. {opts}  /. Options[Alphabet],
        	{Length[res],res}, res ]];

Alphabet[ C_CA,opts___?OptionQ ] := 
    If[ 0<(Normalize /. {opts}  /. Options[Alphabet]),
      	Return[  {ShortAlphabetSize[C],ShortAlphabet[C]}],
      	MakeAlphabet[ C[[2]],opts]
      ];

Alphabet[ "Eps"|Eps|Global`\[Epsilon],opts___?OptionQ ] :=
    
    If[ Full /. {opts}  /. Options[Alphabet],
      	{0,{}}, {} ];

Alphabet[ w_?WordQ,opts___?OptionQ ] :=
    
    With[ {res =  Union@Characters@ToString[w]},
      If[ Full /. {opts}  /. Options[Alphabet],
        	{Length[res],res}, res ]];

Alphabet[ W_List,opts___?OptionQ ]   :=
    
    With[ {res =  Union@Flatten[ Alphabet[W,Full\[Rule]True] ]},
      If[ Full /. {opts}  /. Options[Alphabet],
        	{Length[res],res}, res ]];




































































AlphabetQ[x_Integer] := x \[NotEqual] 0;
AlphabetQ[{xx__String|x__Symbol}] := True;
AlphabetQ[_] := False;






































AlphabetSize[k_Integer]  := Abs[k]; 
AlphabetSize[K_List]        := Length[K]; 
AlphabetSize[M_?FSMQ]     := Abs@Zwei[M];
AlphabetSize[C_CA]            := Abs@Zwei[C];

(* various private helper functions *)

ShortAlphabetSize[M_?FSMQ]:=Zwei[M];
ShortAlphabetSize[C_CA]:=Zwei[C];   (* already simplified *)

ShortAlphabetSize[k_Integer]:=k;
ShortAlphabetSize[K_List]:=
    
    With[{KK=ToString/@K,k=Length[K]},
      If[KK[[1]]==="0"&&KK ===MakeAlphabet[-k],-k,k]
      ];

ShortAlphabet[M_?FSMQ]:=ShortAlphabet@MinusZwei[M];
ShortAlphabet[C_CA]:=ShortAlphabet@C[[4]];

ShortAlphabet[k_Integer]:={};
ShortAlphabet[{}]={};
ShortAlphabet[K_List]:=
    
    Module[{KK=ToString/@K},
      If[KK[[1]]==="a"&&KK === MakeAlphabet[Length[K]],Return[{}]];
      If[KK[[1]]==="0"&&KK === MakeAlphabet[-Length[K]],Return[{}]];
      KK
      ];

GetAlphabet[M_?FSMQ]:={Abs@Zwei[M],Zwei[M],MinusZwei[M]};










































Concatenate[Eps|"Eps"|Global`\[Epsilon]] := "Eps";
Concatenate[x_?WordQ]  := ToString[x];
Concatenate[Eps|"Eps"|Global`\[Epsilon],yy_List] := yy;
Concatenate[xx_List,Eps|"Eps"|Global`\[Epsilon]] := xx;
Concatenate[xx___,Eps|"Eps"|Global`\[Epsilon],yy___] := Concatenate[xx,yy];
Concatenate[x__?WordQ] := StringJoin@@(ToString /@ {x});
Concatenate[{}]       := "Eps";
Concatenate[xx_List]  := Concatenate@@xx;
Concatenate[xx__List] := Apply[ Concatenate, CartesianProduct[xx], 1 ];
Concatenate[xx___,ww_?WordQ,yy___] := Concatenate[xx,{ww},yy];
































































FromEps[xx_] := xx /. {Eps->"","Eps"->"",Global`\[Epsilon]->""};







































Options[FromFrontier]={Full\[Rule]False};

FromFrontier[{""}|{"Eps"}|{Eps}|{Global`\[Epsilon]},___] := {};
FromFrontier[W_List,opts___?OptionQ] := 
    Module[ {WW = ToString /@ W,res}, 
        res = WordPrefixes[WW,Full\[Rule]False];
        If[ Full /. {opts} /. Options[FromFrontier], 
          res,
          WordSort[Union[Flatten[res]]]
          ]
        ]   /;  W=!={};

































FrontierQ[{""}|{"Eps"}|{Eps}|{Global`\[Epsilon]},_] = True;
FrontierQ[W_List,K:(_?AlphabetQ):$alphabet] := 
With[ {KK = MakeAlphabet[K], WW  = WordSort[ToString /@ W]}, 
     ToFrontier[ FromFrontier[WW], K ]===WW
]    /;  W=!={};










































Options[MakeAlphabet]={Full\[Rule]False};

MakeAlphabet[k_Integer?Negative,opts___?OptionQ]  :=
    
    With[ {res = If[ -k<11, ToString /@ Range[0,-k-1],
                      
            Join[ ToString /@ Range[0,9], 
              FromCharacterCode /@ Range[97,86-k] ] ]},
      	If[ Full /. {opts} /. Options[MakeAlphabet],
        	{Length[res],res},
        	res ]
      ];
MakeAlphabet[k_Integer?NonNegative,opts___?OptionQ]  :=
    
    With[ {res =  FromCharacterCode /@ Range[97,96+k]},
      	If[ Full /. {opts} /. Options[MakeAlphabet],
        	{Length[res],res},
        	res ]
      ];

MakeAlphabet[K_List,opts___?OptionQ] :=
    With[ {res = ToString /@ K},
      	If[ Full /. {opts} /. Options[MakeAlphabet],
        	{Length[res],res},
        	res ]
      ];







































makeWordRepeat[{a_,i_}] := StringJoin@@Table[ToString[a],{i}];

MakeWord[]  = "";
MakeWord[w__] := 
    ToEps[ StringJoin@@(makeWordRepeat /@ Partition[{w},2]) ] /; 
      EvenQ[Length[{w}]];
































ParikhVector[ Eps|"Eps"|Global`\[Epsilon], K:(_?AlphabetQ):$alphabet ] := 
     Table[0,{AlphabetSize[K]}];

ParikhVector[ w_?WordQ, K:(_?AlphabetQ):$alphabet ] := 
     Count[ToCharacters[w],#]& /@ MakeAlphabet[K];

ParikhVector[ L_List, K:(_?AlphabetQ):$alphabet ] := 
Block[ {k,alph,parikh},
     {k,alph} = MakeAlphabet[K,Full->True];
     parikh["Eps"|Eps] = Table[0,{k}];
     parikh[x_] := Count[ToCharacters[x],#]& /@ alph;
     parikh /@ L
];






























RandomWord[ n_Integer, K:(_?AlphabetQ):$alphabet ] := 
Module[ {k,alph},
     {k,alph} = MakeAlphabet[K,Full->True];
     If[ Positive[n],
         ToWord[ Random[Integer,{1,k}]& /@ Range[n], alph ],
         ToWord[ Random[Integer,{1,k}]& /@ Range[Random[Integer,-n]], alph ]
     ]
];







































Options[ToBlocks]={Boundary\[Rule]Cyclic};

ToBlocks[ L_List, w_Integer, opts___?OptionQ ] := 
With[ {ww = Ceiling[w/2], bnd = Boundary /. {opts} /. Options[ToBlocks]},
    Switch[  bnd, 
        	Cyclic, Partition[L,w,1,ww],
		None,   Partition[L,w,1],
		Fixed,	Partition[L,w,1,ww,$defzero],
		_,	Partition[L,w,1,ww,bnd]
    ]
];


ToBlocks[ x_?WordQ, w_Integer, opts___?OptionQ ] := 
With[ {ww = Ceiling[w/2], L = ToCharacters[x],
      bnd = Boundary /. {opts} /. Options[ToBlocks]},
    StringJoin /@ 
    Switch[  bnd, 
        	Cyclic, Partition[L,w,1,ww],
		None,   Partition[L,w,1],
		Fixed,	Partition[L,w,1,ww,$defzerochar],
		_,	Partition[L,w,1,ww,bnd]
    ]
];

$defzero = 0;
$defzerochar = "0";



























ToEps[xx_] := xx /. {""->"Eps"};































ToFrontier[{""}|{"Eps"}|{Eps}|Global`\[Epsilon],
      K:(_?AlphabetQ):$alphabet] :=  MakeAlphabet[K];

ToFrontier[W_List,K:(_?AlphabetQ):$alphabet] := 
    With[ {KK = MakeAlphabet[K],WW  = ToString /@ W}, 
           Complement[ Concatenate[WW,KK], WW ] // WordSort
      ];


































ToIndex[ Eps|"Eps"|Global`\[Epsilon], ___ ] = {};
ToIndex[ x_?WordQ ] := ToCharacterCode@ToString[x] - 96;
ToIndex[ x_?WordQ, 2|{a,b}|{"a","b"} ] := ToCharacterCode@ToString[x] - 96;
ToIndex[ x_?WordQ, K:(_?AlphabetQ):$alphabet ] := 
(
        {$kk,$alph} = MakeAlphabet[K,Full->True];
        AssignFunction[ $todig, Flatten[ToCharacterCode /@ $alph], 
        Range[$kk] ];
        $todig /@ ToCharacterCode@ToString[x]
);
ToIndex[ x_Integer, K_ ] := ToIndex[ ToString[x], K ];
ToIndex[ L_List,K_ ] := ToIndex[#,K]& /@ L



































ToWord[ str_String, ___ ] := str;
ToWord[ {}, ___ ] = "Eps";
ToWord[ {xx__Integer}, K:(_?AlphabetQ):$alphabet ] := 
    StringJoin @@ MakeAlphabet[K][[DeleteCases[{xx},0]]];
ToWord[ r_Integer, K:(_?AlphabetQ):$alphabet ]:= 
        MakeAlphabet[K][[r]]  /;   
      1 \[LessEqual] r \[LessEqual] AlphabetSize[K];




































Options[WordBinomial]={DoTrace\[Rule]False};

WordBinomial[ u_?WordQ, Eps|"Eps"|Global`\[Epsilon] ] := 1;
WordBinomial[ Eps|"Eps"|Global`\[Epsilon], v_?WordQ ] := 0;
WordBinomial[ u_?WordQ, v_?WordQ, opts___?OptionQ ] := 
	WordBinomial[ {u}, v, opts ];
WordBinomial[ LL_List, v_?WordQ, opts___?OptionQ ] := 
Module[ {vL,n,nexti,next,h,updateh},
    vL    = ToCharacterCode@ToString[v];
    n     = Length[vL];
    nexti[a_,i_] := If[ vL[[i]]==a, h[i]+h[i-1], h[i] ];
    next[a_] := Scan[ (h[#]=nexti[a,#])&, Reverse[Range[n]]];
    
    updateh = Function[ uu,
   		Clear[h];h[0]=1;h[_]=0;
   		Map[(next[#];h /@ Range[n])&,ToCharacterCode@ToString[uu]] ];
    
    If[ Length[LL]==1,
	    If[ DoTrace /. {opts} /. Options[WordBinomial], 
	    	updateh[First[LL]], 
	    	Last[Last[updateh[First[LL]]]] 
	    ],
	(*else - ignore trace for lists *)
		Last@Last@updateh[#]& /@ LL
	]
];



































Attributes[WordConjugateQ]={Listable};

WordConjugateQ[u_?WordQ,v_?WordQ]:=False/;WordLength[u]=!=WordLength[v];

WordConjugateQ[u_?WordQ,v_?WordQ]:=
    With[{uu=ToString[u],vv=ToString[v]},Length[StringPosition[uu<>uu,vv]]>0];





























Attributes[WordConjugates]={Listable};
WordConjugates[Eps|"Eps"|Global`\[Epsilon]] := {"Eps"};

WordConjugates[u_?WordQ] := 
    	With[ {uu = Characters@ToString[u], nn = WordLength@WordRoot[u]}, 
      	Apply[StringJoin,NestList[RotateLeft,uu,nn-1],{1}]];





























WordFactorizations[ Eps|"Eps"|Global`\[Epsilon] ] = {{"Eps","Eps"}}; 
WordFactorizations[ w_?WordQ ] := 
    	Pairs[ WordPrefixes[w],Reverse[WordSuffixes[w]]];   































WordFactorQ[ Eps|"Eps"|Global`\[Epsilon], _?WordQ ] = True;
WordFactorQ[ u_?WordQ, v_?WordQ ] := 
    StringMatchQ[ ToString[v], StringJoin["*",ToString[u],"*"] ];









































Attributes[WordFactors]={Listable};
Options[WordFactors]={Full\[Rule]True};

WordFactors["Eps"|Eps|""|Global`\[Epsilon],opts___?OptionQ ] := 
  If[ Full /. {opts} /. Options[WordFactors], {"Eps"}, {} ]

WordFactors[x_?WordQ,0,opts___?OptionQ ] := {"Eps"};
		
WordFactors[x_?WordQ,k_Integer?Positive,opts___?OptionQ ] := 
    Module[ {xx=Characters@ToString[x]},
      	Union@Apply[ StringJoin, Partition[xx,k,1], {1} ]
      ];
		
WordFactors[x_?WordQ,opts___?OptionQ ] := 
    Module[ {xx=Characters@ToString[x],n},
      n = If[ Full /. {opts} /. Options[WordFactors], 
          	Length[xx], Length[xx]-1 ];
      	Union@Apply[ StringJoin, Partition[xx,#,1], {1} ]& /@ Range[n] // 
          Flatten // Prepend[#,"Eps"]& 
      ];





























WordFusion[ u_?WordQ, v_?WordQ, r_Integer:1 ] := 
With[ {uu = ToString[u], vv = ToString[v]},
    If[ StringTake[uu,-r]===StringTake[vv,r], uu<>StringDrop[vv,r] ]
];

































Attributes[WordLength]={Listable};
WordLength[Eps|"Eps"|Global`\[Epsilon]]   = 0;
WordLength[x_?WordQ]   := StringLength@ToString[x];
WordLength[Eps|"Eps"|Global`\[Epsilon],_] = 0;
WordLength[x_?WordQ,a_?WordQ] := 
        Length@StringPosition[ToString[x],ToString[a]];
































WordOrder[ x_?WordQ, y_?WordQ ] := 
    If[ x===y, 0 ,
      	If[
        WordLength[x]<WordLength[y] ||
          		   
          WordLength[x]==WordLength[y] && Order[x,y]==1, 1 , -1 ] ];
















































Attributes[WordPeriod]={Listable};
Options[WordPeriod]={Full\[Rule]False};

WordPeriod[Eps|"Eps"|""|\[Epsilon],opts___?OptionQ]:=0;
WordPeriod[w_?WordQ,opts___?OptionQ]:=
    Module[{alph=Alphabet[w],L,p},
      	If[
        Full/.\[InvisibleSpace]{opts}/.\[InvisibleSpace]Options[WordPeriod],
        		Return[fullWordPeriod[w]]];
      
      	p=1;
      	L=ToIndex[w,alph];
      	Catch[ Scan[
          		If[Length[Union[With[{r=Mod[Length[L],#1]},
                      	If[r>0,Partition[Join[L,Take[L,{r+1,#1}]],#1],
                        			Partition[L,#1]]]]]\[Equal]1,Throw[#1]]&,
          		Range[WordLength[w]]]
        	]
      ];

fullWordPeriod[ w_?WordQ ] := 
    Module[{alph=Alphabet[w],L,p},
      
      	p=1;
      	L=ToIndex[w,alph];
      	Reap[ Scan[
            		If[Length[Union[With[{r=Mod[Length[L],#1]},
                        	If[r>0,Partition[Join[L,Take[L,{r+1,#1}]],#1],
                          			Partition[L,#1]]]]]\[Equal]1,Sow[#]]&,
            		Range[WordLength[w]]]
          	][[2,1]]
      ];



































Attributes[WordPower]={Listable};
WordPower[Eps|"Eps"|Global`\[Epsilon],_] := "Eps";
WordPower[_,0] := "Eps";
WordPower[ s_Symbol|s_String, k_Integer:Positive ] := 
    	StringJoin@@Table[ToString[s],{k}];


































WordPrefixQ[ Eps|"Eps"|Global`\[Epsilon], _?WordQ ] = True;
WordPrefixQ[ u_?WordQ, v_?WordQ ] := 
    StringMatchQ[ ToString[v], StringJoin[ToString[u],"*"] ];





































Attributes[WordPrefixes]={Listable};
Options[WordPrefixes]={Full\[Rule]True};

WordPrefixes[ Eps|"Eps"|Global`\[Epsilon],opts___?OptionQ ] := 
    If[ Full /. {opts} /. Options[WordPrefixes], {"Eps"}, {} ]; 

WordPrefixes[ w_?WordQ,opts___?OptionQ ] := 
    With[ {ws = ToString[w]}, 
      	Prepend[ 
        	If[ Full /. {opts} /. Options[WordPrefixes],
          		StringTake[ws,#]& /@ Range@WordLength[ws],
          		Most[StringTake[ws,#]& /@ Range@WordLength[ws]]
          	],
        "Eps" ]
      ];





























Attributes[WordPrimitiveCount]={Listable};

WordPrimitiveCount[n_Integer,k_Integer]:=
    With[{div=Divisors[n]},
      (MoebiusMu/@div). (k^(n/div)) ];





































Attributes[WordPrimitiveQ]={Listable};
WordPrimitiveQ[ Eps|"Eps"|Global`\[Epsilon] ] := True;
WordPrimitiveQ[ s_String|s_Symbol ] := 
	With[ {ss = ToString[s]}, Length[StringPosition[ss<>ss,ss]]==2 ];





























Attributes[WordQ]={Listable};
WordQ[_Symbol|_String] = True;
WordQ[_] = False;





































Attributes[WordReverse]={Listable};
WordReverse[Eps|"Eps"|Global`\[Epsilon]] = "Eps";
WordReverse[x_?WordQ] := StringReverse@ToString[x];






























Attributes[WordRoot]={Listable};
WordRoot[Eps|"Eps"|Global`\[Epsilon]] := "Eps";
WordRoot[ s_String|s_Symbol ] := 
    	With[ {ss = ToString[s]}, 
      StringTake[ss,StringPosition[ss<>ss,ss][[2,1]]-1] ];


































Attributes[WordRotate]={Listable};
WordRotate[Eps|"Eps"|Global`\[Epsilon],_] = "Eps";
WordRotate[x_?WordQ,n_Integer:1] := 
        StringJoin@@RotateLeft[ToCharacters@ToString[x],n];














































Options[Words]={Full\[Rule]True};
Words[ 0, _,opts___?OptionQ ] := {"Eps"};
Words[ r_Integer?Positive, K:(_?AlphabetQ):$alphabet,opts___?OptionQ  ] := 
    With[ { alph = MakeAlphabet[K] },
           Apply[ StringJoin, CartesianProduct@@Table[alph,{r}], 1 ]
      ];

Words[ r_Integer?Negative, K:(_?AlphabetQ):$alphabet,opts___?OptionQ  ] := 
    With[ {res = Flatten[ Words[#,K]& /@ Range[-r] ]},
      	If[ Full /. {opts} /. Options[Words],
        		Prepend[  res, "Eps" ], res ] ];








































WordShuffle[ Eps|"Eps"|Global`\[Epsilon], v_?WordQ ] := {v};
WordShuffle[ u_?WordQ, Eps|"Eps"|Global`\[Epsilon] ] := {u};
WordShuffle[ u_?WordQ, v_?WordQ ] := 
     Apply[ StringJoin, shuffle[ToCharacters[u],ToCharacters[v]], 1 ];
WordShuffle[ u_?WordQ, L_List  ] := WordShuffle[ {u}, L ];
WordShuffle[ L_List, u_?WordQ  ] := WordShuffle[ L,{u} ];
WordShuffle[ L1_List, L2_List ] := 
    Union[Flatten[ Apply[ WordShuffle, CartesianProduct[L1,L2], 1 ]]];
     
shuffle[{},L_] := {L};
shuffle[L_,{}] := {L};
shuffle[L1_List,L2_List] := 
    Union[  Prepend[#,First[L1]]& /@ shuffle[Rest[L1],L2],
     Prepend[#,First[L2]]& /@ shuffle[L1,Rest[L2]]
];


































WordSort[{xx___List}] := 
    Last /@ Sort[Pairs[WordLength /@ First /@ {xx}, {xx} ]];
WordSort[ L_List ] := Last /@ Sort[ Pairs[ WordLength /@ L, L ] ];


































WordSuffixQ[ Eps|"Eps"|Global`\[Epsilon], _?WordQ ] = True;
WordSuffixQ[ u_?WordQ, v_?WordQ ] := 
    StringMatchQ[ ToString[v], StringJoin["*",ToString[u]] ];







































Attributes[WordSuffixes]={Listable};
Options[WordSuffixes]={Full\[Rule]True};

WordSuffixes[ Eps|"Eps"|Global`\[Epsilon],opts___?OptionQ ] := 
    If[ Full /. {opts} /. Options[WordSuffixes], {"Eps"}, {} ]; 

WordSuffixes[ w_?WordQ,opts___?OptionQ ] := 
    With[ {ws = ToString[w]}, 
      Prepend[ 
        If[ Full /. {opts} /. Options[WordSuffixes],
                StringTake[ws,-#]& /@ Range@WordLength[ws],
              Most[StringTake[ws,-#]& /@ Range@WordLength[ws]]
          ],"Eps" ]
      ];







































$bottom = -1;








































$defaultnormalize = 0;










































Options[AcceptQFA]={DoTrace->False, Multiplicity->False};


AcceptQFA[ M_DFA, xx_?WordQ, opts___?OptionQ ] := 
Block[  {A,tr,f},
     A  = Transitions[M];
     
     (*  f: transition function of M *)
     
      f[p_,a_] := f[p,a] = A[[a,p]];   
     tr = FoldList[ f, TheInitial[M], ToIndex[xx,Alphabet[M]] ];
     
     If[ DoTrace /. {opts} /. Options[AcceptQFA], 
     	States[M][[tr]], 
     	MemberQ[ Final[M], Last[tr] ] 
     ]
];

AcceptQFA[ M_NFA, xx_?WordQ, opts___?OptionQ ] := 
Block[  {A,tr,f},

     If[ Multiplicity /. {opts} /. Options[AcceptQFA], 
     	Return[ acceptmult[ToFA[M],xx] ] ];

     A  = Transitions[M];

     (*  transition function of M *)
     
      f[p_,a_] := f[p,a] = Union[ Flatten[ A[[a,p]] ]];   
     tr = FoldList[ f, Initial[M], ToIndex[xx,Alphabet[M]] ];
     
     If[ DoTrace /. {opts} /. Options[AcceptQFA], 
         (States[M][[#]])& /@ tr,
         Length[ Intersection[ Last[tr], Final[M] ] ] > 0
     ]
];


AcceptQFA[ M_FA|M_SA, xx_?WordQ, opts___?OptionQ ] := 
     AcceptQFA[ ToNFA[M], xx, opts ];

acceptmult[M_,xx_] :=
Module[ {n,ff}, 
     n = Size[M];
     TransitionMatrixFA[ M, ff ];    
     ToBitVector[Initial[M],n].ff[xx].ToBitVector[Final[M],n]
];
















































Options[AccessibleFA]={Normalize\[RuleDelayed]$defaultnormalize,
      External\[RuleDelayed]$defaultexternal};

AccessibleFA[ M_?FSMQ, opts___?OptionQ ] := 
Module[  {k,KK,n,Q,nacc,visit,hh,dfs,dfsact,count,
acc,Ini,A,A1,tr,F1,I1,adjlist,norm}  ,
     norm = Normalize /. {opts} /. Options[AccessibleFA];
     
     If[ (External /. {opts} /. Options[AccessibleFA]) && Head[M]===DFA,
         Return[ Automata`extaut`ExtAccessibleFA[M,opts] ] ];

     n = Size[M];
     {k,kk,KK} = GetAlphabet[M];
     Ini = Initial[M];
     Attributes[visit]={Listable};
     Attributes[hh]={Listable};
     adjlist = Edges@ToAdjacencyList@ToGraphFA[M];
     
     visit[_]=0;
     count = 1;
     dfs[z_Integer] := 
      ( If[ visit[z]==0,  visit[z]=count; hh[count++]=z ];
     Scan[ dfsact, adjlist[[z]] ]);
     dfsact[z_Integer] := 
        If[ visit[z]==0, visit[z]=count; hh[count++]=z; dfs[z] ];

     Scan[ dfs, Ini ];
       
     acc  = hh[Range[count-1]];
     nacc = Length[acc];

     If[ Head[M]===FA || Head[M]===SA,
         AA = Select[ Transitions[M], (visit[#[[1]]] > 0)& ];
         tr = Length[AA];
         AA = MapAt[ visit, AA,
                    Join[CartesianProduct[Range[tr],{1}],
                    CartesianProduct[Range[tr],{3}]] ],
     (* else *)     
         A  = Thread[Transitions[M]]; 
         AA = Thread[ Map[visit,A[[acc]],{2}] ]
     ];
     F1 = visit[Intersection[acc,Final[M]]];
     I1 = visit[Ini];

     res = Switch[ Head[M],
       DFA,      DFA[ nacc, kk, AA, I1[[1]], Sort[F1], KK, {} ],
       NFA|FA,    FA[ nacc, kk, AA, Sort[I1], Sort[F1], KK, {} ],
       SA,        SA[ nacc, kk, AA, KK, {} ]
     ];

    Switch[ norm,
       0, res, 
       1, ReplacePart[ res, acc, -1 ],
       2, ReplacePart[ res, States[M][[acc]], -1 ]
     ]
];







































AddTransitionFA[ m_FA|m_SA, p_Integer, w_?WordQ, q_Integer ] := 
Module[ {n,nn,ww,P,tr,alph},
     alph = Alphabet[m];
     n  = nn = Size[m];
     If[ p>n, nn++ ];
     If[ q>n, nn++ ];
     lw = WordLength[w];
     If[ lw <= 1, 
         ww = If[ lw==0, 0, PositionOne[Alphabet[m],ToString[w]] ]; 
         res = ReplaceParts[ m, Join[Transitions[m],{{p,ww,q}}], 3, nn, 1],
     (* else: word longer than 1 *)
         ww = ToIndex[w,alph]; 
         nn += lw - 1;
         P  = Thread@Partition[ Join[ {p}, Range[n+1,nn], {q} ], 2, 1 ];
         tr = Thread[ { First@P, ww, Last@P } ];
         res = ReplaceParts[ m, Join[Transitions[m],tr], 3, nn, 1 ];
     ];
     If[ MinusEins[m]==={}, 
         res,
         ReplacePart[ res, Join[States[m],Range[n+1,nn]], -1 ]
     ]
];

AddTransitionFA[ m_FA|m_SA, p_Integer, w_Integer, q_Integer ] := 
    AddTransitionFA[ m, p, ToWord[{w},Alphabet[m]], q];  (* terrible *) 
AddTransitionFA[ m_FA|m_SA, {p_Integer, w_?WordQ, q_Integer} ] := 
     AddTransitionFA[ m, p, w, q ];
AddTransitionFA[ m_FA|m_SA, tr:{___List} ] := 
     Last@FoldList[ AddTransitionFA, m, tr ];




































Options[AllDFA]={Full\[Rule]True};

AllDFA[ K:(_?AlphabetQ):$alphabet, opts___?OptionQ ] := 
If[ Full /. {opts} /. Options[AllDFA],
    DFA[1, ShortAlphabetSize[K], Table[{1},{AlphabetSize[K]}], 1, {1},
	  ShortAlphabet[K], {} ],
    DFA[2, ShortAlphabetSize[K], Table[{2,2},{AlphabetSize[K]}], 1, {2}, 
	ShortAlphabet[K], {} ]
];











































Options[AmbiguousQFA]={Full\[Rule]False,
      External\[RuleDelayed]$defaultexternal,DoTrace\[Rule]False};

AmbiguousQFA[m_?FSMQ,opts___?OptionQ] := 
Module[{full,ss,dd,g,gg,V,h,badc,p1,p2,p3,R0,R1,pos},
      
      If[ DeterministicQFA[m] || CoDeterministicQFA[m], Return[False] ];
      full =  Full /. {opts} /. Options[AmbiguousQFA];
      
      {ss,dd} = 
        SquareSA[ ToSA[m], Full\[Rule]1, Normalize\[Rule]1,
          DoTrace\[Rule]True];
      g = ToGraphFA[ss, Normalize\[Rule]2];
      gg = ToDirectedAcyclicGraph[ g,Normalize\[Rule]1 ];
      V = VertexSet[gg];
      AssignFunction[h,dd,Table[1,{Length[dd]}],Opts\[Rule]Listable];
      h[_] := 0;
      badc = Select[ V, Union[h[#]]\[Equal]{0,1}& ];
      If[  badc=!={},
        	If[ !full, Return[True]];
        	p1 = p3 = Catch[ Scan[ If[h[#]\[Equal]1,Throw[#]]&, First@badc ]];
        	p2 = Catch[ Scan[ If[h[#]\[Equal]0,Throw[#]]&, First@badc ]];,
        (* else *) 
        	ggr = ReverseGraph[gg];
        	pos = Union[First /@ (FlattenOne@Position[V,#]& /@ dd)];
        	R0 = WeaklyConnectedComponents[gg,pos];
        	R1 = WeaklyConnectedComponents[ggr,pos];
        	badc = Complement[Intersection[ R0,R1],pos];
        	If[!full || badc==={}, Return[badc=!={}]];
        	p2 = First@Complement[Intersection[ R0,R1],pos];
        	p3 = First@Intersection[WeaklyConnectedComponents[gg,p2],pos];
        	p1 = First@Intersection[WeaklyConnectedComponents[ggr,p2],pos];
        ];
      {True, 
        Concatenate[Flatten@TransferSequenceFA[ss, {p1},{p2}],
          Flatten@TransferSequenceFA[ss, {p2},{p3}]]}
      ];






































unionBEFA[ M1_BEFA, M2_BEFA ] := 
Module[ {n1, n2, T1, T2},
     n1 = Size[ M1 ];
     n2 = Size[ M2 ];
     T1 = Transitions[M1] /. {x_Integer,s_,n1} :> {x,s,n1+n2-2} ;
     T2 = Transitions[M2] /. {x_Integer,s_,y_Integer} :> {x+n1-2,s,y+n1-2};
     T2 = T2 /. {n1-1,s_,y_Integer} :> {1,s,y};
     BEFA[ n1+n2-2, Union[T1,T2] ]
];
unionBEFA[ M1_BEFA, M2_BEFA, z___BEFA ] := 
      unionBEFA[ unionBEFA[ M1, M2 ], z ];
      
concatenateBEFA[ M1_BEFA, M2_BEFA ] := 
Module[ {n1,n2,T1,T2},
     n1 = Size[M1];
     n2 = Size[M2];
     T1 = Transitions[M1];
     T2 = Map[ shiftrans[n1-1,n1-1,#]&, Transitions[M2] ];
     BEFA[ n1+n2-1, Union[T1,T2] ]
];
concatenateBEFA[ M1_BEFA, M2_BEFA, z___BEFA ] := 
     concatenateBEFA[ concatenateBEFA[ M1, M2 ], z ];
      
starBEFA[ M_BEFA ] := 
Module[ {n, Tr},
     n = Size[ M ];
     Tr = Map[ shiftrans[1,1,#]&, Transitions[M] ];
     BEFA[ n+2, Union[Tr,{{1,"Eps",2},{n+1,"Eps",2},{2,"Eps",n+2}}] ]
];





























BEFAToFA[ M_BEFA, K:(_?AlphabetQ):$alphabet ] := 
     FA[ Size[M], ShortAlphabetSize[K], 
         ToTransitions[Transitions[M],K], {1}, {Size[M]}, 
ShortAlphabet[K], {} ];
     
unionBEFA[ M1_BEFA, M2_BEFA ] := 
Module[ {n1, n2, T1, T2},
     n1 = Size[ M1 ];
     n2 = Size[ M2 ];
     T1 = Transitions[M1] /. {x_Integer,s_,n1} :> {x,s,n1+n2-2} ;
     T2 = Transitions[M2] /. {x_Integer,s_,y_Integer} :> {x+n1-2,s,y+n1-2};
     T2 = T2 /. {n1-1,s_,y_Integer} :> {1,s,y};
     BEFA[ n1+n2-2, Union[T1,T2] ]
];
unionBEFA[ M1_BEFA, M2_BEFA, z___BEFA ] := 
      unionBEFA[ unionBEFA[ M1, M2 ], z ];
      
concatenateBEFA[ M1_BEFA, M2_BEFA ] := 
Module[ {n1,n2,T1,T2},
     n1 = Size[M1];
     n2 = Size[M2];
     T1 = Transitions[M1];
     T2 = Map[ shiftrans[n1-1,n1-1,#]&, Transitions[M2] ];
     BEFA[ n1+n2-1, Union[T1,T2] ]
];
concatenateBEFA[ M1_BEFA, M2_BEFA, z___BEFA ] := 
     concatenateBEFA[ concatenateBEFA[ M1, M2 ], z ];
      
starBEFA[ M_BEFA ] := 
Module[ {n, Tr},
     n = Size[ M ];
     Tr = Map[ shiftrans[1,1,#]&, Transitions[M] ];
     BEFA[ n+2, Union[Tr,{{1,"Eps",2},{n+1,"Eps",2},{2,"Eps",n+2}}] ]
];

makeBEFA[xx_Symbol|xx_String] := BuildBEFA[xx];
makeBEFA[xx_REP]    := unionBEFA @@ (makeBEFA /@ xx);
makeBEFA[xx_RET]    := concatenateBEFA @@ (makeBEFA /@ xx);
makeBEFA[xx_RES]    := starBEFA[ makeBEFA[First[xx]] ];

sizeBEFA[ ee_Symbol|ee_String ] := WordLength[ee] + 1;
sizeBEFA[ ee_REP ]    := Total[sizeBEFA/@ee] - 2 Length[ee] + 2;
sizeBEFA[ ee_RET ]    := Total[sizeBEFA/@ee] - Length[ee] + 1;
sizeBEFA[ ee_RES ]    := sizeBEFA[ee[[1]]] + 2;









































BehaviorFA[ M_?FSMQ, p_Integer?Positive, r_Integer ] := 
    LanguageFA[ BehaviorFA[M,p], r ]  /;  p \[LessEqual] Size[M];

BehaviorFA[ M_?FSMQ, p_Integer?Positive  ] := 
        MinimizeFA@SetInitialFA[M,p]   /;  p \[LessEqual] Size[M];


















































BuildBEFA[Empty]      := BEFA[2,{}];
BuildBEFA[Eps|"Eps"|Global`\[Epsilon]]  := BEFA[2,{{1,"Eps",2}}];
BuildBEFA[x_?WordQ]   := 
Module[ {L,n,Tr},
     L = ToCharacters[x];
     n = Length[L] + 1;
     Tr = Thread[ {Range[n-1], L, Range[2,n]} ];
     BEFA[ n, Tr ]
];








































Options[BuildDFA]={Normalize:>$defaultnormalize};


BuildDFA[Eps|"Eps"|Global`\[Epsilon],K:(_?AlphabetQ):$alphabet,
      opts___?OptionQ] :=
    
    DFA[2, ShortAlphabetSize[K], Table[{2,2},{AlphabetSize[K]}], 1, {1},
        ShortAlphabet[K], {} ];
BuildDFA[z__?WordQ,K:(_?AlphabetQ):$alphabet,opts___?OptionQ] := 
    QuotientDFA[{z},K,opts];
BuildDFA[L_List,K:(_?AlphabetQ):$alphabet,opts___?OptionQ]    := 
    QuotientDFA[L,K,opts]; 
      































BuildNNFA[Eps|"Eps"|Global`\[Epsilon]] := NNFA[0,{},{},{},{},1];
BuildNNFA[Empty]     := NNFA[0,{},{},{},{},0];
BuildNNFA[ xx_ ]     := 
With[ {n=WordLength[xx]},
      NNFA[ n, Partition[Range[n],2,1], ToCharacters[xx], {1}, {n}, 0 ]
];

    
(*     McNaughton-Yamada style normal NFAs  *)

makeNNFA[xx_Symbol|xx_String] := BuildNNFA[xx];
makeNNFA[xx_REP]    := unionNNFA @@ (makeNNFA /@ xx);
makeNNFA[xx_RET]    := concatenateNNFA @@ (makeNNFA /@ xx);
makeNNFA[xx_RES]    := starNNFA[ makeNNFA[First[xx]] ];

sizeNNFA[ e_?WordQ ] := WordLength[e];
sizeNNFA[ e_REP|e_RET ] := Total[sizeNNFA/@e];
sizeNNFA[ e_RES ]    := sizeNNFA[e[[1]]];

unionNNFA[ M1_NNFA, M2_NNFA ] := 
Module[ {n=M1[[1]], I1=M1[[4]], F1=M1[[5]], I2, F2},
     I2 = M2[[4]] + n;
     F2 = M2[[5]] + n;
     NNFA[    
            n + M2[[1]],
            Union[ M1[[2]], M2[[2]] + n ],
            Join[ M1[[3]], M2[[3]] ],
            Union[ I1, I2 ],
            Union[ F1, F2 ],
            Max[ M1[[6]], M2[[6]] ] 
     ]
];
unionNNFA[ M1_NNFA, M2_NNFA, M___NNFA ] := 
     unionNNFA[ unionNNFA[ M1, M2 ], M ];
       
concatenateNNFA[ M1_NNFA, M2_NNFA ] := 
Module[ {n=M1[[1]], I1=M1[[4]], F1=M1[[5]], I2, F2},
     I2 = M2[[4]] + n;
     F2 = M2[[5]] + n;
     
     NNFA[    
	   n + M2[[1]],
	   Union[ M1[[2]], M2[[2]]+n, CartesianProduct[F1,I2] ],
	   Join[ M1[[3]], M2[[3]] ],
	   If[M1[[6]]==0, I1, Union[ I1, I2 ] ],
	   If[M2[[6]]==0, F2, Union[ F1, F2 ] ],
	   M1[[6]] M2[[6]]
     ]
];
concatenateNNFA[ M1_NNFA, M2_NNFA, M___NNFA ] := 
    concatenateNNFA[ concatenateNNFA[ M1, M2 ], M ];
       
starNNFA[ M_NNFA ] := 
    ReplaceParts[ M, Union[ Zwei[M], CartesianProduct[M[[5]],M[[4]]] ], 2, 
1, 6 ];




































BuildStarDFA[ w_?WordQ, K:(_?AlphabetQ):$alphabet ] :=

    Module[  {n,lab,tr,k,alph},      
    {k,alph} = MakeAlphabet[K,Full->True];
    lab = ToIndex[w,alph];
    n   = Length[lab];
    tr  = Thread[ { Range[n],lab,RotateLeft@Range[n] } ];
    tr  = Last /@ 
          (FA[ n, ShortAlphabetSize[K], tr, {1}, {1}, {}, {} ] // CompleteFA 
// Transitions // Sort);
    DFA[ Max@Flatten[tr], ShortAlphabetSize[K], Thread@Partition[tr,k], 
        1, {1}, 
         ShortAlphabet[K], {} ]
];

































CirculantSA[n_Integer,dd_List,lab_List,K:(_?AlphabetQ):$alphabet] := 
With[
     { ed   = Edges@CirculantGraph[n,dd]}, 
     SA[ n, ShortAlphabetSize[K], Thread[{First/@ed, lab,Last/@ed}], 
        ShortAlphabet[K], {} ]
];





































Options[CoAccessibleFA]={Normalize\[RuleDelayed]$defaultnormalize,
      External\[RuleDelayed]$defaultexternal};

CoAccessibleFA[M_?FSMQ,opts___?OptionQ]:=
    Module[{mc,perm},
      	norm=
        Normalize/.\[InvisibleSpace]{opts}/.\[InvisibleSpace]Options[
            AccessibleFA];
      	mc=ReverseFA[AccessibleFA[ReverseFA[M],Normalize\[Rule]1]];
      	If[norm\[Equal]0,Return[NormalizeFA[mc]]];
      	perm=Last/@Sort[Pairs[States[mc],Range[Size[mc]]]];
      	res=PermuteFA[mc,perm];
      	If[ norm\[Equal]1,Return[res]];
      	ReplacePart[res,
        States[M]\[LeftDoubleBracket]
            States[mc]\[RightDoubleBracket]\[LeftDoubleBracket]
          perm\[RightDoubleBracket],-1]
      ];









































ComplementFA[ M_?FSMQ ] := 
Module[ {MM},
     MM = ToDFA[M];
     ReplacePart[ MM, Complement[Range[Size[MM]],Final[MM]], 5 ] 
];

ComplementFA[ M1_?FSMQ, M2_?FSMQ, opts___?OptionQ ] := 
Module[ {MM1,MM2},
     MM1 = ToDFA[M1];
     MM2 = ComplementFA[M2];
     IntersectionFA[ MM1, MM2, opts ]
];































CompleteFA[ m_FA ] := 
Module[ {n1,deg,add,tr,k},
    deg  = DegreesFA[m];
    If[ Min[Flatten[deg]] > 0, Return[m] ];
    k   = AlphabetSize[m];
    n1  = Size[m] + 1;
    tr  = Transitions[m];
    add[d_Integer,{s_Integer,p_Integer} ] := 
        If[ d==0, AppendTo[ tr, {p,s,n1} ]; ];
    MapIndexed[ add, deg, {2} ];
    tr  = Join[ tr, CartesianProduct[{n1},Range[k],{n1}] ];
    res = ReplaceParts[ m, n1, 1, tr, 3 ];
    If[ MinusEins[m]==={},
        res,  
	ReplacePart[ res, Append[ States[m], $bottom ], -1 ] 
    ]
];

CompleteFA[ M_DFA ] := M;
CompleteFA[ M_NFA ] := ToNFA@CompleteFA@ToFA[M];
CompleteFA[ M_SA ]  := ToSA@CompleteFA@ToFA[M];

































CompleteQFA[ M_?FSMQ ] := !MemberQ[ FlattenOne[ DegreesFA[M] ], 0 ];















































Options[ComputationFA]={Full\[Rule]True};

ComputationFA[ M_DFA|M_FA|M_SA, xx_?WordQ, opts___?OptionQ ] := 
    ComputationFA[ ToNFA[M], xx, opts ];

ComputationFA[ M_NFA, xx_?WordQ, opts___?OptionQ ] :=

    Module[  {alph,A,ff,fff,repl,trac,comps},

    alph = Alphabet[M];
    A = Transitions[M];

    (* build computations *)
    ff[L_List,a_Integer] := ff[p,a] = 
       Flatten /@ CartesianProduct[{Append[L,a]},
       				Union@Flatten[ A[[a,Last[L]]] ] ];
    fff[L_List,a_Integer] := FlattenOne[ ff[#,a]& /@ L ];
    
    (* replace indices by symbols *)
    
      repl[L_List] := MapAt[alph[[#]]&,L,{#}&/@(2Range[Length[L]/2])];   
    trac[L_List] := First /@ Partition[ Append[L,0], 2 ]; 
    
    comps = Last@FoldList[ fff, {#}& /@ Initial[M], ToIndex[xx, alph]];
    If[ Full /. {opts} /. Options[ComputationFA], 
        repl /@ comps,
        trac /@ comps 
    ] 
];































ComputationGraphFA[ M_FA, w_?WordQ, opts___?OptionQ ] := 
	ToTDGraph[ 
		Function[ i, Drop[#,{2}]& /@ Cases[ Transitions[M], {_,i,_} ] ] /@ 
		ToIndex[ w, Alphabet[M] ], Size[M] ];

ComputationGraphFA[ M_NFA|M_SA|M_DFA, w_?WordQ, opts___?OptionQ ] := 
	ComputationGraphFA[ ToFA[M], w, opts ]; 







































Options[ConcatenateFA]={EpsElim\[Rule]True,
      Normalize\[RuleDelayed]$defaultnormalize};

ConcatenateFA[ M1_?FSMQ, M2_?FSMQ, M__?FSMQ, opts___?OptionQ ] := 
    ConcatenateFA[ ConcatenateFA[ M1, M2, opts ], M, opts ]; 

ConcatenateFA[ M1_?FSMQ, M2_?FSMQ, opts___?OptionQ ] := 
    Which[ 
     Head[M1]===BEFA && Head[M2]===BEFA,  concatenateBEFA[M1,M2],
     Head[M1]===NNFA && Head[M2]===NNFA,  concatenateNNFA[M1,M2],
     True,                                
      concatenateFA[ ToFA[M1], ToFA[M2], opts ]
    ];

concatenateFA[ M1_FA, M2_FA, opts___?OptionQ ] := 
Module[ {k,kk,KK,n1,n2,Q1,Q2,Tmid,Tr,norm,eps,M},
      
           norm = Normalize /. {opts} /. Options[ConcatenateFA];
           eps  = EpsElim /. {opts} /. Options[ConcatenateFA];
           
           {k,kk,KK} = GetAlphabet[M1];
           n1 = Size[M1];
           n2 = Size[M2];
           Tmid = CartesianProduct[ Final[M1], {0}, Initial[M2]+n1 ];
           Tr   = Join[ Transitions[M1], Tmid, 
                            shiftrans[n1,n1,#]& /@ Transitions[M2] ];
           res  = FA[ n1+n2, kk, Tr, Initial[M1], Final[M2]+n1, KK, {} ];
           If[ eps, res = EpsilonEliminationFA[res] ];
           Switch[ norm,
        	0, res, 
        	1|2, 
        ReplacePart[ res, 
          Join[{1,#}& /@ States[M1], {2,#}& /@ States[M2]], -1 ]
             ]
      ];





































Options[ConvertToFA]={Normalize\[RuleDelayed]$defaultnormalize,
      ToMatrix\[Rule]False};

ConvertToFA[ H_, Q_List, K_, Tr_List, Ini_, Fin_, opts___?OptionQ ] := 
Module[ {QQ,n,k, kk,KK,alph,hh,A,totrans,norm,tomat},
    norm  = Normalize /. {opts} /. Options[ConvertToFA];
    tomat = ToMatrix  /. {opts} /. Options[ConvertToFA];
    
    n  = Length[Q];
    QQ = If[ norm==0, {}, Q ];
   {k, alph} = MakeAlphabet[K,Full\[Rule]True];
    kk = ShortAlphabetSize[K];
    KK = ShortAlphabet[K];
    AssignFunction[hh,Q,Range[n]];
    hh[x_Integer] := x;
    totrans[{x_,y_Integer,z_}] := {hh[x],y,hh[z]};
    totrans[{x_,y_,z_}] := {hh[x],First@ToIndex[y,alph],hh[z]};
     
    Switch[ H,
    DFA, If[ tomat, 
             A = TransitionsToMatrix[n,k,totrans /@ Tr,Type\[Rule] "DFA" ],
             A = Map[ hh, Tr, {2} ]
         ];
         DFA[ n, kk, A, hh[Ini], hh/@Fin, KK, QQ ],
    NFA, If[ tomat,
             A = TransitionsToMatrix[n,k,totrans /@ Tr],
             A = Map[ hh, Tr, {3} ]
         ];
         NFA[ n, kk, A, hh/@Ini, hh/@Fin, KK, QQ ],
    FA,  FA[ n, kk, totrans /@ Tr, hh/@Ini, hh/@Fin, KK, QQ ]
    ]
];
     
ConvertToFA[ SA, Q_List, K_, Tr_List, opts___?OptionQ ] := 
Module[ {QQ,n,kk,KK,alph,hh,A,totrans,norm},
    norm  = Normalize /. {opts} /. Options[ConvertToFA];
    
    n  = Length[Q];
    QQ = If[ norm==0, {}, Q ];
    alph = MakeAlphabet[K];
    kk = ShortAlphabetSize[K];
    KK = ShortAlphabet[K];
    AssignFunction[hh,Q,Range[n]];
    hh[x_Integer] := x;
    totrans[{x_,y_,z_}] := {hh[x],First@ToIndex[y,alph],hh[z]};
     
    SA[ n, kk, totrans /@ Tr, KK, QQ ]
];

     










































Options[CounterDFA]={Normalize\[RuleDelayed]$defaultnormalize,
      Modulus\[Rule]0};

CounterDFA[ a_?WordQ, n_Integer?NonNegative, K:(_?AlphabetQ):$alphabet, 
      opts___?OptionQ ] := 
    CounterDFA[ a, {n}, K, opts ];

CounterDFA[ a_?WordQ, n_Integer?Negative, K:(_?AlphabetQ):$alphabet, 
      opts___?OptionQ ] := 
    CounterDFA[ a, Range[0,-n], K, opts ];

CounterDFA[ a_?WordQ, LL_List, K:(_?AlphabetQ):$alphabet, 
      opts___?OptionQ ] := 
Module[{A,R,p,k,alph,mm,norm},
      
          norm = Normalize /. {opts} /. Options[CounterDFA];
      
      If[ (mm = Modulus /. {opts} /. Options[CounterDFA]) > 0, 
        	Return[ modCounterDFA[ a, LL, mm, K,norm ] ] ];
      
          {k,alph} = MakeAlphabet[K,Full->True];
          nn = Max[LL] + 2;
          R  = Range[nn];
          p  = First@ToIndex[a,alph];
          
      A  = Join[ Table[R,{p-1}], {Append[Range[2,nn],nn]}, Table[R,{k-p}] ];
          
      mm = DFA[ nn, ShortAlphabetSize[K], A, 1, LL+1, ShortAlphabet[K], {} ];
          If[ norm==0,
                mm,  
                ReplacePart[ mm, Range[0,nn-1], -1 ] 
            ]
      ];

Options[modCounterDFA]={Normalize\[RuleDelayed]$defaultnormalize};

modCounterDFA[ a_, LL_List, m_Integer, K:(_?AlphabetQ):$alphabet, norm_ ] := 
    Module[{A,R,p,k,alph },
          
          {k,alph} = MakeAlphabet[K,Full\[Rule]True];
          R = Range[m];
          p = First@ToIndex[a,alph];
          A = Join[ Table[R,{p-1}], {RotateLeft[R]}, Table[R,{k-p}] ];
          
      res = DFA[ m, ShortAlphabetSize[K], A, 1, Union@Mod[ LL,m]+1, 
          ShortAlphabet[K], {} ];
          If[ norm==0,
                res, 
                ReplacePart[ res, Range[0,m-1], -1 ]
            ]
      ];





































Options[CoverQDFA]={DoTrace\[Rule]False};

CoverQDFA[ M1_DFA, M2_DFA, opts___?OptionQ ] :=
    
    Module[ { n1, n2, Q1, Q2, h, dom, rng, prefin2, cover, trace },
           trace = DoTrace /. {opts} /. Options[CoverQDFA];
           
           n1 = Size[M1];
           n2 = Size[M2];
      
           If[ !MakeHomomorphismDFA[ h, M1, M2 ], Return[False] ];
           
           (* 
        test h for surjectivity and compatibility with final states  *)
      \
     dom = Select[ Range[n1], (h[#] > 0)& ];
           rng = Union[ h[dom] ];
           If[ Length[ rng ] < n2, Return[False] ];
           
           prefin2 = Select[ dom, (MemberQ[ Final[M2], h[#] ])& ];
           cover = Sort[ Intersection[Final[M1],dom] ]===Sort[prefin2];
      
           If[ trace, 
                 If[ cover, 
          	Thread[{States[M1][[dom]],States[M2][[h[dom]]]}], False ],
                 cover
             ]
      ];










































Options[DefiniteQFA]={Full\[Rule]False,
      External\[RuleDelayed]$defaultexternal};

DefiniteQFA[ M_?FSMQ, opts___?OptionQ ] := 
    Module[ {mm,gr},
      
          mm = ToSA[M];
          If[ External /. {opts} /. Options[DefiniteQFA],
        	Return[ Automata`extaut`ExtDefiniteQFA[ mm, opts ] ] ];
      
          gr = ToGraphFA@SquareSA[mm,Full\[Rule] 0];
      
          If[ Full /. {opts} /. Options[DefiniteQFA],
                LongestPath[gr],
                
        Length@StronglyConnectedComponents[gr,NonTrivial\[Rule] True]\[Equal] 
          1
            ]
      ]; 



































Options[DegreesFA]={Direction\[Rule]Forward,Full\[Rule]True};

DegreesFA[ m_?FSMQ,opts___?OptionQ ] := 
    Block[ {res},
      	res = If[ Forward===(Direction /. {opts} /. Options[DegreesFA]),	
          	Map[ Length, Transitions@ToNFA[m], {2} ],
          	Map[ Length, Transitions@ToNFA@ReverseFA[m], {2} ]
          	];
      
      	If[ Full /. {opts} /. Options[DegreesFA],
        		res,
        		Apply[ Plus, Thread[res],{1}]
        	]
      ];



































Options[DeleteStateFA]={Normalize\[Rule]1};

DeleteStateFA[m_FA|m_SA,P_List,opts___?OptionQ] := 
    Module[ {tt,n,nn,Q,nQ,h,R,newtr},
           {k,kk,KK} = GetAlphabet[m];
           n  = Size[m];
           R  = Complement[Range[n],P];
           nn = n - Length[P];
           AssignFunction[h,R,Range[nn]];
           newtr[{pp_,a_,qq_}] := {h[pp],a,h[qq]};
           tt = newtr /@ Select[Transitions[m],
                       (!MemberQ[P,First[#]]&&!MemberQ[P,Last[#]])&];
           res = If[ Head[m]===FA,
                         FA[ nn, kk, tt, h /@ Complement[Initial[m],P],
                               h /@ Complement[Final[m],P], KK, {} ],
                         SA[ nn, kk, tt, KK, {} ]
                     ];
           Switch[ Normalize /. {opts} /. Options[DeleteStateFA],
        	 0, res,
                 1, ReplacePart[ res, R, -1 ],
                 2, ReplacePart[ res, States[m][[R]], -1 ]
             ]         
      ];
      
DeleteStateFA[m_FA|m_SA,p_Integer,opts___?OptionQ] := 
    DeleteStateFA[m,{p},opts];
DeleteStateFA[m_DFA,pp_,opts___?OptionQ] := DeleteStateFA[ToFA[m],pp,opts];









































Options[DeterministicQFA]={Full\[Rule]False,Direction\[Rule]Forward};
SetAttributes[DeterministicQFA,Listable];

DeterministicQFA[ MM_SA, opts___?OptionQ ] := 
Module[ {n, s2, ss2, dd, P, pos, fa, lp, M},
    
    	If[  Forward===(Direction /. {opts} /. Options[DeterministicQFA]),
        		M = MM, M = ReverseFA[MM] ];
      
            If[ ! (Full /. {opts} /. Options[DeterministicQFA]),  
              		Return[ detQFA[M] ] ];
          
          	n = Size[M];
          	{s2,dd} = 
        SquareSA[M,Full\[Rule]1,Normalize\[Rule]1,DoTrace\[Rule]True];
          	
      P = Complement[ Last /@ Select[Transitions[s2],MemberQ[dd,#[[1]]]&],
          dd ] ;
          	If[ P == {}, Return[0]];
          	P = With[ {Q=States[s2]}, Q[[#]] & /@ P ];
          	ss2 = SquareSA[ M, Full\[Rule] 2,Normalize\[Rule]1 ];
          	pos = PositionList[ States[ss2], P ];
          	fa  = SetInitialFinalFA[ ss2, pos, Range[Size[ss2]] ];
          	If[ InfiniteQFA[fa], Return[Infinity] ];
          	lp = LongestPath[ ReverseGraph@ToGraphFA[fa] , Full -> True];
          	Max[ lp[[pos]] ] + 1
      ];

DeterministicQFA[ M_?FSMQ, opts___?OptionQ ] := 
        DeterministicQFA[  ToSA[M], opts ]; 

detQFA[ m_DFA ] = True;
detQFA[ m_NFA ] := Max[Length /@ FlattenOne@Transitions[m] ] <= 1;
detQFA[m_SA|m_FA] := detQFA@ToNFA[m];













































DFA[n_,k_,t_,i_,f_] := DFA[n,k,t,i,f,{},{}];























































Options[DivisibilityDFA]={Direction\[Rule]Forward,Full\[Rule]False,
      SizeOnly\[Rule]False};

DivisibilityDFA[m_Integer?Positive,1,opts___?OptionQ]:=
    If[ SizeOnly/.{opts}/.Options[DivisibilityDFA],
      sizeDivisibility[m,1,opts],
      DFA[m,-1,{RotateLeft[Range[m]]},1,{1},{},Range[m]-1]
      ];

DivisibilityDFA[m_Integer?Positive,B_Integer?Positive,
      opts___?OptionQ]:=
    (
      	If[SizeOnly/.{opts}/.Options[DivisibilityDFA],
        		Return[sizeDivisibility[m,B,opts]]];
      	If[Full/.{opts}/.Options[DivisibilityDFA],
        		Return[canonicalDFA[m,B,opts]]];
      	If[Forward===(Direction/.{opts}/.Options[DivisibilityDFA]),
        		divisibilityDFA[m,B],
        		divisibilityDFAReverse[m,B]]
      );

canonicalDFA[m_Integer?Positive,B_Integer?Positive,opts___?OptionQ]:=
    
    Module[{Q},
      If[Forward===(Direction/.{opts}/.Options[DivisibilityDFA]),
        Return[
          DFA[m,-B,Thread@Partition[Mod[Range[m B]-1,m],B]+1,1,{1},{},
            Range[0,m-1]]]
        ];
      Q=CartesianProduct[Range[0,m-1],Closure[{1},Mod[B #,m]&]];
      FunctionToDFA[Q,-B,
        Function[{p,a},{Mod[p[[1]]+a p[[2]],m],Mod[p[[2]] B,m]}],
        Flatten@Position[Q,{0,1}],Flatten@Position[Q,{0,_}],
        Alphabetic\[Rule]False,Normalize\[Rule]1]
      ];

solveModEq[m_Integer?Positive,B_Integer?Positive,r_Integer,c_Integer] := 
    Module[{XXX,res},
      	res=
        XXX/.Cases[
            Solve[{B^r XXX+c\[Equal]0,Modulus\[Equal]m},XXX,
              Mode\[Rule]Modular],
            		{Modulus\[Rule]m,___}];
      	Switch[res,XXX,{},{XXX},Range[0,m-1],_,res ]
      ];

solveModEq[m_Integer?Positive,B_Integer?Positive,r_Integer,cc_List ] := 
    	 solveModEq[m,B,r,#]& /@ cc ;

solveModEq [m_Integer?Positive,B_Integer?Positive,r_Integer] := 
    solveModEq[m,B,r,Range[0,Min[m,B^r]-1,GCD[B^r,m] ] ];

Attributes[solveStrictModEq]={Listable};
solveStrictModEq[_,_,0]:={{{0},0}};

solveStrictModEq[ m_?Positive,B_?Positive,r_Integer?Positive ]:=
    
    Module[{cc,sol,pre},
      cc=Range[0,Min[B^r,m]-1,GCD[B^r,m]];
      sol=solveModEq[m,B,r,cc];
      pre=Flatten[solveModEq[m,B, r-1]];
      DeleteCases[ Pairs[Complement[#,pre]&/@sol,cc],{{},_}]
      ];

solvemB[m_,B_,c_List]:=Sort@FlattenOne[solvemB[m,B,#]&/@c];

divisibilityDFAReverse[m_Integer?Positive,B_Integer?Positive]:=
    
    Module[{r,Q,del},
      	r=Max[divisibilityRankPlus[m,B],divisibilityStable[m,B]];
      	Q=FlattenOne@Table[solveModEq[ m,B,i],{i,0,r}];
      	If[GCD[m,B]>1,AppendTo[Q,{}]];
      	del[P_List,s_Integer]:=Sort@FlattenOne@solveModEq[m,B,1,s-P];
      	FunctionToDFA[ Q,-B,del,1,PositionList[Q,Cases[Q,{0,___}]],
        		Alphabetic\[Rule]False,Normalize\[Rule]1]
      ];

divisibilityDFA[m_Integer?Positive,B_Integer?Positive]:=
    
    Module[{r,Q,del},
      	r=divisibilityRankPlus[m,B];
      	Q=First/@FlattenOne@Table[solveStrictModEq[m,B,i],{i,0,r}];
      	del[P_List,s_Integer]:=Q[[Position[Q,First@Mod[B P+s,m]][[1,1]]]];
      	FunctionToDFA[Q,-B,del,1,{1},Alphabetic\[Rule]False,Normalize\[Rule]1]
      ];

Attributes[WeakQuotient]={Listable};
WeakQuotient[x_,y_]:=x/GCD[x,y];

Attributes[plainSlice]={Listable};
plainSlice[r_,m_,B_,s_,kk_] :=
    (
      		If[  r \[LessEqual] s,  
        Return[ Min[WeakQuotient[m,B^r],WeakQuotient[B^r,m]]]];
      		If[  s < r < kk,  
        Return@(  WeakQuotient[B^r,m]- WeakQuotient[B^(r-1),m ]) ];
      		If[ s < kk && r \[Equal] kk,   
        Return[ WeakQuotient[m,B^kk]- WeakQuotient[B^(kk-1),m ]]];
      		0
      );

plainSlice[m_,B_] := 
    Module[ {s,kk},
      		s = divisibilityStable[m,B];
      		kk =divisibilityRankPlus[m,B];
      		plainSlice[ Range[ 0, Max[s,kk] ], m, B, s, kk ]
      ];	

Attributes[strictSlice]={Listable};
strictSlice[r_,m_,B_,s_,k_,kk_] :=
    (
      	If[  k < s ,  
        		If[ r\[LessEqual] k, Return[WeakQuotient[B^r,m]]];
        		
        res =  Min[WeakQuotient[m,B^kk],
            WeakQuotient[m,B^k]-WeakQuotient[B^k,m]];
        		If[ r\[Equal] kk,Return[res] ];
        		Return[0];
        	];
      
      	If[  r \[LessEqual] s,  Return[ WeakQuotient[B^r,m]]];
      	If[  s < r \[LessEqual] k,  
        Return[  WeakQuotient[B^(r),m]- WeakQuotient[B^(r-1),m ] ] ];
      	If[  r \[Equal] kk,   
        Return[ WeakQuotient[m,B^kk]- WeakQuotient[B^k,m ]]];
      	0
      );
strictSlice[m_,B_] :=
    Module[ {s, k,kk},
      	s = divisibilityStable[m,B];
      	k = divisibilityRank[m,B];
      	kk = divisibilityRankPlus[m,B];
      	strictSlice[ Range[0,kk], m, B,s,k,kk ]
      ];

sizeDivisibility[m_Integer?Positive,1,opts___?OptionQ]:=
    
    If[ Full/.{opts}/.Options[DivisibilityDFA],
      Table[1,{m}],
      m
      ];

sizeDivisibility[m_Integer?Positive,B_Integer?Positive,opts___?OptionQ]:=
    
    If[Forward===(Direction/.{opts}/.Options[DivisibilityDFA]),
      	With[ {res = strictSlice[m,B]},
        	If[ Full/.{opts}/.Options[DivisibilityDFA], res, Total[res] ]],
      	sizeDivisibilityRev[m,B,opts]
      ];

sizeDivisibilityRev[m_Integer?Positive,B_Integer?Positive,opts___?OptionQ]:=
 
       With[ {res = plainSlice[m,B]},
      If[ Full/.{opts}/.Options[DivisibilityDFA], 
        	res, 
        	Total[res] +If[GCD[m,B]\[Equal]1,0,1] ]
      ];

divisibilityRank[m_Integer?Positive,B_Integer?Positive] := Floor[Log[B,m]]; 
divisibilityRankPlus[m_Integer?Positive,B_Integer?Positive] := 
    Ceiling[Log[B,m]]; 

divisibilityStable[m_Integer?Positive,B_Integer?Positive]:=
    
    Module[{mf,Bf,P},
      	If[GCD[m,B]\[Equal]1,Return[0]];
      	mf=FactorInteger[m];
      	Bf=FactorInteger[B];
      	P=Intersection[First/@mf,First/@Bf];
      	Max@
        Ceiling[(Last/@Select[mf,MemberQ[P,First[#]]&])/(Last/@
                Select[Bf,MemberQ[P,First[#]]&])]
      ];





















































EmptyDFA[ K:(_?AlphabetQ):$alphabet ] := 
    DFA[1, ShortAlphabetSize[K], Table[{1},{AlphabetSize[K]}], 1, {}, 
	ShortAlphabet[K], {} ];





























EmptyQFA[ M_?FSMQ ] := Final@AccessibleFA[M]==={};

















































EpsilonFreeQ[ _DFA]:= True;
EpsilonFreeQ[ M_FA|M_SA ] := Cases[Transitions[M], {_,0,_} ]==={};
EpsilonFreeQ[ M_BEFA ] := 
    Cases[Transitions[M], {_,Eps|"Eps"|Global`\[Epsilon],_} ]==={};















































Options[EpsilonEliminationFA]={DoTrace\[Rule]False,
      Normalize\[RuleDelayed]$defaultnormalize,
      External\[RuleDelayed]$defaultexternal};

EpsilonEliminationFA[ M_FA, opts___?OptionQ ] :=
    
    Module[ {Lout,close,eps,neps,Tr1,Ini,Ini0,Fin,n,g,
             epsadjlst,G,component,trace,ext},
           trace = DoTrace /. {opts} /. Options[EpsilonEliminationFA];
      
           If[ EpsilonFreeQ[M], Return[M] ];
      
           
      If[ !trace && (External /. {opts} /. Options[EpsilonEliminationFA]), 
                 Return[ Automata`extaut`ExtEpsilonEliminationFA[M,opts] ] ];
      
           n   = Size[M];
           Ini = Initial[M];
           Fin = Final[M];
           eps = Drop[#,{2}]& /@ Cases[Transitions[M], {_,0,_} ];
           If[ eps==={}, Return[M] ];
           neps = DeleteCases[ Transitions[M], {_,0,_} ];
           
           
      close[ {p_,a_,q_} ] :=
              
        Partition[ Flatten@CartesianProduct[ {{p,a}}, Lout[[q]] ], 3 ];
           
           epsadjlst[x_]  := Flatten[ Select[eps,(#[[1]]===x)&] ];
          
           component[ x_ ] := 
             Module[ { h, hh, dfs, dfsact, count=1 },
                       h[_]=0;
                       dfs[ z_Integer ] := Scan[  dfsact, G[[z]] ];   
                       dfsact[ z_ ] := 
                             
            If[ h[z]==0, h[z]=count++; hh[count]=z; dfs[z] ];
                       h[x]  = 1;
                       hh[1] = x;
                       dfs[ x ];
                       hh /@ Range[count]
               ];
           
           G    = epsadjlst /@ Range[n]; 
           Lout = component /@ Range[n];
           Tr1  = Union[ Flatten[ close /@ neps, 1 ] ];
           Ini0 = Union[ Flatten[ Lout[[#]]& /@ Ini ] ];
           res  = ReplacePart[ ReplacePart[ M, Tr1, 3 ], Ini0, 4 ];
           If[ trace,
                 { res, eps, neps, Lout},
                 res
             ]
      ];

EpsilonEliminationFA[ M_BEFA, opts___?OptionQ ] := 
         EpsilonEliminationFA[ M // ToFA, opts ];

EpsilonEliminationFA[ M_SA, opts___?OptionQ ] := 
         EpsilonEliminationFA[ M // ToFA, opts ] // ToSA;

EpsilonEliminationFA[ M_DFA|M_NFA, opts___?OptionQ ] := M;

















































(* should use Union/Find *)

Options[EquivalentQFA]={DoTrace\[Rule]False,
      External\[RuleDelayed]$defaultexternal};

SetAttributes[EquivalentQFA,Listable];

EquivalentQFA[ M1_?FSMQ, M2_?FSMQ, opts___?OptionQ ] := 
         If[ External /. {opts} /. Options[EquivalentQFA], 
               Automata`extaut`ExtEquivalentQFA[ M1, M2 ],
      
               If[ DoTrace /. {opts} /. Options[EquivalentQFA],
        	     equivalentfull[ToDFA[M1],ToDFA[M2]], 
        	     equivalentfast[ToDFA[M1],ToDFA[M2]]
                 ]
           ];


equivalentfull[M1_DFA,M2_DFA] := 
    Module[ {n1,n2,nn,K,FF,uf,act,p,q,r1,r2,L},
      	n1 = Size[M1];
      	n2 = Size[M2];
      	nn = n1 + n2;
      	K = Alphabet[M1];
      	FF = Join[ Final[M1], Final[M2] + n1 ];
      	
      	AssignFunction[uf,Range[nn],Range[nn]];
      	
      	TransitionFunctionFA[M1,del1];
      	TransitionFunctionFA[M2,del2];
      	
      	act = {{TheInitial[M1],TheInitial[M2]}};
      	
      	While[ act =!= {},
        		{p,q} = First[act];
        		act = Rest[act];
        		r1 = FixedPoint[uf,p];
        		r2 = FixedPoint[uf,q+n1];
        		
        		If[ r1 != r2, 
          			uf[r2] = r1;
          			Scan[  AppendTo[act,{del1[p,#],del2[q,#]}]&, K ];
          		];
        	];
      	L = FixedPoint[uf,#]& /@ Range[nn];
      	{n1,n2,FF,ToClasses[Range[nn],L,Type->Index]}
      ];	


equivalentfast[M1_DFA,M2_DFA] := 
    Module[ {n1,n2,nn,K,F1,F2,uf,act,p,q,r1,r2},
      	n1 = Size[M1];
      	n2 = Size[M2];
      	nn = n1 + n2;
      	K = Alphabet[M1];
      	F1 = Final[M1];
      	F2 = Final[M2];
      	
      	AssignFunction[uf,Range[nn],Range[nn]];
      	
      	TransitionFunctionFA[M1,del1];
      	TransitionFunctionFA[M2,del2];
      	
      	act = {{TheInitial[M1],TheInitial[M2]}};
      	
      	Catch[
        		While[ act =!= {},
          		       {p,q} = First[act];
          		       act = Rest[act];
          		       r1 = FixedPoint[uf,p];
          		       r2 = FixedPoint[uf,q+n1];
          		       If[ Xor[ MemberQ[F1,p], MemberQ[F2,q] ], Throw[False] ];
          			
          		       If[ r1 != r2, 
            			   uf[r2] = r1;
            			   Scan[  AppendTo[act,{del1[p,#],del2[q,#]}]&, K ];
            		       ];
          	        ];
        		Throw[True]
        	]
      ];



































Options[FactorialQFA]={Full\[Rule]False,
      External\[RuleDelayed]$defaultexternal};

FactorialQFA[m_?FSMQ,opts___?OptionQ]:=
    Module[{mm,p,sa,res},
      	mm=MinimizeFA[m,SelectOptions[MinimizeFA,opts,{Full}]];
      	If[Size[mm]\[Equal]1,Return[True]];
      	p=TrapStatesFA[mm,Full\[Rule]False];
      	If[p\[Equal]0,Return[False]];
      	sa=ToSA[DeleteStateFA[mm,p]];
      	res=IsomorphicQDFA[mm,
          	MinimizeFA[sa,SelectOptions[MinimizeFA,opts,{Full}]]];
      	If[
        Full/.\[InvisibleSpace]{opts}/.\[InvisibleSpace]Options[
            FactorialQFA],{res,sa},res]
      ];



































FA[n_,k_,t_,i_,f_]  :=  FA[n,k,t,i,f,{},{}];

























FinalVectorFA[ M_?FSMQ, opts___?OptionQ ] :=
         
    ToBitVector[Final[M],Size[M]];

PathToWord[ M_?FSMQ, LL_List ] := 
Module[ {tr,run},
	tr  = Transitions@ToFA[M];
	run = Zwei@First@Cases[tr, {First[#],_,Last[#]}]& /@ Partition[LL,2,1];
	ToWord[ run, Alphabet[M] ]
];



























Final[ M_DFA|M_NFA|M_FA ] := M[[5]];
Final[ M_SA ] := Range@Size[M];



































Options[FiniteComplementSA]={Normalize\[RuleDelayed]1};

FiniteComplementSA[ w_?WordQ, K_:2, opts___?OptionQ ] := 
    		FiniteComplementSA[ {w}, K, opts ];

FiniteComplementSA[ W_List, K_:2, opts___?OptionQ ] := 
    Block[{k,alph,tr,n,Q,norm,test,maketr,edge},
           norm = Normalize /. {opts} /. Options[FiniteComplementSA];
           
           maketr[xx_String]  := 
             If[ StringLength[xx]<n,
          	     {StringDrop[xx,-1],Last@ToIndex[xx,alph],xx},
          	     {StringDrop[xx,-1],Last@ToIndex[xx,alph],StringDrop[xx,1]}
               ];
          
           {k,alph} = MakeAlphabet[K,Full->True];
           n = Max[ WordLength /@ W ];
           Q = Words[ -n, alph ];
           Q = Select[ Q, 
               (!Or@@(Function[xx,StringMatchQ[#,xx]]/@
                      Concatenate["*",W,"*"])&) ];
           tr  = ToEps[ maketr /@ Rest[Q] ] /. RankingRules[Q];
           Q = Select[ Q, WordLength[#]<n& ];
           
      res = SA[ Length[Q], ShortAlphabetSize[K], tr, ShortAlphabet[K], {} ];
           If[ norm==0, 
                 res, 
                 ReplacePart[ res, Q, -1 ]
             ]     
      ];





































































































FrontierToDFA[{eqq_List,F_List},K:(_?AlphabetQ):$alphabet] := 
    FrontierToDFA[eqq,F,K];

FrontierToDFA[eqq_List,F_List,K:(_?AlphabetQ):$alphabet] := 
Module[ {eqL,n,Q,delta,del,next,q,KK,epsrules},
      epsrules = {Eps\[Rule] "Eps",""\[Rule] "Eps",
          Global`\[Epsilon]\[Rule] "Eps"};
           KK  = MakeAlphabet[K];
           eq  = Map[ ToString, RulesToPairs[eqq], {2} ];
           eqL = First /@ eq;
           Q = WordSort[Union[Flatten[WordPrefixes[eqL,Full\[Rule]False]]]];
           n   = Length[Q];
           AssignFunction[ next, eq/. epsrules ];
           delta[p_,s_] := 
              ( q = Concatenate[p,s]; If[MemberQ[Q,q],q,next[q]] );
           del[s_] := delta[#,s]& /@ Q;
           DFA[ n, K, PositionList[Q,del[#]]& /@ KK, 1, 
                  PositionList[Q,F/.epsrules], KK, Q ]
      ];





























FSMQ[x_]  := MemberQ[{DFA,NFA,FA,BEFA,NNFA,SA},Head[x]];
matFAQ[x_] := MemberQ[{DFA,NFA},Head[x]];



























FullQFA[ M_?FSMQ ] := EmptyQFA[ ComplementFA[M]];







































Options[FullTransitionMatrixFA]={Type\[Rule]None,Full\[Rule]False};

FullTransitionMatrixFA[M_NFA|M_DFA|M_SA,opts___?OptionQ]:=
    FullTransitionMatrixFA[ToFA[M],opts];

FullTransitionMatrixFA[M_FA,opts___?OptionQ]:=
    Module[{ff,full},
      full = Full /. {opts} /. Options[FullTransitionMatrixFA];
      Switch[ 
        Type/.\[InvisibleSpace]Release[{opts}]/.\[InvisibleSpace]Options[
            TransitionMatrixFA],
        None,
        	natTransitionMatrixFA[M,ff,full];Total[ff/@Alphabet[M]],
        Boolean,
        	booleanTransitionMatrixFA[M,ff,full];Sign[Total[ff/@Alphabet[M]]],
        Tropical,
        	tropicalTransitionMatrixFA[M,ff,full]; Total[ff/@Alphabet[M]]
        ]
      ];































FullTransitions[ M_FA|M_SA ] := 
With[ {alph = Prepend[ Alphabet[M], "Eps" ]}, 
    MapAt[ alph[[#+1]]&, Thread@Transitions[M], 2 ] // Thread
];
FullTransitions[ M_DFA|M_NFA ] := FullTransitions[ ToFA[M] ];







































Options[FunctionToDFA]={Alphabetic\[Rule]True,
      Normalize\[RuleDelayed]$defaultnormalize};

FunctionToDFA[ Q_List, K_, del_, q0_, F_, opts___?OptionQ ] := 
    Module[ {n,k,alph,KK,A,tt,qq0,FF},
      	n = Length[Q];
      	{k,alph} = MakeAlphabet[K,Full->True];
      	
      	If[ Alphabetic /. {opts} /. Options[FunctionToSA],
        		A = alph, A = Range[0,k-1] ];
      		
      	tt = Map[ PositionOne[Q,#]&,
          		
          Thread@Partition[Apply[ del, CartesianProduct[Q,A],{1}], k], {2}];
      
              (* qq0 = PositionOne[Q,q0];
                FF  = PositionList[Q,F]; *)
      	
      If[ IntegerQ[K], k = K; KK={}, KK=alph ];
      
      	If[ 0 == (Normalize /. {opts} /. Options[FunctionToDFA]),
        	    DFA[ n, k, tt, q0, F, KK, {} ],
        	    DFA[ n, k, tt, q0, F, KK, Q ]
        	]
      ];










































Options[FunctionToSA]={Alphabetic\[Rule]True,
      Normalize\[RuleDelayed]$defaultnormalize};

FunctionToSA[ Q_List, K_?AlphabetQ, del_, opts___?OptionQ ] := 
Module[ {n,k,alph,dist,tt},
	n = Length[Q];
	{k,alph} = MakeAlphabet[K,Full\[Rule] True];
	
	If[ Alphabetic /. {opts} /. Options[FunctionToSA],
		A = alph, A = Range[k] ];
		
	dist[{p_,s_},L_List] := Flatten /@ CartesianProduct[{{p,s}},L];
	tt = Pairs[ FlattenOne@Table[ {j,i}, {j,n}, {i,k} ],
		PositionList[Q,#]& /@ Apply[ del, CartesianProduct[Q,A], {1} ] ];
	tt = FlattenOne@Apply[ dist, tt, {1} ];

	If[ 0 == (Normalize /. {opts} /. Options[FunctionToSA]),
	  SA[ n, ShortAlphabetSize[K], tt, ShortAlphabet[K], {} ],
	  SA[ n, ShortAlphabetSize[K], tt, ShortAlphabet[K], Q ]
	]
];












































Options[GenerateDFA]={Full\[Rule]False,
      Normalize\[RuleDelayed]$defaultnormalize};

GenerateDFA[ q0_, op_, K_, fin_, opts___?OptionQ  ] := 
    Block[ {Q,W,tt,k,n,TT,res},
      
      {Q,W,tt} = GenerateCSM[q0,op,K,
          				Equations\[Rule]Full, 
          				SelectOptions[GenerateCSM,opts,{Equations}] ];
      k =  ShortAlphabetSize[K];
      n = Length[Q];
      TT =Thread@Fold[  ReplacePart[  #1,Last[#2],Most[#2] ]&, 
            				Array[0&,{n,Abs[k]}], tt ];
      res = DFA[ n,k, TT, 
          		PositionOne[Q,q0], PositionList[Q,Select[Q,fin]],
          		ShortAlphabet[K],{} ];
      If[ 0 < (Normalize /. {opts} /. Options[GenerateDFA]),
        res = ReplacePart[res,Q,-1]
        ];
      
      If[ Full /. {opts} /. Options[GenerateDFA],
        	{ res, W },
        	res 
        ]
      ];































GenerateQuotients[ L_, K:(_?AlphabetQ):$alphabet ] :=

    Module[ {Q,curr,A,B,k,alph},
    {k,alph} = MakeAlphabet[K,Full->True];
    curr = 0; 
    Q = { L };
    While[ Length[Q] > curr,
           A = Q[[ ++curr ]];
           B = LeftQuotient[#,A]& /@ alph; 
           If[ !MemberQ[Q,#], AppendTo[Q,#] ]& /@ B 
    ];
    Q
];















































Options[GrowthSeriesDFA]={Full\[Rule]False};

GrowthSeriesDFA[M_DFA,x_,opts___?OptionQ]:=
    Module[{A,gfs,id},
      	id=IdentityMatrix[Size[M]];
      	A=Transpose[FullTransitionMatrixFA[M]];
      	gfs=LinearSolve[id-A x,
          		id[[TheInitial[M]]],SelectOptions[LinearSolve,opts]];
      	res=Simplify[Total[gfs[[Final[M]]]]];
      	If[Full/.{opts}/.Options[GrowthSeriesDFA],
        		{res,gfs},
        		res 
        	]
      ];
































HomomorphismFA[ M_FA, hom_List, K_ ] := 
With[
     { newtr = 
          Union[FullTransitions[M] /. Thread[Alphabet[M]->(ToString/@hom)]],
       m0 = FA[ Size[M], ShortAlphabetSize[K], {}, Initial[M], Final[M], 
              ShortAlphabet[K], {} ] },
     Last@FoldList[ AddTransitionFA, m0, newtr ]
];

HomomorphismFA[ M_DFA|M_NFA, hom_List, K_ ] := 
     HomomorphismFA[ M//ToFA, hom, K ];

HomomorphismFA[ M_?FSMQ, hom_, K_ ] := 
     HomomorphismFA[M, hom /@ Alphabet[M], K ];





























































HurwitzProduct[ L1_List, L2_List ] := 
Module[ {inc,S},

     inc[u_,v_] := 
     CartesianProduct[ WordShuffle[First[u],First[v]],
     {Last[u] Last[v]} ];
       
     S = FlattenOne[ Apply[ inc, CartesianProduct[L1,L2], 1 ]];
     S = Sort[ {WordLength[#[[1]]],#[[1]],#[[2]]}& /@ S ];
     (Rest/@S)  //.
     {x___,{u_,c1_},{u_,c2_},z___} :> {x,{u,c1+c2},z}
];     












































IdealBaseFA[ M_?FSMQ ] := MinimizeFA[ToFactorFA[M,Type\[Rule]"NoFactor"]];































IdealQFA[ MM_?FSMQ ] := 
With[ {all = AllDFA[Alphabet[MM]]},
	EquivalentQFA[ ConcatenateFA[ all, MM, all ], MM ] ];





















































InfiniteQFA[ M_?FSMQ ] := CyclicQGraph@ToGraphFA@TrimFA@ToFA[M];

















































InitialVectorFA[ M_?FSMQ, opts___?OptionQ ] :=
         
    ToBitVector[Initial[M],Size[M]];



























Initial[ M_DFA ]  := If[ Head[M[[4]]]===List, M[[4]], {M[[4]]} ];
Initial[ M_FA|M_NFA ] := M[[4]];
Initial[ M_SA ] := Range@Size[M];







































Options[IntersectionFA]={Full\[Rule]False,
      Normalize\[RuleDelayed]$defaultnormalize};

IntersectionFA[ M1_?FSMQ, M2_?FSMQ, opts___?OptionQ ] := 
                ProductFA[ M1, M2, Type\[Rule] "Intersection", opts ];
    
IntersectionFA[ M1_?FSMQ, M2_?FSMQ, M___?FSMQ, opts___?OptionQ ] := 
    IntersectionFA[ IntersectionFA[ M1, M2, opts ], M, opts ];







































Options[IrreducibleFA]={Full\[Rule]False,
      Normalize\[RuleDelayed]$defaultnormalize};

IrreducibleFA[ L_List, K:(_?AlphabetQ):$alphabet, opts___?OptionQ ] := 
    Module[ {LL,Q,QQ,maketrans,fix,tr,full,norm,alph,aalph},
          full = Full /. {opts} /. Options[IrreducibleFA];
          norm = Normalize /. {opts} /. Options[IrreducibleFA];
          alph = MakeAlphabet[K];
          LL = ToString /@ L;
          Q  = Complement[ Flatten[WordPrefixes[LL]], LL ] // WordSort;
          QQ = Join[ Q, LL ];
          maketrans[ {p_, a_} ] := 
            ( xx = Concatenate[p,a];
                               (* 
            delete prefix until in QQ *)
                
          While[ !MemberQ[ QQ, xx ], xx = StringDrop[xx,1] /. ""->"Eps" ];
                               (* 
            new transition only if xx in Q *)
                
          If[ MemberQ[ Q, xx ], {p,a,xx}, {} ]
              );
          aalph = Complement[ alph, LL ];
          tr = Cases[ maketrans /@ CartesianProduct[ Q, aalph ], {__} ];
          If[ full, 
                fix[{p_,a_,q_}] := 
                  {PositionOne[Q,p], PositionOne[alph,a], PositionOne[QQ,q]};
                res = FA[ Length[QQ], ShortAlphabetSize[K], fix /@ tr, {1}, 
            	          PositionList[QQ,LL], 
                              ShortAlphabet[K], {} ];
                If[ norm==0, 
          	    res, 
           	    ReplacePart[ res, QQ, -1 ]
                  ],
            (* else *)
                fix[{p_,a_,q_}] := 
                  {PositionOne[Q,p], PositionOne[alph,a], PositionOne[Q,q]};
                res = FA[ Length[QQ], AlphabetSize[K], 
                              fix /@ Select[tr,MemberQ[Q,Last[#]]&], 
                              {1}, Range@Length[Q], 
                              ShortAlphabet[K], {} ];
                If[ norm==0, 
          	    res, 
           	    ReplacePart[ res, Q, -1 ]
                  ]
            ]
      ];



































Options[IsomorphicQDFA]={DoTrace\[Rule]False,
      External\[RuleDelayed]$defaultexternal};

IsomorphicQDFA[ M1_DFA, M2_DFA, opts___?OptionQ ] :=

    Module[ { n1, n2, Q1, Q2, k, h, A1, A2, F1, F2, iso, trace },

     If[ Size[M1] != Size[M2], Return[False] ];
     If[ AlphabetSize[M1] != AlphabetSize[M2], Return[False] ];

     trace = DoTrace /. {opts} /. Options[IsomorphicQDFA];
      
      If[ !trace && (External /. {opts} /. Options[IsomorphicQDFA]), 
                 Return[ Automata`extaut`ExtIsomorphicQDFA[M1,M2] ] ];
      
           n1 = Size[M1];
           n2 = Size[M2]; 
           F1 = Final[M1]; 
           F2 = Final[M2];
           If[ Length[F1] != Length[F2], Return[False] ];
             
           If[ !MakeHomomorphismDFA[ h, M1, M2 ], Return[False] ];
           
           (* test h for surjectivity and 
                compatibility with final states  *)
           
      If[ Length[ Union[ h[ Range[n1] ] ] ] != n1, Return[False] ];
           
           iso = Sort[h[F1]]===Sort[F2];
           
           If[ trace, 
                 
        If[ iso, Thread[{States[M1],States[M2][[h[Range[n1]]]]}], False ],
                 iso
             ]
      ];















































Options[IthSymbolFA]={Normalize\[RuleDelayed]$defaultnormalize,
      Full\[Rule]False};

IthSymbolFA[ s_, r_Integer?Negative, K:(_?AlphabetQ):$alphabet, 
      opts___?OptionQ ] :=
Module[{n,A,A1,A2,k,norm},
    If[ Full /. {opts} /. Options[IthSymbolFA],
        	Return[ ithSymbolDFA[s,r,K, opts]]];
          norm = Normalize /. {opts} /. Options[IthSymbolFA];
          k  = AlphabetSize[K];
          ss = First@ToIndex[ s, K ];
          n  = -r+1;
          
      A1 = Append[ 
          Thread[ {Table[1,{k}],Range[k],Table[1,{k}]} ], {1,ss,2} ]; 
          
      A2 = Thread[ {Table[#,{k}],Range[k],Table[#+1,{k}]} ]& /@ Range[2,n-1];
          A = Sort@Join[ A1, FlattenOne[A2] ];
          
      res = FA[n, ShortAlphabetSize[K], A, {1}, {n}, ShortAlphabet[K], {} ];
          If[ norm==0,
                res, 
                ReplacePart[ res, Range[0,n-1], -1 ]
            ]
      ];

IthSymbolFA[ s_, r_Integer?Positive, K:(_?AlphabetQ):$alphabet, 
      opts___?OptionQ ] :=
    Module[{n,A,A1,A2,k,norm},
          If[ Full /. {opts} /. Options[IthSymbolFA],
        	Return[ ithSymbolDFA[s,r,K,opts]]];
          norm = Normalize /. {opts} /. Options[IthSymbolFA];
          k  = AlphabetSize[K];
          ss = First@ToIndex[ s, K ];
          n  = r+1;
          
      A1 = Append[ 
          Thread[ {Table[n,{k}],Range[k],Table[n,{k}]} ], {n-1,ss,n} ]; 
          
      A2 = Thread[ {Table[#,{k}],Range[k],Table[#+1,{k}]} ]& /@ Range[n-2];
          A = Sort@Join[ A1, FlattenOne[A2] ];
          
      res = FA[n, ShortAlphabetSize[K], A, {1}, {n}, ShortAlphabet[K], {} ];
          If[ norm==0,
                res, 
                ReplacePart[ res, Range[0,n-1], -1 ]
            ]
      ];

Options[ithSymbolDFA]={Normalize\[RuleDelayed]$defaultnormalize};

ithSymbolDFA[s_,r_Integer?Negative,K:(_?AlphabetQ):$alphabet,
      opts___?OptionQ] := 
    Block[ {k,alph,norm,torow,next1,next2,si,n,Q1,Q2,Q,tr,F},
           {k,alph} = MakeAlphabet[K,Full\[Rule]True];
           norm = Normalize /. {opts} /. Options[ithSymbolDFA];
           torow[ss_] := Last /@ Sort@Select[tr, (#[[2]]===ss)& ];
           next1[L_List] := {L,#,Append[L,#]}& /@ Range[k];
           next2[L_List] := {L,#,Append[Rest[L],#]}& /@ Range[k];
           
           si  = First@ToIndex[s,alph];
           n   = (k^(-r+1)-1)/(k-1);
           Q1  = Tuples[k,r+1];
           Q2  = Tuples[k,-r];
           Q   =  Join[Q1,Q2];
           
      tr  = Join[FlattenOne[next1 /@ Q1],
            FlattenOne[next2 /@ Q2]] /.RankingRules[Q];
           F   = Select[Q2,(First[#]==si)&]/.RankingRules[Q];
           res = DFA[n, ShortAlphabetSize[K], torow /@ Range[k], 1, F, 
                         ShortAlphabet[K], {} ];
           If[ norm==0,
                 res,
                 ReplacePart[ res, Words[r,alph], -1 ]
             ]     
      ];

ithSymbolDFA[s_,r_Integer?Positive,K:(_?AlphabetQ):$alphabet,
      opts___?OptionQ] := 
    Module[ {k,alph,norm,row,A},
           {k,alph} = MakeAlphabet[K,Full\[Rule] True];
           norm = Normalize /. {opts} /. Options[ithSymbolDFA];
           row = Join[ Range[2,r], {r+2,r+1,r+2} ];
           A   = row& /@ Range[k];
           A[[First[ToIndex[s,alph]],r]] = r+1;
           
      res = DFA[r+2, ShortAlphabetSize[K], A, 1, {r+1}, 
          ShortAlphabet[K], {}];
           If[ norm==0,
                 res,
                 ReplacePart[ res, Range[0,r+1], -1]
             ]     
      ];











































Options[JoinSA]={Normalize\[RuleDelayed]$defaultnormalize};

JoinSA[ M1_SA, M2_SA, {A__List}, opts___?OptionQ ] := 
Module[ {k,kk,KK,n1,n2,na,A1,A2,h,f1,f2,f,g,gg,T1,T2},
     
	{k,kk,KK} = GetAlphabet[M1];
	n1  = Size[ M1 ];
	n2  = Size[ M2 ];
	na  = Length[{A}];
	T1  = Transitions[M1];
	{A1,A2} =  Thread[{A}]; 
	AssignFunction[ h,  A2, A1 ];
	AssignFunction[ f1, Range[n1], States[M1] ];	
	AssignFunction[ f2, Range[n2], States[M2] ];	
	AssignFunction[ gg,  Complement[Range[n2],A2], Range[ n1+1,n1+n2-na] ];
	g[x_] := If[ MemberQ[A2,x], h[x], gg[x] ];
	shiftrans[ {x_,s_,z_} ] := {g[x],s,g[z]};
	T2  = shiftrans /@ Transitions[M2];
	res = SA[ n1+n2-na, kk, Join[T1,T2], KK, {} ];

	Switch[ Normalize /. {opts} /. Options[JoinSA],
	    0,	res,
	    1|2,
		ReplacePart[ res, 
		    Join[ If[MemberQ[A1,#],{0,f1[#]},{1,f1[#]}]& /@ Range[n1],
			{2,#}& /@ f2 /@ Complement[Range[n2],A2]], -1 ]
	]
];







































































Options[LanguageFA]={Multiplicity\[Rule]False,SizeOnly\[Rule]False,
      MakeTrim\[Rule]False,Full\[Rule]False,BoundLFA\[Rule]50,
      Implementation\[Rule]1};


(* a kludge *)

LanguageFA[ M_?FSMQ, opts___?OptionQ ] := LanguageFA[M,0,opts];

LanguageFA[ M_DFA|M_NFA, 0 ] := 
      If[ DisjointQ[Initial[M],Final[M]], {}, {"Eps"} ]; 

LanguageFA[ M_DFA, n_Integer, opts___?OptionQ ] := 
Module[ {size,coacc},

     If[ SizeOnly /. {opts} /. Options[LanguageFA],
         Return[ languagesize[M,n] ] ];
     
     If[ Full /. {opts} /. Options[LanguageFA],
         Return[ fulllang[M,SelectOptions[fulllang,opts,{Full}] ] ] ];
     
     If[ MakeTrim /. {opts} /. Options[LanguageFA],
         Return[nondetlanguage[TrimFA@ToFA[M],n]] ];
 
     Switch[ Implementation /. {opts} /. Options[LanguageFA],
             1, detlanguage1[M,n],
             2, detlanguage2[M,n],
             3, detlanguage3[M,n]
     ]
];


LanguageFA[ M_NFA|M_FA|M_SA, n_Integer, opts___?OptionQ ] := 
Module[ {MM},

     If[ Full /. {opts} /. Options[LanguageFA],
         Return[ fulllang[ToDFA[M],SelectOptions[fulllang,opts,{Full}] ] ] ];
      
      If[ SizeOnly /. {opts} /. Options[LanguageFA],
                 Return[ languagesize[M//ToNFA,n] ] ];
           
           If[ Multiplicity /. {opts} /. Options[LanguageFA],
                 Return[ languagemult[M//ToNFA,n] ] ];
           
           If[ MakeTrim /. {opts} /. Options[LanguageFA],
        MM = ToNFA@TrimFA@ToFA[M],
        MM = ToNFA[M] ];
           
           Switch[ Implementation /. {opts} /. Options[LanguageFA],
                     1, nondetlanguage1[MM,n],
                     2, nondetlanguage2[MM,n]
             ]      
      ];


      
languagemult[M_NFA,n_Integer] := 
    Module[  {L,k,alph,Ini,F,A,tmp,prep,words,toword,W,grid},
      
           {k,alph} = Alphabet[M,Full->True];
           Ini = Initial[ M ];
           F   = Final[ M ];
           A   = Thread[Transitions[ M ]];
      
           toword[ x_List ] := StringJoin @@ alph[[x]]; 
           prep[ {a_,L_} ] := Prepend[#,a]& /@ L;
           
           (* all words w : p-->q, |w| = s *)    
           L[0,p_,q_] := L[0,p,q] = If[ p==q, {{}}, {} ];
             
           L[s_,p_,q_] := L[s,p,q] =
                ( tmp = Apply[ Join, Map[ L[s-1,#,q]&, A[[p]], {2} ], 1 ];
                    Flatten[ prep /@ Pairs[ Range[k], tmp ], 1 ] );
            
           (* all words w : p-->q, p in Ini, q in Fin, |w| = s *)
           
      grid = CartesianProduct[Ini,F];
           
      words[s_] := toword /@ Flatten[ Map[ L[s,#[[1]],#[[2]]]&, grid ], 1 ];
      
           If[ Positive[n],
                 Frequencies[words[n]],
                 W = words /@ Range[-n];
                 neps = Length[ Intersection[Final[M], Initial[M]] ];
                 If[ Positive[neps],
                       Prepend[ Frequencies /@ W, {{"Eps",neps}} ],
                       Prepend[ Frequencies /@ W, {} ]
                   ]
             ]
      ];

detlanguage1[ M_DFA, r_Integer, opts___?OptionQ ] :=
    
    Module[ {n,k,alph,F,tr,LL,L0,ext,extend,rule,selectfin,sink,killsink},
          
           {k,alph} = Alphabet[M,Full\[Rule] True];
           n   = Size[M];
           F   = Final[M];
           tr  = Transitions[M];
           
      rule = Thread[ Pairs[ Table[alph[[#]],{n}],tr[[#]] ]& /@ Range[k] ];
           sink = TrapStatesFA[M,Full\[Rule]False];
           If[ sink>0,
                 killsink[X_List] := Select[X,(Last[#]=!=sink)&];
                 rule = killsink /@ rule
             ];
           
           extend[ {s_,p_} ] := ext[s,#]& /@ rule[[p]];
           ext[s_,{a_,q_}] := {StringJoin[s,a],q};
           
      selectfin[ LL_List ] := First /@ Select[ LL, MemberQ[F,Last[#]]& ];
          
           L0 = {{"",TheInitial[M]}};
           If[ Positive[r],
                 LL = Nest[ Flatten[extend/@#,1]&, L0, r ];
                 Union@selectfin[LL],
             (* else *)
                 
        LL = NestList[ Flatten[extend/@#,1]&, L0, -r ];
                 LL = Union@selectfin[#]& /@ Rest[LL];
                 If[ MemberQ[ F, TheInitial[M] ],
                       Prepend[ LL, {"Eps"} ],
                       Prepend[ LL, {} ]
                   ]
             ]
      ];

detlanguage2[ M_DFA, r_Integer ] := 
    Module[  {k,alph,F,A,subst,toword,selectfin,L0,LL},
           {k,alph} = Alphabet[M,Full->True];
           F  = Final[M];
           A  = Thread@Transitions[M];
            
           subst[L_List] := Flatten[ A[[L]] ];
           toword[w_Integer,{rr_Integer}] := 
              StringJoin@@alph[[IntegerDigits[w,k,rr]+1]];
           toword[L_List,{rr_Integer}] := toword[#,{rr}]& /@ L;
           selectfin[L_List,{rr_Integer}] := 
              First /@ Select[Pairs[Range[0,k^rr-1],L],MemberQ[F,Last[#]]&];
           
           L0 = Initial[M];
           If[ Positive[r],
                 LL = Nest[ subst, L0, r ];
                 LL = selectfin[LL,{r}];
                 toword[#,{r}]& /@ LL,
             (* else *)
                 LL = NestList[ subst, L0, -r ];
                 LL = MapIndexed[ selectfin, Rest[LL] ];
                 LL = MapIndexed[ toword, LL ];
                 If[ MemberQ[ F, TheInitial[M] ],
                       Prepend[ LL, {"Eps"} ],
                       Prepend[ LL, {} ]
                   ]
             ]
      ];

detlanguage3[ M_DFA, n_Integer ] := 
    Module[  {k,alph,F,A,prep,words,W,sink},
      
           {k,alph} = Alphabet[M,Full->True];
           F    = Final[ M ];
           A    = Thread[Transitions[ M ]];
            
           prep[{}] = {};
           
      prep[ {P_,a_} ] := Concatenate[a,P];  (* 
        StringJoin[a,#]& /@ P; *)
      
           (* L[s,p,q]: all words w : p-->q, |w| = s *)    
           Clear[$LLL];
           sink = TrapStatesFA[M,Full\[Rule]False];
           If[ sink>0, $LLL[_,sink,_] = {} ];     
           
           $LLL[0,p_,q_] := If[ p==q, {"Eps"}, {} ];
             
           $LLL[s_,p_,q_] := $LLL[s,p,q] =
                 Flatten[ prep /@ Pairs[$LLL[s-1,#,q]& /@ A[[p]], alph] ];
            
           words[s_] := Sort@Flatten[ $LLL[s,TheInitial[M],#]& /@ F];
             
           If[ Positive[n],
                 words[n],
             (*else*)
                 W = words /@ Range[-n];
                 If[ MemberQ[ F, TheInitial[M] ],
                       Prepend[ W, {"Eps"} ],
                       Prepend[ W, {} ]
                   ]
             ]
      ];


nondetlanguage1[ M_NFA, n_Integer ] := 
    Module[  {L,k,alph,II,FF,A,tmp,prep,words,W,grid},
      
           {k,alph} = Alphabet[M,Full->True];
           II   = Initial[M];
           FF   = Final[M];
           A    = Thread[Transitions[M]];
      
           
      prep[ {P_,a_} ] := Concatenate[a,P];  (* 
        StringJoin[a,#]& /@ P; *)
      
           (* all words w : p-->q, |w| = s *)    
           L[0,p_,q_]  := L[0,p,q] = If[ p==q, {""}, {} ];
           L[s_,p_,q_] := L[s,p,q] =
               (  tmp = Apply[ Union, Map[ L[s-1,#,q]&, A[[p]], {2} ], 1 ];
                    FlattenOne[ prep /@ Pairs[ tmp, alph ] ] );
            
           words[s_] := 
               
        Union[Flatten[ L[s,#[[1]],#[[2]]]& /@ CartesianProduct[II,FF] ]];
             
           If[ Positive[n],
                 words[n],
                 
        Prepend[ words /@ Range[-n], If[ DisjointQ[II,FF],{},{"Eps"}]]
             ]
      ];

nondetlanguage2[ M_NFA, r_Integer ] :=
    
    Module[ {n,k,alph,II,FF,tr,LL,ext,extend,rule,selectfin},
           {k,alph} = Alphabet[M,Full->True];
           n   = Size[M];
           II  = Initial[M];
           FF  = Final[M];
           tr  = Transitions[M];
           
      rule = Thread[ Pairs[ Table[alph[[#]],{n}],tr[[#]] ]& /@ Range[k] ];
          
           extend[ {x_,p_} ] := ext[x,#]& /@ rule[[p]];
           ext[x_,{a_,Q_}] := Sequence@@({StringJoin[x,a],#}& /@ Q);
           selectfin[ LL_List ] := 
              First /@ Select[ LL, MemberQ[FF,Last[#]]& ];
          
           If[ Positive[r],
                 LL = Nest[ Union@Flatten[extend/@#,1]&, {"",#}& /@ II, r ];
                 Union@selectfin[LL],
             (* else *)
                 
        LL = NestList[ Flatten[extend/@#,1]&, {"",#}& /@ II, -r ];
                 LL = Union@selectfin[#]& /@ Rest[LL];
                 Prepend[ LL, If[ DisjointQ[II,FF],{},{"Eps"}]]
             ]
      ];

languagemult[ M_NFA, r_Integer ] :=
    
    Module[ {n,k,alph,II,FF,LL,rule,ext,extend,selectfin},
          
           {k,alph} = Alphabet[M,Full->True];
           n   = Size[M];
           II  = Initial[M];
           FF  = Final[M];
           tr  = Transitions[M];
           
      rule = Thread[ Pairs[ Table[alph[[#]],{n}],tr[[#]] ]& /@ Range[k] ];
           
           extend[ {x_,p_} ] := ext[x,#]& /@ rule[[p]];
           ext[x_,{a_,Q_}] := Sequence@@({StringJoin[x,a],#}& /@ Q);
           selectfin[ LL_List ] := 
              First /@ Select[ LL, MemberQ[FF,Last[#]]& ];
           
           If[ Positive[r],
                 LL = Nest[ Flatten[extend/@#,1]&, {"",#}& /@ II, r ];
                 Frequencies@selectfin[LL],
             (* else *)
                 
        LL = NestList[ Flatten[extend/@#,1]&, {"",#}& /@ II, -r ];
                 LL = selectfin[#]& /@ Rest[LL];
                 neps = Length[ Intersection[Final[M], Initial[M]] ];
                 If[ Positive[neps],
                       Prepend[ Frequencies /@ LL, {{"Eps",neps}} ],
                       Prepend[ Frequencies /@ LL, {} ]
                   ]     
             ]
      ];



languagesize[ M_DFA, r_Integer ] :=
    Module[ {n,Q,QQ,B,Ini,Fin,res }, 
           
           n   = Size[M];
           Q   = Range[n];
           Ini = ToBitVector[ Initial[M], Q ];
           Fin = ToBitVector[ Final[M], Q ];
           
           (* make Q by Q multiplicity matrix *)
      If[ n < 20,
        	QQ =FullTransitionMatrixFA[M],
        	QQ =SparseArray[ FullTransitionMatrixFA[M], {n,n} ]
        ];
      
           If[ NonNegative[r],
                 Return[ Ini.MatrixPower[QQ,r].Fin ],
             (*else*)
                 B = IdentityMatrix[n];
                ( res= Ini.B.Fin; B = B.QQ; res )& /@ Range[0,-r]
             ]
      ];

languagesize[ M_NFA, r_Integer ] := 
         If[ Positive[r], Length[languagemult[M,r]], Length /@ 
        languagemult[M,r] ];

languagemult[ M_NFA, r_Integer ] :=
    
    Module[ {n,k,alph,II,FF,LL,rule,ext,extend,selectfin},
          
           {k,alph} = Alphabet[M,Full\[Rule]True];
           n   = Size[M];
           II  = Initial[M];
           FF  = Final[M];
           tr  = Transitions[M];
           
      rule = Thread[ Pairs[ Table[alph[[#]],{n}],tr[[#]] ]& /@ Range[k] ];
           
           extend[ {x_,p_} ] := ext[x,#]& /@ rule[[p]];
           ext[x_,{a_,Q_}] := Sequence@@({StringJoin[x,a],#}& /@ Q);
           selectfin[ LL_List ] := 
              First /@ Select[ LL, MemberQ[FF,Last[#]]& ];
           
           If[ Positive[r],
                 LL = Nest[ Flatten[extend/@#,1]&, {"",#}& /@ II, r ];
                 Frequencies@selectfin[LL],
             (* else *)
                 
        LL = NestList[ Flatten[extend/@#,1]&, {"",#}& /@ II, -r ];
                 LL = selectfin[#]& /@ Rest[LL];
                 neps = Length[ Intersection[Final[M], Initial[M]] ];
                 If[ Positive[neps],
                       Prepend[ Frequencies /@ LL, {{"Eps",neps}} ],
                       Prepend[ Frequencies /@ LL, {} ]
                   ]     
             ]
      ];

(* local Full currently disabled *)

Options[fulllang]={BoundLFA\[Rule] 50,Full\[Rule] False};

fulllang[M_?FSMQ,opts___?OptionQ] := 
    Module[ {MM,tr,fin,extend,paths,bnd},
      	MM = TrimFA@ToFA[M];
      	tr = FullTransitions@MM;
      	fin = Final[MM];
      	extend[{}] = {};
      	extend[{x___,p_}] := 
        		
        FlattenOne /@ 
          CartesianProduct[{{x,p}},Cases[tr,{p,aa__}\[Rule] {aa}]];
      	extend[ {LL__List} ] := FlattenOne[ extend /@ {LL} ];
      	bnd = Min[ BoundLFA /. {opts} /. Options[fulllang], Size[MM]]; 
      	paths = 
        Select[ FlattenOne@
            FixedPointList[ extend, {#}& /@ Initial[MM], bnd ], 
          			MemberQ[fin,Last[#]]& ];
      	If[ Full /. {opts} /. Options[fulllang], 
        		paths,
        		WordSort@Union[ Concatenate[Last /@ Partition[#,2]]& /@ paths ]
        	]
      ];
Null



































LanguageSort[ LL_List ] := WordSort[ WordSort /@ LL ]; 































LanguageToSeries[L_List] := Pairs[ L, Table[1,{Length[L]}] ]; 



































LeftQuotient[ Eps|"Eps"|Global`\[Epsilon], v_?WordQ ] := v;

LeftQuotient[ u_?WordQ, v_?WordQ ] := 
    With[ {us = ToString[u],vs = ToString[v]}, 
           If[ WordPrefixQ[us,vs],
                 If[ us===vs,
                       "Eps",
                       StringDrop[vs,WordLength[us]]
                   ],
                 Empty
             ]
      ];

LeftQuotient[ Eps|"Eps"|Global`\[Epsilon], L_List ] := L;
LeftQuotient[ x_?WordQ, L_List ] := 
    With[ {xs = ToString[x],xl = WordLength[x],LL = ToString/@L},
           
      ToEps[ StringDrop[#,xl]& /@ 
          Select[LL,StringMatchQ[#,StringJoin[ToString[x],"*"]]& ] ]
      ];











































Options[LengthDFA]={Normalize\[RuleDelayed]$defaultnormalize,
      Modulus\[Rule]0};

LengthDFA[ n_Integer?NonNegative, K:(_?AlphabetQ):$alphabet, 
      opts___?OptionQ ] := 
    LengthDFA[ {n}, K, opts ];

LengthDFA[ n_Integer?Negative, K:(_?AlphabetQ):$alphabet, 
      opts___?OptionQ ] := 
    LengthDFA[ Range[0,-n], K, opts ];

LengthDFA[ LL_List, K:(_?AlphabetQ):$alphabet, opts___?OptionQ ] := 
Module[{A,k,res,norm,m,nn},
      
      norm = Normalize /. {opts} /. Options[LengthDFA];
      If[ (m = Modulus /. {opts} /. Options[LengthDFA]) > 0, 
        	Return[ modLengthDFA[LL,m, K,norm] ] ];
      
      k   = AlphabetSize[K];
      nn  = Max[LL] + 2;
      A   = Table[ Append[Range[2,nn],nn], {k} ];
      res  = 
        DFA[ nn, ShortAlphabetSize[K], A, 1, LL+1, ShortAlphabet[K], {} ];
      If[ norm==0,
        	res,
        	ReplacePart[ res, Range[0,nn-1], -1 ]
        ]
      ];

modLengthDFA[ LL_List, m_Integer, K_,norm_ ] := 
    Module[{A,k,res},
      k   = AlphabetSize[K];
      A   = Table[  RotateLeft[Range[m]], {k} ];
      res  = DFA[ m,ShortAlphabetSize[K], A, 1, LL+1,ShortAlphabet[K], {} ];
      If[ norm==0,
        	res,
        	ReplacePart[ res, Range[0,m-1], -1 ]
        ]
      ];










































Options[LocalQSA]={Full\[Rule] False };

LocalQSA[ S_SA, opts___?OptionQ ] := 
    Module[{full,n,ss,V,dia,type,res},
      full = Full /. {opts} /. Options[LocalQSA];
      n = Size[S];
      ss = SquareSA[S,Full\[Rule]1,Normalize\[Rule]1];
      V = States[ss];
      dia = PositionList[ V, Cases[V,{x_,x_}]];
      scc = StronglyConnectedComponents[ToGraphFA[ss],NonTrivial\[Rule]True];
      res = Sort[Flatten[scc]]=== dia;
      If[ full, {res,dia,scc}, res ]	
      ];





































Options[LocalUniversalFA]={Normalize\[RuleDelayed]$defaultnormalize,
      EdgeLU\[Rule]Function[x,True],IniLU\[Rule]Function[x,True],
      FinLU\[Rule]Function[x,True]};

LocalUniversalFA[ n_Integer, K:(_?AlphabetQ):$alphabet, opts___?OptionQ ] := 
Block[{k,alph,Tr,Q,Ini,Fin,rules,norm,test,ini,fin,
     testedge,makelabel,edge},
     norm = Normalize /. {opts} /. Options[LocalUniversalFA];
     test = EdgeLU    /. {opts} /. Options[LocalUniversalFA];
     ini  = IniLU     /. {opts} /. Options[LocalUniversalFA];
     fin  = FinLU     /. {opts} /. Options[LocalUniversalFA];
     
     testedge[{x_,y_}] := test[ x<>StringTake[y,-1] ];
     makelabel[{x_,y_}]  := {x,Last@ToIndex[y,alph],y};
    
     {k,alph} = MakeAlphabet[K,Full->True];
     Tr  = makelabel /@ Select[ DeBruijnEdges[n,alph], testedge ];
     
     Q   = Union[ First/@Tr, Last/@Tr ];
     Ini = Select[Q,ini];
     Fin = Select[Q,fin];
     rules = RankingRules[Q];
     Tr  = Tr  /. rules;
     Ini = Ini /. rules;
     Fin = Fin /. rules;
     res = 
        FA[ Length[Q], ShortAlphabetSize[K], Tr, Ini, Fin, 
          ShortAlphabet[K], {} ];
     If[ norm==0, 
         res, 
         ReplacePart[ res, Q, -1 ]
     ]
];











































LoopAutomatonFA[ M_FA ] :=

    Module[  {k,kk,alph,n1,Tr,T1,T2,TT,TT1,TT2,TT3,Ini,Fin},
     {k,kk,KK} = GetAlphabet[M];
     n1  = Size[M]+1;
     Ini = Initial[M];
     Fin = Final[M];
     Tr  = Transitions[M];
     T1  = Select[ Tr, MemberQ[Ini,First[#]]& ];
     T2  = Select[ Tr, MemberQ[Fin, Last[#]]& ];
     TT1 = {n1,#[[2]],#[[3]]}& /@ T1;
     TT2 = {#[[1]],#[[2]],n1}& /@ T2;
     TT3 = {n1,#[[2]],n1}& /@ Intersection[T1,T2];
     TT  = Union[ Tr, TT1, TT2, TT3 ];
     FA[ n1, kk, TT, {n1}, {n1}, KK, {} ]
];
     
LoopAutomatonFA[ M_NFA ] := LoopAutomatonFA[ ToFA[M] ];     
LoopAutomatonFA[ M_DFA ] := LoopAutomatonFA[ ToFA[M] ];     



BEFAToFA[ M_BEFA, K:(_?AlphabetQ):$alphabet ] := 
     FA[ Size[M], ShortAlphabetSize[K], 
         ToTransitions[Transitions[M],K], {1}, {Size[M]}, 
ShortAlphabet[K], {} ];
     
unionBEFA[ M1_BEFA, M2_BEFA ] := 
Module[ {n1, n2, T1, T2},
     n1 = Size[ M1 ];
     n2 = Size[ M2 ];
     T1 = Transitions[M1] /. {x_Integer,s_,n1} :> {x,s,n1+n2-2} ;
     T2 = Transitions[M2] /. {x_Integer,s_,y_Integer} :> {x+n1-2,s,y+n1-2};
     T2 = T2 /. {n1-1,s_,y_Integer} :> {1,s,y};
     BEFA[ n1+n2-2, Union[T1,T2] ]
];
unionBEFA[ M1_BEFA, M2_BEFA, z___BEFA ] := 
      unionBEFA[ unionBEFA[ M1, M2 ], z ];
      
concatenateBEFA[ M1_BEFA, M2_BEFA ] := 
Module[ {n1,n2,T1,T2},
     n1 = Size[M1];
     n2 = Size[M2];
     T1 = Transitions[M1];
     T2 = Map[ shiftrans[n1-1,n1-1,#]&, Transitions[M2] ];
     BEFA[ n1+n2-1, Union[T1,T2] ]
];
concatenateBEFA[ M1_BEFA, M2_BEFA, z___BEFA ] := 
     concatenateBEFA[ concatenateBEFA[ M1, M2 ], z ];
      
starBEFA[ M_BEFA ] := 
Module[ {n, Tr},
     n = Size[ M ];
     Tr = Map[ shiftrans[1,1,#]&, Transitions[M] ];
     BEFA[ n+2, Union[Tr,{{1,"Eps",2},{n+1,"Eps",2},{2,"Eps",n+2}}] ]
];

makeBEFA[xx_Symbol|xx_String] := BuildBEFA[xx];
makeBEFA[xx_REP]    := unionBEFA @@ (makeBEFA /@ xx);
makeBEFA[xx_RET]    := concatenateBEFA @@ (makeBEFA /@ xx);
makeBEFA[xx_RES]    := starBEFA[ makeBEFA[First[xx]] ];

sizeBEFA[ ee_Symbol|ee_String ] := WordLength[ee] + 1;
sizeBEFA[ ee_REP ]    := Total[sizeBEFA/@ee] - 2 Length[ee] + 2;
sizeBEFA[ ee_RET ]    := Total[sizeBEFA/@ee] - Length[ee] + 1;
sizeBEFA[ ee_RES ]    := sizeBEFA[ee[[1]]] + 2;






































Attributes[MakeHomomorphismDFA]={HoldFirst};

MakeHomomorphismDFA[ h_, M1_DFA, M2_DFA ] :=
    
    Module[ { A1, A2, dfs, dfsact, homo },
      
          ClearAll[h];
          SetAttributes[h,Listable];
          SetAttributes[dfsact,Listable];
      
          A1 = Thread[Transitions[M1]]; 
          A2 = Thread[Transitions[M2]];
          homo = True;
          
          (* initialize h array to 0 *)
          h[_]=0;
          
          (* explore all sons of x *)
          
      dfs[ x_Integer ] := dfsact[ A1[[x]], A2[[h[x]]] ];     
          
          (* explore successor delta[x,a] *)
          dfsact[ p_, q_ ] := 
                If[ h[p] == 0, 
                      h[p] = q; dfs[p],
                      If[ h[p] != q, homo = False ]
                  ];
           
          (*  perform exploration  *)
          
      h[TheInitial[M1]] = TheInitial[M2];
          dfs[ TheInitial[M1] ];
          homo
      ];







































Options[MakeHomomorphism]={Opts\[Rule]{}};
Attributes[MakeHomomorphism]={HoldFirst};

MakeHomomorphism[ ff_, ss_List, tt_List, opts___?OptionQ ] := 
    Module[ {rules},
        ClearAll[ff];
        rules = Thread[ (ToString /@ ss)\[Rule] (ToString /@ tt) ];
        ff[Eps|"Eps"|""|Global`\[Epsilon]] := "Eps";
        ff[x_String] := ToEps@StringReplace[x,rules] ;
        ff[x_Symbol|x_Integer] := ToEps@StringReplace[ToString[x],rules] ;
        SetAttributes[ff,
          Opts/.\[InvisibleSpace]Flatten[{opts}]/.\[InvisibleSpace]Options[
              MakeHomomorphism]];
        rules
        ]   /;  Length[ss]===Length[tt];

















































MatrixToTransitions[M_DFA|M_NFA]:=
    MatrixToTransitions[Transitions[M]];
MatrixToTransitions[A_?MatrixQ]:=
    Module[{k,n},
      	{k,n}=Dimensions[A];
      	Thread/@FlattenOne[ 
          	Thread/@Pairs[ Table[ii,{k},{ii,n}],Table[ii,{ii,k},{n}],
              A]]
      ];



































Options[MinimalFischerFA]={Full\[Rule]False,
      Normalize\[RuleDelayed]$defaultnormalize,
      External\[RuleDelayed]$defaultexternal};

MinimalFischerFA[ s_CA|s_FA, opts___?OptionQ ] := 
    MinimalFischerFA[ToSA[s,opts],opts];
MinimalFischerFA[ s_DFA , opts___?OptionQ ] := 
    MinimalFischerFA[ 
      ToSA@DeleteStateFA[ s, TrapStatesFA[s,Full\[Rule]False] ], opts ];

MinimalFischerFA[ s_SA, opts___?OptionQ ] := 
Module[ {mb, mbs, mm, dag, pos, res},
	mb  = MinimizeFA[s,opts];
	mbs = ToSA[mb,opts];
	If[ Size[mbs]==1, Return[mbs] ];	
	mm  = DeleteStateFA[ mbs, TrapStatesFA[mb,Full\[Rule]False] ];
	dag = ToDirectedAcyclicGraph[ToGraphFA[ mm, Normalize->1 ]];
	pos = Position[ DegreeGraph[ dag, Full->True ], {_,0} ][[1,1]];
	res = SelectFA[ mm, VertexSet[dag][[ pos ]] ];
	If[ 0 == (Normalize /. {opts} /. Options[MinimalFischerFA]),
	    res, 
	    res = ReplacePart[ res, States[mbs], -1 ]
	];
	If[ Full /. {opts} /. Options[MinimalFischerFA],
	    { res, mb, VertexSet[dag][[pos]]  }, res ]
];



































Options[MinimizeDFA]={Normalize\[RuleDelayed]$defaultnormalize,
      DoTrace\[Rule]False,Hopcroft\[Rule]False};

MinimizeDFA[ M_DFA, opts___?OptionQ ] :=

    Module[ {n,norm,t,A,h,p1,p2,makechar,refine,
     nn,F,Ini,trace,tt,top,findpos,B,ff,MM},

    If[ Hopcroft  /. {opts} /. Options[MinimizeFA], 
        	Return[ hopcroft[M,opts] ]];
      
          norm  = Normalize /. {opts} /. Options[MinimizeFA];    
          trace = DoTrace   /. {opts} /. Options[MinimizeFA];    
      
          tt = {};
          n = Size[ M ];
          A = Transitions[ M ];
          
      (*  uses characteristic maps of equivalence relations *)       
          findpos[x_] := 
            If[ h[Last[x]]==0, h[Last[x]]=First[x], h[Last[x]] ];    
          
          makechar[ L_List ] := 
            (  Clear[h];
                 h[_] := 0;
                 LL = Pairs[ Range[Length[L]], L ];
                 h[First[LL]] = 1;
                 findpos /@ LL  );
          
          refine[s_] := 
            (  B = Thread[ Prepend[ s[[#]]& /@ A, s ] ];
                 If[ trace, AppendTo[tt,B] ];
                 makechar[B] );
          
      (*  initialize characteristic function of F,Q-F *)
          
      p1 = Min[ Final[M] ];
          If[ p1=!=1, p2 = 1, p2 = Min[ Complement[ Range[n], Final[M] ]]];
          t  = If[ MemberQ[Final[M],#],p1,p2]& /@ Range[n];
          
      (*  refine partition until no new classes occur *)
          
      t = FixedPoint[ refine, t ];
      
      (*  renumber everything to get output DFA *)
          
      nn  = Length@Union[t];
          AssignFunction[ ff, Union[t], Range[nn] ];
          MM = StateMergeDFA[ M, ff /@ t, opts ];
          If[ trace,  { MM, tt }, MM ]
      ];

hopcroft[ M_DFA, opts___?OptionQ ] :=
    
    Module[ {n,Q,k,KK,alph,norm,h,hh,nn,F,Ini,trace,ttrace,tr,pred, 
             trans,Fin,nop,cnop,part,targ,next,ppiv,sym,piv,j,
             inv,invtr,split,splitpart,getpivot,updatenext},
      
          norm  = Normalize /. {opts} /. Options[MinimizeFA];    
          trace = DoTrace   /. {opts} /. Options[MinimizeFA];
      
           inv[sym_,p_] := Flatten@Position[trans[[sym]],p];
           inv[LL_List] := inv@@LL;
            
           splitpart[i_Integer] := Intersection[part[[i]],#]& /@ pred;
           split[A_List,sym_Integer,B_List] := 
             Module[ {A0},
                A0 = Intersection[A,Flatten[inv[sym,#]& /@ B]];
                {A0, Complement[A,A0]}
               ];
         
           getpivot[L_List] := 
             Module[ {pos,piv},
                       pos = Flatten@Position[ L, {__} ];
                       If[ pos==={},{},piv = First[pos];{piv,L[[piv,1]]}]
               ];
           
           updatenext[ss_] := 
              AppendTo[next[[ss]],
                If[ !MemberQ[next[[ss]],j] && 
                         0 < Length[targ[[j,ss]]] <= Length[targ[[nop,ss]]],
                       j, nop ]
                ];
      
      (* initialize two partitions *)
      
           n = Size[M];
           {k,kk,KK} = GetAlphabet[M];
           alph = Alphabet[M];
           Fin   = Final[M];
           trans = Transitions[M];
           invtr = Partition[inv /@ CartesianProduct[k,n],n];
           pred  = Union /@ trans;
           nop   = 2;
           part  = {Fin,Complement[Range[n],Fin]};
           targ  = splitpart /@ {1,2};
           
      next  = Table[
          If[Length[targ[[1,i]]] <= Length[targ[[2,i]]],{1},{2}],{i,k}];
           ttrace = { {{},part} };
      
           (*  main loop *)
      
           While[ Length[part] < n,
        
               ppiv  = getpivot[next];
               
        If[ Length[ppiv]==0, Break[] ];       (* done, 
          exit *)
               {sym,piv}   = ppiv; 
               next[[sym]] = Rest[next[[sym]]];
               cnop = nop; 
        
               Do[ 
          	   thetarg = targ[[piv,sym]];
          
          	   If[  !DisjointQ[ part[[j]], Flatten[ invtr[[sym,thetarg]] ] ],
            
            	   {P1,P2} = split[ part[[j]], sym, thetarg ]; 
            	   part[[j]] = P1;
            
            	   If[ Length[P2]>0,
              	       nop++;
              	       AppendTo[part,P2];
              	       targ[[j]] = splitpart[j];
              	       AppendTo[ targ, splitpart[nop] ];
              	       updatenext /@ Range[k];
              	   ];
            	   ];
                 ,{j,cnop}];         (* end Do-j  *)
        
               If[ trace, AppendTo[ ttrace, {{alph[[sym]],piv},part} ]];
             ];             (* end while *)
      
           nn  =  Length[part];
           
      AssignFunction[ h, Range[n], 
        First@First@Position[part,#]& /@ Range[n]];
           Scan[ (hh[h[#]]=#)&, Reverse@Range[n] ];
           tr  = Thread@Map[ h, Thread[trans][[hh /@ Range[nn]]], {2} ];
           Ini = h[TheInitial[M]];
           F   = Union[ h /@ Final[M] ];
           res = DFA[ nn, kk, tr, Ini, F, KK, {} ];
      
           If[ trace, Return[ {res, ttrace} ] ];
      
           Switch[ norm, 
                 0, res, 
                 1, ReplacePart[ res, part, -1 ],
                 2, ReplacePart[ res, Q[[#]]& /@ part, -1 ]
             ]
      ];



































Options[MinimizeFA]={DoTrace\[Rule]False,
      Normalize\[RuleDelayed]$defaultnormalize,
      External\[RuleDelayed]$defaultexternal};

MinimizeFA[ M_DFA, opts___?OptionQ ] := 
        If[ External /. {opts} /. Options[MinimizeFA], 
              
      Automata`extaut`ExtMinimizeFA[M,SelectOptions[ExtMinimizeFA,opts]],    
            
      With[{Macc = AccessibleFA[ M, SelectOptions[AccessibleFA,opts] ]},
        If[ Size[Macc] < Size[M],
          MinimizeDFA[ Macc,SelectOptions[MinimizeDFA,opts] ],
          MinimizeDFA[ M,SelectOptions[MinimizeDFA,opts] ]
          ]]
          ];

MinimizeFA[ M_NFA|M_FA|M_SA, opts___?OptionQ ] := 
        If[ External /. {opts} /. Options[MinimizeFA], 
              
      Automata`extaut`ExtMinimizeFA[M,SelectOptions[ExtMinimizeFA,opts]],    
              MinimizeDFA[ToDFA[M,SelectOptions[ToDFA,opts,{Full}]],opts]
          ];




































NFA[n_,k_,t_,i_,f_] := NFA[n,k,t,i,f,{},{}];


































NNFAToFA[ M_NNFA, K:(_?AlphabetQ):$alphabet ] := 
Module[ {insert,shifttr,T},
     insert[{p_,q_}] := {p,M[[3,q]],q};
     shifttr[{p_,s_,q_}] := {p+1,s,q+1};

     T = insert /@ Join[ CartesianProduct[{0},M[[4]] ], Zwei[M] ];
     T = ToTransitions[ T, K ];

     FA[ First[M] + 1,
         ShortAlphabetSize[K],
         shifttr /@ T,
         {1},
         If[ M[[6]]==0, M[[5]], Union[ M[[5]], {0} ] ] + 1,
         ShortAlphabet[K], {}
     ]
];



























unionNNFA[ M1_NNFA, M2_NNFA ] := 
Module[ {n=M1[[1]], I1=M1[[4]], F1=M1[[5]], I2, F2},
     I2 = M2[[4]] + n;
     F2 = M2[[5]] + n;
     NNFA[    
            n + M2[[1]],
            Union[ M1[[2]], M2[[2]] + n ],
            Join[ M1[[3]], M2[[3]] ],
            Union[ I1, I2 ],
            Union[ F1, F2 ],
            Max[ M1[[6]], M2[[6]] ] 
     ]
];

unionNNFA[ M1_NNFA, M2_NNFA, M___NNFA ] := 
         unionNNFA[ unionNNFA[ M1, M2 ], M ];
       
concatenateNNFA[ M1_NNFA, M2_NNFA ] := 
    Module[ {n=M1[[1]], I1=M1[[4]], F1=M1[[5]], I2, F2},
           I2 = M2[[4]] + n;
           F2 = M2[[5]] + n;
           
           NNFA[    
        	   n + M2[[1]],
        	   Union[ M1[[2]], M2[[2]]+n, CartesianProduct[F1,I2] ],
        	   Join[ M1[[3]], M2[[3]] ],
        	   If[M1[[6]]==0, I1, Union[ I1, I2 ] ],
        	   If[M2[[6]]==0, F2, Union[ F1, F2 ] ],
        	   M1[[6]] M2[[6]]
             ]
      ];
concatenateNNFA[ M1_NNFA, M2_NNFA, M___NNFA ] := 
        concatenateNNFA[ concatenateNNFA[ M1, M2 ], M ];
       
starNNFA[ M_NNFA ] := 
    ReplaceParts[ M, Union[ Zwei[M], CartesianProduct[M[[5]],M[[4]]] ], 2, 1, 
      6 ];











































































NormalizeControl::off = "Normalization is turned off (level `1`).";
NormalizeControl::off = "Normalization is turned on (level `1`).";

NormalizeControl[n_:2] := 
( 
  $defaultnormalize = n; 
  If[ n=!=0, Message[NormalizeControl::off,n], 
        Message[NormalizeControl::on,n] ] 
);





























NormalizeFA[ M_?FSMQ ] := ReplacePart[M,{},-1];



























NumberOfDFA[ n_Integer, k_Integer ] := n^(k n + 1) 2^n;



























NumTransitions[ M_DFA ] := Size[M] AlphabetSize[M];
NumTransitions[ M_FA|M_SA|M_BEFA ] := Length@Transitions[M];
NumTransitions[ M_NFA ] := Length@Transitions@ToFA[M];





































PermutationSA[ perms_List, K:(_?AlphabetQ):$alphabet ] := 
Module[ {k,n},
    k  = AlphabetSize[K];
    n  = Length@First[perms];
    SA[ n, ShortAlphabetSize[K], 
        Sort@
          FlattenOne[
            Thread[{Range[n],Table[#,{n}],ToList[perms[[#]]]}]& /@ 
              Range[k]], 
        ShortAlphabet[K], {} ]
];





























PermuteFA[ M_DFA, {pp__}|T[pp__] ] := 
Module[ {n,hh,perm,iperm},
	n = Size[M];
	perm = {pp};
	AssignFunction[ hh, Range[n], perm, Opts->Listable ];
	iperm = ToList@InverseT[T@@perm];
	res = ReplaceParts[ M, hh /@ Thread[ Thread[Transitions[M]][[iperm]] ], 3, 
		hh[ TheInitial[M] ], 4, Sort[hh /@ Final[M]], 5 ];
	ReplacePart[ res, States[M][[perm]], -1 ]
];

PermuteFA[ M_FA, perm_List ] := 
Module[ {n,hh,newtr},
	n = Size[M];
	AssignFunction[ hh, Range[n], perm ];
	newtr[{p_,a_,q_}] := { hh[p],a,hh[q] };
	res = ReplaceParts[ M, newtr /@ Transitions[M], 3, 
		Sort[hh /@ Initial[M]], 4, Sort[hh /@ Final[M]], 5 ];
	ReplacePart[ res, States[M][[perm]], -1 ]
];

PermuteFA[ M_NFA, perm_List ] := ToNFA@PermuteFA[ ToFA[M], perm ];
PermuteFA[ M_SA, perm_List ] := ToSA@PermuteFA[ ToFA[M], perm ];







































Options[PrintFA]={Full\[Rule]False,TransOnly\[Rule]False};

PrintFA[ M_DFA|M_NFA, opts___?OptionQ ] := 
    Block[ {long,trans,n,k,alph,tab,gbx}, 
          long  = Full /. {opts} /. Options[PrintFA];
          trans = TransOnly /. {opts} /. Options[PrintFA];
           
          n  = Size[M];
         If[ long, Q  = States[M], Q = Range[n] ];
          {k,alph} = Alphabet[M,Full->True];
          
         tab = 
             {  {"no. of states:  ",ToBoxes@n},
                   {"alphabet:       ", ToBoxes@alph },
                   { "initial states: ",ToBoxes@Initial[M] },
                   { "final states: ",    ToBoxes@Final[M] } };
      
      If[long, tab = Insert[tab,{"states: ", ToBoxes[Q] },2]];
      
      gbx = GridBox[tab,
          RowLines\[Rule]False,ColumnLines\[Rule]False,
          ColumnAlignments\[Rule]{Left,Left}];
      
      If[ !trans, Print[DisplayForm@gbx]];
      
      TableForm[ Transitions[M], 
                           TableDepth->2, TableSpacing->{0,2}, 
                           TableHeadings->{alph,Automatic}]
      ];

PrintFA[ M_FA|M_SA, opts___?OptionQ ] := 
    Block[ {long,trans,n,k,alph,tab,gbx,toQ,tr}, 
          long  = Full  /. {opts} /. Options[PrintFA];
          trans = TransOnly /. {opts} /. Options[PrintFA];
           
          n  = Size[M];
         If[ long, Q  = States[M], Q = Range[n] ];
      
          {k,alph} = Alphabet[M,Full->True];
          tr = Sort@FullTransitions[M];
          toQ[ {x_,a_,z_} ] := {Q[[x]],a,Q[[z]]};
          
         tab = 
             {  {"no. of states:  ",ToBoxes@n},
                   {"alphabet:       ", ToBoxes@alph },
                   { "initial states: ",
            If[Head[M]===FA, ToBoxes@Initial[M],"-all-"] },
                   { "final states: ",    
            If[Head[M]===FA, ToBoxes@Final[M],"-all-"] } };
      
      If[long, tab = Insert[tab,{"states: ", ToBoxes@Q },2]];
      
      gbx = GridBox[tab,
          RowLines\[Rule]False,ColumnLines\[Rule]False,
          ColumnAlignments\[Rule]{Left,Left}];
      
      If[ !trans, Print[DisplayForm@gbx]];
          
          If[ !long, 
                
        TableForm[ Partition[tr,$transdispwidth,$transdispwidth,1,{}], 
          TableSpacing->{1,1} ],
                toQ /@ tr // MatrixForm
            ]
      ];





































Options[ProductFA]={Full\[Rule]False,Type\[Rule]"Intersection",
      Normalize\[RuleDelayed]$defaultnormalize};

ProductFA[M1_SA,M2_SA,opts___?OptionQ] := 
Module[ {k,cp,Tr0,T1,T2,Tr,A,n,n1,n2,Q,Q1,Q2},
     norm  = Normalize /. {opts} /. Options[ProductFA];

     {k,kk,KK} = GetAlphabet[M1];
     n1  = Size[ M1 ];
     n2  = Size[ M2 ];
     n   = n1 n2;
     cp  = CartesianProduct[ n1, n2 ];

     If[ EpsilonFreeQ[M2], 
         T1 = Transitions[M1], 
         T1 = Join[Transitions[M1], 
				Pairs[Range[n1],Table[0,{n1}],Range[n1]]]
     ];
     If[ EpsilonFreeQ[M1], 
         T2 = Transitions[M2], 
         T2 = Join[Transitions[M2], 
				Pairs[Range[n2],Table[0,{n2}],Range[n2]]]
     ];

     Tr = ProductTransitions[ T1, T2, k ];     
     Tr = DeleteCases[ Tr, {x_,0,x_} ] /. RankingRules[cp];
     res = SA[ n, kk, Tr, KK, {} ];
     Switch[ norm, 
         0, res,
         1, ReplacePart[ res, cp, -1 ],
         2, 
        ReplacePart[ 
          res, {States[M1][[#[[1]]]],States[M2][[#[[2]]]]}& /@ cp, -1 ]
     ]
];

ProductFA[M1_FA,M2_FA,opts___?OptionQ] := 
Module[ {norm, MM1, MM2, ini, del1, del2, Q, tr, fin,res},
      
      norm  = Normalize /. {opts} /. Options[ProductFA];
      
      MM1 = EpsilonEliminationFA[M1];
      MM2 = EpsilonEliminationFA[M2];
      
      ini = CartesianProduct[Initial[MM1],Initial[MM2]];
      TransitionFunctionFA[MM1,del1 ];
      TransitionFunctionFA[MM2,del2 ];
      
      {Q,tr} = Closure[ ini, 
          
          Function[ s,  
              Function[ pq, 
                CartesianProduct[del1[First[pq],s],del2[Last[pq],s]] ] ] /@ 
            Alphabet[MM1],
          SetClosure\[Rule]True ,DoTrace\[Rule]True ];
      
      ini = PositionList[ Q, ini ];
      If[ "Intersection" === (Type /. {opts} /. Options[ProductFA]),
        	fin = PositionList[ Q,
            	
            Select[Q,
              MemberQ[ Final[MM1],#[[1]]]&&MemberQ[ Final[MM2],#[[2]]]&]],
                 fin = PositionList[ Q,
            	Select[Q,
              MemberQ[ Final[MM1],#[[1]]]||MemberQ[ Final[MM2],#[[2]]]&]]
        ];
      
           res = FA[  Length[Q], ShortAlphabetSize[M1], tr, ini, fin,  
          			ShortAlphabet[M1], {} ];
           Switch[ norm, 
                 0, res, 
                 1, ReplacePart[ res, Q, -1 ],
                 2, 
        ReplacePart[ 
          res, {States[M1][[#[[1]]]],States[M2][[#[[2]]]]}& /@ Q, -1 ] 
             ]
      ];

ProductFA[M1_DFA,M2_DFA,opts___?OptionQ] :=
         
    If[ "Intersection" === (Type /. {opts} /. Options[ProductFA]),
               productDFA[ M1, M2, False, opts ],
               productDFA[ M1, M2, True , opts ]
           ];

ProductFA[ M1_?FSMQ, M2_?FSMQ, opts___?OptionQ ] := 
        ProductFA[ M1//ToFA, M2//ToFA, opts ];

ProductFA[ M1_?FSMQ, M2_?FSMQ, M___?FSMQ, opts___?OptionQ ] := 
        ProductFA[ ProductFA[ M1, M2, opts ], M, opts ]; 


Options[productDFA] = {Full\[Rule] False,
      Normalize\[RuleDelayed] $defaultnormalize};

productDFA[ M1_DFA, M2_DFA, bool_, opts___?OptionQ  ] := 
    Module[  { k, K, n, F, Ini, Q, Q1, Q2, Tr, A, A1, A2, 
             states, newstates, next, current, norm, full, rules },
           
           norm = Normalize /. {opts} /. Options[productDFA];
           full = Full /. {opts} /. Options[unionFA];
           If[ full, Return[ fullproductDFA[M1,M2,bool,norm] ] ];
           
           k =AlphabetSize[M1];
           A1 = Thread[Transitions[M1]];
           A2 = Thread[Transitions[M2]];
           states = {{TheInitial[M1],TheInitial[M2]}};
      
           next[{p_,q_}] :=
        ( 
          	t0 = Thread[{A1[[p]],A2[[q]]} ];
          	t  = Thread[ {Table[{p,q},{k}], Range[k], t0} ];
          	Tr = Join[ Tr, t ];
          	newstates = Union[ Select[t0,!MemberQ[states,#]&] ];
          	states = Join[states,newstates]  
          );
            
           Tr = {};
           current = 0;
           While[ current < Length[states],
                    P = states[[++current]];
                    next[ P ]
             ];
           
           Q   = Union@FlattenOne[ Drop[#,{2}]& /@ Tr ];
           n   = Length[Q];
           rules = RankingRules[ Q ];
           Tr  = Tr /. rules;
           A   = TransitionsToMatrix[ n, k, Tr,Type\[Rule]"DFA" ];
           Ini = {TheInitial[M1],TheInitial[M2]} /. rules;
           If[ bool,
                 F = Select[ states, 
                         (MemberQ[Final[M1],#[[1]]] || 
                  MemberQ[Final[M2],#[[2]]])& ],
                 F = Select[ states, 
                         (MemberQ[Final[M1],#[[1]]] && 
                  MemberQ[Final[M2],#[[2]]])& ]      
             ];
           res = DFA[ n, ShortAlphabetSize[M1], A, Ini, Union[F /. rules], 
          		ShortAlphabet[M1], {} ];
           Switch[ norm,
                 0, res,
                 1, ReplacePart[ res, Q, -1 ],
                 2, 
        ReplacePart[ 
          res, {States[M1][[#[[1]]]],States[M2][[#[[2]]]]}& /@ Q, -1 ]  
             ]
      ];

fullproductDFA[ M1_DFA, M2_DFA, bool_, norm_ ] := 
    Module[ {k,F,Ini,rules,cp,T1,T2,Tr,A,n,n1,n2,res},
      
           k =AlphabetSize[M1];
           n1  = Size[ M1 ];
           n2  = Size[ M2 ];
           n   = n1 n2;
           cp  = CartesianProduct[ n1, n2 ];
           rules = RankingRules[ cp ];
           T1  = MatrixToTransitions[M1];
           T2  = MatrixToTransitions[M2];
           Tr  = ProductTransitions[ T1, T2, k ];     
           Tr  = Tr /. rules;
           A   = TransitionsToMatrix[ n, k, Tr,Type\[Rule]"DFA" ];
           Ini = {TheInitial[M1],TheInitial[M2]} /. rules;
           If[ bool,
                 F = Join[ CartesianProduct[Range[n1],Final[M2]], 
                               CartesianProduct[Final[M1],Range[n2]] ],
                 F = CartesianProduct[Final[M1],Final[M2]] 
             ];
           res = DFA[ n, ShortAlphabetSize[M1], A, Ini, Union[F /. rules], 
          		ShortAlphabet[M1], {} ];
           Switch[ norm, 
        	0, res, 
        	1, ReplacePart[ res, cp, -1 ],
        	2, 
        ReplacePart[ 
          res, {States[M1][[#[[1]]]],States[M2][[#[[2]]]]}& /@ cp, -1 ]
             ]
      ];







































Options[ProductTransitions]={Full\[Rule]0};

ProductTransitions[ L1_List, L2_List, k_Integer, opts___?OptionQ ] := 
Module[ {prod,xtrans,sortr,TT,full},  
    full = Full /. {opts} /. Options[ProductTransitions];

    prod[ {{p1_,x_,q1_},{p2_,x_,q2_}} ] := { {p1,p2}, x, {q1,q2} };
    sortr[ {p_,x_,q_} ] := { Sort[p], x, Sort[q] };
    xtrans[x_] := 
        prod /@ CartesianProduct[ Cases[L1,{_,x,_}], Cases[L2,{_,x,_}] ];
    TT = FlattenOne[xtrans /@ Range[0,k]];
    Switch[ full,
    0,	    TT,
    1,	    Union[ sortr /@ TT ],
    2,	    DeleteCases[ Union[ sortr /@ TT ], {{p_,p_},_,_} | {_,_,{q_,q_}} ]
    ]
];





































Options[QuotientDFA]={Normalize\[RuleDelayed]$defaultnormalize};

QuotientDFA[ L_, K:(_?AlphabetQ):$alphabet, opts___?OptionQ ] :=

    Block[ {Q,curr,n,Tr,next,f,grid,fin,k,alph,norm,B,q},
     {k,alph} = MakeAlphabet[K,Full->True];
     norm = Normalize /. {opts} /. Options[QuotientDFA];
     Q = { WordSort[ToString /@ L] } /. ""->"Eps";
     
     next[p_Integer,a_String] :=
     ( 
          B = WordSort[ LeftQuotient[ a, Q[[p]] ] ];
       q = Flatten[ Position[ Q, B ] ];
       If[ q=={},          (* new state found *)
           
            AppendTo[ Q, B ]; 
           n++;
           f[p,a] = n,     (* else: already known *)
           
            f[p,a] = q[[1]] 
       ];
     );
     
     curr = 0; 
     n    = 1;
     While[ n > curr++, next[curr,#]& /@ alph ];

     grid = Thread@Partition[ CartesianProduct[Range[n],alph],k];
     Tr   = Apply[f,grid,{2}];
     fin  = PositionList[Q,Cases[ Q, {___,"Eps",___}]];
     res = DFA[ Length[Q], ShortAlphabetSize[K], Tr, 1, fin, 
			ShortAlphabet[K], {}];
     If[ norm\[Equal]0, res, ReplacePart[ res, Q, -1 ] ]
];












































Options[QuotientMachineFA]={Normalize\[RuleDelayed]$defaultnormalize};

QuotientMachineFA[ m1_FA, m2_FA, opts___?OptionQ ] :=

    Module[ {k,K,n1,n2,tr,Q,FF,m,ma,II,norm},
       norm = Normalize /. {opts} /. Options[QuotientMachineFA];
    
       {k,K} = Alphabet[m1,Full->True];
       n1 = Size[m1];
       n2 = Size[m2];
       tr = 
        ProductTransitions[Transitions[ToFA[m1]],Transitions[ToFA[m2]],k];  
       Q  = CartesianProduct[ n1, n2 ];
       FF = CartesianProduct[ Range[n1], Final[m2] ];

       m  = ConvertToFA[FA,Q,K,tr,{1},FF,Normalize->2];
       ma = AccessibleFA[m,Normalize->2];
       II = PositionList[ States[ma],
               Select[ States[ma], MemberQ[Final[m1],#[[1]]]&] ];
       If[ norm==0, 
           NormalizeFA@SetInitialFA[ma,II],
           SetInitialFA[ma,II]
       ]
];

QuotientMachineFA[ m1_?FSMQ, m2_?FSMQ, opts___?OptionQ ] := 
     QuotientMachineFA[ ToFA[m1], ToFA[m2], opts ];





























RandomDFA[ n_Integer, K:(_?AlphabetQ):$alphabet ] :=
    
    DFA[ n, ShortAlphabetSize[K], 
         Partition[ Random[Integer,{1,n}]& /@ Range[n AlphabetSize[K]], n ], 
         Random[Integer,{1,n}], 
         FromBitVector[Table[Random[Integer],{n}]], 
         ShortAlphabet[K], {} ];





























RankOfDFA[ M_DFA ] := 
Module[ {n,k,c1,c2},
    n   = Size[M];
    k   = AlphabetSize[M];    
    
    c1 = ToBitVector[ Final[M], Reverse[Range[n]] ];
    c1 = FromDigits[ c1, 2 ];
    
    c2 = Append[ Flatten[Transitions[M]], TheInitial[M] ] - 1;
    c2 = FromDigits[ c2, n ];
    
    c2 2^n + c1
];



























RankToDFA[ r_Integer, n_Integer, k_Integer ] := 
Module[ {c1,c2,A,F,q0},
    If[ r > NumberOfDFA[n,k], Return["Rank too big."]];
    c1 = Mod[ r, 2^n ];    
    F  = FromBitVector[ IntegerDigits[c1,2,n], Reverse[Range[n]] ];
    
    c2 = Floor[ r/2^n ];
    A  = IntegerDigits[ c2, n, n k + 1 ] + 1;
    q0 = Last[A]; 
    A  = Partition[ Drop[A,-1], n ];
    DFA[ n, k, A, q0, F, {}, {} ]
];






































DeleteTransitionFA[ m_FA|m_SA, p_Integer, w_, q_Integer ] := 
Module[ {ww},
    ww = If[ WordQ[w], First@ToIndex[ w, Alphabet[m] ], w ];
    ReplacePart[ m, Complement[Transitions[m],{{p,ww,q}}], 3 ]];
DeleteTransitionFA[ m_FA|m_SA, {p_Integer, w_, q_Integer} ] := 
     DeleteTransitionFA[ m, p, w, q ];
DeleteTransitionFA[ m_FA|m_SA, tr:{___List} ] := 
     Last@FoldList[ DeleteTransitionFA, m, tr ];
DeleteTransitionFA[ m_DFA|m_NFA, tt__ ] := 
    DeleteTransitionFA[ ToFA[m], tt ];  





























ReverseFA[ M_FA ] := 
    ReplaceParts[ M, Reverse /@ Transitions[M], 3, Final[M], 4, Initial[M], 
      5 ];
ReverseFA[ M_NFA|M_DFA ] := ReverseFA[ ToFA[M] ];     
ReverseFA[ M_SA ] := ReplacePart[ M, Reverse /@ Transitions[M], 3 ];



































SA[n_,k_,t_] :=  SA[n,k,t,{},{}];























m=DFA[15,2,{{2,4,6,8,10,12,14,8,10,12,14,8,10,12,14},{3,5,7,9,11,13,15,9,11,
          13,15,9,11,13,15}},1,{12,13,14,15}];

mm = SetInitialFA[ SelectFA[ m, Range[8,15] ],{1}]

States[mm]



mm = SetInitialFA[ mm,{1}]

EquivalentQFA[m,mm]



Options[SelectFA]={Normalize\[Rule]1};

SelectFA[ M_FA, L_List, opts___?OptionQ ] :=

    Module[ {hh,hhh,nn,Q,tr,ini,fin,norm},
    norm = Normalize /. {opts} /. Options[SelectFA];
    {k,kk,KK} = GetAlphabet[M];
    nn   = Length[L];
    AssignFunction[hh,L,Range[nn]];
    hhh[{p_,s_,q_}] := {hh[p],s,hh[q]};
    tr   = hhh /@ Select[Transitions[M], 
            (MemberQ[L,First[#]]&&MemberQ[L,Last[#]])&];
    ini  = hh /@ Intersection[ Initial[M], L  ];
    fin  = hh /@ Intersection[ Final[M], L  ];
    res  = FA[ nn, kk, tr, ini, fin, KK, {} ];
    Switch[ norm,
	0, res,
	1, ReplacePart[ res, L, -1 ], 
	2, ReplacePart[ res, States[M][[L]], -1 ] 
    ]
];

SelectFA[ M_DFA | M_NFA, L_List, opts___?OptionQ ] := 
      SelectFA[ ToFA[M], L, opts ];

SelectFA[ M_SA, L_List, opts___?OptionQ ] :=
Module[ {Q,nn,hh,hhh,tr,norm},
    norm = Normalize /. {opts} /. Options[SelectFA];
    {k,kk,KK} = GetAlphabet[M];
    nn   = Length[L];
    AssignFunction[hh,L,Range[nn]];
    hhh[{p_,s_,q_}] := {hh[p],s,hh[q]};
    tr   = hhh /@ Select[Transitions[M], 
            (MemberQ[L,First[#]]&&MemberQ[L,Last[#]])&];
    res  = SA[ nn, kk, tr, KK, {} ];
    Switch[ norm,
	0, res,
	1, ReplacePart[ res, L, -1 ], 
	2, ReplacePart[ res, States[M][[L]], -1 ] 
    ]
];



Test[
SelectFA[DFA[15,2,{{2,4,6,8,10,12,14,8,10,12,14,8,10,12,14},{3,5,7,9,11,13,15,9,11,13,15,9,11,13,15}},1,{12,13,14,15}], Range[8,15]],
FA[8,2,{{1,1,1},{2,1,3},{3,1,5},{4,1,7},{5,1,1},{6,1,3},{7,1,5},{8,1,7},{1,2,2},{2,2,4},{3,2,6},{4,2,8},{5,2,2},{6,2,4},{7,2,6},{8,2,8}},{},{5,6,7,8},{},{8,9,10,11,12,13,14,15}]
];

































Attributes[SetAlphabet]={HoldFirst};

SetAlphabet::incomp = "Incompatible assignment to alphabet; left unchanged.";

SetAlphabet[M_?FSMQ,k_Integer] := 
    If[  Abs[k] \[NotEqual] AlphabetSize[M], 
      	Message[SetAlphabet::incomp];
      	Null,
      	SetAlphabet[M,{k,{}}]
      ];
SetAlphabet[M_?FSMQ,{k_Integer,L_List}] := 
    If[ Abs[k] \[NotEqual] AlphabetSize[M] || ( 
          Length[L] \[NotEqual] AlphabetSize[M] && L =!= {}), 
      	Message[SetAlphabet::incomp];
      	Null,
      	With[{MM=ReplaceParts[M,k,2,L,-2]},
        		Clear[M];M=MM]
      ];
SetAlphabet[M_?FSMQ,L_List] := 
    If[  Length[L] \[NotEqual] AlphabetSize[M], 
      	Message[SetAlphabet::incomp];
      	Null,
      	With[{MM=ReplaceParts[M,L,-2]},
        		Clear[M];M=MM]
      ];

(* auxiliary *)
CAQ[x_] := Head[x]===CA;

SetAlphabet[C_?CAQ,{k_Integer,L_List}] := 
    If[  k \[NotEqual] AlphabetSize[C] ||  
        Length[L] \[NotEqual] AlphabetSize[C], 
      	Message[SetAlphabet::incomp];
      	Null,
      	With[{CC=ReplaceParts[C,k,2,L,-1]},
        		Clear[C];C = CC ]
      ];
SetAlphabet[M_?FSMQ,A_?FSMQ ] := 
    	With[ { KK = Alphabet[A,Normalize\[Rule] 1]},
      		SetAlphabet[ M, KK ]];
SetAlphabet[A_?CAQ, B_CA ] := 
    	With[ { KK = Alphabet[B,Normalize\[Rule] 1]},
      		SetAlphabet[ A, KK ]];











































SetFinalFA[ m_DFA|m_FA|m_NFA, p_Integer ] := ReplacePart[m,{p},5];
SetFinalFA[ m_SA, p_Integer  ] := ReplacePart[ ToFA[m],{p},5];
SetFinalFA[ m_DFA|m_FA|m_NFA, FF_List ] := ReplacePart[m,Flatten[FF],5];
SetFinalFA[ m_SA, FF_List ] := ReplacePart[ ToFA[m],Flatten[FF],5];






































SetInitialFA[ m_DFA, p_Integer ]       := ReplacePart[m,p,4];
SetInitialFA[ m_DFA, II_List ]         := 
    ReplacePart[  ToFA[m],Flatten[II],4];
SetInitialFA[ m_FA|m_NFA, II_List ]    := ReplacePart[m,Flatten[II],4];
SetInitialFA[ m_FA|m_NFA, p_Integer ] := ReplacePart[m,{p},4];
SetInitialFA[ m_SA, II_List ]          := 
    ReplacePart[  ToFA[m],Flatten[II],4];
SetInitialFA[ m_SA, p_Integer ]       := ReplacePart[  ToFA[m],{p},4];









































SetInitialFinalFA[ m_?FSMQ, II_List|II_Integer, FF_List|FF_Integer ] := 
    SetInitialFA[ SetFinalFA[m,FF], II ];





































SetStates::length="Incompatible assignment to state set; left unchanged.";

Attributes[SetStates]={HoldFirst};

SetStates[M_?FSMQ,L_List]:=
    If[Size[M]\[NotEqual]Length[L],
      Message[SetStates::length];
      Null,
      With[{MM=ReplacePart[M,L,-1]},
        		Clear[M];M=MM ]
      ];







































































Options[ShuffleProductFA]={Normalize\[RuleDelayed]$defaultnormalize};

ShuffleProductFA[ M1_?FSMQ, M2_?FSMQ, opts___?OptionQ ] := 
Module[  {MM1,MM2,n1,n2,F,Ini,rules,nn,Tr,Q,T1,T2,norm },
     norm = Normalize /. {opts} /. Options[ShuffleProductFA];

     {k,kk,KK} = GetAlphabet[M1];
     MM1 = ToFA[M1];
     MM2 = ToFA[M2];    
     n1  = Size[MM1];
     n2  = Size[MM2];
     T1  = Transitions[MM1];
     T2  = Transitions[MM2];
     Tr  = shuffleProductTransitions[n1,n2,T1,T2];    
     Q   = Union[ Flatten[ Drop[#,{2}]& /@ Tr, 1 ] ];
     rules = RankingRules[Q];
     Tr  = Tr /. rules;
     Ini = CartesianProduct[ Initial[MM1],Initial[MM2] ] /. rules;
     F   = CartesianProduct[ Final[MM1], Final[MM2] ] /. rules;
     res = FA[ Length[Q], kk, Tr, Sort[Ini], Sort[F], KK, {} ];
     Switch[ norm,
         0, res,
         1, ReplacePart[ res, Q, -1 ],
         2, ReplacePart[ res, {States[M1][[#[[1]]]],States[M2][[#[[2]]]]}& 
/@ Q, -1 ]  
     ]
];

shuffleProductTransitions[ n1_Integer, n2_Integer, L1_List, L2_List ] := 
Module[ {prod1,prod2},  
    prod1[{x_,a_,y_}] := {{x,#},a,{y,#}}& /@ Range[n2];
    prod2[{x_,a_,y_}] := {{#,x},a,{#,y}}& /@ Range[n1];
      
    Union[ Flatten[ prod1 /@ L1, 1 ], Flatten[ prod2 /@ L2, 1 ] ]
];



































SinkQDFA[ M_DFA ] := 
With[ {traps= TrapStatesFA[M],F=Final[M]},
     Complement[traps,F]=!={}  && Length[Final[M]]\[Equal]Size[M]-1
];































































Attributes[Size]={Listable};

Options[Size]={Full\[Rule]False};

Size[M_?FSMQ,opts___?OptionQ]   := 
    If[ Full /. {opts} /. Options[Size],
          { First[M],
        	AlphabetSize[M],
        	If[Head[M]===DFA,
          	    First[M] AlphabetSize[M],
          	    Length[Transitions[M]]
          	],
        	Length[Initial[M]],
        	Length[Final[M]] },
          First[M]
      ];
Size[M__?FSMQ,opts___?OptionQ]  := Size[{M},opts];





























































Options[SquareSA]={Full\[Rule]0,Normalize\[RuleDelayed]$defaultnormalize,
      DoTrace\[Rule]False};

SquareSA[M_SA,opts___?OptionQ] := 
    Module[ {norm,full,k,kk,KK,n,n2,NN,h,newtr,res},
           norm = Normalize /. {opts} /. Options[SquareSA];
           full = Full /. {opts} /. Options[SquareSA];
           
           {k,kk,KK}  = GetAlphabet[M];
           n  = Size[M];
           tr = ProductTransitions[Transitions[M],Transitions[M],k,opts];
      
          Switch[ full,
        	     0,   n2 = n^2;                 NN = CartesianProduct[n, n],
        	     1,   n2 = n(n + 1)/2; NN = ToPairs[n,Full\[Rule]True],
        	     2,   n2 = n(n - 1)/2; NN = ToPairs[n]
             ];
      
           AssignFunction[ h, NN, Range[n2] ];
           newtr[{p_,a_,q_}] := {h[p],a,h[q]};
           res = SA[ n2, kk, newtr /@ tr, KK, {} ];
      
           res = Switch[ norm, 
          	     0,  res, 
          	     1,  ReplacePart[ res, NN, -1 ],
          	     2,  ReplacePart[ res, States[M][[#]]& /@ NN, -1 ]
               ];
      
      If[  DoTrace /. {opts} /. Options[SquareSA],
        	{ res,Flatten@Position[NN,{x_,x_}] }, 
        res ]
      ];

































Options[StarFA]={Normalize\[RuleDelayed]$defaultnormalize,
      EpsElim\[Rule]True};

StarFA[ M_FA, opts___?OptionQ ] := 
Module[ {n,k,kk,KK,T1,T2,Tr,norm,eps,MM},
     norm = Normalize /. {opts} /. Options[StarFA];
     eps  = EpsElim /. {opts} /. Options[StarFA];
     
     {k,kk,KK} = GetAlphabet[M];
     n  = Size[M];
     T1 = Map[ ({1,0,#})&, Initial[M]+1 ];
     T2 = Map[ ({#,0,1})&, Final[M]+1 ];
     Tr = Join[  Map[ shiftrans[1,1,#]&, Transitions[M] ], T1, T2 ];
     res = FA[ n+1, kk, Tr, {1}, {1}, KK, {} ];
     If[ eps, res = EpsilonEliminationFA[res] ];
     Switch[ norm,
		0, res, 
        1|2, ReplacePart[ res, Join[{n+1}, States[M]], -1 ]
     ]
];

StarFA[ M_DFA, opts___?OptionQ  ] := StarFA[ ToFA[M], opts  ]; 
StarFA[ M_NFA, opts___?OptionQ  ] := StarFA[ ToFA[M], opts  ]; 
StarFA[ M_BEFA, opts___?OptionQ  ] := starBEFA[ M ]; 





































Options[StateMergeDFA]={Normalize\[RuleDelayed]$defaultnormalize,
      DoTrace\[Rule]False,Hopcroft\[Rule]False};

StateMergeDFA[ M_DFA, equ_List, opts___?OptionQ ] := 
Module[ {n,nn,h,hh,A,Ini,F,norm}, 
    norm  = Normalize /. {opts} /. Options[MinimizeFA];    
    n  = Size[M];
    {k,kk,KK} = GetAlphabet[M];
    A  = Transitions[M];
    nn = Max[equ];
    AssignFunction[ h, Range[n], equ ];
    Scan[ (hh[h[#]]=#)&, Reverse[Range[n]] ];
    A   = Thread@Map[ h, Thread[A][[hh /@ Range[nn]]], {2} ];
    Ini = h[TheInitial[M]];
    F   = Union[ h /@ Final[M] ];
    res = DFA[ nn, kk, A, Ini, F, KK, {} ];        
    Switch[ norm, 
        0, res, 
        1, ReplacePart[ res, Flatten@Position[equ,#]& /@ Range[nn], -1 ],
        2, 
        ReplacePart[ res, 
          States[M][[Flatten@Position[equ,#]]]& /@ Range[nn], -1 ]
    ]
];































States[M_?FSMQ] := If[ MinusEins[M]=!={}, MinusEins[M],  Range[Size[M]] ];

































Options[SubsetQFA]={External\[RuleDelayed]$defaultexternal};

SubsetQFA[ M1_?FSMQ, M2_?FSMQ, opts___?OptionQ ] := 
    EquivalentQFA[ SumFA[M1,M2], M2 ];













































Options[SubwordCounterDFA]={Normalize\[RuleDelayed]$defaultnormalize,
      Modulus\[Rule]0};

SubwordCounterDFA[w_?WordQ,p_Integer,K:(_?AlphabetQ):$alphabet,
      opts___?OptionQ] :=
Module[  {alph,ws,n,mask,delta,Q,W,m,norm},
     norm = Normalize /. {opts} /. Options[SubwordCounterDFA];
      If[ (mm = Modulus /. {opts} /. Options[SubwordCounterDFA]) > 0, 
        	Return[ modSubwordCounterDFA[ w, p, mm, K,norm ] ] ];
      
           alph = MakeAlphabet[K];
           ws = ToString[w];
           n  = WordLength[w];
           
      mask[i_] := 
        mask[i] = ToBitVector[Union@Flatten@StringPosition[ws,i],n];    
           
      delta[pv_,i_] := 
        Min[#,p+1]& /@ (pv + Most[Prepend[pv,1] Append[mask[i],0]]);
           
      m = GenerateDFA[ Table[0,{n}], delta, alph, Last[#]==p&,
          Normalize\[Rule]norm ]
      ];

modSubwordCounterDFA[w_?WordQ,r_Integer,m_Integer,K_,norm_ ] :=
    
    Module[  {alph,ws,n,mask,delta},
           
           alph = MakeAlphabet[K];
           ws = ToString[w];
           n  = WordLength[w];
           mask[i_] := mask[i] = 
                   ToBitVector[Union@Flatten@StringPosition[ws,i],n];    
           delta[pv_,i_] := 
                 Mod[pv + Most[Prepend[pv,1] Append[mask[i],0]],m];
      
           
      GenerateDFA[ Table[0,{n}], delta, alph, Last[#]==r&,
        Normalize\[Rule]norm  ]
      ];





































Options[SubwordDFA]={Normalize\[RuleDelayed]$defaultnormalize};

SubwordDFA[ w_?WordQ, K:(_?AlphabetQ):$alphabet, opts___?OptionQ ] :=

    Block[  {n,lab,k,alph,A,norm,nexti,next},
    norm = Normalize /. {opts} /. Options[SubwordDFA];
    
    {k,alph} = MakeAlphabet[K,Full->True];
    lab = ToIndex[ w, alph ];
    AppendTo[lab,-1];
    n   = Length[lab];
    nexti[a_,i_] := If[ lab[[i]]==a, i+1, i ];
    next[a_] := nexti[a,#]& /@ Range[n];
     
    res = DFA[ n, ShortAlphabetSize[K], next /@ Range[k], 1, {n}, 
               ShortAlphabet[K], {} ]; 
    If[ norm==0,
        res, 
        ReplacePart[ res, WordPrefixes[w], -1 ]
    ]
];









































Options[SumFA]={Normalize\[RuleDelayed]$defaultnormalize};

SumFA[ M1_SA, M2_SA, opts___?OptionQ ] := 
Module[ {k,kk,KK,n1,n2,Q1,Q2,T1,T2,norm},
     norm = Normalize /. {opts} /. Options[UnionFA];
     
     {k,kk,KK} = GetAlphabet[M1];
     n1  = Size[ M1 ];
     n2  = Size[ M2 ];
     T1  = Transitions[M1];
     T2  = shiftrans[n1,n1,#]& /@ Transitions[M2];
     res = SA[ n1+n2, kk, Join[T1,T2], KK, {} ]; 
     Switch[ norm,
        0, res, 
	1|2, ReplacePart[ res, 
          Join[{1,#}& /@ States[M1], {2,#}& /@ States[M2]], -1 ]
     ]
];

SumFA[ M1_FA, M2_FA, opts___?OptionQ ] := 
Module[ {k,kk,KK,n1,n2,T1,T2,norm},
     norm = Normalize /. {opts} /. Options[UnionFA];
     
     {k,kk,KK} = GetAlphabet[M1];
     n1  = Size[M1];
     n2  = Size[M2];
     T1  = Transitions[M1];
     T2  = shiftrans[n1,n1,#]& /@ Transitions[M2];
     res = FA[ n1+n2, kk, Join[T1,T2], Join[Initial[M1],n1+Initial[M2]],
               Join[Final[M1],n1+Final[M2]], KK, {} ];
     Switch[ norm, 
	0, res, 
	1|2, ReplacePart[ res, 
          Join[{1,#}& /@ States[M1], {2,#}& /@ States[M2]], -1 ]
     ]
];

SumFA[ M1_?FSMQ, M2_?FSMQ, opts___?OptionQ ] := 
    SumFA[ M1//ToFA, M2//ToFA, opts ];

SumFA[ M1_?FSMQ, M2_?FSMQ, M___?FSMQ, opts___?OptionQ ] := 
    SumFA[ SumFA[ M1, M2, opts ], M, opts ]; 
shiftrans[ s1_Integer, s2_Integer, {x_,y_,z_} ] := {x+s1,y,z+s2};


































SwitchTransitionFA[ m_FA|m_SA, p_Integer, q_Integer ] := 
Module[ {tr,ss,sss},
    tr = Cases[Transitions[m], {p,_,q} ];
    If[ tr==={}, Return[m] ];
    ss = Zwei@First[tr]; 
    sss = If[ ss < AlphabetSize[m], ss+1, 1 ];
    ReplacePart[ m, 
		 Union[Complement[Transitions[m],{{p,ss,q}}],{{p,sss,q}}], 3 ]
];
SwitchTransitionFA[ m_FA|m_SA, {p_Integer, q_Integer} ] := 
     SwitchTransitionFA[ m, p, q ];
SwitchTransitionFA[ m_FA|m_SA, tr:{___List} ] := 
     Last@FoldList[ SwitchTransitionFA, m, tr ];
SwitchTransitionFA[ m_DFA|m_NFA, tt__ ] := 
    SwitchTransitionFA[ ToFA[m], tt ];  



























TheInitial[ M_DFA ]  := 
     If[ Head[M[[4]]]===List, M[[4,1]], M[[4]] ];















































ToCharacters[x_]   := Characters@ToString[x];













































Options[ToDFA]={Full\[Rule]False,Normalize\[RuleDelayed]$defaultnormalize,
      External\[RuleDelayed]$defaultexternal,SizeOnly\[Rule]False};

ToDFA[ M_NFA, opts___?OptionQ ] :=

    Module[ {current,Q,nextstate,A,nn,newT,F,FF,rules,n,k,alph,
     h,hh,next,q,full,norm,ext,size},
    
    full = Full      /. {opts} /. Options[ToDFA];
    norm = Normalize /. {opts} /. Options[ToDFA];
    size = SizeOnly  /. {opts} /. Options[ToDFA];
    ext  = External  /. {opts} /. Options[ToDFA];

    If[ full, Return[ tofullDFA[M,norm] ] ];

    If[ ext, 
        If[ size, 
            Return[ Automata`extaut`ExtToDFASize[ ToFA[M] ] ],    
            Return[ Automata`extaut`ExtToDFA[ ToFA[M], opts] ]] 
    ];
 
    {k,kk,KK} = GetAlphabet[M];
    n   = Size[M];
    F   = Final[M];
    TT  = Transitions[M];    

    nn    = 1;
    h[_]  = 0;
    hh[_] = 0;
    h[1]  = Initial[M];
    hh[h[1]] = 1;
    
    next[a_] := 
      ( q = Union[ Flatten[ TT[[ a, h[current] ]] ] ];
        nextstate = If[ hh[q]==0, h[++nn] = q; hh[q] = nn, hh[q]];
        AppendTo[ newT, {current,a,nextstate} ]; 
      );

    (* compute all accessible state sets and transitions *)
    newT    = {};
    current = 0;
    While[ current < nn,
           ++current;
           Scan[ next, Range[k] ];
    ];

    If[ size, Return[nn] ]; 

    (* compute transition matrix *)
    newT = Drei /@ Sort[newT];
    A    = Thread[Partition[ newT, k ]];
    FF   = Select[ Range[nn], (!DisjointQ[h[#],F])& ]; 
    
    res = DFA[ nn, kk, A, 1, FF, KK, {} ]; 
    Switch[ norm, 
        0, res, 
        1, ReplacePart[ res, h/@Range[nn], -1 ],
        2, ReplacePart[ res, States[M][[#]]& /@ (h/@Range[nn]), -1 ]
    ]
];


ToDFA[ M_DFA, opts___?OptionQ ] := M;
ToDFA[ M_BEFA, K:(_?AlphabetQ):$alphabet, opts___?OptionQ ] := 
    ToDFA[ ToFA[M,K], opts ];
ToDFA[ M_NNFA, K:(_?AlphabetQ):$alphabet, opts___?OptionQ ] := 
    ToDFA[ ToFA[M,K], opts ];

ToDFA[ M_FA|M_SA, opts___?OptionQ ] :=

    Module[ {current,Q,nextstate,A,nn,newT,F,FF,rules,n,k,KK,
     h,hh,next,q,full,norm,ext,size},
    
    full = Full      /. {opts} /. Options[ToDFA];
    norm = Normalize /. {opts} /. Options[ToDFA];
    size = SizeOnly  /. {opts} /. Options[ToDFA];
    ext  = External  /. {opts} /. Options[ToDFA];

    If[ full, Return[ tofullDFA[M,norm] ] ];

    If[ ext, 
        If[ size, 
            Return[ Automata`extaut`ExtToDFASize[M] ],    
            Return[ Automata`extaut`ExtToDFA[M,opts] ]] 
    ];
    
    ToDFA[ ToNFA[M,opts], opts ]
];


tofullDFA[ M_NFA, norm_ ] :=

    Module[ {n,k,kk,KK,n2,A,TT,pow,rules,next,Ini,F,FF},
    
    n   = Size[M];
    {k,kk,KK} = GetAlphabet[M];
    F   = Final[M];
    TT  = Transitions[M];
    n2  = 2^n;
    pow = PowerSet[n];
    rules = RankingRules[pow];
     
    next[{a_,P_}] := Union[ Flatten[ TT[[ a, P ]] ] ];
    
    A   = next /@ CartesianProduct[Range[k],pow];
    A   = Partition[A,n2] /. rules;
    Ini = Initial[M] /. rules;
    FF  = Union[ Select[ pow, (!DisjointQ[F,#])& ] ] /. rules;
    res = DFA[ n2, kk, A, Ini, FF, KK, {} ];
    Switch[ norm, 
        0, res, 
        1, ReplacePart[ res, pow, -1 ],
        2, ReplacePart[ res, States[M][[#]]& /@ pow, -1 ]
    ]
];


tofullDFA[ M_FA|M_SA, norm_ ] := tofullDFA[ ToNFA[M], norm ];
tofullDFA[ M_DFA, norm_ ] := M;

































ToEquationsDFA[ M_DFA ] := 
Block[ {n,alph,A,F,rightside,makeequ},
     alph = Alphabet[M];
     n = Size[M];
     A = Thread[Transitions[M]];
     F = Final[M];
     rightside[i_] := 
       If[ !MemberQ[F,i],
           Inner[ RET,alph,X /@ A[[i]],REP ],
           Insert[ Inner[RET,alph,X /@ A[[i]],REP],Eps,1]
       ];
     makeequ[i_] := Equal[ X[i], rightside[i] ];
     makeequ /@ Range[n]
];







































Options[ToFA]={Normalize\[RuleDelayed]$defaultnormalize};

ToFA[ M_DFA, opts___?OptionQ ] := 
     FA@@ReplaceParts[ M, MatrixToTransitions[ M ], 3, 
                          Initial[M], 4 ];
      
ToFA[ M_NFA, opts___?OptionQ ] := 
Module[ {k,A,makeT,cp,tr},
     cp[ {p_Integer,x_Integer,L_List} ] := {p,x,#}& /@ L;     
     makeT[p_] := Flatten[cp /@ Thread[{Table[p,{k}],Range[k],A[[p]]}], 1];
     k  = AlphabetSize[M];
     A  = Thread@Transitions[M];
     tr = Sort@Flatten[ makeT /@ Range@Size[M], 1 ];
     FA@@ReplacePart[ M, tr, 3 ]
];


ToFA[ M_BEFA, K:(_?AlphabetQ):$alphabet, opts___?OptionQ ] := 
    FA[ Size[M], ShortAlphabetSize[K], 
	Transitions[M] /. Flatten[{RankingRules[MakeAlphabet[K]], "Eps"->0 }], {1}, 
	{Size[M]}, ShortAlphabet[K], {} ];

ToFA[ M_NNFA, K:(_?AlphabetQ):$alphabet, opts___?OptionQ ] := 
    NNFAToFA[ M, K ];

ToFA[ M_SA, opts___?OptionQ] := FA@@Insert[ M, Range[Size[M]], {{4},{4}} ];

ToFA[ M_FA ] := M;

ToFA[ C_CA, opts___?OptionQ ] := ToFA[ToSA[C,opts]];























































Options[ToFactorFA]={Normalize\[RuleDelayed]$defaultnormalize,
      Type\[Rule]"Factor"};

ToFactorFA[ M_?FSMQ,  opts___?OptionQ ] :=
  
  With[ {norm = Normalize /. {opts} /. Options[ToFactorFA]},
    Switch[   Type /. {opts} /. Options[ToFactorFA], 
      "Factor",       factorMFA[M,norm],
      "NoFactor",  properFactorMFA[M,norm],
      "Suffix",      suffixMFA[M,norm],
      "NoSuffix",  properSuffixMFA[M,norm],
      "Prefix",      prefixMFA[M,norm],
      "NoPrefix",  properPrefixMFA[M,norm]
      ]]

suffixMFA[ M_?FSMQ, norm_ ] :=
    With[ {m =TrimFA[M,Normalize\[Rule]norm]},
              SetInitialFA[ m, Range[Size[m]] ]];              

prefixMFA[M_?FSMQ,norm_] := 
    With[ {m =TrimFA[M,Normalize\[Rule]norm]},
              SetFinalFA[ m, Range[Size[m]] ]];                  

factorMFA[M_?FSMQ,norm_] := 
    With[ {m =TrimFA[M,Normalize\[Rule]norm]},
              
      SetInitialFinalFA[ m, Range[Size[m]], Range[Size[m]] ]];              

properSuffixMFA[ M_?FSMQ,norm_ ] := 
    	ReverseFA[properPrefixMFA[ReverseFA[M],norm]];

properPrefixMFA[ MM_?FSMQ,norm_ ] := 
    Module[ {M,tr,F},
      	M  = ToFA[ToDFA[MM,Normalize\[Rule] norm] ];
      	tr = Transitions[M];
      	F  = Final[M];
      	ReplacePart[ M, Complement[ tr, Select[ tr, MemberQ[F,First[#]]& ] ], 
        3 ] 
      ];

properFactorMFA[ MM_?FSMQ,norm_ ] := 
Module[ {k,alph,ini,F,ff,delta},
      	
      	{k,alph} = Alphabet[MM,Full\[Rule] True ];
      	TransitionFunctionFA[ToFA@MM,delta];
      	ini = Initial[MM];
      	F = Final[MM];
      
      	ff[ {{},{}},_] := {{},{}};
      	ff[ {P_,PP_},s_] := 
        	If[ Intersection[P,F]=!={} || Intersection[PP,F]=!={}, 
          			{{},{}},
          			{ delta[P,s], Union[delta[PP,s],ini]} 
          		];
      	 GenerateDFA[ {ini,{}},ff,alph,
        		(Intersection[F,#[[1]]]=!={} && 
              		Intersection[F,#[[2]]]==={})& ,Normalize\[Rule]norm ]
      ];





















































Options[ToFrontierDFA]={Periodic\[Rule]False};

ToFrontierDFA[ m_DFA, opts___?OptionQ ] := 
    Module[ {K,A,q0,dot,Q,W,eq},
      
      If[ Periodic /. {opts} /. Options[ToFrontierDFA],
        	Return[toperiodicFDFA[m]]];
      
           K  = Alphabet[m];
           A  = Transitions[m];
           q0 = TheInitial[m];
           dot[p_,a_] := A[[ PositionOne[K,a], p ]];
           {Q,W,eq}= GenerateCSM[ q0, dot, K, Equations->True ];
           { PairsToRules[eq], W[[Final[m]]] }
      ];


toperiodicFDFA[ M_DFA ] := 
    Block[ {k,K,A,q,QQ,act,act0,frnt,nexti,next,wi},
           {k,K} = Alphabet[M,Full->True];
           A  = Transitions[M];
           act   = { { "Eps", TheInitial[M] } };
           QQ    = act;
           front = {};
           
           nexti[{w_,p_}, i_] := 
             ( 
           q  = A[[i,p]];
          wi = Concatenate[w,K[[i]]];
          If[ (int=Intersection[ QQ, 
                    CartesianProduct[WordPrefixes[w],{q}]])=!={} ,
            	Sow[wi\[Rule]First@Last[int]],
            	AppendTo[act0,{wi,q}];
             ] 
          );
           next[x_] := Scan[ nexti[x,#]&, Range[k] ];
            
          frnt = Reap[
           While[ act=!={},
                        act0 = {};
                        Scan[ next, act ];
                        QQ = Union[ QQ, act0 ];
                        act  = act0
            ]
               ];
           { frnt[[2,1]],First /@ Select[QQ,MemberQ[Final[M],Zwei[#]]&]}
      ];





































ToGeneratorsFA[M_DFA] := 
    GEN[ Size[M], ShortAlphabetSize[M], Apply[ T, Transitions[M], 1 ] ];

ToGeneratorsFA[m_FA|m_NFA|m_SA]  := 
Module[{mm,tt},
	mm = CompleteFA[m];
	tt = Last /@ Sort[ Transitions[mm], 
		(#1[[2]]<#2[[2]])||((#1[[2]]==#2[[2]])&&(#1[[1]] <= #2[[1]]))& ];
	GEN[Size[mm], ShortAlphabetSize[m], Apply[T,Partition[tt,Size[mm]],{1}] ] 
];



































Options[ToGraphFA]={Unlabeled\[Rule]True,Normalize\[Rule]$defaultnormalize};

ToGraphFA[ M_?FSMQ, opts___?OptionQ ] := 
Module[ {n,ed},
     n  = Size[M];
     ed = Transitions@ToFA[M];
     res = If[ Unlabeled /. {opts} /. Options[ToGraphFA],
               ed = Union[ Drop[#,{2}]& /@ ed ];
               Graph[ n, Length[ed], "EList", ed, {} ],
               Graph[ n, Length[ed], "LEList", ed, {} ]
     ];
     If[ 0 == (Normalize /. {opts} /. Options[ToGraphFA]),
         res, 
         ReplacePart[ res, States[M], -1 ]
     ]
];

















































Options[ToKernelFA]={Normalize\[Rule]1,Full\[Rule]False,
      External\[RuleDelayed]$defaultexternal};

ToKernelFA[ M_FA|M_NFA|M_SA, {xx__Integer}, opts___?OptionQ ] :=   
    ToKernelFA[ M, {#}& /@ {xx}, opts ];
ToKernelFA[ M_FA|M_NFA|M_SA, pp_Integer, opts___?OptionQ ] :=   
    ToKernelFA[ M, {pp}, opts ];
ToKernelFA[ M_FA|M_NFA|M_SA, opts___?OptionQ ] :=  
    ToKernelFA[ M, {#}& /@ Initial[M], opts ];
ToKernelFA[ M_NFA, {LL__List}, opts___?OptionQ ] := 
    ToKernelFA[ ToFA[M], {LL}, opts ];

ToKernelFA[ M_FA|M_SA, {LL__List}, opts___?OptionQ ] := 
Module[ {n,Q,k,KK,TT,nn,h,hh,next,newT,current,nt,mm,q,j,ff},

    If[ External /. {opts} /. Options[ToKernelFA], 
        Return[ Automata`extaut`ExtToKernelFA[ M, {LL}, opts ] ] ];
    
    {k,KK} = Alphabet[M,Full\[Rule]True];
      If[ Head[Zwei[M]]\[Equal]Integer,kk=Zwei[M],kk=k];
          n  = Size[M];
          TT = Transitions@ToNFA[M];
          empty = 0;
          nn    = Length[{LL}];
          AssignFunction[ h,  Range[nn], {LL} ];
          AssignFunction[ hh, {LL}, Range[nn] ];
      Scan[ (dp[#]=0)&, Range[nn] ];
          h[_]  = 0;
          hh[_] = 0;
          
          next[a_] :=
        ( 
          	q = Union@Flatten[ TT[[ a, h[current] ]] ];
          	j = If[ hh[q]==0,
              		h[++nn] = q; dp[nn]=dp[current]+1;hh[q] = nn,
              		(*else*)
              		hh[q]
              	];
          	AppendTo[ newT, {current,a,j} ];
          );
      
          newT = {};
          current = 0;
          While[ current < nn,
                   ++current;
                   Scan[ next, Range[k] ];
            ];
           
          nt   = Thread[newT];
          newT = Thread[{First[nt],Zwei[nt],Drei[nt]}];
          QQ   = h /@ Range[nn];
          ff   = Final[M];
          res  = If[ Head[M]===SA,
                         SA[ nn, kk, newT, KK, {} ], 
                         FA[ nn, kk, newT, PositionList[QQ,{LL}], 
                               PositionList[QQ,Select[QQ,!DisjointQ[#,ff]&]], 
            KK, {} ]
                 ];
          
         res = Switch[ Normalize /. {opts} /. Options[ToKernelFA], 
                 0, res, 
                 1, ReplacePart[ res, QQ, -1 ],
                 2, 
          ReplacePart[ res, QQ /. Thread[ Range[n] -> States[M] ], -1 ]
               ];
      
      If[ Full /. {opts} /. Options[ToKernelFA],
        	{res, dp /@ Range[nn]}, res ]
      ];

















































ToNFA[ M_FA, opts___?OptionQ ] := 
Module[ {n,k,M1,tr},
      n  = Size[M];
      k  = AlphabetSize[M];
      M1 = EpsilonEliminationFA[M];
      tr = Transitions[M1];
      NFA@@ReplaceParts[ M, TransitionsToMatrix[n,k,tr], 3, Initial[M1], 4 ]
      ];  

ToNFA[ M_DFA, opts___?OptionQ ] := 
         NFA@@
      ReplaceParts[ M, Map[{#}&,Transitions[M],{2}], 3, Initial[M], 4 ];

ToNFA[M_SA, opts___?OptionQ ] := 
    With[ {n=Size[M]}, ToNFA[ SetInitialFinalFA[M,Range[n],Range[n]]]];     

ToNFA[ M_NFA, opts___?OptionQ ] := M;







































Options[ToRegularExpressionFA]={RegExpSimp\[Rule]True,DoTrace\[Rule]False};

ToRegularExpressionFA[ MM_?FSMQ, opts___?OptionQ ] := 
Module[  {M,k,n,tran,Ini,Fin,exp,simp,L,trace,trc},
     simp =  RegExpSimp /. {opts} /. Options[ToRegularExpressionFA];
     trace = DoTrace /. {opts} /. Options[ToRegularExpressionFA];

     trc={};
     M = ToFA[MM];
     n = Size[M];
     Ini  = Initial[ M ];
     Fin  = Final[ M ];
     tran = FullTransitions[ M ];

     (* Kleene's algorithm *)    
     L[0,p_,q_] := L[0,p,q] =
     Module[ {lab,exp},
	 lab = Zwei /@ Cases[tran,{p,_,q}];
	 If[ lab==={},
	     exp = If[p==q,Eps,Empty],
     	     exp = If[p==q,
	              REP[Eps,Sequence @@ lab ],
	              If[ Length[lab]>1,REP@@lab,lab[[1]] ]
	           ]
	 ];
	 If[ trace, AppendTo[trc,{{0,p,q},exp}] ];
	 exp
     ];     
       
     L[s_,p_,q_] := L[s,p,q] = 
     Module[ {exp},
         exp = REP[ L[s-1,p,q], RET[ L[s-1,p,s], 
RES[L[s-1,s,s]],L[s-1,s,q]] ];
         If[ simp, exp = exp //. $regexrules ];
         If[ trace, AppendTo[trc,{{s,p,q},exp}] ];
         exp
     ];

     exp = REP@@( L[n,#[[1]],#[[2]]]& /@ CartesianProduct[Ini,Fin] );
     If[ simp, exp = exp //. $regexrules ];
     If[ trace, {exp,trc}, exp ]
];











































Options[ToSA]={Normalize\[RuleDelayed]$defaultnormalize};

ToSA[M_FA,opts___?OptionQ] := Delete[ SA@@M, {{4},{5}} ];
ToSA[M_NFA|M_DFA,opts___?OptionQ] := Delete[ SA@@ToFA[M,opts], {{4},{5}} ];
ToSA[M_SA,opts___?OptionQ] := M;

ToSA[ C_CA, opts___?OptionQ ] :=
Module[ {n,Rn,k,K,w,lab,B1,B2,norm,tr},
     norm  = Normalize /. {opts} /. Options[ToSA];
     w     = WidthCA[C] - 1;
     {k,K} = Alphabet[C,Full\[Rule]True];
     n    = k^w;
     Rn   = Range[n];
     lab  = IntegerDigits[ RuleCA[C],k,k^(w+1)] + 1 ;
     B1   = Flatten@Thread@Table[Rn,{k}];
     B2   = Join@@Table[Rn,{k}];
     tr   = Pairs[B1,Reverse@lab,B2];
     res  = SA[ n, ShortAlphabetSize[C], tr, ShortAlphabet[C], {} ];
     If[ norm==0,
         res,
         ReplacePart[ res, Words[w,K], -1 ]
     ]
];

































ToSeries[ L_List ] := 
    HoldForm[Release[((#[[2]] #[[1]])& /@ L)]] /. List -> Plus;


























ToTransitions[ tr_List, K:(_?AlphabetQ):$alphabet ] := 
Module[ {k,alph},
    {k,alph} = MakeAlphabet[K,Full->True];
    tr /. Thread[ Prepend[alph,"Eps"] -> Range[0,k] ]
];































TransferSequenceFA[ m_?FSMQ, s_Integer, TT_List ] :=
Block[ {expand,d,Q,L,x},

    expand[{a_,q_}] := 
       If[ d[q]<0, AppendTo[Q,q]; L[q] = Concatenate[L[x],a]; 
          d[q] = d[x]+1 ];

     Q    = {s}; 
     d[s] = 0;
     d[_] = -1;
     L[s] = "Eps";
     tr   = FullTransitions@ToFA[m];

     While[ Q =!= {},
            x = First[Q];
            Q = Rest[Q];
            expand /@  Rest /@ Cases[tr,{x,_,_}];
     ];
     L[_] = "-";
     L /@ TT
];

TransferSequenceFA[m_?FSMQ, s_Integer, t_Integer ] := 
   TransferSequenceFA[m,s,{t}]; 
TransferSequenceFA[m_?FSMQ,SS_List,TT_List] := 
   TransferSequenceFA[m, #, TT]& /@ SS;
TransferSequenceFA[m_?FSMQ] := 
   TransferSequenceFA[m, Initial[m], Final[m] ];









































Options[TransitionFunctionFA]={Full\[Rule]False};

TransitionFunctionFA[ M_DFA, del_, opts___?OptionQ ] :=  
Module[ {trfct,full},
      
      full = Full /. {opts} /. Options[TransitionFunctionFA];
      alp = Alphabetic /. {opts} /. Options[TransitionFunctionFA];
      
           ClearAll[del];
           AssignFunction[ trfct, Alphabet[M], Transitions[M]];
           
           del[p_,Eps|"Eps"|Global`\[Epsilon]]  = p;
           del[p_,w_?WordQ]  := del[p,ToCharacters[w]];
      
           If[ full, 
        	     
        del[p_List,W_List]    := 
          FoldList[ Union[Flatten[trfct[#2][[#1]]]]&, p, W ];
        	     del[p_Integer,W_List] := FoldList[ trfct[#2][[#1]]&, p, W ],
        	 (*else*)
        	     
        del[p_List,W_List]    := 
          Fold[ Union[Flatten[trfct[#2][[#1]]]]&, p, W ];
        	     del[p_Integer,W_List] := Fold[ trfct[#2][[#1]]&, p, W ]
             ];
      ];

TransitionFunctionFA[ M_NFA, del_, opts___?OptionQ ] := 
    Module[ {trfct,full}, 
      
           full = Full /. {opts} /. Options[TransitionFunctionFA];
      
           ClearAll[del];
           AssignFunction[ trfct, Alphabet[M], Transitions[M]];
           
           del[p_Integer,Eps|"Eps"|Global`\[Epsilon]] = {p};
           del[p_List,Eps|"Eps"|Global`\[Epsilon]] = p;
           del[p_,w_?WordQ]  := del[p,ToCharacters[w]];
      
           If[ full, 
        	     
        del[p_List,W_List]    := 
          FoldList[ Union@Flatten[trfct[#2][[#1]]]&, p, W ];
        	     
        del[p_Integer,W_List] := 
          FoldList[ Union@Flatten[trfct[#2][[#1]]]&, {p}, W ],
        	 (*else*)
        	     
        del[p_List,W_List]    := 
          Fold[ Union@Flatten[trfct[#2][[#1]]]&, p, W ];
        	     
        del[p_Integer,W_List] := 
          Fold[ Union@Flatten[trfct[#2][[#1]]]&, {p}, W ]
             ]; 
      ];

TransitionFunctionFA[ M_FA|M_SA, d_, opts___?OptionQ ] :=
           
    TransitionFunctionFA[ ToNFA[M], d, opts ]; 













































Options[TransitionMatrixFA]={Type\[Rule]None,Full\[Rule]False};
Attributes[TransitionMatrixFA]={HoldRest};

TransitionMatrixFA[ M_FA, ff_, opts___?OptionQ ] :=
    
    With[ {full = Full/. Release[{opts}] /. Options[TransitionMatrixFA]},
      	ClearAll[ff];
      	Switch[ Type /. Release[{opts}] /. Options[TransitionMatrixFA],
        	None,           natTransitionMatrixFA[M,ff, full ],
        	Boolean,    booleanTransitionMatrixFA[M,ff, full],
        	Tropical,  tropicalTransitionMatrixFA[M,ff, full]
        	]
      ];

TransitionMatrixFA[M_NFA|M_DFA|M_SA, f_, opts___?OptionQ ] := 
        TransitionMatrixFA[ ToFA[M], f, opts ];

swapsq[{p_,s_,q_}] := {s,p,q}\[Rule]1;

natTransitionMatrixFA[ M_FA, ff_, full_ ] :=
    Module[ {k,alph,n,gen},
      
      Attributes[ff]={Listable};
      n = Size[M];
      {k,alph} = Alphabet[M,Full\[Rule] True];
      
      gen = SparseArray[ swapsq /@ Transitions[M], {k,n,n}];
      If[ full, gen = Normal[gen] ];
      
      ff[Eps|"Eps"|Global`\[Epsilon]]  = IdentityMatrix[n];
      ff[w_?WordQ]  := Dot@@gen[[ ToIndex[w,alph] ]];
      ];

booleanTransitionMatrixFA[ M_FA, ff_, full_ ] :=
    Module[ {k,alph,n,gen},
      
      Attributes[ff]={Listable};
      n = Size[M];
      {k,alph} = Alphabet[M,Full\[Rule] True];
      
      gen = SparseArray[ swapsq /@ Transitions[M], {k,n,n}];
      If[ full, gen = Normal[gen] ];
      
      ff[Eps|"Eps"|Global`\[Epsilon]]  = IdentityMatrix[n];
      ff[w_?WordQ]  := Sign[Dot@@gen[[ ToIndex[w,alph] ]]];
      ];

tropicalTransitionMatrixFA[ M_FA, ff_, full_ ] :=
    
    Module[ {k,n,tr,gen,alph},
      
      n = Size[M];
      {k,alph} = Alphabet[M,Full->True];
      tr = #[[{2,1,3}]]& /@ Transitions[M];
      
      gen = Table[ TS[Infinity], {k}, {n}, {n} ];
      gen = Fold[ ReplacePart[#1,TS[0],#2]&, gen, DeleteCases[tr, {_,_,n} ]];
      gen = Fold[ ReplacePart[#1,TS[1],#2]&, gen, Cases[tr, {_,_,n} ]];
      
      ff[Eps|"Eps"|Global`\[Epsilon]] = TropicalIdentityMatrix[n];
      ff[w_?WordQ] := Dot@@gen[[ ToIndex[w,alph] ]];
      ];











































Options[TransitionsToMatrix]={Type\[Rule]"NFA"};

TransitionsToMatrix[ n_Integer, k_Integer, tr_List, opts___?OptionQ  ] := 
    Module[{A,rp,process},
      	rp = Reap[   
            		Scan[ Sow[#,{#}]&, Union[Most /@ tr] ];
            		Scan[ Sow[Last[#],{Most[#]}]&, tr ]  ][[2]];
      	A = Table[ {}, {k},{n}];
      	process[{{p_,s_},qq__}] :=   A = ReplacePart[A,{qq},{s,p}];
      	Scan[process,rp];
      
      	If[   "DFA" ===(Type /. {opts} /. Options[TransitionsToMatrix]),
        		Partition[Flatten[A],n],
        		A
        	]
      ];





























Transitions[ M_BEFA ]  := Zwei[M];
Transitions[ M_TD ]    := M[[4]];
Transitions[ M_?FSMQ ] := Drei[M];

































Options[TransitiveLanguageQFA]={External\[RuleDelayed]$defaultexternal};

TransitiveLanguageQFA[ m_?FSMQ, opts___?OptionQ ]:=
Module[{mm,snk,mp,gr},

        mm = MinimizeFA[m,SelectOptions[MinimizeFA,opts]];
	If[Size[mm]==1,Return[True]];
	snk = TrapStatesFA[mm,Full\[Rule]False];
	If[snk==0,Return[False]];
	mp = DeleteStateFA[ mm,snk];
	gr = ToGraphFA[mp];
	Not@TrueQ[ Catch[  
	    If[!SubsetQFA[ mp, 
		SetInitialFA[mp,WeaklyConnectedComponents[gr,# ]] ],
		    Throw[True]]&  /@ Final[mp]
	]]
];

































Options[TransitiveQFA]={DoTrace\[Rule]False,
      External\[RuleDelayed]$defaultexternal};

TransitiveQFA[M_?FSMQ,opts___?OptionQ] := 
Module[ {res},
	res = StronglyConnectedComponents[ ToGraphFA[M],
                 SelectOptions[StronglyConnectedComponents,opts] ]; 
        If[ DoTrace /. {opts} /. Options[TransitiveQFA], 
            res, 
            Length[res] == 1
        ]
];































































Options[TrapStatesFA]={Full\[Rule]True};

TrapStatesFA[M_?FSMQ,opts___?OptionQ]:=
    Module[{MM=ToNFA[M],traps},
      traps=FlattenOne@
          Select[Union/@
              FlattenOne/@Thread[Append[Transitions[MM],Range@Size[M]]],
            Length[#]\[Equal]1&];
      If[Full/.{opts}/.Options[TrapStatesFA],traps,
        traps=Complement[traps,Final[M]];
        If[traps==={},0,First[traps]]]];

































Options[TrimFA]={Normalize\[RuleDelayed]$defaultnormalize};

TrimFA[M_FA,opts___?OptionQ] := 
Module[ {Q,QQ,I0,I1,F0,F1,nn,pos,hh,norm,k,kk,KK},
     norm = Normalize /. {opts} /. Options[TrimFA];
     {k,kk,KK} = GetAlphabet[M];
     I0  = Initial[M];
     F0  = Final[M];
     QQ  = VertexSet@BiAccessibleGraph[ToGraphFA[M],I0,F0];
     nn  = Length[QQ];
     AssignFunction[hh,QQ,Range[nn]];
     I1  = hh /@ Intersection[I0,QQ];
     F1  = hh /@ Intersection[F0,QQ];
     tr  = 
        Select[ Transitions[
            M], (MemberQ[QQ,First[#]] && MemberQ[QQ,Last[#]])& ];
     res = FA[ nn, kk, 
     		Function[ xx, { hh[xx[[1]]], xx[[2]], hh[xx[[3]]] } ] /@ tr, 
     		Sort[I1], Sort[F1], KK, {} ];
     Switch[ norm,
        0,   res, 
                 1,   ReplacePart[ res, QQ, -1 ],
        _,  With[{QM=States[M]},ReplacePart[ res, QM[[#]]& /@ QQ, -1 ]]
             ]
      ];
TrimFA[M_SA, opts___?OptionQ] := M;
TrimFA[M_DFA,opts___?OptionQ] := TrimFA[ToFA[M,opts],opts]; 
TrimFA[M_NFA,opts___?OptionQ] := ToFA[TrimFA[ToFA[M,opts],opts],opts]; 

























TropicalIdentityMatrix[n_Integer] := 
With[ {row = Join[{TS[0]}, Table[TS[Infinity],{n-1}]]},
    RotateRight[row,#]& /@ Range[0,n-1] 
];

























































Format[TS[Infinity]] := \[Infinity];
Format[TS[x_]] := x;

TS/:  TS[a_] + TS[b_]  := TS[ Min[a,b] ];
TS/:  TS[a_] * TS[b_]  := TS[ a + b ];
TS/:  _ TS[a_]         := TS[a];
TS/:  TS[a_]^k_        := TS[k a];





































Options[UnionFA]={Full\[Rule]False,Normalize\[RuleDelayed]$defaultnormalize};

UnionFA[ M1_?FSMQ, M2_?FSMQ, opts___?OptionQ ] := 
Which[ 
     Head[M1]===DFA && Head[M2]===DFA,   
      ProductFA[ M1, M2, Type->"Union", opts],
     Head[M1]===BEFA && Head[M2]===BEFA, unionBEFA[M1,M2],
     Head[M1]===NNFA && Head[M2]===NNFA, unionNNFA[M1,M2],
     True,                               SumFA[ M1, M2, opts ]
];
    
UnionFA[ M1_?FSMQ, M2_?FSMQ, M___?FSMQ, opts___?OptionQ ] := 
    UnionFA[ UnionFA[ M1, M2, opts ], M, opts ];


















































checkRange[L_List,n_Integer] := SubsetQ[L,Range[n]];
checkRange0[L_List,n_Integer] := SubsetQ[L,Range[0,n]];
checkRange[x_Integer,n_Integer] :=1 \[LessEqual]x \[LessEqual] n;

VerifyFA[xx_SA] :=
    
    MatchQ[ xx, 
        SA[_Integer,_Integer,{{_Integer,_Integer,_Integer}...},_List,_List] ] \
&&
      With[ {n=xx[[1]], k = xx[[2]], t = xx[[3]]},
        checkRange[ First /@ t, n ] &&
          checkRange0[ Zwei /@ t, k ] &&

                    
          checkRange[ Last /@ t, 
            n ] &&
          (xx[[-2]]=={} || 
              Length[xx[[-2]]] == k ) &&
          (xx[[-1]]=={} || 
              Length[xx[[-1]]] == n ) ];

VerifyFA[xx_FA] :=
    
    MatchQ[ xx, FA[_Integer,_Integer,{{_Integer,_Integer,_Integer}...},
          {_Integer...},{_Integer...},_List,_List] ] &&
      
      With[ {n=xx[[1]], k = xx[[2]], t = xx[[3]]},
        checkRange[ First /@ t, n ] &&
          checkRange0[ Zwei /@ t, k ] &&

                    checkRange[ Last /@ t, n ] &&
          
          checkRange[ xx[[4]], n ] &&
          
          checkRange[ xx[[5]], 
            n ] &&
          (xx[[-2]]=={} || 
              Length[xx[[-2]]] == k ) &&
          (xx[[-1]]=={} || 
              Length[xx[[-1]]] == n ) ];

VerifyFA[xx_DFA] :=
    MatchQ[ xx, DFA[_Integer,_Integer,{{_Integer...}...},
          _Integer|{_Integer},{_Integer...},_List,_List] ] &&
      
      With[ {n=xx[[1]], k = xx[[2]], t = xx[[3]]},
        checkRange[ Flatten[t], n ] &&
          Dimensions[t] == {k,n} &&
   
                 checkRange[ Flatten[{xx[[4]]}], n ] &&
          
          checkRange[ xx[[5]], 
            n ] &&
          (xx[[-2]]=={} || 
              Length[xx[[-2]]] == k ) &&
          (xx[[-1]]=={} || 
              Length[xx[[-1]]] == n ) ];

VerifyFA[xx_NFA] :=
    
    MatchQ[ xx, NFA[_Integer,_Integer,{{{_Integer...}...}...},
          {_Integer...},{_Integer...},_List,_List] ] &&
      
      With[ {n=xx[[1]], k = xx[[2]], t = xx[[3]]},
        checkRange[ Flatten[t], n ] &&
          Dimensions[t] == {k,n} &&
   
                 checkRange[ xx[[4]], n ] &&
          
          checkRange[ xx[[5]], 
            n ] &&
          (xx[[-2]]=={} || Length[xx[[-2]]] == k ) &&
     
               (xx[[-1]]=={} || Length[xx[[-1]]] == n ) ];























































Options[WordToFA]={Normalize\[RuleDelayed]$defaultnormalize,
      Type\[Rule]"Factor",Full\[Rule]False };

WordToFA[w_?WordQ, K:(_?AlphabetQ):$alphabet, opts___?OptionQ ] :=
    
    Module[ {norm,k,alph,n,Tr,res},
      
      	If[   Full /. {opts} /. Options[WordToFA],
        		Return[ wordFactorFA[w,K,opts]] ];
      	norm = Normalize /. {opts} /. Options[WordToFA];
      
      	{k,alph} = MakeAlphabet[K,Full\[Rule] True];
      	lab = ToIndex[ w, alph ];
      	n   = Length[lab] + 1;
      	Tr  = Thread[ {Range[n-1],lab,Range[2,n]} ];
      	res = FA[n, ShortAlphabetSize[K],Tr,{1}, {n}, ShortAlphabet[K], {} ];
      
      	Switch[   Type /. {opts} /. Options[WordToFA],
        		"Factor",  res = SetInitialFinalFA[res,Range[n],Range[n]],
        		"Suffix",  res = SetInitialFA[res,Range[n]],
        		"Prefix",  res = SetFinalFA[res,Range[n]]
        	];
      	If[ norm==0,
        		res,
        		ReplacePart[ res, WordPrefixes[w], -1 ]
        	]
      ];


Options[wordFactorFA]={Normalize\[RuleDelayed]$defaultnormalize,
      Type\[Rule]"Factor" };

wordFactorFA[w_?WordQ, K:(_?AlphabetQ):$alphabet, opts___?OptionQ ] :=
  
  With[ {norm = Normalize /. {opts} /. Options[wordFactorFA]},
    Switch[   Type /. {opts} /. Options[wordFactorFA], 
      "Factor",  infixFA[w,K,norm ],
      "Suffix",  suffixFA[w,K,norm ],
      "Prefix",  prefixFA[w,K,norm ]
      ]]

infixFA[ w_?WordQ, K_?AlphabetQ,norm_  ] :=
    
    Module[  {n,lab,k,alph,T1,T2,T3},
      {k,alph} = MakeAlphabet[K,Full\[Rule] True];
      lab = ToIndex[ w, alph ];
      n   = Length[lab] + 1;
      T1  = Thread[ {Table[1,{k}],Range[k],Table[1,{k}]} ];
      T2  = Thread[ {Table[n,{k}],Range[k],Table[n,{k}]} ];
      T3  = Thread[ {Range[n-1],lab,Range[2,n]} ];
      res = FA[n, ShortAlphabetSize[K],
          		Join[T1,T2,T3], {1}, {n}, ShortAlphabet[K], {} ];
      If[ norm==0,
                res, 
                ReplacePart[ res, WordPrefixes[w], -1 ]
            ]
      ];

prefixFA[ w_?WordQ, K_?AlphabetQ, norm_   ] :=
    
    Module[  {n,lab,k,alph,T1, T2,nexti,next},
      {k,alph} = MakeAlphabet[K,Full\[Rule] True];
      lab = ToIndex[ w, alph ];
      n   = Length[lab];
      T1 =  Thread[ {Range[n], lab, Range[2,n+1]} ];
      T2 =  Table[{n+1,i,n+1},{i,k}];
      res = FA[n+1,ShortAlphabetSize[K],
          		Join[T1,T2],{1},{n+1},ShortAlphabet[K],{}];
      If[ norm==0,
        res,
        ReplacePart[ res, WordPrefixes[w], -1 ]
        ]
      ];

suffixFA[ w_?WordQ, K_?AlphabetQ, norm_  ] :=
    
    Module[  {n,lab,k,alph,T1,T2},
      {k,alph} = MakeAlphabet[K,Full->True];
      lab = ToIndex[ w, alph ];
      n   = Length[lab] + 1;
      T1  = Table[{1,i,1},{i,k}];
      T2  = Thread[ {Range[n-1],lab,Range[2,n]} ];
      res = FA[n, ShortAlphabetSize[K], 
          		Join[T1,T2], {1}, {n}, ShortAlphabet[K], {} ];
      If[ norm==0,
        	res,
        	ReplacePart[ res, WordPrefixes[w], -1 ]
        ]
      ];

















































$regexrules = Dispatch[{
     REP[x___,REP[z__],y___] \[RuleDelayed]  REP[x,z,y], 
     REP[x___,Empty,y___] \[RuleDelayed]  REP[x,y],
     REP[x___,u_,y___,u_,z___] \[RuleDelayed]  REP[x,u,z,y],
     RET[x___,RET[z___],y___] \[RuleDelayed]  RET[x,z,y], 
     RET[___,Empty,___] \[Rule]  Empty,
     RET[x___,Eps,y___] :> RET[x,y],
     REP[] \[Rule]  Empty,
     RET[] \[Rule]  Eps,
     REP[xx_] \[RuleDelayed]   xx,
     RET[xx_] \[RuleDelayed]  xx,
     RES[Empty] -> Eps,
     RES[Eps] -> Eps,
     RES[RES[x_]] :> RES[x],
     REP[x___,u_,z___,RES[u_],y___] \[RuleDelayed]  REP[x,z,RES[u],y],
     REP[x___,RES[u_],z___,u_,y___] \[RuleDelayed]  REP[x,RES[u],z,y],
     RES[REP[x___,Eps,y___]] \[RuleDelayed]  RES[REP[x,y]],
     RET[x___,REP[Eps,y__],RES[y__],z___] \[RuleDelayed]  RET[x,RES[y],z] ,
     RET[x___,RES[y__],REP[Eps,y__],z___] \[RuleDelayed]  RET[x,RES[y],z], 
     REP[x___,RES[y__],z___,Eps,u___] \[RuleDelayed]  REP[x,RES[y],z,u],
     REP[x___,Eps,z___,RES[y__],u___] \[RuleDelayed]  REP[x,RES[y],z,u],
     RET[x___,a_Symbol,b_Symbol,y___] \[RuleDelayed]  
          RET[x,Concatenate[a,b],y],
     RET[a_String,b_String,x___] \[RuleDelayed]  RET[ a<>b, x ]
}];
























































ArdenSolve[ Equal[LS_,RS_] ] :=
Module[ {mc,ac},
     mc = Select[RS,!FreeQ[#,LS]&];
     mc = mc //. distrib;
     mc = mc //. $regexrules;
     mc = mc //. RET[x__,LS]:>RET[x];
     mc = mc //. $regexrules;
     ac = Select[RS,FreeQ[#,LS]&];
     ac = ac //. $regexrules;
     Equal[LS, RET[RES[mc],ac] //. $regexrules ]
];

distrib = 
    RET[x__,REP[z1_,z2__]] \[RuleDelayed]  REP[RET[x,z1],RET[x,REP[z2]]];





















































FormatX[] := FormatX[True];
FormatX[True] :=( Format[X[i_]] := Subscript["X",i] );
FormatX[False] :=( Format[X[i_]] =. );





























REEpsQ["Eps"|Eps]  = True;
REEpsQ["Empty"|Empty] = False;
REEpsQ[w_?WordQ]   = False;
REEpsQ[REP[xx__]] := Or@@( REEpsQ /@ {xx} );
REEpsQ[RET[xx__]] := And@@( REEpsQ /@ {xx} );
REEpsQ[RES[xx__]]  = True;





























































Options[RegularExpressionToBEFA]={SizeOnly\[Rule]False};

RegularExpressionToBEFA[ exp_,opts___?OptionQ  ] :=
    
    If[ SizeOnly  /. {opts} /. Options[RegularExpressionToBEFA],
      	sizeBEFA[ ToRegExp[exp] ], 
      	makeBEFA[ ToRegExp[exp] ] 
      ];













































Options[RegularExpressionToFA]={SizeOnly\[Rule]False,EpsElim\[Rule]True,
      Thompson\[Rule]False};

RegularExpressionToFA[exp_,K_:$alphabet,opts___?OptionQ]:=
    
    Module[{ m,eps,tomp},
      
      eps  =
        EpsElim/.\[InvisibleSpace]{opts}/.\[InvisibleSpace]Options[
            RegularExpressionToFA];
      tomp=
        Thompson/.\[InvisibleSpace]{opts}/.\[InvisibleSpace]Options[
            RegularExpressionToFA];
      
      If[  
        SizeOnly/.\[InvisibleSpace]{opts}/.\[InvisibleSpace]Options[
            RegularExpressionToFA],
        	If[ tomp,
          		Return[sizeBEFA[ToRegExp[exp]]],
          		Return[sizeNNFA[ToRegExp[exp]]+1]
          	]
        ];
      If[ tomp,
        	m=BEFAToFA[RegularExpressionToBEFA[exp],K];
        	If[ eps,
          		EpsilonEliminationFA[m],m],
        		NNFAToFA[RegularExpressionToNNFA[exp],K]
        	]
      ];



































Options[RegularExpressionToNNFA]={SizeOnly\[Rule]False};

RegularExpressionToNNFA[ exp_,opts___?OptionQ  ] :=
    
    If[ SizeOnly  /. {opts} /. Options[RegularExpressionToNNFA],
      	sizeNNFA[ ToRegExp[exp] ], 
      	makeNNFA[ ToRegExp[exp] ] 
      ];































































REQuotient[ Eps|"Eps"|Global`\[Epsilon], w_ ] := w; 
REQuotient[ u_?WordQ, Eps ] = Empty;
REQuotient[ u_?WordQ, Empty ] = Empty;
REQuotient[ u_?WordQ, w_?WordQ ] := LeftQuotient[u,w] /. {"Eps"->Eps };
REQuotient[ u_?WordQ, re_ ] := 
    Last@FoldList[ REQuotient[#2,#1]&, re, ToCharacters[u] ] /; 
      WordLength[u]>1;
REQuotient[ aa_, REP[xx_] ] := REQuotient[ aa, xx ];
REQuotient[ aa_, RET[xx_] ] := REQuotient[ aa, xx ];
REQuotient[ aa_, REP[xx__] ] := REP@@( REQuotient[aa,#]& /@ {xx} );
REQuotient[ aa_, RET[xx_,yy__] ] := 
    If[REEpsQ[xx], 
        REP[ RET[REQuotient[aa,xx],yy], REQuotient[aa,RET[yy]] ],
             RET[REQuotient[aa,xx],yy]];
REQuotient[ aa_, RES[xx_] ] := RET[ REQuotient[aa,xx], RES[xx] ];





























































fromsymbs = {  Global`\[Epsilon]\[Rule]Eps,"Eps"\[Rule] Eps,
      Global`\[EmptySet]\[Rule]Empty};

RESimplify[
      exp_]:= (ToRegExp[exp]   /. fromsymbs )//.\[InvisibleSpace]$regexrules ;



































































SubstituteRE[ Equal[LS1_,RS1_], Equal[LS2_,RS2_] ] := 
     (Equal[LS1,RS1] /. {LS2 -> RS2}) //. Join[{distrib},$regexrules];
     
SubstituteRE[ e_Equal, e1_Equal, e2__Equal ] := 
     SubstituteRE[ SubstituteRE[e,e1], e2 ];































ToRegExp[exp_] := 
    exp /. {NonCommutativeMultiply\[Rule] RET,Plus\[Rule] REP,
        Times[_Integer,x_]\[Rule] x };













































\!\(\(BFunctionToCA[ff_, 
        w_Integer\ ] := \[IndentingNewLine]Module[{rules, bfct, 
          lab}, \[IndentingNewLine]\[IndentingNewLine]rules\  = \ 
          Join[\ \[IndentingNewLine]Thread[\ 
              Table[\ Global`x\_i\ , \ {i, w}]\  \[Rule] \ 
                SymbolList["\<x\>", w]], 
            Thread[\ Table[\ Global`y\_i\ , \ {i, w}] \[Rule] \ 
                Not /@ \ SymbolList["\<x\>", w]], \[IndentingNewLine]Thread[\ 
              SymbolList["\<y\>", w] \[Rule] 
                Not /@ SymbolList["\<x\>", 
                    w]], \[IndentingNewLine]{Plus \[Rule] Or, 
              Times \[Rule] 
                And}\ ]; \[IndentingNewLine]\[IndentingNewLine]bfct = 
          Function[Evaluate[SymbolList["\<x\>", w]], 
            Evaluate[
              ff /. \[InvisibleSpace]rules]]; \[IndentingNewLine]\
\[IndentingNewLine]lab = 
          Apply[bfct, \ Tuples[{True, False}, w], 
              1] /. \[InvisibleSpace]{False \[Rule] 0, 
              True \[Rule] 1}; \[IndentingNewLine]\[IndentingNewLine]CA[
          w, \(-2\), FromDigits[lab, 2]]\[IndentingNewLine]];\)\)



































CA[r_Integer?NonNegative] := CA[ 3,-2, r, {},{}];
CA[w_Integer?Positive, k_Integer,r_Integer?NonNegative ] := CA[ w,k,r,{},{}];

Unprotect[C];
ClearAll[C];

(* old public *)

ToLabelCA[ C_CA ] :=
    Module[ {k,alph,w = WidthCA[C],r = RuleCA[C]},
           {k,alph} = Alphabet[C,Full\[Rule] True];
           alph[[IntegerDigits[r,k,k^w]+1]]
      ];

(* does not check if third component is a list *)

LabelToCodeCA[ C_CA ] :=
    With[ {lab = C[[3]]}, 
         ReplacePart[ C,FromDigits[ToIndex[StringJoin@@lab,Alphabet[C]]-1], 
        3 ] ];

LabelToCodeCA[ lab_List, w_Integer, K_ ] :=
       
    FromDigits[ToIndex[StringJoin@@lab,MakeAlphabet[K]]-1,AlphabetSize[K]];















































Options[ClassifyCA]={Full\[Rule]False,
      External\[RuleDelayed]$defaultexternal};

$classcamess = {"none","surjective","open","injective"};

ClassifyCA[ C_CA, opts___?OptionQ ] := 
    Module[{n,cmp,dag,dia,deg,full,res},
      
      full = Full /. {opts} /. Options[ClassifyCA];
      
      If[ External /. {opts} /. Options[ClassifyCA],
        	res = Automata`extaut`ExtClassifyCA[C];
        	Return[ If[  full,$classcamess[[res+1]],res ]]
        ];
      
      
      If[   Length@Union[Last /@ Frequencies[ToLabelCA[C]]] > 1,
        	res = 0 ,
        (* else is balanced *)
        	n  = AlphabetSize[C]^(WidthCA[C]-1);
        	dag  = NonTransientGraph@ToGraphFA@SquareSA[ ToSA[C],Full\[Rule] 1];
        	cmp  = VertexSet[dag];
        	dia  = PositionOne[cmp,1];             (* 
          position of diagonal SCC *)
        	
        deg  = DegreeGraph[dag,PositionOne[cmp,dia]];
        
        	res = Which[
            	Length[cmp]==1 && Length[cmp[[dia]]]==n,  3,
            	deg==0 && Length[cmp[[dia]]]==n,           2,
            	Length[cmp[[dia]]]==n,                    1,
            	True,				     0
            	];
        ];
      
      If[  full,$classcamess[[res+1]],res ]
      ];       







































Options[ComposeCA]={External\[RuleDelayed]$defaultexternal};

ComposeCA[ C1_CA, C2_CA, opts___?OptionQ ] :=

    Module[ {k,alph,w,f1,f2,B,norm},

    If[ External  /. {opts} /. Options[ComposeCA], 
	Return[ Automata`extaut`ExtComposeCA[C1,C2] ] ];

    w = WidthCA[C1] + WidthCA[C2] - 1;
    {k,alph} = Alphabet[C1,Full\[Rule] True];
	
    GlobalMapCA[f1,C1,WordMap\[Rule] True,Boundary\[Rule] None];
    LocalMapCA[f2,C2,WordMap\[Rule] True];
    B = f2[f1[#]]& /@ Reverse@Words[w,alph];
    CA[ w,ShortAlphabetSize[C1], 
          FromDigits[PositionList[alph,B]-1,k],ShortAlphabet[C1], {} ]
        ]  /;  Alphabet[C1]===Alphabet[C2];

ComposeCA[C1_CA,C2_CA,C__CA,opts___?OptionQ] := 
         ComposeCA[ComposeCA[C1,C2,opts],C,opts];
ComposeCA[C_CA,opts___?OptionQ] := C;























































Options[EvolutionCA]={Boundary\[Rule]Cyclic,
      External\[RuleDelayed]$defaultexternal};

EvolutionCA[ C_CA, t_Integer:50, opts___?OptionQ ] := 
     EvolutionCA[C,SeedConfiguration[{1},2t+1],t,opts];

EvolutionCA[ C_CA, pat_List, t_Integer:50, opts___?OptionQ ] := 
     PlotMatrix[ OrbitCA[C,pat,t,opts], 
		 SelectOptions[PlotMatrix,opts], SelectOptions[Graphics,opts] ];




























DependencyCA[ C_CA ] := Dependency[ ToLabelCA[C], AlphabetSize[C] ];































FSurjectiveCA[ C_CA ] := 
Module[{w,k,alph,A,lab,G},
     w   = WidthCA[C];
     {k,alph} = Alphabet[ C,Full\[Rule]True];
     A   = DeBruijnEdges[w-1,alph,Normalize\[Rule] 0];
     lab = Reverse@IntegerDigits[ RuleCA[C], k, k^w ];
     A   = Thread[ {First/@A, lab, Last/@A}  ];
     A   = Complement[ Cases[A,{_,0,_}], {{1,0,1}} ];
     G   = Graph[ k^(w-1), Length[A], "EList", Drop[#,{2}]& /@ A, {} ];
     ! CyclicQGraph[G]
]; 

































FunctionToCA[ ff_, w_Integer?Positive, K:(_?AlphabetQ):$alphabet ] := 
With[ {kk = AlphabetSize[K]},
     CA[ w,ShortAlphabetSize[K],
        FromDigits[Apply[ff,Reverse[CartesianProduct@@Table[kk,{w}]-1],1],kk],
        ShortAlphabet[K], {} ]
];









































Attributes[GlobalMapCA]={HoldFirst};

Options[GlobalMapCA]={Boundary\[Rule]Cyclic,WordMap\[Rule]False};

GlobalMapCA[ ff_, C_CA, opts___?OptionQ ] := 
    (
          ClearAll[ff];
          If[ WordMap  /. {opts} /. Options[GlobalMapCA],
            	makeWordMap[ ff, C, opts ],
            	makeListMap[ ff, C, opts ]
            ];
      );

$zpref[w_Integer?Positive] := Table["0",{w}];

makeWordMap[ ff_, C_CA, opts___?OptionQ ] := 
    Module[ {w,ww,rules},
          w   = WidthCA[C];
          ww  = Ceiling[w/2];
          rules = Dispatch@ToRulesCA[C,WordMap\[Rule] True];
      
          ff = 
            Switch[ Boundary /. {opts} /. Options[GlobalMapCA],
              	Cyclic, 
          StringJoin[ (StringJoin /@ Partition[ToCharacters[#],w,1,ww]) /. 
                rules]&,
              	Fixed,  
          StringJoin[ (StringJoin /@ 
                    Partition[ToCharacters[#],w,1,ww,First@Alphabet[C]]) /. 
                rules]&,
          	None,   
          StringJoin[ (StringJoin /@ Partition[ToCharacters[#],w,1])/.rules]&
              ];
      ];
	
makeListMap[ ff_, C_CA, opts___?OptionQ ] := 
    Module[ {w,ww,rules},
          w   = WidthCA[C];
          ww  = Ceiling[w/2];
          rules = Dispatch@ToRulesCA[C,WordMap\[Rule] False];
      
          ff = 
            Switch[ Boundary /. {opts} /. Options[GlobalMapCA],
          	    Cyclic, (Partition[#,w,1,ww] /. rules)&,
          	    Fixed,  (Partition[#,w,1,ww,$defzero] /. rules)&,
          	    None,   (Partition[#,w,1] /. rules)&
              ];
      ];



































Options[InverseCA]={External\[RuleDelayed]$defaultexternal,Full\[Rule]False};

InverseCA[CA[r_Integer,1,k_Integer]] := 
Module[{lab,Rk,h,hh},
     lab = ToLabelCA[CA[ 1,k,r]];
     Rk  = Range[0,Abs[k]-1];
     AssignFunction[h,Rk,ToExpression/@Reverse@lab];
     AssignFunction[hh,h/@Rk,Rk];
     CA[1,k,ToString /@ Reverse[hh /@ Rk]] // LabelToCodeCA
];

InverseCA[C_CA,opts___?OptionQ] := 
Module[{Wl,Wr,defl,defr,ww,sa,Lr,Ll,join,LL,k,alph,ll,rul,lab,res},

    {Wl,Wr} = Last@WelchCA[C,Full\[Rule] True];
    defl = DefiniteQFA[Wl,Full\[Rule] True];
    defr = DefiniteQFA[Wr,Full\[Rule] True];
    ww = defl + defr;
    sa = ToSA[ C ];
    Lr = fullanguage[ sa, defl ];
    Ll = fullanguage[ ReverseFA[sa], defr ];
    join[ {L1_List,L2_List} ] := 
	    Apply[ StringJoin, CartesianProduct[ StringReverse/@L1, L2 ], 1 ];
    LL = Sort@
          FlattenOne@MapIndexed[ CartesianProduct, join /@ Pairs[Ll,Lr] ];
    {k,alph} = Alphabet[C,Full\[Rule] True];
    ll  = k^(WidthCA[C]-1);
    rul = 
        Thread[ Range[ll] \[Rule]  Flatten[ Thread[ Table[alph,{ll/k}] ] ] ];
    lab = LabelToCodeCA[ Reverse[ (Last /@ LL) /. rul ], ww, alph ];
      res = CA[ ww,ShortAlphabetSize[C],lab, ShortAlphabet[C], {} ];
      If[ Full /. {opts} /. Options[InverseCA],
        	res ,
        	res// SimplifyCA
        ]
      ];

(* compute lists of all words where |w|=r, delta(p,w)!=0, for all p *)

fullanguage[ M_SA, r_Integer ] :=
    
    Module[ {n,k,alph,tr,extone,extt,extend,rul,w,a,p,L},
          {k,alph} = Alphabet[M,Full\[Rule] True];
          n   = Size[M];
          tr  = Partition[FlattenOne@Transitions@ToNFA[M],n];
          rul = Thread[Pairs[Table[alph[[#]],{n}],tr[[#]]]& /@ Range[k] ];
          extend[ L_List  ] := FlattenOne[ extone /@ L ];
          extone[ {w_,p_} ] := FlattenOne[ extt[ w, # ]& /@ rul[[p]] ];
          extt[ w_, {a_,L_List} ] := { w<> a, # }& /@ L;
          
      Union /@ Map[ First , Nest[ extend, {{"",#}}, r ]& /@ Range[n], {2} ]
      ];































Options[IterateCA]={Normalize\[RuleDelayed]$defaultnormalize};

IterateCA[ C_CA, t_Integer:2, opts___?OptionQ ] :=

    Module[ {k,alph,w,wt,ff,lab},
      
     {k,alph} = Alphabet[C,Full\[Rule] True];
     w  = WidthCA[C];
     wt = t (w - 1) + 1;
     GlobalMapCA[ff,C,WordMap\[Rule] True,Boundary\[Rule] None];
     lab  = Nest[ff,#,t]& /@ Reverse@Words[wt,alph];
     CA[  wt,ShortAlphabetSize[C],FromDigits[PositionList[alph,lab]-1,k],
        	ShortAlphabet[C],{} ]
      ];







































Attributes[LocalMapCA]={HoldFirst};

Options[LocalMapCA]={WordMap\[Rule]False};

LocalMapCA[ ff_, C_CA, opts___?OptionQ ] := 
    With[ {wmp = WordMap /. {opts} /. Options[LocalMapCA]},
      	AssignFunction[ ff, Sequence@@domCodomCA[C,wmp], 
        Kary\[Rule] Not[wmp] ]
      ];

domCodomCA[ C_CA, b_ ] := 
    Module[ {r,k,alph,w,n},
           r   = RuleCA[C];
           w   = WidthCA[C];
           {k,alph} = Alphabet[C,Full\[Rule] True];
           n   = k^w;
           
           If[ b, 
        		{ StringJoin@@alph[[#]]& /@ (IntegerDigits[Range[0,n-1],k,w]+1),
          		  Reverse[ alph[[IntegerDigits[r,k,n]+1]] ] },
        		{ IntegerDigits[Range[0,n-1],k,w], Reverse[IntegerDigits[r,k,n]] }
             ]
      ];



























NumberOfCA[ w_Integer, k_Integer ] := k^(k^w);



























NumberOfTotalisticCA[ w_Integer, k_Integer ] := k^(w(k-1)+1);









































Options[OrbitCA]={Boundary\[Rule]Cyclic,
      External\[RuleDelayed]$defaultexternal,Full\[Rule]False};

OrbitCA[ C_CA, pat_String, t_Integer:40, opts___?OptionQ ] := 
Module[ {G},
     (*If[ External /. {opts} /. Options[OrbitCA], 
         Return[ Automata`extaut`ExtOrbitCA[C,pat,t,opts] ] ]; *)
     
      GlobalMapCA[ G, C, WordMap\[Rule] True, 
        SelectOptions[GlobalMapCA,opts] ];
     NestList[ G, pat, t ] 
];

OrbitCA[ C_CA, pat_List, t_Integer:40, opts___?OptionQ ] := 
Module[ {G,res},
      	If[ External /. {opts} /. Options[OrbitCA],
        		res =  Automata`extaut`ExtOrbitCA[C,pat,t,opts],
        (* else *)
        		
        GlobalMapCA[ G, C, WordMap\[Rule] False, 
          SelectOptions[GlobalMapCA,opts] ];
        		res = NestList[ G, pat, t ]
        	];
      	If[  Full /. {opts} /. Options[OrbitCA], 
        		Developer`ToPackedArray[res],
        		res
        	]
      ];

























































PolynomialToCA[ pol_, w_Integer, k_Integer:2, str_String:"x" ] := 
Block[ {ff,kk},
    kk = Abs[k];
    ff = Function[ Evaluate[SymbolList[str,w]], Mod[ pol, kk ] ];
    FunctionToCA[ ff, w, -kk ]
];



























PrintCA[C_CA] := 
    Module[ {rules = ToRulesCA[C]},
          If[ Head[rules]=!=List, rules = First[rules]];
          Switch[ WidthCA[C],
            	1,       {rules},
            	2|3,  Partition[ rules, AlphabetSize[C]^(WidthCA[C]-1) ],
            	_,        Partition[ rules, AlphabetSize[C]^(WidthCA[C]-2) ] 
            ]
          ] // Thread // TableForm[#,TableSpacing\[Rule] {1,2}]&;



























Attributes[RuleCA]={Listable};

RuleCA[C_CA]:=C\[LeftDoubleBracket]3\[RightDoubleBracket];



































RulesToCA[ rw_List, w_Integer?Positive, Q_List  ] := 
With[ {k = Length[Q],QQ = Reverse@Tuples[ Q,w ]},
     CA[ w,-k,FromDigits[  QQ/. rw /. RankingRules[Q,Index\[Rule]0],k  ]  ]
];

















































Options[SeedConfiguration]={Where\[Rule]Center,Type\[Rule]List,
      Padding\[Rule]0,Random\[Rule]0};

SeedConfiguration[  n_Integer?Positive, opts___?OptionQ] := 
    SeedConfiguration[ {1}, n, opts ];

SeedConfiguration[ s_List| s_String, n_Integer?Positive, opts___?OptionQ] := 
    Module[{rnd,whr,pad,typ},
      
      	If[ 0<(rnd =  Random /. {opts} /. Options[SeedConfiguration]),
        			Return[  Table[Random[Integer,{0,rnd-1}],{n}] ] ];
      
      	whr =  Where     /. {opts} /. Options[SeedConfiguration];
      	pad =  Padding /. {opts} /. Options[SeedConfiguration];	
      	typ =  Type        /. {opts} /. Options[SeedConfiguration];
      
      	If[ typ === String && Head[pad] =!= String, 
        		pad = "a" ];
      
      	Switch[  typ,
        		List,     listSeed[ s, n, pad, whr ],
        		_,            wordSeed[ s, n, pad, whr ]
        	]
      ];

listSeed[s_List, n_Integer, pad_,  whr_] := 
    Switch[  whr, 
        	Center, PadLeft[ s, n, pad, Floor[(n-Length[s])/2]],
        	Right,  PadLeft[ s, n, pad ],
        	_,         PadRight[ s, n, pad ]			
        ]  // Flatten;


wordSeed[s_String, n_Integer, pad_,  whr_] := 
    StringJoin@@Switch[ whr, 
        	Center, PadLeft[ {s}, n, pad, Floor[n/2]],
        	Right,  PadLeft[ {s}, n, pad ],
        	_,           PadRight[ {s}, n, pad ]			
        ];













































Options[SimplifyCA]={Full\[Rule]False};

SimplifyCA[ C_CA, opts___?OptionQ ] :=

    Module[ {lab,lab1,lab2,w,k,alph,dr,dl,full,res},
     full = Full /. {opts} /. Options[SimplifyCA];
     lab = ToLabelCA[C];
     w   = WidthCA[C];
     {k,alph}  = Alphabet[C,Full\[Rule]True];
     dr  = 1;
     While[ 
        dr \[LessEqual]  w && Max[Length /@ Union /@ Partition[lab,k^dr]]==1, 
        dr++ ];
     dr--;
     lab1 = First /@ Partition[lab,k^dr];
     dl   = w-dr;
     While[ dl \[GreaterEqual]  0 && Length@Union@Partition[lab1,k^dl]==1, 
        dl-- ];
     dl++;
     lab2 = LabelToCodeCA[ First@Union@Partition[lab1,k^dl], dl, alph ];
     res = CA[ dl,ShortAlphabetSize[C],lab2,ShortAlphabet[C],{}];
     If[ full,
         { res, {w-dr-dl,dr}},
           res
     ] 
];































Options[ToRulesCA]={WordMap\[Rule]True};

ToRulesCA[ C_CA, opts___?OptionQ ] :=
Module[ {lab,k,alph,w,B,n,r},
     r   = RuleCA[C];
     w   = WidthCA[C];
     {k,alph} = Alphabet[C,Full->True];
     n   = k^w;
     
     If[ WordMap /. {opts} /. Options[ToRulesCA],
		lab = Reverse[ alph[[IntegerDigits[r,k,n]+1]]];
		B = StringJoin@@alph[[#]]& /@ (IntegerDigits[Range[0,n-1],k,w]+1),
	(*else*)
		lab =  Reverse@IntegerDigits[r,k,n];
		B = IntegerDigits[Range[0,n-1],k,w]
	];
     
    Dispatch[ Thread[ B \[Rule]  lab ] ]
];





























TotalisticRuleToCA[ w_Integer, k_Integer,r_Integer ] := 
With[ {rL = Reverse@IntegerDigits[ r, Abs[k], w(Abs[k]-1)+1 ]}, 
		FunctionToCA[rL[[ Plus[##]+1 ]]&, w, -Abs[k] ]
];



























ToTotalisticRuleCA[ ca_CA ] := 
Module[ {ff,k,w,makepat,qq,LL},
		makepat[s_Integer] := 
		(
          		qq = Quotient[s,k-1];
          		LL = Table[k-1,{qq}];
          		If[qq<w, AppendTo[LL,Mod[s,k-1]]];
          		Join[ LL, Table[0,{w-1-qq}] ]
          		);
      		k = AlphabetSize[ca];
      		w = WidthCA[ca];
      		LocalMapCA[ff,ca];
      		FromDigits[ Apply[ ff, makepat /@ Reverse@Range[0,w(k-1)], 1 ], k ]
      ];







































Options[WelchCA]={External\[RuleDelayed]$defaultexternal,Full\[Rule]False};

WelchCA[C_CA,opts___?OptionQ] := 
Module[ {nwl,nwm,nwr},

     If[ Full /. {opts} /. Options[WelchCA], 
	 Return[ toWelchCA[C,SelectOptions[toWelchCA,opts]]] ];

     If[ External /. {opts} /. Options[WelchCA], 
         {nwl,nwr} = Automata`extaut`ExtWelchCA[C],
         {nwl,nwr} = First@toWelchCA[C,SelectOptions[toWelchCA,opts]] 
     ];

     nwm = AlphabetSize[C]^(WidthCA[C]-1)/(nwl nwr);
     {nwl,nwm,nwr}
];


Options[toWelchCA]={Normalize\[Rule] 1,
      External\[RuleDelayed] $defaultexternal};

toWelchCA[ C_CA, opts___?OptionQ] :=

    Module[ {m,ml,mr,mxr,mxl,Ql,Qr,pos,wr,wl,w,k,alph,rules},

     If[ External /. {opts} /. Options[toWelchCA], 
         Return[Automata`extaut`ExtToWelchCA[C,opts]] ];
     norm = Normalize /. {opts} /. Options[toWelchCA];

     sa  = C // ToSA;
     mr  = ToKernelFA[ sa, 1, External\[Rule] False ];
     Qr  = States[mr];
     mxr = Max[ Length /@ Qr ];
     pos = PositionList[ Qr, Select[ Qr, Length[#]==mxr& ] ];
     wr  = SelectFA[mr,pos,opts];
     ml  = ToKernelFA[ sa//ReverseFA, 1, External->False ];
     Ql  = States[ml];
     mxl = Max[ Length /@ Ql ];
     pos = PositionList[ Ql, Select[ Ql, Length[#]==mxl& ] ];
     wl  = SelectFA[ml,pos,opts];

     If[  norm==0, 
          wl = wl // NormalizeFA;
          wr = wr // NormalizeFA; 
     ];
     If[ norm==2,
         {k,alph} = Alphabet[C,Full->True];
         w  = WidthCA[C] - 1;
         rules = RankingRules[ Words[w,alph],Type\[Rule]Backward ];
         wl = ReplacePart[ wl, States[wl]/.rules, -1 ];
         wr = ReplacePart[ wr, States[wr]/.rules, -1 ];
     ];

     {{mxl,mxr},{wl,wr}}
];























































Attributes[WidthCA]={Listable};

WidthCA[C_CA] := First[C];































































AddEdge[G_Graph,{x_Integer,y_Integer} ] := 
Module[ {GG},
      If[ EdgeQ[G,x,y], Return[G]];
      GG = ReplacePart[ G, NumEdges[G]+1,2 ];
      Switch[  TypeGraph[G],
        "EList",  ReplacePart[GG,Sort[Append[Edges[G],{x,y}]],4],
        "AMat",  ReplacePart[GG,ReplacePart[Edges[G],1,{x,y}],4],
        "AList",  ReplacePart[GG,Sort[ Append[Edges[G][[x]],y]],{4,x}]
        ]
      ];

AddEdge[G_Graph,{x_Integer,s_Integer,y_Integer} ] := 
    Module[ {GG},
        If[ EdgeQ[G,x,y], Return[G]];
        GG = ReplacePart[ G, NumEdges[G]+1,2 ];
        ReplacePart[GG,Sort[Append[Edges[G],{x,s,y}]],4]
        ]    /;  TypeGraph[G] === "LEList";





































AddVertex[ G_Graph] := 
    With[ {GG = ReplacePart[ G, NumVertices[G]+1, 1 ]},
      If[ GG[[-1]]==={}, 
        	GG,
        	ReplacePart[ GG, Append[VertexSet[G],NumVertices[G]+1],-1]
        ]];
	

AddVertex[ G_Graph,x_ ] := 
    With[ {GG = ReplacePart[ G, NumVertices[G]+1, 1 ]},
      If[ GG[[-1]]==={}, 
        		ReplacePart[ GG, Append[Range[NumVertices[G]],x],-1],
        		ReplacePart[ GG, Append[VertexSet[G],x],-1]
        ]];




































BiAccessibleGraph[ G_Graph, SS_List, TT_List, opts___?OptionQ ] := 
Module[ {VV,UU},
       VV = WeaklyConnectedComponents[G,SS];
       UU = WeaklyConnectedComponents[G//ReverseGraph,Intersection[VV,TT]];
       SubGraph[ G, Intersection[ VV, UU ], opts ]
];
BiAccessibleGraph[ G_Graph, s_Integer, t_Integer, opts___?OptionQ ] := 
		BiAccessibleGraph[ G, {s}, {t}, opts ];




































AccessibleGraph[ G_Graph, SS_List, opts___?OptionQ ] := 
       SubGraph[ G, WeaklyConnectedComponents[G,SS], opts ];
AccessibleGraph[ G_Graph, p_Integer, opts___?OptionQ ] := 
		AccessibleGraph[ G, {p}, opts ];







































CirculantGraph[n_Integer,d_List] := 
Module[{Q,k,ed},
	k = Length[d];
	Q = Range[0,n-1];
	ed = Thread[{Join@@Table[Q,{k}], Mod[#,n]& /@ Join@@((Q+#)& /@ d)}];
	Graph[ n, Length[ed], "EList", ed+1, {} ]
];

































CyclicQGraph[ G_Graph ] :=
Module[ { n,L,cnt,Z,indeg,in },

        (* compute indegrees *)
        n  = NumVertices[G];
	L  = Edges@ToAdjacencyList[G];
        AssignFunction[indeg,Range[n],First /@ DegreeGraph[G,Full->True]];

        (* prepare candidates  *)
        
      Z = Select[Range[n],(indeg[#]==0)&];

        cnt = 0;
        While[ Length[Z]>0,
                cnt++;
                x = First[Z];
                Z = Rest[Z];
                Scan[(indeg[#]--;If[ indeg[#]==0, Z={Z,#}])&, L[[x]] ];
		Z = Flatten[Z]
        ];
    cnt < n
];





































Options[DeBruijnEdges]={Normalize\[Rule]1};

DeBruijnEdges[ w_Integer, K_:{0,1}, opts___?OptionQ ] := 
    Module[ {k,alph,norm,Rn,B},
      	norm = Normalize /. {opts} /. Options[DeBruijnEdges];
      	{k,alph} = MakeAlphabet[K,Full\[Rule] True];
      	Rn = Range[k^w];
      	B  = Pairs[ Flatten[Thread@Table[Rn,{k}]], Join@@Table[Rn,{k}] ];
      	If[ norm==0, 
        		B, 
        		{ StringJoin@@alph[[IntegerDigits[#[[1]],k,w]+1]],
              		  
              StringJoin@@alph[[IntegerDigits[#[[2]],k,w]+1]] }& /@ (B-1) 
        	]
      ];





































Options[DeBruijnGraph]={Normalize->0};

DeBruijnGraph[ ww_Integer, K_:{0,1}, opts___?OptionQ ] := 
Module[ {k,norm},
     norm = Normalize /. {opts} /. Options[DeBruijnGraph];
     k = AlphabetSize[K]; 
     res = Graph[ k^ww, k^(ww+1), "EList", 
			DeBruijnEdges[ww,K,Normalize->0], {} ];
     If[ norm==0,
         res,
	 ReplacePart[ res, Words[ww,K], -1 ]
     ]
];






































Options[DegreeGraph]={Full\[Rule]False};

DegreeGraph[G_Graph,v_Integer,opts___?OptionQ] := 
Module[{ed,in,out},
	full = Full /. {opts} /. Options[DegreeGraph];

	ed  = Edges@ToEdgeList[G];
	out = Length[Cases[ed,{v,__}]];
	in  = Length[Cases[ed,{__,v}]];
	If[ full, {in,out}, in + out ]
];

(*  dangerous, slow on big graphs *)

DegreeGraph[G_Graph,V_List,opts___?OptionQ] := 
Module[{degs,ed,in,out},
	full = Full /. {opts} /. Options[DegreeGraph];
	ed  = Edges@ToEdgeList[G];
	out[v_] := Length[Cases[ed,{v,__}]];
	in[v_]  := Length[Cases[ed,{__,v}]];
	degs = Thread[{in /@ V,out /@ V}];
	If[ full,  degs, Apply[Plus, degs, 1] ]
];

DegreeGraph[G_Graph,opts___?OptionQ] := 
Module[{deg,ed,ind,outd,makdeg},

	ed  = Edges@ToEdgeList[G];
	If[ TypeGraph[G] === "LEList", ed = Drop[#,{2}]& /@ ed];
	If[ Full /. {opts} /. Options[DegreeGraph], 
	    ind[_] = 0; outd[_] = 0;
	    makdeg[{a_,b_}] := (ind[b]=ind[b]+1; outd[a]=outd[a]+1);
	    Scan[ makdeg, ed ];
	    Return[ 
          Thread[{ind /@ Range@NumVertices[G], 
              outd /@ Range@NumVertices[G]}] ];
	];

        deg[_] = 0;
	makdeg[{a_,b_}] := (deg[b]=deg[b]+1; deg[a]=deg[a]+1);
	Scan[ makdeg, ed ];
	Return[ deg /@ Range@NumVertices[G] ];
];





























DeleteEdge[G_Graph,{x_Integer,y_Integer} ] := 
Module[ {GG},
      	GG = ReplacePart[ G, NumEdges[G]-1,2 ];
      Switch[  TypeGraph[G],
        "EList",  ReplacePart[GG,DeleteCases[Edges[G],{x,y}],4],
        "LEList",  ReplacePart[GG,DeleteCases[Edges[G]],{x,y},4],
        "AMat",  ReplacePart[GG,ReplacePart[Edges[G],0,{x,y}],4],
        "AList",  ReplacePart[GG,Complement[Edges[G][[x]],{y}],{4,x}]
        ]
      ];































DeleteVertex[GG_Graph,x_Integer] := 
Module[ {h,ed,newedge,n,VV},
        n  = NumVertices[GG];
        VV = Join[Range[x-1],Range[x+1,n]];
        AssignFunction[h, Pairs[VV,Range[n-1]] ];
        newedge[{u_,v_}] := {h[u],h[v]};
        newedge[{u_,a_,v_}] := {h[u],a,h[v]};
        ed = newedge /@ Select[Edges[GG],(First[#]=!=x && Last[#]=!=x)&];
        res = ReplaceParts[ GG, n-1, 1, Length[ed], 2, "EList", 3, ed, 4 ];
        If[ MinusEins[GG]==={},
            res, 
            ReplacePart[ res, VertexSet[GG][[VV]], -1 ]
        ]
];























EdgeQ[ G_Graph, x_Integer, y_Integer ] := 
Switch[ TypeGraph[G],
        "EList"|"LEList",Cases[ Edges[G], {x,___,y} ]=!={},
        "AMat",                        Edges[G][[x,y]]==1,
        "AList",                      MemberQ[ Edges[G][[x]], y ]
];





























Edges[ G_Graph ] := G[[4]];













































Graph[n_,k_,i_,ed_] := Graph[n,k,i,ed,{}];







































Options[GridGraph]={Type\[Rule] None};

GridGraph[n_Integer,m_Integer,opts___?OptionQ]:=
  Module[{V,ed,type},
    		V = CartesianProduct[n,m];
    		ed = Select[ 
        				Join[ Pairs[V,{0,1}+#& /@ V],  Pairs[V,{1,0}+#& /@ V]],
        				And@@Thread[ #[[2]] \[LessEqual]  {n,m}]& ];
    		type = Type /. {opts} /. Options[GridGraph];
    		Switch[ type,
      			"Cylinder",   ed = Join[ ed, Table[{{i,m},{i,1}},{i,n}] ],
      			"Torus",   ed = Join[ ed, Table[{{i,m},{i,1}},{i,n}], 
          						Table[{{n,i},{1,i}},{i,m}] ]
      		];
    			
    		Graph[ n m,Length[ed], "EList", Sort[ed/.RankingRules[V]], V ]
    ]





























LabelEdgeList[ G_Graph, lab_List ] := 
    ReplaceParts[ G, "LEList", 3, 
      Thread[ {First/@Edges[G], lab, Last/@Edges[G]}], 4 ];







































Options[LongestPath]={Full\[Rule]False};

LongestPath[ G_Graph, opts___?OptionQ ] :=

    Module[ {expl,explore,n,deg,indeg,Q,adj,dd,x},

     expl[x_] := explore[x,#]& /@ adj[[x]];
     explore[x_,u_] := 
      ( If[ dd[u]<dd[x]+1, dd[u]=dd[x]+1 ];  (* 
            update depth of vertex u *)
        indeg[u] = indeg[u]-1;
        If[ indeg[u]==0, AppendTo[Q,u]] );
           
     n   = NumVertices[G];
     deg = First /@ DegreeGraph[G,Full->True];
     AssignFunction[indeg,Range[n],deg];
     Q   = Select[ Range[n], indeg[#]==0& ];

     dd[_]= 0;
     adj = Edges@ToAdjacencyList[G];
     While[ Q =!= {},
            x = First[Q];
            Q = Rest[Q];
            expl[x];
     ];
     If[ Full /. {opts} /. Options[LongestPath], 
         dd /@ Range[n], 
         Max[dd /@ Range[n]] ]
];































NormalizeGraph[ G_Graph ] := ReplacePart[ G, {}, -1 ];

































Options[NonTransientGraph]={Normalize\[Rule]1};

NonTransientGraph[G_Graph,opts___?OptionQ ] := 
    Module[ {dag,comps,ntcomps,ntr},
      	dag = ToDirectedAcyclicGraph[G,Normalize\[Rule]1];
      	comps = VertexSet[dag];
      	ntcomps = 
        Select[ comps, (Length[#]>1 || EdgeQ[G,First[#],First[#]])& ];
      	ntr = PositionList[comps,ntcomps];
      	ntr = Intersection[
          		WeaklyConnectedComponents[dag,ntr], 
          		WeaklyConnectedComponents[ReverseGraph[dag],ntr]];
      	res = SubGraph[dag,ntr,Normalize\[Rule]2];
      Switch[ Normalize /. {opts} /. Options[NonTransientGraph],
        0,  NormalizeGraph[res],
        1,   res, 
        _,   
        ReplacePart[ res, 
          With[{VV=VertexSet[G]}, VV[[#]]& /@ VertexSet[res] ],-1 ]
        ]
      ]; 













































NumEdges[ G_Graph ]  := Zwei[G];





























NumVertices[ G_Graph ]      := First[G];







































Options[PathGraph]={Full\[Rule]False};

PathGraph[n_,opts___?OptionQ] := 
Module[ {ed}, 
	ed = Partition[Range[n],2,1];
	If[ Full /. {opts} /. Options[PathGraph],  AppendTo[ed,{n,n}] ];
	Graph[ n, Length[ed], "EList", ed ]
];






























PermuteGraph[ G_Graph, perm_List ] := 
Module[{ed,n,h},
        n = NumVertices[G];
        If[ Length[perm]=!=n, Return[G]];
        AssignFunction[h,Pairs[Range[n],perm]];
        ed = Switch[ TypeGraph[G],
                     "EList", Sort[Map[ h, Edges[G], {2} ]],
                     "LEList", 
          Sort[ {h[#[[1]]],#[[2]],h[#[[3]]]}& /@ Edges[G] ],
                     "AMat", Thread[Thread[Edges[G][[perm]]][[perm]]],
                     "AList", Sort /@ Map[ h, Edges[G][[perm]], {2} ]
            ];
        res = ReplacePart[ G, ed, 4 ];
        If[ MinusEins[G]==={},
            res, 
            ReplacePart[ res, VertexSet[G][[perm]], -1 ]
        ]
];













































Options[ProductGraph]={Full\[Rule]True,Normalize\[Rule] 1};

ProductGraph[ G1_Graph, G2_Graph, opts___?OptionQ ] := 
Block[ { ed, e1, e2, edges, V, VV }, 

       e1 = Edges[G1];
       e2 = Edges[G2];

       If[ Full /. {opts} /. Options[ProductGraph], 
	   edges[{x_, y_}] := 
		 CartesianProduct[{{x, y}},
		 Join[ CartesianProduct[{x}, Last /@ Cases[e2, {y, _}]], 
		       CartesianProduct[Last /@ Cases[e1, {x, _}], {y}] ]],
       (* else *)
	   edges[{x_, y_}] := CartesianProduct[{{x, y}}, 
		 CartesianProduct[Last /@ Cases[e1, {x, _}], Last /@ Cases[e2, {y, _}]]]
       ];

       V = CartesianProduct[NumVertices[G1],NumVertices[G2]];
       ed = FlattenOne[edges /@ V];

       VV = Switch[ Normalize /. {opts} /. Options[ProductGraph], 
          	0,  {},
          	1,   V,
          	2,   With[{V1=VertexSet[G1],V2=VertexSet[G2]},
            			{V1[[#[[1]]]],V2[[#[[2]]]]}& /@ V ]
          ];
        
      Graph[ Length[V], Length[ed], "EList", ed/.RankingRules[V], VV ]
      
      ];

































ProductLabeledGraph[ G1_Graph, G2_Graph ] := 
Block[ { ed, L1, L2, prod, edges, alph, t1, t2, V, rules }, 

    L1 = Edges[G1];
    L2 = Edges[G2];
    alph = Union[ Zwei /@ Join[L1,L2] ];
     
    prod[{x_, y_}] := { {x[[1]],y[[1]]}, x[[2]], {x[[3]],y[[3]]} };
    edges[a_] := 
    (   
        t1 = Cases[L1,{_,a,_}];
        t2 = Cases[L2,{_,a,_}];
        ed = Join[ ed, prod /@ CartesianProduct[t1,t2] ]; 
    );
    ed = {};
    Scan[ edges, alph ];
    V = CartesianProduct[VertexSet[G1],VertexSet[G2]]; 
    Graph[ Length[V], Length[ed], "LEList", ed/.RankingRules[V], V ]
];































ReverseGraph[ G_Graph ] := 
Module[{e,GG},
      Switch[ TypeGraph[G],
      "EList"|"LEList", MapAt[ Reverse, G, {4,#}& /@ Range[NumEdges[G]] ],
      "AMat",   ReplacePart[ G, Thread@Edges[G], 4 ],
      "AList",   GG = ToEdgeList[G];
           
        ToAdjacencyList[ MapAt[ Reverse, GG, {4,#}& /@ Range[NumEdges[G]] ] ]
      ]
];

































SetVertices::length="List must have same length as vertex set.";

Attributes[SetVertices]={HoldFirst};

SetVertices[G_,L_List]:=
    If[ NumVertices[G]\[NotEqual]Length[L],
        Message[SetVertices::length];
        Return[G],
        With[{GG=ReplacePart[G,L,-1]},
          	Clear[G];G=GG]
        ]   /;  Head[G]===Graph;




































Options[ShortestPath]={Full\[Rule]False};

ShortestPath[ G_Graph, s_Integer, opts___Rule ] := 
Block[ {Q,R,d,pre,bfs,getpath},
	Q = R = {s};
	d[s] = 0;
	d[_] := -1;
	pre[s] = s;
	
	adjl = Edges@ToAdjacencyList[G];
	
	bfs[x_][y_] := 
		If[ d[y]==-1, 
		    d[y]=d[x]+1; pre[y]=x; 
		    AppendTo[Q,y]; AppendTo[R,y] ];
		    
	
	While[ Q =!= {},
		   x = First[Q];
		   Q = Rest[Q];
		   
		   Scan[ bfs[x], adjl[[x]] ];
    ];
    
    If[ Full /. {opts} /. Options[ShortestPath], 
		getpath[z_] := {z} /; pre[z]==z;
		getpath[z_] := Append[ getpath[pre[z]], z ];
		getpath /@ Sort[R],
    (*else*)
  	    {#,d[#]}& /@ Sort[R]
    ]
];





































Options[StronglyConnectedComponents]={NonTrivial\[Rule]False,
      External\[RuleDelayed]$defaultexternal};

StronglyConnectedComponents[ G_Graph, opts___?OptionQ ] :=

    Module[ {ntriv, GG},

    If[ NonTrivial /. {opts} /. Options[StronglyConnectedComponents], 
    	ntriv=1, ntriv=0 ];

(* bad, should convert to most convenient type *) 
    If[ TypeGraph[G]=!="EList" && TypeGraph[G]=!="AList", 
        GG = ToAdjacencyList[G],
        GG = G 
    ];

    If[ External /. {opts} /. Options[StronglyConnectedComponents], 
        Automata`extaut`ExtStronglyConnectedComponents[GG,ntriv],
        procSCC[GG,ntriv]
    ] // Function[ xx, Sort[xx,(Min[#1]<Min[#2])&]]
];


procSCC[ G_Graph, ntriv_ ] :=

    Block[ {n, adjc, curr, comps, comp, cnt, dfsnum, lownum, dfs, dfsact}, 

    n    = NumVertices[G];
    adjc = Edges@ToAdjacencyList[G];
    
                        (* initialize dfsnum and lownum arrays to 0 *)
    
      dfsnum[_Integer]=0; 
    lownum[_Integer]=0;

                                           (* auxiliary procedures  *)
    
      dfs[ x_Integer ] := 
    (   
        lownum[x] = dfsnum[x];
        Scan[  dfsact[x], adjc[[x]] ];     (* explore all sons of x *)
    
        If[ lownum[x]===dfsnum[x],          (* x is a root *)
            
            comp = Select[ curr, (dfsnum[#] >= dfsnum[x])& ];
            AppendTo[ comps, Sort[comp] ];
            curr = Complement[ curr, comp ]
        ]        
    );

    dfsact[x_Integer][y_Integer] :=                    (* 
          explore son y of x *)
    (   If[ dfsnum[y] === 0,
            dfsnum[y] = ++cnt;
            AppendTo[ curr, y ];
            dfs[y];
            lownum[x] = Min[lownum[x],lownum[y]]
        ];
        If[ dfsnum[y] < dfsnum[x] && MemberQ[ curr, y ],
            lownum[x] = Min[ lownum[x], dfsnum[y] ]
        ] 
    );

                                           (*  perform exploration  *)
    
      curr  = {};
    comps = {};
    cnt   = 0;
    Scan[ If[ dfsnum[#]===0, dfsnum[#]=++cnt; AppendTo[curr,#]; dfs[#] ]&, 
          Range[n] ];

    If[ ntriv==1,
        Select[ 
          comps, (Length[#]>1 || 
                MemberQ[ adjc[[First[#]]], First[#] ] )& ],  
        comps
    ]
];



































Options[SubGraph]={Normalize\[Rule]1};

SubGraph[ G_Graph, LL_List, opts___?OptionQ ] := 
Module[ {ed,n,h,edh},
	ed = Edges@ToEdgeList[G];
	n  = Length[LL];
	AssignFunction[h,LL,Range[n]];
	ed = Select[ed, (MemberQ[LL,First[#]] && MemberQ[LL,Last[#]])& ];
	edh = If[ TypeGraph[G]=="EList",
			Partition[h /@ Flatten[ed],2],
			renum[{p_,a_,q_}] := {h[p],a,h[q]};
			renum /@ ed
		];
        res = Graph[ n, Length[edh], "EList", edh, {} ];
        Switch[ Normalize /. {opts} /. Options[SubGraph],
            0, res,
            1, ReplacePart[ res, LL, -1 ],
            2, ReplacePart[ res, VertexSet[G][[LL]], -1 ]
        ]
];

































ToAdjacencyList[ G_Graph ] := 
Module[ {adjl,n,V},
     Switch[ TypeGraph[G],
     "EList",
        n = NumVertices[G];
                adjl = Table[ {}, {n} ];
                Scan[ (AppendTo[ adjl[[First[#]]], Last[#] ])&, Edges[G] ];
                ReplaceParts[ G, "AList", 3, adjl, 4 ],
             "LEList", 
        n = NumVertices[G];
                adjl = Table[ {}, {n} ];
                Scan[ (AppendTo[ adjl[[First[#]]], Rest[#] ])&, Edges[G] ];
                ReplaceParts[ G, "LAList", 3, Flatten /@ adjl, 4 ],
             "AMat", 
        n = NumVertices[G];
                
        ReplaceParts[ G, "AList",3, Flatten@Position[#,1]& /@ Edges[G], 4 ],
             _,  G
             ]
      ];





























ToAdjacencyMatrix[ G_Graph ] := 
Module[ {n,mat},
        If[ TypeGraph[G]=="AMat", Return[G] ];

        n   = NumVertices[G];
		mat = Table[0,{n},{n}];
		Scan[ (mat[[ First[#], Last[#] ]] = 1)&, Edges[ToEdgeList[G]] ];
        ReplaceParts[ G, "AMat", 3, mat, 4 ]
];

































Options[ToDirectedAcyclicGraph]={Normalize\[Rule]1};

ToDirectedAcyclicGraph[ G_Graph, opts___?OptionQ ] := 
Module[ {comps,n,hh,ed,edh,P,pair,VV,res},
	pair[{L_List,i_Integer}] := CartesianProduct[L,{i}];
        n  = NumVertices[G];
        ed = Edges@ToEdgeList[G];
	If[ TypeGraph[G]=="LEList", ed = Drop[#,{2}]& /@ ed ];
        comps = StronglyConnectedComponents[G];
        P = Thread[ {comps,Range[Length[comps]]} ];
        AssignFunction[ hh, FlattenOne[pair /@ P]  ];
        edh = Select[Union[Map[hh,ed,{2}]],(First[#]=!=Last[#])&]; 
	VV = Switch[ Normalize /. {opts} /. Options[ToDirectedAcyclicGraph],
		0,  {},
		1,  comps,
		2,  With[{W=VertexSet[G]}, W[[#]]& /@ comps ] 
	];
        Graph[ Length[comps], Length[edh],"EList", edh, VV ]
];





























ToEdgeList[ G_Graph ] := 
Module[ {n,ed,P},
     Switch[ TypeGraph[G],
     "EList"|"LEList",   G,
     "AMat",
        n = NumVertices[G];
                 ed = Flatten[Thread /@ Pairs[ Range[n], 
                                        Flatten@Position[#,1]& /@ Edges[G] ], 
            1 ];
                 ReplaceParts[ G, "EList", 3, ed, 4 ],
             "AList",     
        n = NumVertices[G];
                 P = Thread[ {Range[n], Edges[G] } ];
                 ReplaceParts[ G, "EList", 3, FlattenOne[ Thread/@P ], 4 ]
             ]
      ];



































Options[ToTDGraph]={Normalize\[Rule]0};

(*  vertex set in TD-graph is  [n] x [m] --> space x time  *)
(*  
  but ordered by columns, not like CartesianProduct[n,m] *)
(*  
  must reverse for plotting                              *)
(*  
  ranking and unranking:                                 *)

cptork[n_Integer][{x_,y_}] := (y-1)n+x;
rktocp[n_Integer][z_]    := { Mod[z-1,n]+1,Quotient[z-1,n]+1};
rktocoord[n_Integer][z_] := { Quotient[z-1,n]+1,Mod[z-1,n]+1};
coordtork[n_Integer][{x_,y_}] := (x-1)n+y;

TDGiedges[n_Integer][L_List,{i_Integer}] := 
	L /. {x_Integer,y_Integer}->{(i-1)n+x,n*i+y};

TDGmakeEdges[n_Integer][ LL_List ] := 
	FlattenOne@MapIndexed[ TDGiedges[n], LL ];

ToTDGraph[ {RR___List}, n_Integer, opts___?OptionQ ] :=
Module[ {m,ed,V},
	m  = Length[{RR}] + 1;
	ed = TDGmakeEdges[n][{RR}];
	If[ 0==(Normalize /. {opts} /. Options[ToTDGraph]),
	    V = {},
	    V  = rktocp[n] /@ Range[n m]
	];
	Graph[ m n, Length[ed], "EList", ed, V ]
];



































TypeGraph[ G_Graph ] := Drei[G];





























VertexSet[ G_Graph ] := 
    If[ MinusEins[G]==={}, Range[First[G]], MinusEins[G] ];





























WeaklyConnectedComponents[ G_Graph, x_Integer ] := 
    WeaklyConnectedComponents[G,{x}];

WeaklyConnectedComponents[ G_Graph, A_List ] :=
Block[ { n, L, cnt, h },

    n = NumVertices[G];
    L = Edges@ToAdjacencyList[G];
    h[_]=0;
    
                                     (* explore all sons of x *)
    
      dfs[ x_Integer ] := Scan[  dfsact, L[[x]] ]; 

                                     (* explore son y of x *)
    
      dfsact[ y_ ] := If[ h[y] == 0, h[y] = ++cnt; dfs[ y ] ];
    
                                     (*  perform exploration  *)
    cnt = 0;
    Scan[ If[ h[#]==0, h[#] = ++cnt; dfs[#];]&, A ];
    Select[ Range[n], (h[#]>0)& ]
];





























$generateSGBound = 5000;

























$identitystring = "1";

























$nullstring = "0";































AllTimes[A_List, B_List] :=
     
    Apply[NonCommutativeMultiply, CartesianProduct[A,B], {1}];
AllTimes[A_List,B_List,R__List] := AllTimes[AllTimes[A,B], R];

























AlternatingGroupSG[n_] := SG[OneT[n]]   /;  n<3;
AlternatingGroupSG[n_Integer, opts___?OptionQ ] :=
	
    GenerateSG[ GEN[ n, n-2, Join[ {T@@Join[{2,3,1},Range[4,n]]},
		TranspositionT[n,1] ** (TranspositionT[n,#]& /@ Range[3,n-1]) ] ], opts ];



































AperiodicQSG[ SS_SG ] := 
Module[ {S,m,Sq,sq},

     S = ToList[SS];
     m = Length[First[S]];
     
     If[ m==1, Return[True] ];
     
     (* compute list x^2, x in S,
		convert to transformation t : [n] --> [n], 
		t(i) = position of S[[i]]^2 in S     
		r minimal such that 2^r >= m,  
     	compute list of 2^r-th powers of S via t^r *)
     	
     sq = FastExpoT[ T@@PositionList[ S, S^2 ], Ceiling[N[Log[2,m]]] ];
     Sq = S[[ ToList[sq] ]];
     Sq === Sq**S
]; 

AperiodicQSG[S_List] := 
    GenerateSG[GEN[Length@First[S],Length[S],S]] // AperiodicQSG;
AperiodicQSG[x_T] := 
	With[ {xn = FastExpoT[x,Length[x]]}, xn === xn**x ];AperiodicQSG[z__T]   := 
    GenerateSG[GEN[Length@First[{z}],1,{z}]] // AperiodicQSG;

































AperiodicSG[S_SG] := ToList[Select[S,AperiodicQSG]];







































BlocksToDClass::irrg = "D-class is irregular, must supply semigroup.";

BlocksToDClass[ db_List, S_SG:SG[] ] := 
Module[ {e,x,H,pos,rm,lm,S1},
	e = Catch[ 
          	Scan[If[ #**#===#, Throw[#] ]&, Flatten[db]];
          	Throw[Null]
          ]; (* find idempotent *)
      	If[ e=!=Null,
        		 pos = First@Position[db,e];
        		 H  = db[[Sequence@@Drop[pos,-1]]];
        		 rm = First /@ db[[First[pos]]];
        		 lm = First /@ Thread[db][[Zwei[pos]]],
        	(* else class is irregular *)
        	
        If[ S===SG[], Message[BlocksToDClass::irrg]; Return[$Failed]];
        	    S1 = MakeMonoidSG[S];
        	    H  = db[[1,1]];
        	    x  = First[H];
        	    rm = SolveSG[x,#,S1,Full\[Rule] False]& /@ First /@ First[db];
        	    
        lm = SolveSG[x,#,S1,Full\[Rule] False,Where\[Rule] Left]& /@ 
            First /@ First[Thread[db]]        
        	];
      	DC[lm,rm,H]
      ];





































































CollapseT[z_] := 
With[ {ker = KernelT[z]},
     T@@(First /@ FlattenOne[Position[ker,#]& /@ ImageT[z]])
];

























ConstantT[k_Integer,n_Integer] := T@@Table[k,{n}];

































Options[CycleDecompositionT]={Full->False};

CycleDecompositionT[x_T,opts___?OptionQ] := 
Module[ {testcyc,cycs,orb},
	testcyc[ LL_List ] := 
		With[ {ss = x[[Last[LL]]]},
			If[ MemberQ[LL,ss], LL, Append[LL,ss] ]];	
	cycs = Reap[NestWhile[ 
		(Sow[orb = FixedPoint[ testcyc, {Min[#]}]];
		Complement[#,orb])&, Range[Length[x]], #=!={}&
	]][[2,1]];
	If[ Full /. {opts} /. Options[CycleDecompositionT], 
	    cycs,
	    DeleteCases[ cycs, {_} ]
	]
];



































CycleToT[ {cyc___List}, n_Integer ] := 
	OneT[n] /. Flatten[Thread[#->RotateLeft[#]]& /@ {cyc} ];























































































Options[DClassDecomposition]={RegularOnly\[Rule]True};

DClassDecomposition[S_SG,opts___?OptionQ]:=
    Module[{idem,regular,d,S1,Sirr,dclist,makeDClass,hs,rs,sel0,sel1,lind,
        rind,lid,rid,inds,V,VV,scc,adjL,gr},
      
      regular=
        RegularOnly/.\[InvisibleSpace]{opts}/.\[InvisibleSpace]Options[
            DClassDecomposition];
      
      dclist={};
      Sirr=ToList[S];
      idem=IdemSG[S];
      While[ Length[idem]>0,
        	d=DClassT[First[idem],S];
        	dL=Flatten[ToList[DClassToBlocks[d]]];
        	dclist={dclist,d};
        	idem=Complement[idem,dL];
        	If[!regular,Sirr=Complement[Sirr,dL]];
        ];
      
      If[regular||Sirr==={},Return[Flatten[dclist]]];
      
      makeDClass[LL_List]:=
        (
          VV=V[[LL]];
          sel0=Select[inds,MemberQ[VV,Most[#]]&];
          sel1=Most/@sel0;
          hs=Count[sel1,First[sel1]];
          rs=Count[First/@sel1,First[First[sel1]]]/hs;
          Partition[Partition[Drei/@sel0,hs],rs]
          );
      
      S1=MakeMonoidSG[S];
      Scan[(lid[#1]:=lid[#1]=LeftIdealT[#1,S1])&,Sirr];
      Scan[(rid[#1]:=rid[#1]=RightIdealT[#1,S1])&,Sirr];
      AssignFunction[lind,Sirr,First[MakeIndex[Sirr,lid[#1]===lid[#2]&]]];
      AssignFunction[rind,Sirr,First[MakeIndex[Sirr,rid[#1]===rid[#2]&]]];
      inds=Sort[({rind[#1],lind[#1],#1}&)/@Sirr];
      V=Union[Most/@inds];
      adjL=(PositionList[V,
                Cases[V,{First[#1],_}]\[Union]Cases[V,{_,Last[#1]}]]&)/@V;
      gr=Graph[Length[V],Plus@@Length/@adjL,"AList", adjL,4];
      scc=StronglyConnectedComponents[gr];
      Join[ Flatten[dclist],(BlocksToDClass[#1,S]&)/@makeDClass/@scc]
      ];



































Options[DClassSize]={Full\[Rule]False};
Attributes[DClassSize]={Listable};
DClassSize[dc_DC,opts___?OptionQ] := 
    With[ {res = ToList[Length /@ dc]},
      If[ Full /. {opts} /. Options[DClassSize],
        res,
        Times@@res
        ]
      ];



































DClassT[z_T,S_SG] := 
Module[ {rank,Rz,Lz,H,SL,pairs,k1,k2},
     
    SL   = ToList[MakeMonoidSG[S]];
    rank = RankT[z];

    Rz  = DeleteDuplicates[z**SL,SL,OutPairs\[Rule] True];
    Rz  = Select[Rz,(RankT[#[[1]]]==rank)& ];
    H    = Select[First /@ Rz,(ImageT[#]==ImageT[z])& ];
    Rz  = Zwei@DeleteDuplicates[ImageT[#[[1]]]& /@ Rz, Last /@ Rz ];
    Lz  = DeleteDuplicates[SL**z,SL,OutPairs\[Rule] True];
    Lz  = Select[Lz,(RankT@First[#]==rank)& ];
    Lz  = Zwei@DeleteDuplicates[Sort@KernelT@First[#]& /@ Lz, Last /@ Lz];

    pairs = CartesianProduct[Lz,Rz];
    pairs = Select[ pairs, SelectorQ[ImageT[z**#[[2]]],KernelT[#[[1]]**z]]&];
    Rz  = Union[Last  /@ pairs];
    Lz  = Union[First /@ pairs];
    DC[Lz,Rz,H]
];

































Attributes[DClassToBlocks]={Listable};

DClassToBlocks[ dcl_DC ] := Outer[ (#1**dcl[[3]]**#2)&, dcl[[1]], dcl[[2]] ];

































DihedralGroupSG[n_Integer]:=
    With[{t=ShiftT[n],s=T@@Reverse[Range[n]]},
      GenerateSG[GEN[2,n,{s,t}]]];







































































GenerateCSM::trunc = 
    "Truncating since semimodule size `1` is larger than bound. 
Increase BoundCSM.";

Options[GenerateCSM]={Equations\[Rule]False,BoundCSM\[Rule]2000,
      Direction\[Rule]Right};

GenerateCSM[ q0_, dot_, K:(_?AlphabetQ):$alphabet, opts___?OptionQ ] :=
    
    Module[ {wit,val,testwi,testw,k,alph,S,act,eq,eqns,smax,x,wi,right,h,W},
      eqns   = Equations /. {opts} /. Options[GenerateCSM];
      right = Right===(Direction /. {opts} /. Options[GenerateCSM]);
      smax   = BoundCSM  /. {opts} /. Options[GenerateCSM];
      
      {k,alph} = MakeAlphabet[K,Full\[Rule]True];
      If[  eqns===False, Return[generatecsm[q0,dot,alph,smax]] ];
      
      testwi[ w_String, i_Integer ] :=
        (
          If[ right,
            	wi = StringJoin[ w, alph[[i]] ];x  = dot[ val[w], alph[[i]] ] ,
            	wi = StringJoin[ alph[[i]], w ];x  = dot[ alph[[i]], val[w] ]
            ];
          
          If[ MemberQ[ S,x ],
            	Sow[  {h[w],i,h[wit[x]]} ,0],
                 	(* else *)
            	AppendTo[ S, x ]; 
                		val[wi] = x;
            	wit[x] = wi;
            	h[wi] = ++cnt;
            	Sow[{h[w],i,cnt},0];
            	Sow[wi,1]
            ]; 
          );
      
      testw[w_String] := Scan[ testwi[w,#]&, Range[k] ];
      
      h[""]=h["Eps"] = cnt = 1;
      val[""] = q0;
      wit[q0] = "Eps";
      S     = {q0};
      act = {""};     
      
       eq = Reap[
            While[ Length[act] > 0 && Length[S] < smax,
              	act = Flatten@Zwei[Reap[ Scan[testw, act], 1 ]];
                  ],0 ][[2,1]];
      
      If[ Length[S] \[GreaterEqual] smax, 
        Message[GenerateCSM::trunc,Length[S]]];
      
      W = wit /@ S;
      If[  eqns === True,
        	{ S, W, Map[ W[[#]]&,Drop[#,{2}]& /@ eq,{1}] },
        	{ S, W, eq }
        ]
      
      ];

(* brute force closure, apparently faster *)

generatecsm[ q0_, op_, alph_, smax_ ] :=
    Module[ {act,S,gen},
           act = S = gen = {q0};
           While[ Length[act]>0 && Length[S]<smax,
                S   = Union[S,act];
                
        act = Complement[Union[Apply[ op, CartesianProduct[act,alph], 1 ]], 
            S ];
             ];
           S
      ];

















































Options[GenerateCayleyGraph]={BoundCSM\[Rule]1000,Direction\[Rule]Right,
      Type\[Rule]None};

GenerateCayleyGraph[ q0_, dot_, K:(_?AlphabetQ):$alphabet, opts___?OptionQ ] :=

        Module[ {V,W,eq},
      
      {V,W,eq} = GenerateCSM[ q0, dot, K, 
          			Equations\[Rule]Full, SelectOptions[GenerateCSM,opts] ];
      
      If[ None === (Type /. {opts} /. Options[GenerateCayleyGraph]),
        Graph[ Length[V], Length[eq], "EList", Drop[#,{2}]& /@ eq, V ],
        Graph[ Length[V], Length[eq], "LEList",  eq, V ]
        ]
      ];











































































Options[GenerateSG]={Full\[Rule]False,Equations\[Rule]False,
      Filter\[Rule]Identity,DClasses\[Rule]False,
      BoundGSG\[RuleDelayed]$generateSGBound,
      External\[RuleDelayed]$defaultexternal};

GenerateSG[ gg_GEN, opts___?OptionQ ] :=

    Block[ {gen,eqns,filt,S,mu,active,act,k,eq,towit,testwi,smax,x,wi,
     testw,mod,full,unit,g1,dclass,ss,ww,ee,K},

     (* call external code, but only on transformations  *)
     
      If[ (External /. {opts} /. Options[GenerateSG]) && 
         Head[First@Last[gg]]===T, 
         Return[ Automata`extaut`ExtGenerateSG[gg,opts] ] ];

     eqns   = Equations /. {opts} /. Options[GenerateSG];
     filt   = Filter    /. {opts} /. Options[GenerateSG];
     smax   = BoundGSG  /. {opts} /. Options[GenerateSG];
     full   = Full      /. {opts} /. Options[GenerateSG];
     dclass = DClasses  /. {opts} /. Options[GenerateSG];

     {k,K} = MakeAlphabet[Zwei[gg],Full\[Rule]True];
     gen   = Last[gg];
     g1    = First[gen];
     unit  = UnitElement[g1];
     If[ Head[g1]===T, 
         oper=NonCommutativeMultiply,
         oper=Dot
     ];

     If[ !(eqns || dclass), Return[generatesg[gen,oper,filt,smax,full]] ];

     testwi[ w_List, i_Integer ] :=
     (  wi = Append[w,i];
        x  = oper[ mu[w], gen[[i]] ] // filt;
        mu[wi] = x;
        If[ MemberQ[S,x],
            If[ eqns || dclass, AppendTo[ eq, {wi,towit[x]} ] ],
        (*else*)
            AppendTo[ S, x ];
            towit[x] = wi;
            AppendTo[ act, wi ];
        ]; );

     testw[w_List] := Scan[ testwi[w,#]&, Range[k] ];

     If[ full,
         S = {unit}; towit[unit]={},
         S = {}
     ];
     act    = {};
     eq     = {};
     active = {{}};
     mu[{}] = unit;
     While[ Length[active] > 0 && Length[S] < smax,
            Scan[ testw, active ];
            {active,act} = {act,{}};
     ];
     
     {ss,ww,ee} = {SG@@S,ToWord[#,K]&/@towit/@S, Map[ToWord[#,K]&,eq,{2}]};
     If[ dclass, 
         Append[ {ss,ww,ee}, DClassDecomposition[ss] ],
         {ss,ww,ee}
     ]
];


GenerateSG[ z__T, K:(_?AlphabetQ):$alphabet, opts___?OptionQ ] := 
    GenerateSG[ GEN[ Length@First[z], K, {z} ], opts ];

generatesg[ z_List, op_, fil_, smax_, full_ ] :=
Module[ {act,S,gen},
     act = S = gen = z;
     If[ full, AppendTo[ S, UnitElement@First[z] ]];
     While[ Length[act]>0 && Length[S]<smax,
            S   = Union[S,act];
            act = Union[ Apply[ op, CartesianProduct[act,gen], 1 ] ] // fil;
            act = Complement[act,S];
     ];
     SG @@ S
];




















GreenHQT[x_T,y_T,S_SG] := GreenRQT[x,y,S] && GreenLQT[x,y,S];























GreenJQT[x_T,y_T,S_SG] := 
     RankT[x]===RankT[y] && IdealT[x,S]===IdealT[y,S];



















GreenLQT[x_T,y_T,S_SG] := 
     Sort[ImageT[x]]===Sort[ImageT[y]] && LeftIdealT[x,S]===LeftIdealT[y,S];



















GreenRQT[x_T,y_T,S_SG] := 
     Sort[KernelT[x]]===Sort[KernelT[y]] &&
     
      RightIdealT[x,S]===RightIdealT[y,S];





















Attributes[HClassSize]={Listable};
HClassSize[dc_DC]:=Last[DClassSize[dc,Full\[Rule]True]];



















HClassT[ a_T, S_SG ] :=
    
    Union[ Select[ Union[ a**ToList[S] ], (ImageT[#]===ImageT[a])& ] ];





























HTrivialQSG[S_SG] := Union[HClassSize[DClassDecomposition[S]]]==={1};































IdealT[x_T,S_SG] := 
With[ {S1 = ToList@MakeMonoidSG[S]}, 
		Union@AllTimes[S1,Union[x**S1]]
];





































Attributes[IdemSG]={Listable};

IdemSG[a_T]   := a**a === a;
IdemSG[S_SG] := Select[ ToList[S], IdemSG ];





























SetAttributes[{ImageT,KernelT,RankT}, Listable];
ImageT[ a_T ]   := ToList@Union[a];



































Attributes[InGroupSG]={Listable};

InGroupSG[ S_SG ] := Select[ ToList[S], InGroupSG ];
InGroupSG[ a_T ]  := SelectorQ[ ImageT[a], KernelT[a] ];





























Attributes[InverseT]={Listable};
InverseT[x_T] := 
    Module[ {ord},
           If[ RankT[x]==Length[x],
              Return[T@@(Last /@ 
                           
                Sort[Reverse /@ Pairs[Range@Length[x],ToList[x]]])] ];
           ord = OrderT[CollapseT[x]];
           If[ ord==1, x, x^(ord-1) ]
      ];



































JTrivialQSG[S_SG] := Union[DClassSize[DClassDecomposition[S]]]==={1};
shiftT[T[x__]] := T@@({x}+Table[1,{Length[{x}]}]);































JTrivialSG[n_Integer] := JTrivialSG[n,1];
JTrivialSG[n_Integer,a_Integer] := jtrivialsg[n,a];

jtrivialsg[0,_] = {};
jtrivialsg[n_Integer,0] = jtrivialsg[n,1]; 
jtrivialsg[n_Integer,n_Integer] := SG[ConstantT[n,n]];
jtrivialsg[n_Integer,a_Integer] := jtrivialsg[n,a] =
Sort[ SG@@Join[ 
     ToList[jtrivialsg[n,a+1]],
     Insert[#,a,1]& /@ (shiftT /@ ToList[jtrivialsg[n-1,a-1]]) 
]];
shiftT[T[x__]] := T@@({x}+Table[1,{Length[{x}]}]);































KernelImageToT[ker_List,im_List] := 
     T@@(Last /@ Sort@Flatten[Thread /@ Pairs[ker,im],1]);





























KernelT[ a_T ]  := Flatten[Position[a,#]]& /@ ImageT[a];































LeftIdealT[x_T,S_SG]  := Union[ToList[MakeMonoidSG[S]]**x];



































Attributes[LeftNullSG]={Listable};

LeftNullSG[ a_T, S_SG ] :=  
  a**a===a &&
    Catch[  Scan[If[a**#=!=a,Throw[False]]&, S]; Throw[True] ];
LeftNullSG[ S_SG ] := Select[ ToList[S], LeftNullSG[#,S]& ];





































Attributes[LeftNullSG]={Listable};

LeftOneSG[ S_SG ] := Select[ ToList[S], LeftOneSG[#,S]& ];

LeftOneSG[ a_, S_SG ] := a**a===a && 
      Catch[ Scan[If[a**#=!=#,Throw[False]]&,S];Throw[True]];





































LocallyCommutativeQSG[ S_SG ] := 
With[ {SL= ToList[S]},
      Catch[ Scan[ Function[ e, 
                             With[ {eSe = Union[e**SL**e]},
                               
              A = Partition[ AllTimes[eSe,eSe], Length[eSe] ];
                               If[ A=!=Transpose[A], Throw[False]]]] ,
          IdemSG[S] ];
        	Throw[True] ]
      ];

































LocallyIdempotentQSG[ S_SG ] := 
With[ {idem = IdemSG[S],SL = ToList[S]},
      Catch[  
        Scan[ If[ !SubsetQ[ Union[#**SL**#], idem ],Throw[False]]&, idem ];
        		Throw[True] ]
      ];



































Merge12T[n_Integer] := T @@ Join[ {1,1}, Range[3,n] ];



























MakeMonoidSG[ S_SG, gen___ ] := 
    If[ MonoidQSG[S,gen], S, Prepend[S,OneT@First[S]]]; 



























MonoidQSG[ S_SG ] := OneSG[S]=!={};

MonoidQSG[ S_SG, gen_List ] := 
Module[ {id,unit,n,i},
     If[ MemberQ[S,OneT@First[S]], Return[True] ];
     id = IdemSG[S];
     i  = 1;
     n  = Length[id];
     unit = False;
     While[ !unit && i <= n,
      unit = OneSG[ id[[i++]], gen ]
     ];
     unit
];





























NilpotentQSG[S_SG] := Sort[IdemSG[S]]===Sort[NullSG[S]];


































Attributes[NullSG]={Listable};

NullSG[ a_T, S_SG ] := LeftNullSG[a,S] && RightNullSG[a,S];

NullSG[SS_SG] :=
    Module[{idem,Lnul},
            idem = IdemSG[SS];
            Lnul = Select[ idem, LeftNullSG[#,SS]& ];
            Select[ Lnul, RightNullSG[#,SS]& ]       
      ];













































OneSG[ a_T, S_SG ] := LeftOneSG[a,S] && RightOneSG[a,S];
OneSG[ a_T, gen_List ] := (a**#)& /@ gen===gen && (#**a)& /@ gen===gen;

OneSG[SS_SG] :=
    Module[{n,idem,Lone},
            n = Length@First[SS];
            If[ MemberQ[SS,OneT[n]], Return[{OneT[n]}] ];
            idem = IdemSG[SS];
            Lone = Select[ idem, LeftOneSG[#,SS]& ];
            Select[ Lone, RightOneSG[#,SS]& ]        
      ];

OneSG[SS_SG,gen_List] :=
    Module[{n,idem,Lone},
            n = Length@First[SS];
            If[ MemberQ[SS,OneT[n]], Return[{OneT[n]}] ];
            idem = IdemSG[SS];
            Lone = Select[ idem, (#**gen===gen)& ];
            Select[ Lone, (gen**#===gen)& ]
      ];































OneT[k_Integer] := T@@Range[k];
OneT[a_T]       := OneT[Length[a]];
ConstantT[i_Integer,n_Integer] := T@@Table[i,{n}];



























Attributes[OrderT]={Listable};

OrderT[ x_T ] := 
        If[ RankT[x]!=Length[x], 
      	0,
      	LCM@@( Length /@ CycleDecompositionT[x,Full->True] ) ];































SetAttributes[PrintDClass,Listable];

PrintDClass[ d_DC ] := 
Module[ {s,r,H,n,m,z,h,i,j},
     {s,r,H} = ToList[d];
     z = H[[1]];
     {n,m,h} = DClassSize[d,Full\[Rule]True];
     Print["---------------------------------------------------------"];
     Print["dimensions:  ",n," by ",m," by ",h];
     Print["H: ", H ];
     Print["---------------------------------------------------------"];
     Print["  "];
     Do[
        Print[ "image: ", ImageT[z**r[[j]]] ];
        Do[
           Print["   kernel: ", KernelT[ s[[i]]**z**r[[j]] ] ];
           Print["       H-class:  ", s[[i]]**H**r[[j]] ];
        , {i,n} ];
        Print[];
     , {j,m} ];
];

































Options[PrintEquations]={Cols\[Rule]None,Algebraic\[Rule]False};

PrintEquations[eq_List,opts___?OptionQ]:=
Module[{eqs,cols,vspace},
	If[ Algebraic/.{opts}/.Options[PrintEquations],
		vspace=2; eqs=Map[AlgebraicForm,eq,{2}],
		vspace=1; eqs=eq
	];
	eqs = Thread[Rule[First/@eqs,Last/@eqs]];
	cols = Cols /. {opts} /. Options[PrintEquations];
	If[ cols===None, 
	    eqs = Apply[ ColonForm, Pairs[padNums[Length[eqs]],eqs], {1} ] ];
	
	Switch[ cols,
		None,          TableForm[ eqs, TableSpacing\[Rule]{vspace,1}],
		_Integer, TableForm[ Partition[eqs,cols], TableSpacing\[Rule]{1,2}]
	]
];

padNums[n_Integer] := 
    With[ {k = Length@IntegerDigits[n]},
            Apply[ StringJoin, PadLeft[#, k, " "] & /@ 
                    Map[ ToString, IntegerDigits[Range[n]], {2} ], {1}]];

























PrintWitnesses[ S_SG|S_List, wit_List ] :=
     
    TableForm[  Thread[{wit,ToList[S]}], 
		 TableHeadings->{Automatic,None}, TableSpacing->{1,1}, TableDepth->2 ];

































RegularSG[ S_SG ] := ToList[Select[S,RegularSG[#,S]&]];
RegularSG[ x_T, S_SG ] := 
    Catch[Scan[If[x**#**x===x, Throw[True]]&,S];Throw[False]];





























RandomT[n_Integer] := T@@Table[ Random[Integer,{1,n}], {n} ];



























Attributes[RankT]={Listable};

RankT[ a_T ]    := Length[ ImageT[a] ];




















































RightIdealT[x_T,S_SG] := Union[x**ToList[MakeMonoidSG[S]]];



































Attributes[RightNullSG]={Listable};

RightNullSG[ S_SG ] := Select[ ToList[S], RightNullSG[#,S]& ];
RightNullSG[ a_T, S_SG ] := a**a===a && 
      Catch[  Scan[If[#**a=!=a,Throw[False]]&, S]; Throw[True] ];





































Attributes[RightOneSG]={Listable};

RightOneSG[ S_SG ] := Select[ ToList[S], RightOneSG[#,S]& ];
RightOneSG[ a_, S_SG ] := 
    a**a\[Equal]a &&
      
      Catch[ Scan[If[#**a=!=#,Throw[False]]& , S]; Throw[True] ];



































ShiftT[n_Integer,k_Integer:1] := T @@ RotateRight[Range[n],k];































































Options[SolveSG]={Full\[Rule]True,Where\[Rule]Right};

SolveSG[{a_T,b_T},S_SG,opts___?OptionQ] := SolveSG[a,b,S,opts];
SolveSG[a_T,b_T,S_SG,opts___?OptionQ] :=
Module[{res},
     If[ Right === (Where /. {opts} /. Options[SolveSG]),
         res = Select[ ToList[S], (a**#===b)& ],
         res = Select[ ToList[S], (#**a===b)& ]
     ];
     If[ Full /. {opts} /. Options[SolveSG],
         res,
	 If[ res==={}, $Failed, First[res] ]
     ]
];



























SymmetricGroupSG[n_Integer, opts___?OptionQ ] :=
     
    GenerateSG[ GEN[n,2,{ShiftT[n], TranspositionT[n]}], opts ];

































SyntacticCongruence[ gg_GEN, r_Integer ] := 
Block[ {gen,K,next,index,index0,cumindex,rules},

     index = cumindex = {OneT[First[gg]]};
     K = Zwei[gg];
     gen = Last[gg];

     next[L_List] := Sequence@@(#**gen)& /@ L;
    
     If[ NonNegative[r],    
		 index  = Nest[ next, index, r ];
		 index0 = Union[index];
		 count  = Max[index0];
		 rules  = RankingRules[index0];
		 index  = index /. rules;
		 ToClasses[Words[r,K],index,Type->Index],
     (* else *)
		 
        Scan[ (cumindex = Join[cumindex,index=next[index]];)&, Range[-r] ];
		 index0 = Union[cumindex];
		 count  = Max[index0];
		 rules  = RankingRules[index0];
		 index  = cumindex /. rules;
		 ToClasses[Flatten@Words[r,K],index,Type->Index]
     ]
];

SyntacticCongruence[ M_DFA, r_Integer ] := 
     SyntacticCongruence[ ToGeneratorsFA[M], r ];



































Attributes[SyntacticHomomorphism]={HoldFirst};

SyntacticHomomorphism[ ff_, M_DFA ] := 
    Module[ {k,alph,gens},
           ClearAll[ff];
           Attributes[ff]={Listable};
           {k,alph} = Alphabet[M,Full\[Rule]True];
           gens = Last@ ToGeneratorsFA[M];
           ff[Eps|"Eps"|Global`\[Epsilon]] = OneT[First[gens]];
           Scan[ (ff[#]  = gens[[#]])&, Range[k] ];
           ff[w_] := NonCommutativeMultiply@@ff[ ToIndex[w,alph] ];
      ];





























SyntacticSG[ M_DFA, opts___?OptionQ ] := 
    GenerateSG[ ToGeneratorsFA[M], opts ];































prot=Unprotect[NonCommutativeMultiply];
SetAttributes[NonCommutativeMultiply,Listable];
Protect[Evaluate[prot]];

NonCommutativeMultiply[T[x__]] ^:= T[x];
T[x__]**T[y__] ^:= T[y][[{x}]];
T[x__]**T[y__]**z__T ^:= T[y][[{x}]]**z;
T[x__]^k_  ^:=FastExpoT[T[x],k];
FastExpoT[x_T,0]:=OneT[x];
FastExpoT[x_T,1]:=x;
FastExpoT[x_T,n_Integer?Positive]:=
    Block[{fe},
      fe[1]=x;
      fe[m_Integer?Positive]:=fe[m]=
          	fe[Floor[m/2]]**fe[Ceiling[m/2]];
      fe[n]
      ];





























TableSG[ SS_SG, W_List ] := 
Module[ {S,mult,towit,one,theone,onewit,null,thenull,nullwit},
     S = ToList[SS];
     AssignFunction[towit,S,W];
      
     one = OneSG[SS];
     If[ one=!={},
         theone = First[one];
         onewit = W[[PositionOne[SS,theone]]];
         towit[theone] = $identitystring;
     ];
     null = NullSG[SS];
     If[ null=!={},
      thenull = First[null];
      nullwit = W[[PositionOne[SS,thenull]]];
           towit[thenull] = $nullstring; 
     ];

     mult = Apply[ NonCommutativeMultiply, CartesianProduct[S,S], 1 ];
     mult = Partition[ towit /@ mult, Length[S] ]; 
     TableForm[ mult, TableDepth\[Rule] 2, 
        TableHeadings\[Rule] {towit/@S,towit/@S} ]
];























ToIdentityString[XX_]   := XX /. ""->$identitystring;





























TransformationSG[n_Integer, opts___?OptionQ ] := 
     GenerateSG[ GEN[n,3,{ShiftT[n], TranspositionT[n], Merge12T[n]}], opts ];































TransientPeriodicT[xx_T] := 
Module[ {kx,L},
     If[ RankT[xx]==Length[xx], Return[{0,OrderT[xx]}]];
     kx = CollapseT[xx];
     L  = FixedPointList[ CollapseT, xx ];
     { Max[Length[L]-2,0], OrderT[Last[L]] }
];

































TranspositionT[n_Integer,
      i_Integer:1]:=(OneT[n]/.\[InvisibleSpace]{i\[Rule]i+1,i+1\[Rule]i})/;
      1\[LessEqual]i<n;

TranspositionT[n_Integer,i_Integer,
      j_Integer]:=(OneT[n]/.\[InvisibleSpace]{i\[Rule]j,j\[Rule]i})/;
      1\[LessEqual]i\[LessEqual]n&&1\[LessEqual]j\[LessEqual]n;































UnitElement[a_T] := T@@Range@Length[a];
UnitElement[mat_?MatrixQ] := 
     Switch[ Head[First@First[mat]],
         TS, TropicalIdentityMatrix[Length[mat]],
         _,  IdentityMatrix[Length[mat]]
      ];





























$rewriteSimpBound = 100;































AllStringReplace[L_List][{}] := {};

AllStringReplace[L_List][{ss__?WordQ}] := 
     WordSort@Union@Flatten[ AllStringReplace[L] /@ {ss} ];

AllStringReplace[L_List][ss_?WordQ] := 
With[ {str = ToString[ss],
       LL = Map[ ToString, L /. Rule->List, {2} ] },
       Union[stringRep[str] /@ FlattenOne[ gethandle[str] /@ LL ] ]
];

(* is this really needed ? *)

AllStringReplace[rr_->tt_][ss_] := AllStringReplace[{{rr,tt}}][ss];

gethandle[ww_String][{u_String,v_String}] := 
    Prepend[#,v]& /@ StringPosition[ww,u];

stringRep[s_String][{t_String, i_Integer, j_Integer} ] :=
	
    Concatenate[ StringTake[s,i-1], t, StringDrop[s,j] ];































































































Options[EquationsToWitnesses]={Full\[Rule]False,BoundETW\[Rule]500};

EquationsToWitnesses[ eq_List, K:(_?AlphabetQ):$alphabet, opts___?OptionQ ] :=

    Block[ {KK,pats,testwi,testw,wit,active,act,bound,nulls,
     x,wi,eqq,res},
     bound = BoundETW /. {opts} /. Options[EquationsToWitnesses];

     KK   = MakeAlphabet[K];
     eqq  = Map[ ToString, eq, {-1} ];
     pats = First /@ eqq;

     testwi[ w_, i_ ] := 
     ( wi = Concatenate[w,i];
       If[ StringPosition[wi,pats]==={}, 
			AppendTo[ wit, wi ]; AppendTo[ act, wi ] ]; );

     testw[w_] := Scan[ testwi[w,#]&, KK ];

     nulls = Cases[eqq,{_,$nullstring}];
     front = {};
     If[ Cases[eqq,{_,$identitystring|"Eps"}]=!={}, 
     		AppendTo[front,"Eps"] ];
     If[ nulls=!={}, AppendTo[front,First@First[nulls]] ];

     wit = {};
     active = {Eps};
     While[ Length[active]>0 && Length[wit]<bound,
            act = {};
            Scan[ testw, active ];
            active = act;
     ];
     res = Join[ front, wit ] // WordSort;

     If[ (Full /. {opts} /. 
              Options[EquationsToWitnesses]) &&
         !MemberQ[res,"Eps"],
         Prepend[res,"Eps"],
         res
	 ]
];

















































FromIdentityString[XX_] :=XX/. {$identitystring->""};































IrreducibleQ[ Eps|"Eps"|Global`\[Epsilon], __ ] = True;

IrreducibleQ[ w_?WordQ, rs_List ] :=
    With[ { ww = ToString[w],
                rss = Concatenate["*", First/@ RulesToPairs[rs],"*"]},
              Catch[ 
                	If[ StringMatchQ[ww,#], Throw[False] ]& /@ rss;
                	Throw[True]
                ]
      ];
IrreducibleQ[ W_List, rs_List ] :=
    
    With[ { rss = Concatenate["*", First/@RulesToPairs[rs] ,"*"]},
             Function[ww, Catch[ 
                    	If[ StringMatchQ[ww,#], Throw[False] ]& /@ rss;
                    	Throw[True] ] ] /@ ToString /@ W
             
      ];



























PairsToRules[ {rw__List} ] := Apply[Rule,{rw},{1}];
PairsToRules[ {ls_?WordQ,rs_?WordQ} ] :=ls\[Rule]rs;
PairsToRules[xx_] := xx;



























RulesToPairs[ {rw__Rule} ] := Apply[List,{rw},{1}];
RulesToPairs[ ls_?WordQ \[Rule] rs_?WordQ ] :={ls,rs};
RulesToPairs[xx_] := xx;

































Options[SimplifyEquations]={Full\[Rule]True};

SimplifyEquations[ S_SG, W_List, eqn_List, opts___?OptionQ ] := 
Module[ {one,theone,onewit,null,thenull,nullwit,
    neweq,oldeq,e1,e11,len,rules,front,full,eqs},

    full = Full /. {opts} /. Options[SimplifyEquations];

    oldeq = eqn;
    rules = {};
    front = {};
    neweq = {};
    While[ oldeq != {},
	e1  = First[oldeq];
	e11 = First[e1];
	neweq = Append[ neweq, e1 ];
	oldeq = Select[Rest@oldeq, (StringPosition[First[#],e11]==={})&];
    ];

    If[ full, 
	one = OneSG[S];
	If[ one != {},
	    theone = First[one];
	    onewit = W[[PositionOne[S,theone]]];
	    AppendTo[ front,{onewit,$identitystring} ];
	    AppendTo[ rules,onewit\[Rule] $identitystring ];
	    neweq = Select[neweq,(StringPosition[ #[[1]], onewit ]==={})& ];
	];
	null = NullSG[S];
	If[ null =!= {} && null =!= one,
	    thenull = First[null];
	    nullwit = W[[PositionOne[S,thenull]]];
	    AppendTo[ front, {nullwit,$nullstring} ];       
	    AppendTo[ rules, nullwit\[Rule] $nullstring ];
	    neweq = Select[neweq,(StringPosition[ #[[1]], nullwit ]==={})& ];
	];
    ];  
     
    eqs = Join[ front, neweq /. rules ]; 
    If[ onewit==="Eps" && Length@Cases[eqs,{_,$identitystring}]>1,
        Rest[eqs],
        eqs
    ]
];

SimplifyEquations[ {S_SG, W_List, eqn_List}, opts___?OptionQ ] := 
    SimplifyEquations[ S, W, eqn, opts ];





































Options[SimplifyRewriteSystem]={DoTrace\[Rule]False};

SimplifyRewriteSystem[ eqn_List, opts___?OptionQ ] := 
With[ {trc = DoTrace /. {opts} /. Options[SimplifyRewriteSystem],
	oldidstr = $identitystring},
	$identitystring = "";
	$rewritetrace = {};
	$rewriteequs  = Map[ ToString, RulesToPairs[eqn], {2}];
	FixedPoint[ (simpright[];simpleft[trc])&, $rewriteequs, $rewriteSimpBound ];
	$identitystring = oldidstr;

	If[ trc, {$rewriteequs,$rewritetrace}, $rewriteequs ] // ToEps
];

fastReduce[ "", _ ] = "";
fastReduce[ w_String, equ_List ] :=
   
    With[ {rules = Apply[Rule,equ,1]}, 
      FixedPoint[ StringReplace[#,rules]&, ToString[w] ]];


simpright[] := 
	$rewriteequs = MapAt[ fastReduce[#,$rewriteequs]&, $rewriteequs, 
                              Table[ {i,2}, {i,Length[$rewriteequs]} ] ];
		
simpleft[trc_] := 
(
    pp = findred[First/@$rewriteequs]; 
    If[ pp=!=0,
	{i,j} = pp; (* equation j reduces i *) 

	If[ $rewriteequs[[i]]==$rewriteequs[[j]], 
	    $rewriteequs = Drop[ $rewriteequs, {i} ];
	    (* If[ trc, AppendTo[ $rewritetrace, {i,j} ] ]; *)
	    
          If[ trc, AppendTo[ $rewritetrace, "EQUAL" ] ];
	    Return[$rewriteequs] 
	];

	If[ StringLength[$rewriteequs[[i,1]]] > 
              StringLength[$rewriteequs[[j,1]]] ||
         	    
            WordOrder[ $rewriteequs[[i,2]], $rewriteequs[[j,2]] ]==-1, 
	    {ll,rr} = $rewriteequs[[i]];
	    $rewriteequs = Drop[ $rewriteequs, {i} ];
	    If[ trc, AppendTo[ $rewritetrace, {i,j} ] ]; 
	    If[ j>i, j-- ];
	    pp = First@StringPosition[ll,$rewriteequs[[j,1]]];
	    nl = 
            StringJoin[ StringTake[ll,pp[[1]]-1], $rewriteequs[[j,2]], 
              StringDrop[ll,pp[[2]]] ];

	    If[ ClosureSearch[{nl},rr,AllStringReplace[$rewriteequs],
              SetClosure->True], 
		If[ trc, AppendTo[ $rewritetrace, {} ] ];
		Return[$rewriteequs]
	    ];
			
	    neweq = Reverse@WordSort[{nl,rr}];
	    $rewriteequs = Append[ $rewriteequs, neweq ];
	    If[ trc, AppendTo[ $rewritetrace, neweq ] ]; 
	];
    ]; 
    $rewriteequs
);

findred[ W_List ] := 
Block[{n,test,res,j,i},
	n = Length[W];
	test[i_] := 
	( 
	    j = 1;
	    While[ j<=n,  
		If[ i=!=j && (StringPosition[W[[i]],W[[j]]]=!={}), Return[{i,j}] ];
		j++; 
	    ];
	   0 
	);
			
	i = 1;
	While[ i<=n, 
		res = test[i];
		If[ res=!=0, Return[res] ];
		i++;
	];
	0
];









































Options[WordReduce]={DoTrace\[Rule]False,BoundWR\[Rule]500};

WordReduce[ Eps|"Eps"|Global`\[Epsilon], ___ ] = $identitystring;
WordReduce[ w_?WordQ, equ_List, opts___?OptionQ ] :=
	
    WordReduce[ {w}, equ, opts ];

WordReduce[ LL_List, equ_List, opts___?OptionQ ] :=

    Block[ {trace,eq,nulleq,nullpat,rules,red,bnd},
    trace = DoTrace /. {opts} /. Options[WordReduce];
    bnd   = BoundWR /. {opts} /. Options[WordReduce];
    (* trace only useful for single words *)
    
      If[ trace, Return[ traceWordReduce[LL[[1]],equ] ] ];
    eq      = Map[ ToString, equ, {2} ];
    nulleq  = Cases[eq,{_,$nullstring}];
    nullpat = First /@ nulleq;
    rules   = Apply[ Rule, FromIdentityString[Complement[eq,nulleq]], 1 ];
    If[ nulleq==={},
        red[s_] := StringReplace[s, rules ],
        red[s_] :=
           If[ StringPosition[s,nullpat]==={},
               StringReplace[s, rules ],
               $nullstring
           ]
    ];
    
    If[ Length[LL]==1,
	    ToIdentityString[ FixedPoint[ red, ToString[First[LL]], bnd ] ],
	    ToIdentityString[ FixedPoint[ red, ToString[#], bnd ]& /@ LL ]
	]
];


traceWordReduce[ w_?WordQ, eqq_List ] := 
Block[ {curr,trace,eq,pats,gethandle,go,handle,pos},
    curr = ToString[w];
    trace = {curr};
    eq   = Map[ ToString, eqq, {2} ];
    pats = Flatten /@ Pairs[ Range@Length[eq], eq /. Rule -> List ];
    gethandle[ww_String,{i_Integer,u_String,v_String}] := 
        Join[{i,u,v},#]& /@ StringPosition[ww,u];
    go = True;
            (* Sort: first applicable rule chosen *)
    While[ go,   
           handle = Sort@FlattenOne@Cases[gethandle[curr,#]& /@ pats,{__}];
           If[ handle === {},
              go   = False,
              pos  = First[handle];
              AppendTo[trace,Drop[pos,{2,3}]];
              curr = StringJoin[ StringTake[curr,pos[[4]]-1], pos[[3]], 
                                 StringDrop[curr,pos[[5]]] ];
              AppendTo[trace,curr]
           ];
    ];
    TableForm[ Partition[Append[trace,{}], 2 ],
        TableDepth->2, TableSpacing->{1,5}, 
        TableHeadings->{Automatic,None} ]
];

































BooleanComplement[R_?MatrixQ] := 1-R;
BooleanComplement[R_?MatrixQ,S_?MatrixQ] := 
    BooleanIntersection[R,1-S];

































BooleanComposition[R__?MatrixQ] := Sign@Dot[R];



































BooleanConverse[R_?MatrixQ] := Transpose[R];































BooleanIntersection[R_?MatrixQ,S_?MatrixQ] := 
    MapThread[ Min, {R,S}, 2 ];































BooleanPower[R_?MatrixQ,0] := IdentityMatrix[Length[R]];
BooleanPower[R_?MatrixQ,n_Integer] := Sign[Dot@@Table[R,{n}]];































BooleanUnion[R_?MatrixQ,S_?MatrixQ] := 
    MapThread[ Max, {R,S}, 2 ];



























































RelationToMatrix[  n_Integer, R_List ] := 
    ReplacePart[ Array[0&,{n,n}], 1, R ];
RelationToMatrix[  L_List, R_List ] := RelationToMatrix[  Length[L], R ];
RelationToMatrix[  L_List, rel_ ] := 
    Table[ If[rel[L[[i]],L[[j]]],1,0], {i,Length[L]}, {j,Length[L]} ];
RelationToMatrix[  n_Integer, rel_ ] := 
    Table[ If[rel[i,j],1,0], {i,n}, {j,n} ];



















































Options[ToClasses]={Type\[Rule]Relation};

ToClasses[ A_List, r_, opts___?OptionQ]:=

    Switch[  Type  /.{opts} /.  Options[ToClasses],
	Function, 
	    Reap[Scan[Sow[#,{r[#]}]& , A]][[2]],
	Relation,          
	    Reap[Scan[Sow[#[[1]],{#[[2]]}]& ,Pairs[A,First@MakeIndex[A,r]]]][[2]],
	Matrix, 
	    Union[(A[[Flatten[Position[#1,1]]]]&)/@ r],
	Index,
	   Reap[Scan[Sow[#[[1]],{#[[2]]}]& ,Pairs[A,r]]][[2]]
];













































Options[TransitiveClosure]={Reflexive\[Rule]False};

TransitiveClosure[R_?MatrixQ,opts___?OptionQ] := 
If[ Reflexive /. {opts} /. Options[TransitiveClosure],
    FixedPoint[ Sign[#.#]&,    Sign[R+IdentityMatrix[Length[R]]]],
    FixedPoint[ Sign[#+#.#]&, Sign[R] ]
];















































Options[Warshall]={Full\[Rule]False,Reflexive\[Rule]False};

Warshall[ e_?MatrixQ, opts___?OptionQ ] := 
Module[ {i,j,n,ee},
    ee = Sign[e];
    n  = Length[e];
    If[ Reflexive /. {opts} /. Options[Warshall],
        ee = ReplacePart[ ee, 1, Pairs[Range[n],Range[n]] ] ];
    If[ Full /. {opts} /. Options[Warshall],
      ee = ReplacePart[ ee, 0, Pairs[Range[n],Range[n]] ];
      Do[ If[ ee[[i,k]] > 0,
                ee[[i]] = MapThread[
		          Function[{a,b},If[ a>0 && b>0, 2, a ]], {ee[[i]],ee[[k]]} ]] , 
      {k,n}, {i,n} ];
      { Sign[ee], ee /. {2\[Rule]0} }
      , (* else *)
      Do[ If[ ee[[i,k]] > 0,
                ee[[i]] = MapThread[ Max, {ee[[i]],ee[[k]]} ]] , 
      {k,n}, {i,n} ];
      ee
    ]
];





























































Options[AnalyzeOrbit]={Cycle\[Rule]None,Periodic\[Rule]False,
      BoundAO\[Rule] 5000};

AnalyzeOrbit::trunc = 
    "Search for anchor point was truncated after `1` steps; you might \
consider to increase the value of BoundAO.";

AnalyzeOrbit[ ff_, aa_, gg_, opts___?OptionQ ] := 
    Module[ {slow,fast,peb,peb1,peb2,pcnt,qcnt},
      
      trnc = BoundAO /. {opts} /. Options[AnalyzeOrbit];
      pcnt = 0;
      If[ Periodic /. {opts} /. Options[AnalyzeOrbit],
        	    Return[ analyzePeriodicOrbit[ ff, aa, opts ] ] ];
      
      	(*  find a point slow on the cycle  *)
      	slow = ff[aa];
      	fast = gg[aa];
      	While[ slow=!=fast && ++pcnt < trnc, 
        			slow = ff[slow];
        			fast = gg[fast];
        	];
      
      If[ pcnt \[Equal] trnc, 
        	Message[AnalyzeOrbit::trunc,trnc];
        	Return[Null]
        ];
      
      	(*  compute the length pcnt of the cycle  *)
      	peb = ff[slow];
      	pcnt = 1;
      	While[ peb=!=slow, 
        			pcnt++;
        			peb = ff[peb] 
        	];
      	
      	(*  find entry point on cycle  *)
      	peb1 = aa;
      	peb2 = Nest[ ff, aa, pcnt ];
      	qcnt = 0;
      	While[ peb1=!=peb2, 
        			peb1 = ff[peb1];
        			peb2 = ff[peb2]; 
        			qcnt++;
        	];
      	
      	Switch[ Cycle /. {opts} /. Options[AnalyzeOrbit],
        	None,     {qcnt,pcnt},
        		False,   {qcnt,pcnt,peb1},
        		True,     {qcnt,pcnt,NestList[ff,peb1,pcnt-1]} 
        	]
      ];

AnalyzeOrbit[ ff_, aa_, opts___?OptionQ ] := 
    	AnalyzeOrbit[ ff, aa, ff[ff[#]]&, opts ];

analyzePeriodicOrbit[ ff_, aa_, opts___?OptionQ ] := 
    Module[ {pcnt}, 
      
      	(*  orbit must be a cycle, does not check  *)
      
      	pcnt = 1;
      	NestWhile[ (pcnt++; ff[#])&, ff[aa], #=!=aa& ]; 
      	
      	Switch[ Cycle /. {opts} /. Options[AnalyzeOrbit],
        		None,        {0,pcnt},
        		False,      {0,pcnt,aa},
        		True,        {0,pcnt,NestList[ff,aa,pcnt-1]} 
        	]
      ];

























































CartesianProduct[___,{},___] = {};
CartesianProduct[ LL___List ] := Distribute[{LL},List];
CartesianProduct[ ints__Integer ]  := Distribute[Range /@ {ints},List];































$closureBound = 500;









































$closureSearchBound = 500;







































Options[ClosureSearch]={SetClosure\[Rule]False,
      ClosureBound\[RuleDelayed]$closureSearchBound};

ClosureSearch[ LL_List, targ_, ff__, opts___?OptionQ ] :=

    Block[ {act,S,sc,cb},
	sc = If[ SetClosure /. {opts} /. Options[Closure], 2, 1 ];
	cb = ClosureBound /. {opts} /. Options[ClosureSearch];
	act = LL;
	S = {};
	While[ Length[act] > 0 && Length[S] < cb,
	       S   = Union[S,act];
	       If[ MemberQ[S,targ], Return[True] ];
	       act = Complement[Flatten[ Function[z,z /@ act] /@ {ff},sc],S];
	];
	False
];































































Options[Closure]={SetClosure\[Rule]False,ClosureBound\[Rule]$closureBound,
      BoundCSM\[Rule]5000,Rank\[Rule]False,DoTrace\[Rule]False,
      Filter\[Rule]Identity,Index\[Rule]1};

Closure[LL_List,ff_List,opts___?OptionQ]:=
    Block[{S,sc,cb,rk,SS,cnt},
      
      	If[ DoTrace /. {opts} /. Options[Closure],
        		Return[ generateClosure[LL,ff,
            		SelectOptions[Closure,opts,{ClosureBound,Rank,DoTrace}] ] ]];
      	sc=If[SetClosure/.{opts}/.Options[Closure],2,1];
      
      	cb=ClosureBound/.{opts}/.Options[Closure];
      	S={};
      
      (* FP: the set of active elements is empty *)
      
      	If[Rank/.{opts}/.Options[Closure],
        		cnt=0;
        		Scan[(rk[#]=cnt)&,LL];
        		FixedPoint[
          			(  S=Union[S,#];
              			SS=Complement[Flatten[Function[z,z/@#]/@ff,sc],S];
              			cnt++; Scan[(rk[#]=cnt)&,SS];
              			SS)&,
          			LL,cb ];
        		{S,rk/@S},
        (*else*)
        	FixedPoint[
          	( S=Union[S,#];
              	Complement[Flatten[Function[z,z/@#]/@ff,sc],S])&,
          	LL,cb];
        	S
        	]
      ];

Closure[LL_List,ff__,opts___?OptionQ]:= Closure[LL,{ff},opts ];

generateClosure[ Q0_List, F_List, opts___?OptionQ ] :=
    
    Module[ {smax,filt,sc,ind,k,S,h,cnt,rp,A,x,a},
      smax   = BoundCSM  /. {opts} /. Options[Closure];
      filt   = Filter  /. {opts} /. Options[Closure];
      sc=If[ SetClosure/.{opts}/.Options[Closure],2,1];
      ind=If[ 0===(Index/.{opts}/.Options[Closure]),1,0];
      
      k = Length[F];
      S = act = Q0;
      AssignFunction[h,Q0,Range[Length[Q0]]];
      cnt = Length[Q0];
      rp = Reap[
          While[ act =!= {} && Length[S]<smax,
            	{x,act} = {First@act,Rest@act};
            	Do[ 
              		A = F[[i]][x];
              		If[sc\[Equal]1,A = {A}];
              		Scan[  
                			( a = filt[#];
                    			If[ !MemberQ[S,a],
                      				AppendTo[S,a];
                      				AppendTo[act,a];
                      				h[a] = ++cnt;
                      			];
                    			Sow[ {h[x],i-ind,h[a]}];
                    			)&, A ],
              		{i,k} 
              	];
            ]];
      {S,rp[[2,1]]}
      ];




























































Options[DeleteDuplicates]={OutPairs\[Rule]False};

DeleteDuplicates[LL_List] :=Reap[Sow[Null,LL],_,#&][[2]];

DeleteDuplicates[L1_List,L2_List,opts___?OptionQ] :=

    With[ {res = 
            Reap[   Scan[  Sow[#[[2]],{#[[1]]}]&, Pairs[L1,L2]],_,
                Function[{x,y},{x,First[y]}] ][[2]] },
                If[ OutPairs /. {opts} /. Options[DeleteDuplicates],
                      res, 
                      Thread[res]
                  ]
        ]  /;  Length[L1]\[Equal]Length[L2];





























DisjointQ[L1_List,L2_List] := Length[Intersection[L1,L2]]==0;





































Options[EnumForm]={Index\[Rule]1};

EnumForm[LL_List,opts___?OptionQ] := 
With[ {nn = Index /. {opts} /. Options[EnumForm]},
	Apply[ ColonForm, Pairs[ Range[nn,nn+Length[LL]-1],LL], 1 ]] // ColumnForm;



















































FastPowerSet[{}] = {{}};
FastPowerSet[{a_,xx___}] := 
    With[{p=FastPowerSet[{xx}]}, Join[ p, Prepend[#,a]& /@ p ] ];

























































Frequencies[L_List] := 
	With[ {LL = Union[L]},  Pairs[LL,Count[L,#]& /@ LL] ];





























FromBitVector[B_List,UU_List] := UU[[ Flatten[Position[B,1]] ]];
FromBitVector[B_List,___] := Flatten[Position[B,1]];



































































Options[LongestCommonSubsequence]={Full\[Rule]True};

(* 0:  D, 1: L, 2: U *)

LongestCommonSubsequence[A_List,B_List,opts___?OptionQ]:=
    
    Module[{la,lb,L,tt,generateLCS},
      generateLCS[ i_Integer,j_Integer]:=
        (
          	If[i\[Equal]0||j\[Equal]0,Return[{}]];
          	Switch[ tt[i,j],
            	0,Append[generateLCS[i-1,j-1],A[[i]]],
            	1,generateLCS[i,j-1],
            	2,generateLCS[i-1,j]]
          );
      
      la=Length[A];
      lb=Length[B];
      L[0,_]=0;
      L[_,0]=0;
      L[i_,j_] := L[i,j] = 
          If[A[[i]]\[Equal]B[[j]],
            	tt[i,j]=0;L[i-1,j-1]+1,
            	If[L[i,j-1]>L[i-1,j],
              		tt[i,j]=1; L[i,j-1],
              		tt[i,j]=2;L[i-1,j]
              ]];
      res = L[la,lb];
      If[  Full /. {opts} /. Options[LongestCommonSubsequence],
        	generateLCS[la,lb], res ]
      ];

































MakeIndex[ LL_List, R_ ] := 
Block[ {h,hh,findindex,top},
        top = 1;
        h[_] := 0;
        h[First[LL]] = 1;
        hh[1] = First[LL];
        
        findindex[x_] := Catch[
             Scan[ If[ R[x,hh[#]], Throw[ h[x]=# ] ]&, Range[top] ];
             h[x]=++top; hh[top]=x ;Throw[top] ];    
        
        { findindex /@ LL, top }
];

MakeIndex[ LL_List ] := 
    Block[ {hh,top},
              top = 1;
              hh[_] = 0;
              hh[First[LL]] = 1;
              { If[ hh[#]==0, hh[#]=++top, hh[#] ]& /@ LL, top }
      ];























































Options[NonDecreasingSequences]={Full\[Rule]True};

NonDecreasingSequences[n_Integer?Positive, 0,opts___?OptionQ ] := {{}};
NonDecreasingSequences[n_Integer?Positive, k_Integer?Positive,
      opts___?OptionQ] :=
    Module[ {ind, iter},
      ind = Table[Unique[], {k}];
      If[ Full /. {opts} /. Options[NonDecreasingSequences],
        	iter = Thread[{ind, Prepend[Most[ind], 1], Table[n, {k}]}],
        	iter = Thread[{ind, Prepend[Most[ind], 0]+1, Table[n, {k}]}]
        ];
      Flatten[ Table[Evaluate[ind], Evaluate[Sequence @@ iter]], k-1]
      ];
NonDecreasingSequences[L_List,k_Integer?Positive,opts___?OptionQ] := 
    	L[[#]]& /@  NonDecreasingSequences[Length[L],k,opts];









































































Pairs[LL__List] := Thread[{LL}];




























Partitions[n_Integer?NonNegative] := Partitions[n,n];
Partitions[n_Integer?Negative,_] := {};
Partitions[0,m_Integer?NonNegative] := {{}};
Partitions[n_Integer,1] := {Table[1,{n}]};
Partitions[_,0] := {};
Partitions[n_Integer,m_Integer?NonNegative] :=
  
    Join[ Prepend[#,m]& /@ Partitions[n-m,m], Partitions[n,m-1] ];

















































PowerSet[L_List] := 
	Sort[ Distribute[{{},{#}}& /@ Union[L],List,List,List,Union]];
PowerSet[n_Integer?NonNegative] := PowerSet[Range[n]];

PowerSet[n_Integer,0] := {{}}; 
PowerSet[n_Integer,k_Integer?Positive] := {}  /;  n < k;  
PowerSet[n_Integer,k_Integer?Positive] := 
Module[ {ind, iter},
	ind = Table[ Unique[], {k}];
	iter = Thread[ { ind, Prepend[Drop[ind, -1], 0] + 1, Range[ n-k+1, n ] } ];
	       Flatten[  Table[  Evaluate[ind], Evaluate[Sequence@@iter] ], k-1 ]
] /;    0 < k <= n;

PowerSet[L_List,0] := {{}};
PowerSet[L_List,1] := Partition[L,1];
PowerSet[L_List,k_Integer?Positive] := {L} /; (k == Length[L]);
PowerSet[L_List,k_Integer?Positive] := {}  /; (k > Length[L]);
PowerSet[ L_List, k_Integer ] := 
	  L[[#]] & /@ PowerSet[Length[L], k]  /; 0 < k <= Length[L];



























RandomPermutation[k_Integer] := 
	Last /@ Sort[Pairs[Random[Integer,{1,k}]& /@ Range[k],Range[k]]];































































Options[RankingRules]={Direction\[Rule]Forward,Index\[Rule]1};

RankingRules[L_List, opts___?OptionQ ] := 
With[ { ind = Index /. {opts} /. Options[RankingRules]},
    	If[ (Direction /. {opts} /. Options[RankingRules]) === Forward, 
      		Thread[ L \[Rule]  Range[ind, ind + Length[L] - 1] ],
      		Thread[ Range[ind, ind + Length[L] - 1] \[Rule]  L ] ]
];

































































RootList[L_List] := 
Module[ {n,div,r},
	n = Length[L];
	If[ n==1, Return[L] ];
			
	div = Divisors[n];	
	If[ Length[div]==2,      (* n is prime *)
		
        Return@If[ Length[Union[L]]==1, Take[L,1], L ]
	];
	
	r = Catch[ Map[ If[ Length@Union@Partition[L,#]==1, Throw[#] ]&, div ] ];
	Take[L,r]
];































SelectorQ[ im_List, ker_List ] := 
     Union[ Length /@ (Intersection[#,im]& /@ ker) ] === {1};    













































Shuffle[{},L_List] = {L};
Shuffle[L_List,{}] = {L};
Shuffle[L1_List,L2_List] := 
        Union[ 
            Prepend[#,First[L1]]& /@ Shuffle[Rest[L1],L2],
            Prepend[#,First[L2]]& /@ Shuffle[L1,Rest[L2]]
        ];
        
Shuffle[n1_Integer,n2_Integer] := 
        Shuffle[ Table[1,{n1}], Table[2,{n2}] ];





























SubsetQ[S1_List,S2_List] := Union[S1,S2]===Union[S2];































ToBitVector[S_List,UU_List]   := If[MemberQ[S,#],1,0]& /@ UU;
ToBitVector[S_List,n_Integer] := If[MemberQ[S,#],1,0]& /@ Range[n];

















ToList[S_] := List@@S;









































Options[ToPairs] ={Full\[Rule]False};

ToPairs[ 1 ,opts___?OptionQ ]:=
    
    If[  Full /. {opts} /. Options[ToPairs], {{1,1}}, {} ] ;

ToPairs[ n_Integer?Positive ,opts___?OptionQ ]:=ToPairs[ Range[n] ,opts ];

ToPairs[ n_Integer?Positive ,opts___?OptionQ ] := 
    If[  Full /. {opts} /. Options[ToPairs], 
      Thread [
        	{Join@@NestList[  Rest[#]+1&,Table[1,{n}],n-1 ] ,
          	Join@@ Range[Range[n],n]}] ,
      Thread[ 
        	{Join@@NestList[  Rest[#]+1&,Table[1,{n-1}],n-2 ] ,
          	Join@@ Range[  Range[2,n] ,n] } ]
      ];

(* probably should not use Part *) 

ToPairs[ L_List ,opts___?OptionQ ] := L[[#]]& /@  ToPairs[Length[L],opts ];











































Tuples[_,0]:={{}};
Tuples[k_Integer?Positive,n_Integer]:= Tuples[Range[k],n];
Tuples[k_Integer?Negative,n_Integer]:= Tuples[Range[0,-k-1],n];
Tuples[L_List,n_Integer?Positive]:=CartesianProduct@@Table[L,{n}];
Tuples[L_List,n_Integer?Negative]:=
    
    FlattenOne[Table[CartesianProduct@@Table[L,{k}],{k,0,-n}]];



















































$extlink = Null;



























$defaultexternal = False;













































































$shortlines = 4;



























$transdispwidth = 20;



































































Attributes[AssignFunction]={HoldFirst};

Options[AssignFunction]={Opts\[Rule]{},Kary\[Rule]False};

AssignFunction[h_,L_List,opts___?OptionQ]:=
    (
      	ClearAll[h];
      	If[ 
        Kary/.\[InvisibleSpace]{opts}/.\[InvisibleSpace]Options[
            AssignFunction],
        	Scan[(h[Sequence@@First[#1]]=Last[#1])&,L],
        	Scan[(h[First[#1]]=Last[#1])&,L]
        	];
      	SetAttributes[h,
        Opts/.\[InvisibleSpace]Flatten[{opts}]/.\[InvisibleSpace]Options[
            AssignFunction]];
      );

AssignFunction[h_,L1_List,L2_List,opts___?OptionQ]:=
    AssignFunction[h,Pairs[L1,L2],opts]   /;  Length[L1]\[Equal]Length[L2];































Curry[fff_] := Function[yyy,Function[xxx,fff[xxx,yyy]]];































Dependency[ lab_List, k_Integer:2 ] := 
With[ {n = Log[ k, Length[lab] ]}, 
	n - Select[ Range[0,n-1],
	 !SameQ@@(Flatten /@ Thread@Partition[Partition[lab,k^#],k])& ] // Sort
]; 





































Drei = #[[3]]&;   

































ExtAutomata::onmsg =
    "External code turned on, $defaultexternal set to True.  Use \
ExtAutomata[False] to turn off.";
ExtAutomata::offmsg =
    "External code turned off, $defaultexternal set to False.  Use \
ExtAutomata[True] to turn on.";
ExtAutomata::haslnk =
    "Link to extaut already exists; you might wish to use ExtAutomata[False] \
to uninstall this link.";
ExtAutomata::failed =
    "Attempt to install link to extaut failed; make sure the external code is \
properly installed.";

getExternalLinks[] := 
    Select[Links[], StringMatchQ[First[#],"*extaut*"]& ];

hasExternalLinks[] := getExternalLinks[] =!= {};

ExtAutomata[md_:True]:=
    If[ md,
      	If[  hasExternalLinks[],
        		Message[ExtAutomata::haslnk]
        	];
      	Needs["Automata`automata`"];
      	SetDirectory[
        StringJoin[$PreferencesDirectory,"/Applications/Automata/"]];
      	$extlink=Install["extaut"];
      	ResetDirectory[];
      	If[  hasExternalLinks[],
        		Format[LineBreak[_]]="";
        		Off[General::spell1];
        		Message[ExtAutomata::onmsg]; 
        		$extautomataflag = $defaultexternal=True;
        		Null,
        	(* else failed *)
        		Message[ExtAutomata::failed];
        		Null
        	],
      (* else turn off *)
      	$defaultexternal= False;
      	Uninstall /@ getExternalLinks[];
      	Message[ExtAutomata::offmsg]; 
      	$extlink = Null
      ];




























FlattenOne[xx_] := Flatten[xx,1];





















































$postrules={""\[Rule]Global`\[Epsilon],Eps\[Rule]Global`\[Epsilon],
      "Eps"\[Rule]Global`\[Epsilon],Empty\[Rule]Global`\[EmptySet]};
$formatautomata = None;

FormatAutomata[Null|None] := 
    If[ $formatautomata =!= None,
      Module[{prt},
        	prt=Unprotect[CA,SA,FA,DFA,NFA,Graph];
        	Unset[Format[CA[w_,k_,r_,__]]]; 
        	Unset[Format[SA[n_,k_,t_,__]]]; 
        	Unset[Format[FA[n_,k_,t_,i_,f_,__]]];
        	Unset[Format[NFA[n_,k_,t_,i_,f_,__]]];
        	Unset[Format[DFA[n_,k_,t_,i_,f_,__]]];
        	Unset[Format[Graph[v_,e_,i_,ed_,__]]];
        	Protect[prt];
        	$Post=.;
          $formatautomata = None;
        ]
      ];

FormatAutomata[Some] := 
    Module[{prt},
      	prt=Unprotect[CA,SA,FA,DFA,NFA,Graph];
      	Format[CA[ w_,k_,r_,__]] := HoldForm[CA[w,k,r]]; 
      	Format[SA[n_,k_,t_,__]] := HoldForm[SA[n,k,t]];	
      	Format[FA[n_,k_,t_,i_,f_,__]] := HoldForm[FA[n,k,t,i,f]];
      	Format[NFA[n_,k_,t_,i_,f_,__]] := HoldForm[NFA[n,k,t,i,f]];
      	Format[DFA[n_,k_,t_,i_,f_,__]] := HoldForm[DFA[n,k,t,i,f]];
      	Format[Graph[v_,e_,i_,ed_,__]] := HoldForm[Graph[v,e,i,ed]];
      	Protect[prt];
      $Post=ReplaceAll[#,$postrules]&;
      $formatautomata = Some;
      ];

FormatAutomata[Automatic] := 
    Module[{prt},
      	prt=Unprotect[CA,SA,FA,DFA,NFA,Graph];
      	Format[CA[ w_,k_,r_,__]] := 
        HoldForm[CA[ w,k,Short[r,#]]]&[$shortlines]; 
      	Format[SA[n_,k_,t_,__]] := 
        HoldForm[SA[n,k,Short[t,#]]]&[$shortlines];	
      	Format[FA[n_,k_,t_,i_,f_,__]] := 
        HoldForm[FA[n,k,Short[t,#],Short[i,#],Short[f,#]]]&[$shortlines];
      	Format[NFA[n_,k_,t_,i_,f_,__]] := 
        HoldForm[NFA[n,k,Short[t,#],Short[i,#],Short[f,#]]]&[$shortlines];
      	Format[DFA[n_,k_,t_,i_,f_,__]] := 
        HoldForm[DFA[n,k,Short[t,#],Short[i,#],Short[f,#]]]&[$shortlines];
      	Format[Graph[v_,e_,i_,ed_,__]] := 
        HoldForm[Graph[v,e,i,Short[ed,#]]]&[$shortlines];
      	Protect[prt];
      	$Post=ReplaceAll[#,$postrules]&;
      $formatautomata = Automatic;
      ];

FormatAutomata[SizeOnly] := 
    Module[{prt},
      	prt=Unprotect[CA,SA,FA,DFA,NFA,Graph];
      	Format[CA[w_,k_,r_,__]] := HoldForm[CA[w,k]]; 
      	Format[SA[n_,k_,t_,__]] := HoldForm[SA[n,k]];	
      	Format[FA[n_,k_,t_,i_,f_,__]] := HoldForm[FA[n,k]];
      	Format[NFA[n_,k_,t_,i_,f_,__]] := HoldForm[NFA[n,k]];
      	Format[DFA[n_,k_,t_,i_,f_,__]] := HoldForm[DFA[n,k]];
      	Format[Graph[v_,e_,i_,ed_,__]] := HoldForm[Graph[v,e,i]];
      	Protect[prt];
      	$Post=ReplaceAll[#,$postrules]&;
        $formatautomata = SizeOnly;
      ];

FormatAutomata[Full] := 
    Module[{prt},
      	prt=Unprotect[CA,SA,FA,DFA,NFA,Graph];
      	Format[CA[w_,k_,r_,__]] := "-CA-"; 
      	Format[SA[n_,k_,t_,__]] := "-SA-";
      	Format[FA[n_,k_,t_,i_,f_,__]] := "-FA-";
      	Format[NFA[n_,k_,t_,i_,f_,__]] := "-NFA-";
      	Format[DFA[n_,k_,t_,i_,f_,__]] := "-DFA-";
      	Format[Graph[v_,e_,i_,ed_,__]] := "-Graph-";
      	Protect[prt];
        $Post=ReplaceAll[#,$postrules]&;
        $formatautomata = Full;
      ];



































MinusEins = #[[-1]]&;





















MinusZwei = #[[-2]]&;






























































Options[PositionList]={Type\[Rule]None};

PositionList[L1_List,L2_List,opts___?OptionQ] := 
    If[ None===(Type /. {opts} /. Options[PositionList]),
      	Flatten[ Position[L1,#]& /@ L2 ],
      	With[ {A = T@@(Last /@ Sort@Pairs[L1,Range[Length[L1]]]),
          	B = T@@(Last /@ Sort@Pairs[L2,Range[Length[L2]]])},
        		ToList[InverseT[B] ** A] ]
      ];

(* and a hack ... *)

PositionList[L1_List,L2_ ] := PositionList[L1,{L2}];



























PositionOne[xx_,yy_] := Position[xx,yy][[1,1]];

























ReplaceParts[xx_,r1_,p1_]:=ReplacePart[xx,r1,p1];
ReplaceParts[xx_,r1_,p1_,rp__]:=ReplaceParts[ReplacePart[xx,r1,p1],rp];



















SelectOptions[ cmd_Symbol, opts___?OptionQ ] :=
        
    SelectOptions[ First /@ Options[cmd], opts ];

SelectOptions[ L_List, opts___?OptionQ ] :=
        
    Sequence@@Select[ Flatten[{opts}], MemberQ[L, First[#]]& ];
 
SelectOptions[cmd_Symbol,opts___?OptionQ,{excl__}] := 
		SelectOptions[ Options[cmd],opts,{excl}];
	
SelectOptions[L_List,opts___?OptionQ,{excl__}] := 
With[ {OO = Complement[First/@L,{excl}]},
	Sequence@@Select[ Flatten[{opts}],MemberQ[OO,First[#]]& ] ];





















Status[] := 
Print[
	$Version,", RN: ",$ReleaseNumber,"\n",
	"Automata:   ", $AutomataReleaseNumber,"\n",
	"time:       ", 
	StringJoin@Flatten@Thread[
		{RotateRight[ToString/@Date[],3],{":",":","  ","/","/",""}}],"\n",
	"time used:  ",TimeUsed[],"\n",
	"memory:     ",MemoryInUse[]/2^20//N,"\n",
	"packages:   ",Select[ $Packages, StringMatchQ[#, "Automata`*"]& ],"\n",
	"links:      ",Links[]
];

























SymbolList[ str_String, ll_Integer ] := SymbolList[ str, Range[ll] ]; 
SymbolList[ str_String, LL_List] := 
    ToExpression /@ (StringJoin[ str, ToString[#] ]& /@ LL);





















Zwei = #[[2]]&;   























$AutomataReleaseNumber = "5.0";















FormatAutomata[Automatic];

If[ Global`$AutomataMessages, 
    Message[automata::ldend,$AutomataReleaseNumber] ];















automata::ldend = "Automata loaded, version: `1`.\n
Modified built-ins:\n
(1) NonCommutativeMultiply: is Listable.\n
(2) ToString[Eps|\"Eps\"]==>\"\"."; 

prt=Unprotect[ToString];
ToString[Eps|"Eps"|Global`\[Epsilon]] := "";
Protect[prt];



























$deffatline = 0.005;

























$deflabeloffset  = 0.2;



























$defpointsize = 0.02;





























$defthinline = 0.003;

























$plotrangeoffset  = 0.8;































$rastercolors={
      0\[Rule]RGBColor[0.8,1.,1.],
      1\[Rule]RGBColor[0, 0.2, 1.],
      2\[Rule]RGBColor[1., 0,1.],
      3\[Rule]RGBColor[1., 1.,0],
      4\[Rule]RGBColor[0.2, 1., 0.2],
      5\[Rule]RGBColor[1.,0.,0.],
      6\[Rule]RGBColor[0.,1.,1.],
      7\[Rule]RGBColor[0.53,0.26,0.12],
      8\[Rule]RGBColor[0.75,0.75,0.75],
      9\[Rule]RGBColor[0.,0.,0.]
      };



















ColorQ[_RGBColor|_GrayLevel|_Hue] = True;
ColorQ[_] = False;





























DoShow[gr_,opts___?OptionQ ]   := 
	Show[gr,DisplayFunction->$DisplayFunction,opts]; 

































Options[GridLine]={PlotStyle\[Rule]{GrayLevel[0.8],$defthinline},
      GridOffset\[Rule]{0,0},Full\[Rule]All};

Unprotect[PointSize,Thickness];
Attributes[PointSize] = {Flat};
Attributes[Thickness] = {Flat};
Protect[PointSize,Thickness];

GridLine[m_Integer,n_Integer, opts___?OptionQ] := 
Module[ {ps,xoff,yoff,full,lines},
	ps = PlotStyle /. {opts} /. Options[GridLine];
	{xoff,yoff} = GridOffset /. {opts} /. Options[GridLine];

	full = Full /. {opts} /. Options[GridLine];

	ps = 
	Switch[ ps, 
		_?ColorQ,     {ps,$defthinline},
		{_?ColorQ},   {ps[[1]],$defthinline},
		_Real,        {GrayLevel[0.8],ps},
		{_Real},      {GrayLevel[0.8],ps[[1]]},
		_,            ps
	];
	ps = MapAt[ Thickness, ps, 2 ];
	
	shift[{x_,y_}] := {x-xoff,y-yoff};

	lines = 
	Switch[ full,
		All,	Join[ Line/@Table[shift/@{{i,1},{i,m}},{i,n}],  
			      Line/@Table[shift/@{{1,i},{n,i}},{i,m}] ],
		_List,	{ Map[ Line, full, {-3} ] }
	];

	Graphics[ Join[ ps, lines ], 
     		MakePlotRange[n,m], 
     		SelectOptions[Graphics,opts] ]
];

















































Options[GridPoints]={LabelGrid\[Rule]None,Full\[Rule]All,
      LabelPoints\[Rule]None,
      PlotStyle\[RuleDelayed]{{Blue,$defpointsize},{Red,1.2 $defpointsize}}};

GridPoints[m_Integer,n_Integer,opts___?OptionQ] := 
Module[ {txtl,txtr,txtm,del,ps,full,lab,labf,labff,i,j,pnts},
	txtl = txtr = txtm = {};
	del  = $deflabeloffset + n/40; 
	ps   = PlotStyle /. {opts} /. Options[GridPoints];
	full = Full      /. {opts} /. Options[GridPoints];
	
	If[ (lab = LabelGrid /. {opts} /. Options[GridPoints]) =!= None, 
	    If[ lab===Automatic, 
          	labf = #&,
          		If[ Head[lab]===List, labf = lab[[#]]&, labf = lab ]];
        		
        txtl = Table[ 
            Text[labf[i],{1-del,i},TextStyle\[Rule]$TextStyle], {i,m} ];
        		
        txtr = Table[ 
            Text[labf[i],{n+del,i},TextStyle\[Rule]$TextStyle], {i,m} ];
        	];
      
      	If[ (labff = LabelPoints /. {opts} /. Options[GridPoints]) =!= None, 
        		
        txtm = Table[ 
              Text[labff[j,i],{j-del/2,i-del/2},
                TextStyle\[Rule]$TextStyle], {i,m},{j,n} ];
        	];
      
      	ps = 
        	Switch[ ps, 
          	    _?
            ColorQ,              {{ps,$defpointsize},{Red,1.2$defpointsize}},
          	    {_?ColorQ},            {{ps[[1]],$defpointsize},{Red,
              1.2$defpointsize}},
          	    _Real,		   {{Blue,ps},{Red,$defpointsize}},		
          	    {_Real,_Real},         {{Blue,ps[[1]]},{Red,ps[[2]]}},		
          	    {_?ColorQ,_Real},      {ps,{Red, 1.2 ps[[2]]}},
          	    {_?ColorQ,_?ColorQ},   {{ps[[1]],$defpointsize},{ps[[2]],
              1.2$defpointsize}},	
          	    _,                     ps
          	];
      	ps = MapAt[ PointSize, ps, {{1,2},{2,2}} ];		
      	
      	pnts = 
        	Switch[ full,
          		All,	{}, 
          		_List,	full,
          		_,	Select[CartesianProduct[n,m],full[#[[1]],#[[2]]]& ]
          	];
      
           Graphics[ Join[ txtl, txtr, txtm,  
               		ps[[1]], Point /@ Complement[CartesianProduct[n,m],pnts], 
               		ps[[2]], Point /@ pnts],
             		MakePlotRange[n,m], 
             		SelectOptions[Graphics,opts] ]
      ];



























HueRasterColors[(p_Integer)?Positive, off_:0] := 
  With[{RR = Range[0,p-1]}, Thread[RR -> (Hue[N[#1/p]+off] &) /@ RR]];








































































MakePlotRange[x2_,y2_]:=MakePlotRange[1,x2,1,y2];
MakePlotRange[x1_,x2_,y1_,y2_]:=
    PlotRange\[Rule]{{x1-$plotrangeoffset,
          x2+$plotrangeoffset},{y1-$plotrangeoffset,y2+$plotrangeoffset}};





































































Options[PlotComputationFA]={DoTrace\[Rule]Automatic,LabelGrid\[Rule]None,
      Full\[Rule]False,Frame\[Rule]True};

PlotComputationFA[ M_NFA|M_DFA|M_SA, w_?WordQ, opts___?OptionQ] := 
      PlotComputationFA[ ToFA[M], w, opts];
      
PlotComputationFA[ M_FA, w_?WordQ, opts___?OptionQ ] :=

    Block[  {n,A,B,trace,full},

	trace = DoTrace /. {opts} /. Options[PlotComputationFA];
	full  = Full /. {opts} /. Options[PlotComputationFA];

	 n  = Size[M];	 
	{A,B} = 
	Switch[ trace,
		Automatic,     {Initial[M],Final[M]},
		All,           {Range[n],Range[n]},
		{__Integer},   {trace,Range[n]},
		_,             trace
	]; 
      
	PlotTDGraph[ ComputationGraphFA[M,w], n, 
		     DoTrace\[Rule] {A,B}, Full\[Rule] full, FrameTicks\[Rule] None, opts ]
];



























PlotFunction[ ff_, A_List, num_Integer:8, opts___?OptionQ ] := 
With[ {R = Pairs[Range[Length[A]],( ff /@ A ) /. RankingRules[A]], 
        n = Length[A]}, 
		PlotTDGraph[ ToTDGraph[ Table[ R, {num} ], n ], n, opts ] ];

PlotFunction[ ff_, n_Integer, num_Integer:8, opts___?OptionQ ] := 
With[ {R = Pairs[Range[n], ff /@ Range[n]]}, 
		PlotTDGraph[ ToTDGraph[ Table[ R, {num} ], n ], n, opts ] ];


















































Options[PlotMatrix]={Frame\[Rule]True,GridLines\[Rule]False,
      MultiCol\[Rule]False,NRows\[Rule]30,RView\[Rule]False,
      NoRest\[Rule]False,RasterStyle\[RuleDelayed]$rastercolors,
      Background\[Rule]LightYellow};

PlotMatrix[mm_SparseArray,opts___?OptionQ]:=
    	
    PlotMatrix[ Normal[mm],opts ];

PlotMatrix[mm_?MatrixQ,opts___?OptionQ]:=
    
    If[MultiCol/.\[InvisibleSpace]{opts}/.\[InvisibleSpace]Options[
          PlotMatrix],
      	plotmatrixblocks[mm,opts],
      	plotmatrix[mm,opts] ];

plotmatrix[mm_?MatrixQ,opts___?OptionQ]:=
    
    Module[{ps,gr,asp,grdl,frm,mmm},
      
      {ps,grdl,frm,
          rv}={RasterStyle,GridLines,Frame,
              RView}/.\[InvisibleSpace]{opts}/.\[InvisibleSpace]Options[
            PlotMatrix];
      
      If[ps===Automatic,ps=HueRasterColors[Max[Flatten[mm]]+1]];
      mmm=If[rv,Thread[mm],mm];
      asp=Length[mmm]/Length[First[mmm]];
      
      gr=If[frm,
          
          Graphics[RasterArray[Reverse[mmm/.\[InvisibleSpace]ps]],
            AspectRatio\[Rule]asp,Frame\[Rule]True,FrameTicks\[Rule]None],
          
          Graphics[RasterArray[Reverse[mmm/.\[InvisibleSpace]ps]],
            AspectRatio\[Rule]asp]
          ];
      
      Switch[grdl,
        	False,Show[gr,SelectOptions[Graphics,opts,{GridLines}]],
        	True,Show[{gr,GridLine[Length[mmm]+1,Length[First[mmm]]+1,
              GridOffset\[Rule]{1,1}]},
          SelectOptions[Graphics,opts,{GridLines}]],
        _, 
        Show[{gr,
            GridLine[Length[mmm]+1,Length[First[mmm]]+1,
              GridOffset\[Rule]{1,1},PlotStyle\[Rule]grdl]},
          SelectOptions[Graphics,opts,{GridLines}]]
        ]
      ];

plotmatrix[L_?VectorQ,opts___?OptionQ]:=plotmatrix[{L},opts];

plotmatrixblocks[L_?MatrixQ,opts___?OptionQ]:=
    Module[{part,gr,nr,rv},
      
      nr=NRows/.\[InvisibleSpace]{opts}/.\[InvisibleSpace]Options[
            PlotMatrix];
      rv=RView/.\[InvisibleSpace]{opts}/.\[InvisibleSpace]Options[
            PlotMatrix];
      
      If[ 
        NoRest/.\[InvisibleSpace]{opts}/.\[InvisibleSpace]Options[
            PlotMatrix],
        part=Partition[L,nr],
        part=Partition[L,nr,nr,1,{}]
        ];
      
      If[ rv,part=Thread/@part];
      
      gr=(plotmatrix[#,DisplayFunction\[Rule]Identity,
                SelectOptions[PlotMatrix,opts]]&)/@part;
      
      ShowArray[ gr,If[rv,1,Length[part]]]
      ];



























PlotRelation[ {RR___List}, A_List, opts___?OptionQ ] := 
With[ {n = Length[A]}, 
	PlotTDGraph[ ToTDGraph[ {RR}, n ], n, opts ] ];
	
PlotRelation[ {RR___List}, n_Integer, opts___?OptionQ ] := 
	PlotTDGraph[ ToTDGraph[ {RR}, n ], n, opts ];


(*  R: A x A -->  Bool   representing relation on A *) 

PlotRelation[ R_, A_List, num_Integer:1, opts___?OptionQ] := 
With[ {RL = 
          Select[ CartesianProduct[A,A], R[ #[[1]],#[[2]] ]& ] /. 
            RankingRules[A]},
		PlotRelation[ Table[RL,{num}], A, opts ]
]; 

PlotRelation[ R_, n_Integer, num_Integer:1, opts___?OptionQ ] := 
	PlotRelation[ R, Range[n], num, opts];

































Options[PlotTDGraph]={DoTrace\[Rule]All,Full\[Rule]False,
      PlotStyle\[RuleDelayed]{{Blue,$defpointsize},{Red,1.2 $defpointsize}},
      LineStyle\[RuleDelayed]{{GrayLevel[.5],$defthinline},{Black,$deffatline}\
}};

PlotTDGraph[ gr_Graph, n_Integer, opts___?OptionQ ] := 
Module[ {m,V,ed,RtoV,ls,ps,A,B,res,acc,VV,edd},

	m  = NumVertices[gr]/n;
	V  = rktocp[n] /@ Range[n m];
	ed = Edges[gr];

	ps = PlotStyle /. {opts} /. Options[PlotTDGraph];
	ls = LineStyle /. {opts} /. Options[PlotTDGraph];
	
	ls =
	Switch[ ls, 
		_?ColorQ,              {{ls,$defthinline},{Black,$deffatline}},
		{_?ColorQ},            {{ls[[1]],$defthinline},{Black,$deffatline}},
		{_Real,_Real},         {{GrayLevel[.5],ls[[1]]},{Black,ls[[2]]}},		
		{_?ColorQ,_Real},      {ls,{Black, $deffatline}},
		{_?ColorQ,_?ColorQ},   {{ls[[1]],$defthinline},{ls[[2]],$deffatline}},	
		_,                     ls
	];
	ls = MapAt[ Thickness, ls, {{1,2},{2,2}} ];		

	{A,B} = 
	Switch[ (sel = DoTrace /. {opts} /. Options[PlotTDGraph]),
		None|{},            {{},{}},
		All,                {Range[n],Range[n]},
		{__Integer},        {sel,Range[n]},
		{All,{__Integer}},  {Range[n],sel[[2]]},
		_,                  sel
	];
	
	B   = B + n(m-1);  (* fix positional notation *)
	
      acc = BiAccessibleGraph[gr,A,B];
	VV  = VertexSet[acc];
	edd = Select[ ed, MemberQ[VV,#[[1]]]&&MemberQ[VV,#[[2]]]& ];
     
	(* grid points, lines for orbits, high light orbits *)
	(* 
        GridPoints usese MakePlotRange automatically     *)
	res =  
	{ 
	    GridPoints[n,m,PlotStyle\[Rule] ps,Full\[Rule] (rktocoord[n] /@ VV),
						SelectOptions[GridPoints,opts] ],
	    Graphics[ Join[ ls[[2]], Line /@  Map[ rktocoord[n], edd, {2}] ],
 			 	MakePlotRange[m,n], SelectOptions[Graphics,opts]  ]
	};
 		   
 	If[ Full /. {opts} /. Options[PlotTDGraph],
 		PrependTo[ res, Graphics[ Join[ ls[[1]], 
			    Line /@  Map[ rktocoord[n], ed, {2}] ],
			    MakePlotRange[m,n] ] ] ];

 	Show[ res, SelectOptions[Graphics,opts] ]
];

































PlotT[ t_T, num_Integer:8, opts___?OptionQ] := 
	PlotFunction[ t[[#]]&, Length[t], num, Frame\[Rule]True, 
      FrameTicks\[Rule]None, opts ]; 

PlotT[ tt__T, opts___?OptionQ ] := 
With[ {n = Length[First[{tt}]] },
	PlotRelation[ Pairs[Range[n],ToList[#]]& /@ {tt}, n, Frame\[Rule] True, 
        FrameTicks\[Rule] None, opts ] ]; 

PlotT[ {tt__T}, opts___?OptionQ ] := 
	With[ {n = Length[First[{tt}]] },
	PlotRelation[ Pairs[Range[n],ToList[#]]& /@ {tt}, Range[n], opts ]];





























































ShowArray[LL_List,k_Integer,opts___?OptionQ] := 
    Show[ 
	GraphicsArray[ Partition[LL,k,k,1,{}],SelectOptions[GraphicsArray,opts]],
        SelectOptions[Graphics,opts]
    ];

ShowArray[gr_List,opts___?OptionQ] := 
	ShowArray[gr,Ceiling@N@Sqrt@Length[gr], opts ];



























Options[StaircasePlot]={Full\[Rule]False,PlotStyle\[Rule]Blue};

StaircasePlot[L_List,opts___?OptionQ] := 
Module[ {n,xcoor,op,ps,grf},
	n = Length[L];
        xcoor = Join[ {1}, Flatten[Pairs[Range[2,n],Range[2,n]]], {n+1} ];
	If[ Full /. {opts} /. Options[StaircasePlot], 
	    grf =  
          Polygon[ Join[Pairs[xcoor,Flatten[Pairs[L,L]]], {{n+1,L[[1]]}}] ],
	    grf =  Line[Pairs[xcoor,Flatten[Pairs[L,L]]]] 
	];
	ps = PlotStyle /. {opts} /. Options[StaircasePlot]; 
        Graphics[ { ps, grf }, 
		  PlotRange->{{0,n+2},{-2,Max[L]+1}},
		  SelectOptions[Graphics,opts]]  // Show
];



End[];

AlgebraicForm::args="Wrong argument(s), try AlgebraicForm[w]";
AlgebraicForm[__]:=$Failed/;Message[AlgebraicForm::args];
Alphabet::args="Wrong argument(s), try Alphabet[M]";
Alphabet[__]:=$Failed/;Message[Alphabet::args];
AlphabetQ::args="Wrong argument(s), try AlphabetQ[K]";
AlphabetQ[__]:=$Failed/;Message[AlphabetQ::args];
AlphabetSize::args="Wrong argument(s), try AlphabetSize[K]";
AlphabetSize[__]:=$Failed/;Message[AlphabetSize::args];
Concatenate::args="Wrong argument(s), try Concatenate[u,v]";
Concatenate[__]:=$Failed/;Message[Concatenate::args];
FromEps::args="Wrong argument(s), try FromEps[exp]";
FromEps[__]:=$Failed/;Message[FromEps::args];
FromFrontier::args="Wrong argument(s), try FromFrontier[W]";
FromFrontier[__]:=$Failed/;Message[FromFrontier::args];
FrontierQ::args="Wrong argument(s), try FrontierQ[L,K]";
FrontierQ[__]:=$Failed/;Message[FrontierQ::args];
MakeAlphabet::args="Wrong argument(s), try MakeAlphabet[KK]";
MakeAlphabet[__]:=$Failed/;Message[MakeAlphabet::args];
MakeWord::args="Wrong argument(s), try MakeWord[a,i,b,j,...]";
MakeWord[__]:=$Failed/;Message[MakeWord::args];
ParikhVector::args="Wrong argument(s), try ParikhVector[w,K]";
ParikhVector[__]:=$Failed/;Message[ParikhVector::args];
RandomWord::args="Wrong argument(s), try RandomWord[n,K]";
RandomWord[__]:=$Failed/;Message[RandomWord::args];
ToBlocks::args="Wrong argument(s), try ToBlocks[L,w]";
ToBlocks[__]:=$Failed/;Message[ToBlocks::args];
ToEps::args="Wrong argument(s), try ToEps[x]";
ToEps[__]:=$Failed/;Message[ToEps::args];
ToFrontier::args="Wrong argument(s), try ToFrontier[W,K]";
ToFrontier[__]:=$Failed/;Message[ToFrontier::args];
ToIndex::args="Wrong argument(s), try ToIndex[w,K]";
ToIndex[__]:=$Failed/;Message[ToIndex::args];
ToWord::args="Wrong argument(s), try ToWord[L,K]";
ToWord[__]:=$Failed/;Message[ToWord::args];
WordBinomial::args="Wrong argument(s), try WordBinomial[u,v]";
WordBinomial[__]:=$Failed/;Message[WordBinomial::args];
WordConjugateQ::args="Wrong argument(s), try WordConjugateQ[u,v]";
WordConjugateQ[__]:=$Failed/;Message[WordConjugateQ::args];
WordConjugates::args="Wrong argument(s), try WordConjugates[w]";
WordConjugates[__]:=$Failed/;Message[WordConjugates::args];
WordFactorizations::args="Wrong argument(s), try WordFactorizations[w]";
WordFactorizations[__]:=$Failed/;Message[WordFactorizations::args];
WordFactorQ::args="Wrong argument(s), try WordFactorQ[x,y]";
WordFactorQ[__]:=$Failed/;Message[WordFactorQ::args];
WordFactors::args="Wrong argument(s), try WordFactors[w,opts]";
WordFactors[__]:=$Failed/;Message[WordFactors::args];
WordFusion::args="Wrong argument(s), try WordFusion[u,v,r]";
WordFusion[__]:=$Failed/;Message[WordFusion::args];
WordLength::args="Wrong argument(s), try WordLength[w]";
WordLength[__]:=$Failed/;Message[WordLength::args];
WordOrder::args="Wrong argument(s), try WordOrder[u,v]";
WordOrder[__]:=$Failed/;Message[WordOrder::args];
WordPeriod::args="Wrong argument(s), try WordPeriod[w]";
WordPeriod[__]:=$Failed/;Message[WordPeriod::args];
WordPower::args="Wrong argument(s), try WordPower[w,r]";
WordPower[__]:=$Failed/;Message[WordPower::args];
WordPrefixQ::args="Wrong argument(s), try WordPrefixQ[x,y]";
WordPrefixQ[__]:=$Failed/;Message[WordPrefixQ::args];
WordPrefixes::args="Wrong argument(s), try WordPrefixes[w]";
WordPrefixes[__]:=$Failed/;Message[WordPrefixes::args];
WordPrimitiveCount::args="Wrong argument(s), try WordPrimitiveCount[n,k]";
WordPrimitiveCount[__]:=$Failed/;Message[WordPrimitiveCount::args];
WordPrimitiveQ::args="Wrong argument(s), try WordPrimitiveQ[w]";
WordPrimitiveQ[__]:=$Failed/;Message[WordPrimitiveQ::args];
WordQ::args="Wrong argument(s), try WordQ[w]";
WordQ[__]:=$Failed/;Message[WordQ::args];
WordReverse::args="Wrong argument(s), try WordReverse[w]";
WordReverse[__]:=$Failed/;Message[WordReverse::args];
WordRoot::args="Wrong argument(s), try WordRoot[w]";
WordRoot[__]:=$Failed/;Message[WordRoot::args];
WordRotate::args="Wrong argument(s), try WordRotate[w,n]";
WordRotate[__]:=$Failed/;Message[WordRotate::args];
Words::args="Wrong argument(s), try Words[r,K]";
Words[__]:=$Failed/;Message[Words::args];
WordShuffle::args="Wrong argument(s), try WordShuffle[u,v]";
WordShuffle[__]:=$Failed/;Message[WordShuffle::args];
WordSort::args="Wrong argument(s), try WordSort[L]";
WordSort[__]:=$Failed/;Message[WordSort::args];
WordSuffixQ::args="Wrong argument(s), try WordSuffixQ[x,y]";
WordSuffixQ[__]:=$Failed/;Message[WordSuffixQ::args];
WordSuffixes::args="Wrong argument(s), try WordSuffixes[w]";
WordSuffixes[__]:=$Failed/;Message[WordSuffixes::args];
AcceptQFA::args="Wrong argument(s), try AcceptQFA[M,w]";
AcceptQFA[__]:=$Failed/;Message[AcceptQFA::args];
AccessibleFA::args="Wrong argument(s), try AccessibleFA[M]";
AccessibleFA[__]:=$Failed/;Message[AccessibleFA::args];
AddTransitionFA::args="Wrong argument(s), try AddTransitionFA[M,p,w,q]";
AddTransitionFA[__]:=$Failed/;Message[AddTransitionFA::args];
AllDFA::args="Wrong argument(s), try AllDFA[K]";
AllDFA[__]:=$Failed/;Message[AllDFA::args];
AmbiguousQFA::args="Wrong argument(s), try AmbiguousQFA[M,opts]";
AmbiguousQFA[__]:=$Failed/;Message[AmbiguousQFA::args];
BEFAToFA::args="Wrong argument(s), try BEFAToFA";
BEFAToFA[__]:=$Failed/;Message[BEFAToFA::args];
BehaviorFA::args="Wrong argument(s), try BehaviorFA[M,p]";
BehaviorFA[__]:=$Failed/;Message[BehaviorFA::args];
BuildBEFA::args="Wrong argument(s), try BuildBEFA[w]";
BuildBEFA[__]:=$Failed/;Message[BuildBEFA::args];
BuildDFA::args="Wrong argument(s), try BuildDFA[w1,..,ws,K]";
BuildDFA[__]:=$Failed/;Message[BuildDFA::args];
BuildNNFA::args="Wrong argument(s), try BuildNNFA[w]";
BuildNNFA[__]:=$Failed/;Message[BuildNNFA::args];
BuildStarDFA::args="Wrong argument(s), try BuildStarDFA[w]";
BuildStarDFA[__]:=$Failed/;Message[BuildStarDFA::args];
CirculantSA::args="Wrong argument(s), try CirculantSA[n,dd,lab,K]";
CirculantSA[__]:=$Failed/;Message[CirculantSA::args];
CoAccessibleFA::args="Wrong argument(s), try CoAccessibleFA[M]";
CoAccessibleFA[__]:=$Failed/;Message[CoAccessibleFA::args];
ComplementFA::args="Wrong argument(s), try ComplementFA[M]";
ComplementFA[__]:=$Failed/;Message[ComplementFA::args];
CompleteFA::args="Wrong argument(s), try CompleteFA[M]";
CompleteFA[__]:=$Failed/;Message[CompleteFA::args];
CompleteQFA::args="Wrong argument(s), try CompleteQFA[M]";
CompleteQFA[__]:=$Failed/;Message[CompleteQFA::args];
ComputationFA::args="Wrong argument(s), try ComputationFA[M,w,opts]";
ComputationFA[__]:=$Failed/;Message[ComputationFA::args];
ComputationGraphFA::args="Wrong argument(s), try ComputationGraphFA[M,w]";
ComputationGraphFA[__]:=$Failed/;Message[ComputationGraphFA::args];
ConcatenateFA::args="Wrong argument(s), try ConcatenateFA[M1,M2]";
ConcatenateFA[__]:=$Failed/;Message[ConcatenateFA::args];
ConvertToFA::args="Wrong argument(s), try ConvertToFA[H,Q,K,A,I,F]";
ConvertToFA[__]:=$Failed/;Message[ConvertToFA::args];
CounterDFA::args="Wrong argument(s), try CounterDFA[a,r,K]";
CounterDFA[__]:=$Failed/;Message[CounterDFA::args];
CoverQDFA::args="Wrong argument(s), try CoverQDFA[M1,M2,opts]";
CoverQDFA[__]:=$Failed/;Message[CoverQDFA::args];
DefiniteQFA::args="Wrong argument(s), try DefiniteQFA[M]";
DefiniteQFA[__]:=$Failed/;Message[DefiniteQFA::args];
DegreesFA::args="Wrong argument(s), try DegreesFA[M]";
DegreesFA[__]:=$Failed/;Message[DegreesFA::args];
DeleteStateFA::args="Wrong argument(s), try DeleteStateFA[M,p]";
DeleteStateFA[__]:=$Failed/;Message[DeleteStateFA::args];
DeterministicQFA::args="Wrong argument(s), try DeterministicQFA[M]";
DeterministicQFA[__]:=$Failed/;Message[DeterministicQFA::args];
DivisibilityDFA::args="Wrong argument(s), try DivisibilityDFA[m,B,opts]";
DivisibilityDFA[__]:=$Failed/;Message[DivisibilityDFA::args];
EmptyDFA::args="Wrong argument(s), try EmptyDFA[K]";
EmptyDFA[__]:=$Failed/;Message[EmptyDFA::args];
EmptyQFA::args="Wrong argument(s), try EmptyQFA[M]";
EmptyQFA[__]:=$Failed/;Message[EmptyQFA::args];
EpsilonFreeQ::args="Wrong argument(s), try EpsilonFreeQ[M]";
EpsilonFreeQ[__]:=$Failed/;Message[EpsilonFreeQ::args];
EpsilonEliminationFA::args="Wrong argument(s), try EpsilonEliminationFA[M]";
EpsilonEliminationFA[__]:=$Failed/;Message[EpsilonEliminationFA::args];
EquivalentQFA::args="Wrong argument(s), try EquivalentQFA[M1,M2]";
EquivalentQFA[__]:=$Failed/;Message[EquivalentQFA::args];
FactorialQFA::args="Wrong argument(s), try FactorialQFA[M,opts]";
FactorialQFA[__]:=$Failed/;Message[FactorialQFA::args];
FinalVectorFA::args="Wrong argument(s), try FinalVectorFA[M]";
FinalVectorFA[__]:=$Failed/;Message[FinalVectorFA::args];
Final::args="Wrong argument(s), try Final[M]";
Final[__]:=$Failed/;Message[Final::args];
FiniteComplementSA::args="Wrong argument(s), try FiniteComplementSA[W,K]";
FiniteComplementSA[__]:=$Failed/;Message[FiniteComplementSA::args];
FrontierToDFA::args="Wrong argument(s), try FrontierToDFA[g,F]";
FrontierToDFA[__]:=$Failed/;Message[FrontierToDFA::args];
FSMQ::args="Wrong argument(s), try FSMQ[M]";
FSMQ[__]:=$Failed/;Message[FSMQ::args];
FullQFA::args="Wrong argument(s), try EmptyQFA[M]";
FullQFA[__]:=$Failed/;Message[FullQFA::args];
FullTransitionMatrixFA::args="Wrong argument(s), try FullTransitionMatrixFA[M]";
FullTransitionMatrixFA[__]:=$Failed/;Message[FullTransitionMatrixFA::args];
FullTransitions::args="Wrong argument(s), try FullTransitions[M]";
FullTransitions[__]:=$Failed/;Message[FullTransitions::args];
FunctionToDFA::args="Wrong argument(s), try FunctionToDFA[Q,K,del,q0,F,opts]";
FunctionToDFA[__]:=$Failed/;Message[FunctionToDFA::args];
FunctionToSA::args="Wrong argument(s), try FunctionToSA[Q,K,del]";
FunctionToSA[__]:=$Failed/;Message[FunctionToSA::args];
GenerateDFA::args="Wrong argument(s), try GenerateDFA[q0,dot,K,fin]";
GenerateDFA[__]:=$Failed/;Message[GenerateDFA::args];
GenerateQuotients::args="Wrong argument(s), try GenerateQuotients[L,K]";
GenerateQuotients[__]:=$Failed/;Message[GenerateQuotients::args];
GrowthSeriesDFA::args="Wrong argument(s), try GrowthSeriesDFA[M,x]";
GrowthSeriesDFA[__]:=$Failed/;Message[GrowthSeriesDFA::args];
HomomorphismFA::args="Wrong argument(s), try HomomorphismFA[M,h,K]";
HomomorphismFA[__]:=$Failed/;Message[HomomorphismFA::args];
HurwitzProduct::args="Wrong argument(s), try HurwitzProduct[S1,S2]";
HurwitzProduct[__]:=$Failed/;Message[HurwitzProduct::args];
IdealBaseFA::args="Wrong argument(s), try IdealBaseFA[M]";
IdealBaseFA[__]:=$Failed/;Message[IdealBaseFA::args];
IdealQFA::args="Wrong argument(s), try IdealQFA[M]";
IdealQFA[__]:=$Failed/;Message[IdealQFA::args];
InfiniteQFA::args="Wrong argument(s), try InfiniteQFA[M]";
InfiniteQFA[__]:=$Failed/;Message[InfiniteQFA::args];
InitialVectorFA::args="Wrong argument(s), try InitialVectorFA[M]";
InitialVectorFA[__]:=$Failed/;Message[InitialVectorFA::args];
Initial::args="Wrong argument(s), try Initial[M]";
Initial[__]:=$Failed/;Message[Initial::args];
IntersectionFA::args="Wrong argument(s), try IntersectionFA[M1,M2]";
IntersectionFA[__]:=$Failed/;Message[IntersectionFA::args];
IrreducibleFA::args="Wrong argument(s), try IrreducibleFA[W,K]";
IrreducibleFA[__]:=$Failed/;Message[IrreducibleFA::args];
IsomorphicQDFA::args="Wrong argument(s), try IsomorphicQDFA[M1,M2]";
IsomorphicQDFA[__]:=$Failed/;Message[IsomorphicQDFA::args];
IthSymbolFA::args="Wrong argument(s), try IthSymbolFA[a,i,K]";
IthSymbolFA[__]:=$Failed/;Message[IthSymbolFA::args];
JoinSA::args="Wrong argument(s), try JoinSA[M1,M2,A]";
JoinSA[__]:=$Failed/;Message[JoinSA::args];
LanguageFA::args="Wrong argument(s), try LanguageFA[M,n]";
LanguageFA[__]:=$Failed/;Message[LanguageFA::args];
LanguageSort::args="Wrong argument(s), try LanguageSort[LL]";
LanguageSort[__]:=$Failed/;Message[LanguageSort::args];
LanguageToSeries::args="Wrong argument(s), try LanguageToSeries[L]";
LanguageToSeries[__]:=$Failed/;Message[LanguageToSeries::args];
LeftQuotient::args="Wrong argument(s), try LeftQuotient[w,L]";
LeftQuotient[__]:=$Failed/;Message[LeftQuotient::args];
LengthDFA::args="Wrong argument(s), try LengthDFA[n,K]";
LengthDFA[__]:=$Failed/;Message[LengthDFA::args];
LocalQSA::args="Wrong argument(s), try LocalQSA[M,opts]";
LocalQSA[__]:=$Failed/;Message[LocalQSA::args];
LocalUniversalFA::args="Wrong argument(s), try LocalUniversalFA[n,k,opts]";
LocalUniversalFA[__]:=$Failed/;Message[LocalUniversalFA::args];
LoopAutomatonFA::args="Wrong argument(s), try LoopAutomatonFA[M]";
LoopAutomatonFA[__]:=$Failed/;Message[LoopAutomatonFA::args];
MakeHomomorphismDFA::args="Wrong argument(s), try MakeHomomorphismDFA[h,M1,M2]";
MakeHomomorphismDFA[__]:=$Failed/;Message[MakeHomomorphismDFA::args];
MakeHomomorphism::args="Wrong argument(s), try MakeHomomorphism[f,A,B]";
MakeHomomorphism[__]:=$Failed/;Message[MakeHomomorphism::args];
MatrixToTransitions::args="Wrong argument(s), try MatrixToTransitions[M]";
MatrixToTransitions[__]:=$Failed/;Message[MatrixToTransitions::args];
MinimalFischerFA::args="Wrong argument(s), try MinimalFischerFA[M]";
MinimalFischerFA[__]:=$Failed/;Message[MinimalFischerFA::args];
MinimizeDFA::args="Wrong argument(s), try MinimizeDFA[M]";
MinimizeDFA[__]:=$Failed/;Message[MinimizeDFA::args];
MinimizeFA::args="Wrong argument(s), try MinimizeFA[M,opts]";
MinimizeFA[__]:=$Failed/;Message[MinimizeFA::args];
NNFAToFA::args="Wrong argument(s), try NNFAToFA[M]";
NNFAToFA[__]:=$Failed/;Message[NNFAToFA::args];
NormalizeControl::args="Wrong argument(s), try NormalizeControl[]";
NormalizeControl[__]:=$Failed/;Message[NormalizeControl::args];
NormalizeFA::args="Wrong argument(s), try NormalizeFA[M]";
NormalizeFA[__]:=$Failed/;Message[NormalizeFA::args];
NumberOfDFA::args="Wrong argument(s), try NumberOfDFA[n,k]";
NumberOfDFA[__]:=$Failed/;Message[NumberOfDFA::args];
NumTransitions::args="Wrong argument(s), try NumTransitions[M]";
NumTransitions[__]:=$Failed/;Message[NumTransitions::args];
PermutationSA::args="Wrong argument(s), try PermutationSA[perm,K]";
PermutationSA[__]:=$Failed/;Message[PermutationSA::args];
PermuteFA::args="Wrong argument(s), try PermuteFA[M,perm]";
PermuteFA[__]:=$Failed/;Message[PermuteFA::args];
PrintFA::args="Wrong argument(s), try PrintFA[M]";
PrintFA[__]:=$Failed/;Message[PrintFA::args];
ProductFA::args="Wrong argument(s), try ProductFA[M1,M2]";
ProductFA[__]:=$Failed/;Message[ProductFA::args];
ProductTransitions::args="Wrong argument(s), try ProductTransitions[T1,T2,k]";
ProductTransitions[__]:=$Failed/;Message[ProductTransitions::args];
QuotientDFA::args="Wrong argument(s), try QuotientDFA[L,K]";
QuotientDFA[__]:=$Failed/;Message[QuotientDFA::args];
QuotientMachineFA::args="Wrong argument(s), try QuotientMachineFA[M1,M2]";
QuotientMachineFA[__]:=$Failed/;Message[QuotientMachineFA::args];
RandomDFA::args="Wrong argument(s), try RandomDFA[n,k]";
RandomDFA[__]:=$Failed/;Message[RandomDFA::args];
RankOfDFA::args="Wrong argument(s), try RankOfDFA[M]";
RankOfDFA[__]:=$Failed/;Message[RankOfDFA::args];
RankToDFA::args="Wrong argument(s), try RankToDFA[r,n,k]";
RankToDFA[__]:=$Failed/;Message[RankToDFA::args];
DeleteTransitionFA::args="Wrong argument(s), try DeleteTransitionFA";
DeleteTransitionFA[__]:=$Failed/;Message[DeleteTransitionFA::args];
ReverseFA::args="Wrong argument(s), try ReverseFA[M]";
ReverseFA[__]:=$Failed/;Message[ReverseFA::args];
SelectFA::args="Wrong argument(s), try SelectFA[M,L]";
SelectFA[__]:=$Failed/;Message[SelectFA::args];
SetAlphabet::args="Wrong argument(s), try SetAlphabet[M,K]";
SetAlphabet[__]:=$Failed/;Message[SetAlphabet::args];
SetFinalFA::args="Wrong argument(s), try SetFinalFA[m,F]";
SetFinalFA[__]:=$Failed/;Message[SetFinalFA::args];
SetInitialFA::args="Wrong argument(s), try SetInitialFinalFA[m,I]";
SetInitialFA[__]:=$Failed/;Message[SetInitialFA::args];
SetInitialFinalFA::args="Wrong argument(s), try SetInitialFinalFA[m,I,F]";
SetInitialFinalFA[__]:=$Failed/;Message[SetInitialFinalFA::args];
SetStates::args="Wrong argument(s), try SetStates[M,Q]";
SetStates[__]:=$Failed/;Message[SetStates::args];
ShuffleProductFA::args="Wrong argument(s), try ShuffleProductFA[M1,M2]";
ShuffleProductFA[__]:=$Failed/;Message[ShuffleProductFA::args];
SinkQDFA::args="Wrong argument(s), try SinkQDFA[M]";
SinkQDFA[__]:=$Failed/;Message[SinkQDFA::args];
Size::args="Wrong argument(s), try Size[M]";
Size[__]:=$Failed/;Message[Size::args];
SquareSA::args="Wrong argument(s), try SquareSA[M]";
SquareSA[__]:=$Failed/;Message[SquareSA::args];
StarFA::args="Wrong argument(s), try StarFA[M]";
StarFA[__]:=$Failed/;Message[StarFA::args];
StateMergeDFA::args="Wrong argument(s), try StateMergeDFA[M,R]";
StateMergeDFA[__]:=$Failed/;Message[StateMergeDFA::args];
States::args="Wrong argument(s), try States[M]";
States[__]:=$Failed/;Message[States::args];
SubsetQFA::args="Wrong argument(s), try SubsetQFA[M1,M2]";
SubsetQFA[__]:=$Failed/;Message[SubsetQFA::args];
SubwordCounterDFA::args="Wrong argument(s), try SubwordCounterDFA[w,p,K,opts]";
SubwordCounterDFA[__]:=$Failed/;Message[SubwordCounterDFA::args];
SubwordDFA::args="Wrong argument(s), try SubwordDFA[w,K]";
SubwordDFA[__]:=$Failed/;Message[SubwordDFA::args];
SumFA::args="Wrong argument(s), try SumFA[M1,M2]";
SumFA[__]:=$Failed/;Message[SumFA::args];
SwitchTransitionFA::args="Wrong argument(s), try SwitchTransitionFA[M,p,q]";
SwitchTransitionFA[__]:=$Failed/;Message[SwitchTransitionFA::args];
TheInitial::args="Wrong argument(s), try TheInitial[M]";
TheInitial[__]:=$Failed/;Message[TheInitial::args];
ToCharacters::args="Wrong argument(s), try ToCharacters[w]";
ToCharacters[__]:=$Failed/;Message[ToCharacters::args];
ToDFA::args="Wrong argument(s), try ToDFA[M]";
ToDFA[__]:=$Failed/;Message[ToDFA::args];
ToEquationsDFA::args="Wrong argument(s), try ToEquationsDFA[M]";
ToEquationsDFA[__]:=$Failed/;Message[ToEquationsDFA::args];
ToFA::args="Wrong argument(s), try ToFA[M]";
ToFA[__]:=$Failed/;Message[ToFA::args];
ToFactorFA::args="Wrong argument(s), try ToFactorFA[M]";
ToFactorFA[__]:=$Failed/;Message[ToFactorFA::args];
ToFrontierDFA::args="Wrong argument(s), try ToFrontierDFA[M]";
ToFrontierDFA[__]:=$Failed/;Message[ToFrontierDFA::args];
ToGeneratorsFA::args="Wrong argument(s), try ToGeneratorsFA[M]";
ToGeneratorsFA[__]:=$Failed/;Message[ToGeneratorsFA::args];
ToGraphFA::args="Wrong argument(s), try ToGraphFA[M]";
ToGraphFA[__]:=$Failed/;Message[ToGraphFA::args];
ToKernelFA::args="Wrong argument(s), try ToKernelFA[M,L,opts]";
ToKernelFA[__]:=$Failed/;Message[ToKernelFA::args];
ToNFA::args="Wrong argument(s), try ToNFA[M]";
ToNFA[__]:=$Failed/;Message[ToNFA::args];
ToRegularExpressionFA::args="Wrong argument(s), try ToRegularExpressionFA[M]";
ToRegularExpressionFA[__]:=$Failed/;Message[ToRegularExpressionFA::args];
ToSA::args="Wrong argument(s), try ToSA[M]";
ToSA[__]:=$Failed/;Message[ToSA::args];
ToSeries::args="Wrong argument(s), try ToSeries[L]";
ToSeries[__]:=$Failed/;Message[ToSeries::args];
ToTransitions::args="Wrong argument(s), try ToTransitions[T,K]";
ToTransitions[__]:=$Failed/;Message[ToTransitions::args];
TransferSequenceFA::args="Wrong argument(s), try TransferSequenceFA[M,S,T]";
TransferSequenceFA[__]:=$Failed/;Message[TransferSequenceFA::args];
TransitionFunctionFA::args="Wrong argument(s), try TransitionFunctionFA[M,delta]";
TransitionFunctionFA[__]:=$Failed/;Message[TransitionFunctionFA::args];
TransitionMatrixFA::args="Wrong argument(s), try TransitionMatrixFA[M,f]";
TransitionMatrixFA[__]:=$Failed/;Message[TransitionMatrixFA::args];
TransitionsToMatrix::args="Wrong argument(s), try TransitionsToMatrix[n,k,T]";
TransitionsToMatrix[__]:=$Failed/;Message[TransitionsToMatrix::args];
Transitions::args="Wrong argument(s), try Transitions[M]";
Transitions[__]:=$Failed/;Message[Transitions::args];
TransitiveLanguageQFA::args="Wrong argument(s), try TransitiveLanguageQFA[M]";
TransitiveLanguageQFA[__]:=$Failed/;Message[TransitiveLanguageQFA::args];
TransitiveQFA::args="Wrong argument(s), try TransitiveQFA[M,opts]";
TransitiveQFA[__]:=$Failed/;Message[TransitiveQFA::args];
TrapStatesFA::args="Wrong argument(s), try TrapStatesFA[M]";
TrapStatesFA[__]:=$Failed/;Message[TrapStatesFA::args];
TrimFA::args="Wrong argument(s), try TrimFA[M]";
TrimFA[__]:=$Failed/;Message[TrimFA::args];
TropicalIdentityMatrix::args="Wrong argument(s), try TropicalIdentityMatrix[n]";
TropicalIdentityMatrix[__]:=$Failed/;Message[TropicalIdentityMatrix::args];
UnionFA::args="Wrong argument(s), try UnionFA[M1,M2]";
UnionFA[__]:=$Failed/;Message[UnionFA::args];
VerifyFA::args="Wrong argument(s), try VerifyFA[M]";
VerifyFA[__]:=$Failed/;Message[VerifyFA::args];
WordToFA::args="Wrong argument(s), try WordToFA[w]";
WordToFA[__]:=$Failed/;Message[WordToFA::args];
ArdenSolve::args="Wrong argument(s), try ArdenSolve[eq]";
ArdenSolve[__]:=$Failed/;Message[ArdenSolve::args];
FormatX::args="Wrong argument(s), try FormatX[True]";
FormatX[__]:=$Failed/;Message[FormatX::args];
REEpsQ::args="Wrong argument(s), try REEpsQ[reg]";
REEpsQ[__]:=$Failed/;Message[REEpsQ::args];
RegularExpressionToBEFA::args="Wrong argument(s), try RegularExpressionToBEFA[exp]";
RegularExpressionToBEFA[__]:=$Failed/;Message[RegularExpressionToBEFA::args];
RegularExpressionToFA::args="Wrong argument(s), try RegularExpressionToFA[exp,K]";
RegularExpressionToFA[__]:=$Failed/;Message[RegularExpressionToFA::args];
RegularExpressionToNNFA::args="Wrong argument(s), try RegularExpressionToNNFA[exp]";
RegularExpressionToNNFA[__]:=$Failed/;Message[RegularExpressionToNNFA::args];
REQuotient::args="Wrong argument(s), try REQuotient[w,exp]";
REQuotient[__]:=$Failed/;Message[REQuotient::args];
RESimplify::args="Wrong argument(s), try RESimplify[exp]";
RESimplify[__]:=$Failed/;Message[RESimplify::args];
SubstituteRE::args="Wrong argument(s), try SubstituteRE[eq1,eq2]";
SubstituteRE[__]:=$Failed/;Message[SubstituteRE::args];
ToRegExp::args="Wrong argument(s), try ToRegExp[reg]";
ToRegExp[__]:=$Failed/;Message[ToRegExp::args];
BFunctionToCA::args="Wrong argument(s), try BFunctionToCA[f,w]";
BFunctionToCA[__]:=$Failed/;Message[BFunctionToCA::args];
ClassifyCA::args="Wrong argument(s), try ClassifyCA[C]";
ClassifyCA[__]:=$Failed/;Message[ClassifyCA::args];
ComposeCA::args="Wrong argument(s), try ComposeCA[C1,C2]";
ComposeCA[__]:=$Failed/;Message[ComposeCA::args];
EvolutionCA::args="Wrong argument(s), try EvolutionCA[C,X,t,opts]";
EvolutionCA[__]:=$Failed/;Message[EvolutionCA::args];
DependencyCA::args="Wrong argument(s), try DependencyCA[C]";
DependencyCA[__]:=$Failed/;Message[DependencyCA::args];
FSurjectiveCA::args="Wrong argument(s), try FSurjectiveCA[C]";
FSurjectiveCA[__]:=$Failed/;Message[FSurjectiveCA::args];
FunctionToCA::args="Wrong argument(s), try FunctionToCA[f,w,k]";
FunctionToCA[__]:=$Failed/;Message[FunctionToCA::args];
GlobalMapCA::args="Wrong argument(s), try GlobalMapCA[f,C]";
GlobalMapCA[__]:=$Failed/;Message[GlobalMapCA::args];
InverseCA::args="Wrong argument(s), try InverseCA[C]";
InverseCA[__]:=$Failed/;Message[InverseCA::args];
IterateCA::args="Wrong argument(s), try IterateCA[C,t]";
IterateCA[__]:=$Failed/;Message[IterateCA::args];
LocalMapCA::args="Wrong argument(s), try LocalMapCA[f,C]";
LocalMapCA[__]:=$Failed/;Message[LocalMapCA::args];
NumberOfCA::args="Wrong argument(s), try NumberOfCA[w,k]";
NumberOfCA[__]:=$Failed/;Message[NumberOfCA::args];
NumberOfTotalisticCA::args="Wrong argument(s), try NumberOfTotalisticCA[w,K]";
NumberOfTotalisticCA[__]:=$Failed/;Message[NumberOfTotalisticCA::args];
OrbitCA::args="Wrong argument(s), try OrbitCA[C,pat,t,opts]";
OrbitCA[__]:=$Failed/;Message[OrbitCA::args];
PolynomialToCA::args="Wrong argument(s), try PolynomialToCA[pol,w,k]";
PolynomialToCA[__]:=$Failed/;Message[PolynomialToCA::args];
PrintCA::args="Wrong argument(s), try PrintCA[C]";
PrintCA[__]:=$Failed/;Message[PrintCA::args];
RuleCA::args="Wrong argument(s), try RuleCA[C]";
RuleCA[__]:=$Failed/;Message[RuleCA::args];
RulesToCA::args="Wrong argument(s), try RulesToCA[rw,w,Q]";
RulesToCA[__]:=$Failed/;Message[RulesToCA::args];
SeedConfiguration::args="Wrong argument(s), try SeedConfiguration[{w},n]";
SeedConfiguration[__]:=$Failed/;Message[SeedConfiguration::args];
SimplifyCA::args="Wrong argument(s), try SimplifyCA[C]";
SimplifyCA[__]:=$Failed/;Message[SimplifyCA::args];
ToRulesCA::args="Wrong argument(s), try ToRulesCA[C]";
ToRulesCA[__]:=$Failed/;Message[ToRulesCA::args];
TotalisticRuleToCA::args="Wrong argument(s), try TotalisticRuleToCA[w,k,r]";
TotalisticRuleToCA[__]:=$Failed/;Message[TotalisticRuleToCA::args];
ToTotalisticRuleCA::args="Wrong argument(s), try ToTotalisticRuleCA[C]";
ToTotalisticRuleCA[__]:=$Failed/;Message[ToTotalisticRuleCA::args];
WelchCA::args="Wrong argument(s), try WelchCA[C]";
WelchCA[__]:=$Failed/;Message[WelchCA::args];
WidthCA::args="Wrong argument(s), try WidthCA[C]";
WidthCA[__]:=$Failed/;Message[WidthCA::args];
AddEdge::args="Wrong argument(s), try AddEdge[G,e]";
AddEdge[__]:=$Failed/;Message[AddEdge::args];
AddVertex::args="Wrong argument(s), try AddVertex[G]";
AddVertex[__]:=$Failed/;Message[AddVertex::args];
BiAccessibleGraph::args="Wrong argument(s), try BiAccessibleGraph[G,S,T]";
BiAccessibleGraph[__]:=$Failed/;Message[BiAccessibleGraph::args];
AccessibleGraph::args="Wrong argument(s), try AccessibleGraph[G,A]";
AccessibleGraph[__]:=$Failed/;Message[AccessibleGraph::args];
CirculantGraph::args="Wrong argument(s), try CirculantGraph[n,{d1,...,dr}]";
CirculantGraph[__]:=$Failed/;Message[CirculantGraph::args];
CyclicQGraph::args="Wrong argument(s), try CyclicQGraph[G]";
CyclicQGraph[__]:=$Failed/;Message[CyclicQGraph::args];
DeBruijnEdges::args="Wrong argument(s), try DeBruijnEdges[w,K]";
DeBruijnEdges[__]:=$Failed/;Message[DeBruijnEdges::args];
DeBruijnGraph::args="Wrong argument(s), try DeBruijnGraph[w,K]";
DeBruijnGraph[__]:=$Failed/;Message[DeBruijnGraph::args];
DegreeGraph::args="Wrong argument(s), try DegreeGraph[G,v]";
DegreeGraph[__]:=$Failed/;Message[DegreeGraph::args];
DeleteEdge::args="Wrong argument(s), try DeleteEdge[G,e]";
DeleteEdge[__]:=$Failed/;Message[DeleteEdge::args];
DeleteVertex::args="Wrong argument(s), try DeleteVertex";
DeleteVertex[__]:=$Failed/;Message[DeleteVertex::args];
EdgeQ::args="Wrong argument(s), try EdgeQ[G,x,y]";
EdgeQ[__]:=$Failed/;Message[EdgeQ::args];
Edges::args="Wrong argument(s), try Edges[G]";
Edges[__]:=$Failed/;Message[Edges::args];
LabelEdgeList::args="Wrong argument(s), try LabelEdgeList[E,lab]";
LabelEdgeList[__]:=$Failed/;Message[LabelEdgeList::args];
LongestPath::args="Wrong argument(s), try LongestPath[G]";
LongestPath[__]:=$Failed/;Message[LongestPath::args];
NormalizeGraph::args="Wrong argument(s), try NormalizeGraph[M]";
NormalizeGraph[__]:=$Failed/;Message[NormalizeGraph::args];
NonTransientGraph::args="Wrong argument(s), try NonTransientGraph[G]";
NonTransientGraph[__]:=$Failed/;Message[NonTransientGraph::args];
NumEdges::args="Wrong argument(s), try NumEdges[G]";
NumEdges[__]:=$Failed/;Message[NumEdges::args];
NumVertices::args="Wrong argument(s), try NumVertices[G]";
NumVertices[__]:=$Failed/;Message[NumVertices::args];
PathGraph::args="Wrong argument(s), try PathGraph[n]";
PathGraph[__]:=$Failed/;Message[PathGraph::args];
PermuteGraph::args="Wrong argument(s), try PermuteGraph[G,p]";
PermuteGraph[__]:=$Failed/;Message[PermuteGraph::args];
ProductGraph::args="Wrong argument(s), try ProductGraph[G1,G2]";
ProductGraph[__]:=$Failed/;Message[ProductGraph::args];
ProductLabeledGraph::args="Wrong argument(s), try ProductLabeledGraph[G1,G2]";
ProductLabeledGraph[__]:=$Failed/;Message[ProductLabeledGraph::args];
ReverseGraph::args="Wrong argument(s), try ReverseGraph[G]";
ReverseGraph[__]:=$Failed/;Message[ReverseGraph::args];
SetVertices::args="Wrong argument(s), try SetVertices[G,V]";
SetVertices[__]:=$Failed/;Message[SetVertices::args];
ShortestPath::args="Wrong argument(s), try ShortestPath[G,s]";
ShortestPath[__]:=$Failed/;Message[ShortestPath::args];
StronglyConnectedComponents::args="Wrong argument(s), try StronglyConnectedComponents[G]";
StronglyConnectedComponents[__]:=$Failed/;Message[StronglyConnectedComponents::args];
SubGraph::args="Wrong argument(s), try SubGraph[G,L]";
SubGraph[__]:=$Failed/;Message[SubGraph::args];
ToAdjacencyList::args="Wrong argument(s), try ToAdjacencyList[G]";
ToAdjacencyList[__]:=$Failed/;Message[ToAdjacencyList::args];
ToAdjacencyMatrix::args="Wrong argument(s), try ToAdjacencyMatrix[G]";
ToAdjacencyMatrix[__]:=$Failed/;Message[ToAdjacencyMatrix::args];
ToDirectedAcyclicGraph::args="Wrong argument(s), try ToDirectedAcyclicGraph[G]";
ToDirectedAcyclicGraph[__]:=$Failed/;Message[ToDirectedAcyclicGraph::args];
ToEdgeList::args="Wrong argument(s), try ToEdgeList[G]";
ToEdgeList[__]:=$Failed/;Message[ToEdgeList::args];
ToTDGraph::args="Wrong argument(s), try ToTDGraph[{RR},m]";
ToTDGraph[__]:=$Failed/;Message[ToTDGraph::args];
TypeGraph::args="Wrong argument(s), try TypeGraph[G]";
TypeGraph[__]:=$Failed/;Message[TypeGraph::args];
VertexSet::args="Wrong argument(s), try VertexSet[G]";
VertexSet[__]:=$Failed/;Message[VertexSet::args];
WeaklyConnectedComponents::args="Wrong argument(s), try WeaklyConnectedComponents[G,X]";
WeaklyConnectedComponents[__]:=$Failed/;Message[WeaklyConnectedComponents::args];
AllTimes::args="Wrong argument(s), try AllTimes[L1,L2]";
AllTimes[__]:=$Failed/;Message[AllTimes::args];
AlternatingGroupSG::args="Wrong argument(s), try AlternatingGroupSG[n]";
AlternatingGroupSG[__]:=$Failed/;Message[AlternatingGroupSG::args];
AperiodicQSG::args="Wrong argument(s), try AperiodicQSG[S]";
AperiodicQSG[__]:=$Failed/;Message[AperiodicQSG::args];
AperiodicSG::args="Wrong argument(s), try AperiodicSG[S]";
AperiodicSG[__]:=$Failed/;Message[AperiodicSG::args];
BlocksToDClass::args="Wrong argument(s), try BlocksToDClass[db,S]";
BlocksToDClass[__]:=$Failed/;Message[BlocksToDClass::args];
CollapseT::args="Wrong argument(s), try CollapseT[t]";
CollapseT[__]:=$Failed/;Message[CollapseT::args];
CycleDecompositionT::args="Wrong argument(s), try CycleDecompositionT[t]";
CycleDecompositionT[__]:=$Failed/;Message[CycleDecompositionT::args];
CycleToT::args="Wrong argument(s), try CycleToT[cycles,n]";
CycleToT[__]:=$Failed/;Message[CycleToT::args];
DClassDecomposition::args="Wrong argument(s), try DClassDecomposition[S]";
DClassDecomposition[__]:=$Failed/;Message[DClassDecomposition::args];
DClassSize::args="Wrong argument(s), try DClassSize[dc]";
DClassSize[__]:=$Failed/;Message[DClassSize::args];
DClassT::args="Wrong argument(s), try DClassT[x,S]";
DClassT[__]:=$Failed/;Message[DClassT::args];
DClassToBlocks::args="Wrong argument(s), try DClassToBlocks[dc]";
DClassToBlocks[__]:=$Failed/;Message[DClassToBlocks::args];
DihedralGroupSG::args="Wrong argument(s), try DihedralGroupSG[n]";
DihedralGroupSG[__]:=$Failed/;Message[DihedralGroupSG::args];
GenerateCSM::args="Wrong argument(s), try GenerateCSM[q0,dot,K,opts]";
GenerateCSM[__]:=$Failed/;Message[GenerateCSM::args];
GenerateCayleyGraph::args="Wrong argument(s), try GenerateCayleyGraph[q0,dot,K,opts]";
GenerateCayleyGraph[__]:=$Failed/;Message[GenerateCayleyGraph::args];
GenerateSG::args="Wrong argument(s), try GenerateSG[gen]";
GenerateSG[__]:=$Failed/;Message[GenerateSG::args];
GreenHQT::args="Wrong argument(s), try GreenRQT[x,y,S]";
GreenHQT[__]:=$Failed/;Message[GreenHQT::args];
GreenJQT::args="Wrong argument(s), try GreenRQT[x,y,S]";
GreenJQT[__]:=$Failed/;Message[GreenJQT::args];
GreenLQT::args="Wrong argument(s), try GreenRQT[x,y,S]";
GreenLQT[__]:=$Failed/;Message[GreenLQT::args];
GreenRQT::args="Wrong argument(s), try GreenRQT[x,y,S]";
GreenRQT[__]:=$Failed/;Message[GreenRQT::args];
HClassSize::args="Wrong argument(s), try HClassSize[dc]";
HClassSize[__]:=$Failed/;Message[HClassSize::args];
HClassT::args="Wrong argument(s), try HClassT[x,S]";
HClassT[__]:=$Failed/;Message[HClassT::args];
HTrivialQSG::args="Wrong argument(s), try HTrivialQSG[S]";
HTrivialQSG[__]:=$Failed/;Message[HTrivialQSG::args];
IdealT::args="Wrong argument(s), try IdealT[x,S]";
IdealT[__]:=$Failed/;Message[IdealT::args];
IdemSG::args="Wrong argument(s), try IdemSG[S]";
IdemSG[__]:=$Failed/;Message[IdemSG::args];
ImageT::args="Wrong argument(s), try ImageT[t]";
ImageT[__]:=$Failed/;Message[ImageT::args];
InGroupSG::args="Wrong argument(s), try InGroupSG[S]";
InGroupSG[__]:=$Failed/;Message[InGroupSG::args];
InverseT::args="Wrong argument(s), try InverseT[x]";
InverseT[__]:=$Failed/;Message[InverseT::args];
JTrivialQSG::args="Wrong argument(s), try JTrivialQSG[S]";
JTrivialQSG[__]:=$Failed/;Message[JTrivialQSG::args];
JTrivialSG::args="Wrong argument(s), try JTrivialSG[n]";
JTrivialSG[__]:=$Failed/;Message[JTrivialSG::args];
KernelImageToT::args="Wrong argument(s), try KernelImageToT[ker,im]";
KernelImageToT[__]:=$Failed/;Message[KernelImageToT::args];
KernelT::args="Wrong argument(s), try KernelT[t]";
KernelT[__]:=$Failed/;Message[KernelT::args];
LeftIdealT::args="Wrong argument(s), try LeftIdealT[x,S]";
LeftIdealT[__]:=$Failed/;Message[LeftIdealT::args];
LeftNullSG::args="Wrong argument(s), try LeftNullSG[S]";
LeftNullSG[__]:=$Failed/;Message[LeftNullSG::args];
LeftOneSG::args="Wrong argument(s), try LeftOneSG[S]";
LeftOneSG[__]:=$Failed/;Message[LeftOneSG::args];
LocallyCommutativeQSG::args="Wrong argument(s), try LocallyCommutativeQSG[S]";
LocallyCommutativeQSG[__]:=$Failed/;Message[LocallyCommutativeQSG::args];
LocallyIdempotentQSG::args="Wrong argument(s), try LocallyIdempotentQSG[S]";
LocallyIdempotentQSG[__]:=$Failed/;Message[LocallyIdempotentQSG::args];
Merge12T::args="Wrong argument(s), try Merge12T[n]";
Merge12T[__]:=$Failed/;Message[Merge12T::args];
MakeMonoidSG::args="Wrong argument(s), try MakeMonoidSG[S]";
MakeMonoidSG[__]:=$Failed/;Message[MakeMonoidSG::args];
MonoidQSG::args="Wrong argument(s), try MonoidQSG[S]";
MonoidQSG[__]:=$Failed/;Message[MonoidQSG::args];
NilpotentQSG::args="Wrong argument(s), try NilpotentQSG[S]";
NilpotentQSG[__]:=$Failed/;Message[NilpotentQSG::args];
NullSG::args="Wrong argument(s), try NullSG[S]";
NullSG[__]:=$Failed/;Message[NullSG::args];
OneSG::args="Wrong argument(s), try OneSG[S]";
OneSG[__]:=$Failed/;Message[OneSG::args];
OrderT::args="Wrong argument(s), try OrderT[x]";
OrderT[__]:=$Failed/;Message[OrderT::args];
PrintDClass::args="Wrong argument(s), try PrintDClass[dc]";
PrintDClass[__]:=$Failed/;Message[PrintDClass::args];
PrintEquations::args="Wrong argument(s), try PrintEquations[eq]";
PrintEquations[__]:=$Failed/;Message[PrintEquations::args];
PrintWitnesses::args="Wrong argument(s), try PrintWitnesses[S,wit]";
PrintWitnesses[__]:=$Failed/;Message[PrintWitnesses::args];
RegularSG::args="Wrong argument(s), try RegularSG[S]";
RegularSG[__]:=$Failed/;Message[RegularSG::args];
RandomT::args="Wrong argument(s), try RandomT[n]";
RandomT[__]:=$Failed/;Message[RandomT::args];
RankT::args="Wrong argument(s), try RankT[t]";
RankT[__]:=$Failed/;Message[RankT::args];
RightIdealT::args="Wrong argument(s), try RightIdealT[x,T]";
RightIdealT[__]:=$Failed/;Message[RightIdealT::args];
RightNullSG::args="Wrong argument(s), try LeftNullSG[S]";
RightNullSG[__]:=$Failed/;Message[RightNullSG::args];
RightOneSG::args="Wrong argument(s), try RightOneSG[S]";
RightOneSG[__]:=$Failed/;Message[RightOneSG::args];
SolveSG::args="Wrong argument(s), try SolveSG[a,b,S]";
SolveSG[__]:=$Failed/;Message[SolveSG::args];
SymmetricGroupSG::args="Wrong argument(s), try SymmetricGroupSG[n]";
SymmetricGroupSG[__]:=$Failed/;Message[SymmetricGroupSG::args];
SyntacticCongruence::args="Wrong argument(s), try SyntacticCongruence[M,r]";
SyntacticCongruence[__]:=$Failed/;Message[SyntacticCongruence::args];
SyntacticHomomorphism::args="Wrong argument(s), try SyntacticHomomorphism[f,M]";
SyntacticHomomorphism[__]:=$Failed/;Message[SyntacticHomomorphism::args];
SyntacticSG::args="Wrong argument(s), try SyntacticSG[M]";
SyntacticSG[__]:=$Failed/;Message[SyntacticSG::args];
TableSG::args="Wrong argument(s), try TableSG[S,W]";
TableSG[__]:=$Failed/;Message[TableSG::args];
ToIdentityString::args="Wrong argument(s), try ToIdentityString[x]";
ToIdentityString[__]:=$Failed/;Message[ToIdentityString::args];
TransformationSG::args="Wrong argument(s), try TransformationSG[n]";
TransformationSG[__]:=$Failed/;Message[TransformationSG::args];
TransientPeriodicT::args="Wrong argument(s), try TransientPeriodicT[x]";
TransientPeriodicT[__]:=$Failed/;Message[TransientPeriodicT::args];
TranspositionT::args="Wrong argument(s), try TranspositionT[n,i]";
TranspositionT[__]:=$Failed/;Message[TranspositionT::args];
UnitElement::args="Wrong argument(s), try UnitElement[x]";
UnitElement[__]:=$Failed/;Message[UnitElement::args];
EquationsToWitnesses::args="Wrong argument(s), try EquationsToWitnesses[eq,K]";
EquationsToWitnesses[__]:=$Failed/;Message[EquationsToWitnesses::args];
FromIdentityString::args="Wrong argument(s), try FromIdentityString[x]";
FromIdentityString[__]:=$Failed/;Message[FromIdentityString::args];
IrreducibleQ::args="Wrong argument(s), try IrreducibleQ[w,eq]";
IrreducibleQ[__]:=$Failed/;Message[IrreducibleQ::args];
PairsToRules::args="Wrong argument(s), try PairsToRules[rw]";
PairsToRules[__]:=$Failed/;Message[PairsToRules::args];
RulesToPairs::args="Wrong argument(s), try RulesToPairs[rw]";
RulesToPairs[__]:=$Failed/;Message[RulesToPairs::args];
SimplifyEquations::args="Wrong argument(s), try SimplifyEquations[S,wit,eq]";
SimplifyEquations[__]:=$Failed/;Message[SimplifyEquations::args];
SimplifyRewriteSystem::args="Wrong argument(s), try SimplifyRewriteSystem[eq]";
SimplifyRewriteSystem[__]:=$Failed/;Message[SimplifyRewriteSystem::args];
WordReduce::args="Wrong argument(s), try WordReduce[w,eq,opt]";
WordReduce[__]:=$Failed/;Message[WordReduce::args];
BooleanComplement::args="Wrong argument(s), try BooleanComplement[M1,M2]";
BooleanComplement[__]:=$Failed/;Message[BooleanComplement::args];
BooleanComposition::args="Wrong argument(s), try BooleanComposition[M1,M2]";
BooleanComposition[__]:=$Failed/;Message[BooleanComposition::args];
BooleanConverse::args="Wrong argument(s), try BooleanConverse[M]";
BooleanConverse[__]:=$Failed/;Message[BooleanConverse::args];
BooleanIntersection::args="Wrong argument(s), try BooleanIntersection[M1,M2]";
BooleanIntersection[__]:=$Failed/;Message[BooleanIntersection::args];
BooleanPower::args="Wrong argument(s), try BooleanPower[M,n]";
BooleanPower[__]:=$Failed/;Message[BooleanPower::args];
BooleanUnion::args="Wrong argument(s), try BooleanUnion[M1,M2]";
BooleanUnion[__]:=$Failed/;Message[BooleanUnion::args];
RelationToMatrix::args="Wrong argument(s), try RelationToMatrix[A,rel]";
RelationToMatrix[__]:=$Failed/;Message[RelationToMatrix::args];
ToClasses::args="Wrong argument(s), try ToClasses[L,R]";
ToClasses[__]:=$Failed/;Message[ToClasses::args];
TransitiveClosure::args="Wrong argument(s), try TransitiveClosure[B]";
TransitiveClosure[__]:=$Failed/;Message[TransitiveClosure::args];
Warshall::args="Wrong argument(s), try Warshall[B]";
Warshall[__]:=$Failed/;Message[Warshall::args];
AnalyzeOrbit::args="Wrong argument(s), try AnalyzeOrbit[f,x]";
AnalyzeOrbit[__]:=$Failed/;Message[AnalyzeOrbit::args];
CartesianProduct::args="Wrong argument(s), try CartesianProduct[A,B]";
CartesianProduct[__]:=$Failed/;Message[CartesianProduct::args];
ClosureSearch::args="Wrong argument(s), try ClosureSearch[L,targ,ff]";
ClosureSearch[__]:=$Failed/;Message[ClosureSearch::args];
Closure::args="Wrong argument(s), try Closure[L,ff]";
Closure[__]:=$Failed/;Message[Closure::args];
DeleteDuplicates::args="Wrong argument(s), try DeleteDuplicates";
DeleteDuplicates[__]:=$Failed/;Message[DeleteDuplicates::args];
DisjointQ::args="Wrong argument(s), try DisjointQ[L1,L2]";
DisjointQ[__]:=$Failed/;Message[DisjointQ::args];
EnumForm::args="Wrong argument(s), try EnumForm[L]";
EnumForm[__]:=$Failed/;Message[EnumForm::args];
FastPowerSet::args="Wrong argument(s), try FastPowerSet[L]";
FastPowerSet[__]:=$Failed/;Message[FastPowerSet::args];
Frequencies::args="Wrong argument(s), try Frequencies[L]";
Frequencies[__]:=$Failed/;Message[Frequencies::args];
FromBitVector::args="Wrong argument(s), try FromBitVector[B,U]";
FromBitVector[__]:=$Failed/;Message[FromBitVector::args];
LongestCommonSubsequence::args="Wrong argument(s), try LongestCommonSubsequence[A,B]";
LongestCommonSubsequence[__]:=$Failed/;Message[LongestCommonSubsequence::args];
MakeIndex::args="Wrong argument(s), try MakeIndex[L,R]";
MakeIndex[__]:=$Failed/;Message[MakeIndex::args];
NonDecreasingSequences::args="Wrong argument(s), try NonDecreasingSequences[n,k]";
NonDecreasingSequences[__]:=$Failed/;Message[NonDecreasingSequences::args];
Pairs::args="Wrong argument(s), try Pairs[A,B]";
Pairs[__]:=$Failed/;Message[Pairs::args];
Partitions::args="Wrong argument(s), try Partitions[n]";
Partitions[__]:=$Failed/;Message[Partitions::args];
PowerSet::args="Wrong argument(s), try PowerSet[L,k]";
PowerSet[__]:=$Failed/;Message[PowerSet::args];
RandomPermutation::args="Wrong argument(s), try RandomPermutation[k]";
RandomPermutation[__]:=$Failed/;Message[RandomPermutation::args];
RankingRules::args="Wrong argument(s), try RankingRules[L]";
RankingRules[__]:=$Failed/;Message[RankingRules::args];
RootList::args="Wrong argument(s), try RootList[L]";
RootList[__]:=$Failed/;Message[RootList::args];
SelectorQ::args="Wrong argument(s), try SelectorQ[A,P]";
SelectorQ[__]:=$Failed/;Message[SelectorQ::args];
Shuffle::args="Wrong argument(s), try Shuffle[A,B]";
Shuffle[__]:=$Failed/;Message[Shuffle::args];
SubsetQ::args="Wrong argument(s), try SubsetQ[S1,S2]";
SubsetQ[__]:=$Failed/;Message[SubsetQ::args];
ToBitVector::args="Wrong argument(s), try ToBitVector[S,U]";
ToBitVector[__]:=$Failed/;Message[ToBitVector::args];
ToList::args="Wrong argument(s), try ToList[S]";
ToList[__]:=$Failed/;Message[ToList::args];
ToPairs::args="Wrong argument(s), try ToPairs[A]";
ToPairs[__]:=$Failed/;Message[ToPairs::args];
Tuples::args="Wrong argument(s), try Tuples[L,k]";
Tuples[__]:=$Failed/;Message[Tuples::args];
AssignFunction::args="Wrong argument(s), try AssignFunction[h,P]";
AssignFunction[__]:=$Failed/;Message[AssignFunction::args];
Dependency::args="Wrong argument(s), try Dependency[V,k]";
Dependency[__]:=$Failed/;Message[Dependency::args];
ExtAutomata::args="Wrong argument(s), try ExtAutomata[bool]";
ExtAutomata[__]:=$Failed/;Message[ExtAutomata::args];
FlattenOne::args="Wrong argument(s), try FlattenOne[x]";
FlattenOne[__]:=$Failed/;Message[FlattenOne::args];
FormatAutomata::args="Wrong argument(s), try FormatAutomata[fmt]";
FormatAutomata[__]:=$Failed/;Message[FormatAutomata::args];
PositionList::args="Wrong argument(s), try PositionList[A,B,opts]";
PositionList[__]:=$Failed/;Message[PositionList::args];
PositionOne::args="Wrong argument(s), try PositionOne[x,y]";
PositionOne[__]:=$Failed/;Message[PositionOne::args];
ReplaceParts::args="Wrong argument(s), try ReplaceParts[x,r1,p1,r2,p2]";
ReplaceParts[__]:=$Failed/;Message[ReplaceParts::args];
SelectOptions::args="Wrong argument(s), try SelectOptions[cmd,opts]";
SelectOptions[__]:=$Failed/;Message[SelectOptions::args];
Status::args="Wrong argument(s), try Status[]";
Status[__]:=$Failed/;Message[Status::args];
SymbolList::args="Wrong argument(s), try SymbolList[sym,k]";
SymbolList[__]:=$Failed/;Message[SymbolList::args];
ColorQ::args="Wrong argument(s), try ColorQ[x]";
ColorQ[__]:=$Failed/;Message[ColorQ::args];
DoShow::args="Wrong argument(s), try DoShow[gr]";
DoShow[__]:=$Failed/;Message[DoShow::args];
GridLine::args="Wrong argument(s), try GridLine[n,m]";
GridLine[__]:=$Failed/;Message[GridLine::args];
GridPoints::args="Wrong argument(s), try GridPoints[n,m]";
GridPoints[__]:=$Failed/;Message[GridPoints::args];
HueRasterColors::args="Wrong argument(s), try HueRasterColors[p]";
HueRasterColors[__]:=$Failed/;Message[HueRasterColors::args];
MakePlotRange::args="Wrong argument(s), try MakePlotRange[x1,x2,y1,y2]";
MakePlotRange[__]:=$Failed/;Message[MakePlotRange::args];
PlotComputationFA::args="Wrong argument(s), try PlotComputationFA[M,w,opts]";
PlotComputationFA[__]:=$Failed/;Message[PlotComputationFA::args];
PlotFunction::args="Wrong argument(s), try PlotFunction[f,A,n,opts]";
PlotFunction[__]:=$Failed/;Message[PlotFunction::args];
PlotMatrix::args="Wrong argument(s), try PlotMatrix[M,opts]";
PlotMatrix[__]:=$Failed/;Message[PlotMatrix::args];
PlotRelation::args="Wrong argument(s), try PlotRelation[R,A,n,opts]";
PlotRelation[__]:=$Failed/;Message[PlotRelation::args];
PlotTDGraph::args="Wrong argument(s), try PlotTDGraph[gr,n]";
PlotTDGraph[__]:=$Failed/;Message[PlotTDGraph::args];
PlotT::args="Wrong argument(s), try PlotT[t,n]";
PlotT[__]:=$Failed/;Message[PlotT::args];
ShowArray::args="Wrong argument(s), try ShowArray[L,k]";
ShowArray[__]:=$Failed/;Message[ShowArray::args];
StaircasePlot::args="Wrong argument(s), try StaircasePlot[L,opts]";
StaircasePlot[__]:=$Failed/;Message[StaircasePlot::args];



Protect[AlgebraicForm, Alphabet, AlphabetQ, AlphabetSize, Concatenate, FromEps, FromFrontier, FrontierQ, MakeAlphabet, MakeWord, ParikhVector, RandomWord, ToBlocks, ToEps, ToFrontier, ToIndex, ToWord, WordBinomial, WordConjugateQ, WordConjugates, WordFactorizations, WordFactorQ, WordFactors, WordFusion, WordLength, WordOrder, WordPeriod, WordPower, WordPrefixQ, WordPrefixes, WordPrimitiveCount, WordPrimitiveQ, WordQ, WordReverse, WordRoot, WordRotate, Words, WordShuffle, WordSort, WordSuffixQ, WordSuffixes, AcceptQFA, AccessibleFA, AddTransitionFA, AllDFA, AmbiguousQFA, BEFAToFA, BehaviorFA, BuildBEFA, BuildDFA, BuildNNFA, BuildStarDFA, CirculantSA, CoAccessibleFA, ComplementFA, CompleteFA, CompleteQFA, ComputationFA, ComputationGraphFA, ConcatenateFA, ConvertToFA, CounterDFA, CoverQDFA, DefiniteQFA, DegreesFA, DeleteStateFA, DeterministicQFA, DivisibilityDFA, EmptyDFA, EmptyQFA, EpsilonFreeQ, EpsilonEliminationFA, EquivalentQFA, FactorialQFA, FinalVectorFA, Final, FiniteComplementSA, FrontierToDFA, FSMQ, FullQFA, FullTransitionMatrixFA, FullTransitions, FunctionToDFA, FunctionToSA, GenerateDFA, GenerateQuotients, GrowthSeriesDFA, HomomorphismFA, HurwitzProduct, IdealBaseFA, IdealQFA, InfiniteQFA, InitialVectorFA, Initial, IntersectionFA, IrreducibleFA, IsomorphicQDFA, IthSymbolFA, JoinSA, LanguageFA, LanguageSort, LanguageToSeries, LeftQuotient, LengthDFA, LocalQSA, LocalUniversalFA, LoopAutomatonFA, MakeHomomorphismDFA, MakeHomomorphism, MatrixToTransitions, MinimalFischerFA, MinimizeDFA, MinimizeFA, NNFAToFA, NormalizeControl, NormalizeFA, NumberOfDFA, NumTransitions, PermutationSA, PermuteFA, PrintFA, ProductFA, ProductTransitions, QuotientDFA, QuotientMachineFA, RandomDFA, RankOfDFA, RankToDFA, DeleteTransitionFA, ReverseFA, SelectFA, SetAlphabet, SetFinalFA, SetInitialFA, SetInitialFinalFA, SetStates, ShuffleProductFA, SinkQDFA, Size, SquareSA, StarFA, StateMergeDFA, States, SubsetQFA, SubwordCounterDFA, SubwordDFA, SumFA, SwitchTransitionFA, TheInitial, ToCharacters, ToDFA, ToEquationsDFA, ToFA, ToFactorFA, ToFrontierDFA, ToGeneratorsFA, ToGraphFA, ToKernelFA, ToNFA, ToRegularExpressionFA, ToSA, ToSeries, ToTransitions, TransferSequenceFA, TransitionFunctionFA, TransitionMatrixFA, TransitionsToMatrix, Transitions, TransitiveLanguageQFA, TransitiveQFA, TrapStatesFA, TrimFA, TropicalIdentityMatrix, UnionFA, VerifyFA, WordToFA, ArdenSolve, FormatX, REEpsQ, RegularExpressionToBEFA, RegularExpressionToFA, RegularExpressionToNNFA, REQuotient, RESimplify, SubstituteRE, ToRegExp, BFunctionToCA, ClassifyCA, ComposeCA, EvolutionCA, DependencyCA, FSurjectiveCA, FunctionToCA, GlobalMapCA, InverseCA, IterateCA, LocalMapCA, NumberOfCA, NumberOfTotalisticCA, OrbitCA, PolynomialToCA, PrintCA, RuleCA, RulesToCA, SeedConfiguration, SimplifyCA, ToRulesCA, TotalisticRuleToCA, ToTotalisticRuleCA, WelchCA, WidthCA, AddEdge, AddVertex, BiAccessibleGraph, AccessibleGraph, CirculantGraph, CyclicQGraph, DeBruijnEdges, DeBruijnGraph, DegreeGraph, DeleteEdge, DeleteVertex, EdgeQ, Edges, LabelEdgeList, LongestPath, NormalizeGraph, NonTransientGraph, NumEdges, NumVertices, PathGraph, PermuteGraph, ProductGraph, ProductLabeledGraph, ReverseGraph, SetVertices, ShortestPath, StronglyConnectedComponents, SubGraph, ToAdjacencyList, ToAdjacencyMatrix, ToDirectedAcyclicGraph, ToEdgeList, ToTDGraph, TypeGraph, VertexSet, WeaklyConnectedComponents, AllTimes, AlternatingGroupSG, AperiodicQSG, AperiodicSG, BlocksToDClass, CollapseT, CycleDecompositionT, CycleToT, DClassDecomposition, DClassSize, DClassT, DClassToBlocks, DihedralGroupSG, GenerateCSM, GenerateCayleyGraph, GenerateSG, GreenHQT, GreenJQT, GreenLQT, GreenRQT, HClassSize, HClassT, HTrivialQSG, IdealT, IdemSG, ImageT, InGroupSG, InverseT, JTrivialQSG, JTrivialSG, KernelImageToT, KernelT, LeftIdealT, LeftNullSG, LeftOneSG, LocallyCommutativeQSG, LocallyIdempotentQSG, Merge12T, MakeMonoidSG, MonoidQSG, NilpotentQSG, NullSG, OneSG, OrderT, PrintDClass, PrintEquations, PrintWitnesses, RegularSG, RandomT, RankT, RightIdealT, RightNullSG, RightOneSG, SolveSG, SymmetricGroupSG, SyntacticCongruence, SyntacticHomomorphism, SyntacticSG, TableSG, ToIdentityString, TransformationSG, TransientPeriodicT, TranspositionT, UnitElement, EquationsToWitnesses, FromIdentityString, IrreducibleQ, PairsToRules, RulesToPairs, SimplifyEquations, SimplifyRewriteSystem, WordReduce, BooleanComplement, BooleanComposition, BooleanConverse, BooleanIntersection, BooleanPower, BooleanUnion, RelationToMatrix, ToClasses, TransitiveClosure, Warshall, AnalyzeOrbit, CartesianProduct, ClosureSearch, Closure, DeleteDuplicates, DisjointQ, EnumForm, FastPowerSet, Frequencies, FromBitVector, LongestCommonSubsequence, MakeIndex, NonDecreasingSequences, Pairs, Partitions, PowerSet, RandomPermutation, RankingRules, RootList, SelectorQ, Shuffle, SubsetQ, ToBitVector, ToList, ToPairs, Tuples, AssignFunction, Dependency, ExtAutomata, FlattenOne, FormatAutomata, PositionList, PositionOne, ReplaceParts, SelectOptions, Status, SymbolList, ColorQ, DoShow, GridLine, GridPoints, HueRasterColors, MakePlotRange, PlotComputationFA, PlotFunction, PlotMatrix, PlotRelation, PlotTDGraph, PlotT, ShowArray, StaircasePlot];


Protect[Eps, BEFA, DFA, FA, NFA, NNFA, SA, TS, REP, RES, RET, CA, Graph, GridGraph, ConstantT, DC, GEN, OneT, ShiftT, SG, T];


Protect[Curry];




EndPackage[];

FormatAutomata[Automatic];If[Global`$AutomataMessages,Message[automata::ldend,$automataReleaseNumber]];